Package: aroma.affymetrix
Version: 3.2.3
Depends: R (>= 3.2.0), R.utils (>= 2.9.0), aroma.core (>= 3.2.0)
Imports: methods, R.methodsS3 (>= 1.7.1), R.oo (>= 1.23.0), R.cache (>=
        0.14.0), R.devices (>= 2.16.1), R.filesets (>= 2.13.0),
        aroma.apd (>= 0.6.0), MASS, splines, matrixStats (>= 0.55.0),
        listenv, future
Suggests: DBI (>= 1.0.0), RColorBrewer (>= 1.1-2), Biobase (>= 2.28.0),
        BiocGenerics (>= 0.14.0), affxparser (>= 1.40.0), affy (>=
        1.46.0), affyPLM (>= 1.44.0), aroma.light (>= 2.4.0), gcrma (>=
        2.40.0), limma (>= 3.24.1), oligo (>= 1.32.0), oligoClasses (>=
        1.30.0), pdInfoBuilder (>= 1.32.0), preprocessCore (>= 1.28.0),
        AffymetrixDataTestFiles, dChipIO (>= 0.1.1)
SuggestsNote: BioC (>= 3.0), Recommended: preprocessCore, affyPLM,
        aroma.light, affxparser, DNAcopy
Title: Analysis of Large Affymetrix Microarray Data Sets
Authors@R: c(
  person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                 email="henrikb@braju.com"),
  person("James", "Bullard", role="ctb"),
  person("Kasper", "Hansen", role="ctb"),
  person("Pierre", "Neuvial", role="ctb"),
  person("Elizabeth", "Purdom", role="ctb"),
  person("Mark", "Robinson", role="ctb"),
  person("Ken", "Simpson", role="ctb"))
Description: A cross-platform R framework that facilitates processing of any number of Affymetrix microarray samples regardless of computer system.  The only parameter that limits the number of chips that can be processed is the amount of available disk space.  The Aroma Framework has successfully been used in studies to process tens of thousands of arrays.  This package has actively been used since 2006.
License: LGPL (>= 2.1)
URL: https://www.aroma-project.org/,
        https://github.com/HenrikBengtsson/aroma.affymetrix
BugReports: https://github.com/HenrikBengtsson/aroma.affymetrix/issues
LazyLoad: TRUE
biocViews: Infrastructure, ProprietaryPlatforms, ExonArray, Microarray,
        OneChannel, GUI, DataImport, DataRepresentation, Preprocessing,
        QualityControl, Visualization, ReportWriting, aCGH,
        CopyNumberVariants, DifferentialExpression, GeneExpression,
        SNP, Transcription
NeedsCompilation: no
Packaged: 2025-08-19 03:09:09 UTC; hb
Author: Henrik Bengtsson [aut, cre, cph],
  James Bullard [ctb],
  Kasper Hansen [ctb],
  Pierre Neuvial [ctb],
  Elizabeth Purdom [ctb],
  Mark Robinson [ctb],
  Ken Simpson [ctb]
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Repository: CRAN
Date/Publication: 2025-08-19 07:00:02 UTC
Built: R 4.6.0; ; 2026-04-28 22:46:28 UTC; unix

Package: aroma.affymetrix
Version: 3.2.3
Depends: R (>= 3.2.0), R.utils (>= 2.9.0), aroma.core (>= 3.2.0)
Imports: methods, R.methodsS3 (>= 1.7.1), R.oo (>= 1.23.0), R.cache (>=
        0.14.0), R.devices (>= 2.16.1), R.filesets (>= 2.13.0),
        aroma.apd (>= 0.6.0), MASS, splines, matrixStats (>= 0.55.0),
        listenv, future
Suggests: DBI (>= 1.0.0), RColorBrewer (>= 1.1-2), Biobase (>= 2.28.0),
        BiocGenerics (>= 0.14.0), affxparser (>= 1.40.0), affy (>=
        1.46.0), affyPLM (>= 1.44.0), aroma.light (>= 2.4.0), gcrma (>=
        2.40.0), limma (>= 3.24.1), oligo (>= 1.32.0), oligoClasses (>=
        1.30.0), pdInfoBuilder (>= 1.32.0), preprocessCore (>= 1.28.0),
        AffymetrixDataTestFiles, dChipIO (>= 0.1.1)
SuggestsNote: BioC (>= 3.0), Recommended: preprocessCore, affyPLM,
        aroma.light, affxparser, DNAcopy
Title: Analysis of Large Affymetrix Microarray Data Sets
Authors@R: c(
  person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                 email="henrikb@braju.com"),
  person("James", "Bullard", role="ctb"),
  person("Kasper", "Hansen", role="ctb"),
  person("Pierre", "Neuvial", role="ctb"),
  person("Elizabeth", "Purdom", role="ctb"),
  person("Mark", "Robinson", role="ctb"),
  person("Ken", "Simpson", role="ctb"))
Description: A cross-platform R framework that facilitates processing of any number of Affymetrix microarray samples regardless of computer system.  The only parameter that limits the number of chips that can be processed is the amount of available disk space.  The Aroma Framework has successfully been used in studies to process tens of thousands of arrays.  This package has actively been used since 2006.
License: LGPL (>= 2.1)
URL: https://www.aroma-project.org/,
        https://github.com/HenrikBengtsson/aroma.affymetrix
BugReports: https://github.com/HenrikBengtsson/aroma.affymetrix/issues
LazyLoad: TRUE
biocViews: Infrastructure, ProprietaryPlatforms, ExonArray, Microarray,
        OneChannel, GUI, DataImport, DataRepresentation, Preprocessing,
        QualityControl, Visualization, ReportWriting, aCGH,
        CopyNumberVariants, DifferentialExpression, GeneExpression,
        SNP, Transcription
NeedsCompilation: no
Packaged: 2025-08-19 03:09:09 UTC; hb
Author: Henrik Bengtsson [aut, cre, cph],
  James Bullard [ctb],
  Kasper Hansen [ctb],
  Pierre Neuvial [ctb],
  Elizabeth Purdom [ctb],
  Mark Robinson [ctb],
  Ken Simpson [ctb]
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Repository: CRAN
Date/Publication: 2025-08-19 07:00:02 UTC
Built: R 4.6.0; ; 2026-04-25 19:45:22 UTC; unix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# IMPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom("R.oo", "throw")
importFrom("R.methodsS3", "setMethodS3")
importFrom("R.oo", "setConstructorS3")
importFrom("R.oo", "extend")
importFrom("R.oo", "uses")

## Importing Class:es
importFrom("R.oo", "Class")
importFrom("R.oo", "Interface")
importFrom("R.oo", "Object")
importFrom("R.oo", "Package")
importFrom("R.utils", "GenericSummary")
importFrom("R.utils", "Options")
importFrom("R.utils", "ProgressBar")
importFrom("R.filesets", "getChecksumFile")
importFrom("R.filesets", "getChecksumFileSet")
importFrom("R.filesets", "GenericDataFile")
importFrom("R.filesets", "GenericDataFileSet")
importFrom("R.filesets", "TabularTextFile")
importFrom("aroma.core", "AromaCellPositionFile")
importFrom("aroma.core", "AromaCellSequenceFile")
importFrom("aroma.core", "AromaCellTabularBinaryFile")
importFrom("aroma.core", "AromaMicroarrayDataFile")
importFrom("aroma.core", "AromaMicroarrayDataSet")
importFrom("aroma.core", "AromaMicroarrayDataSetTuple")
importFrom("aroma.core", "AromaPackage")
importFrom("aroma.core", "AromaPlatform")
importFrom("aroma.core", "AromaTransform")
importFrom("aroma.core", "AromaUflFile")
importFrom("aroma.core", "AromaUgcFile")
importFrom("aroma.core", "AromaUgpFile")
importFrom("aroma.core", "AromaUnitGenotypeCallFile")
importFrom("aroma.core", "AromaUnitGenotypeCallSet")
importFrom("aroma.core", "AromaUnitSignalBinaryFile")
importFrom("aroma.core", "AromaUnitSignalBinarySet")
importFrom("aroma.core", "AromaUnitTabularBinaryFile")
importFrom("aroma.core", "AromaUnitTotalCnBinaryFile")
importFrom("aroma.core", "AromaUnitTotalCnBinarySet")
importFrom("aroma.core", "AromaUnitFracBCnBinaryFile")
importFrom("aroma.core", "AromaUnitFracBCnBinarySet")
importFrom("aroma.core", "ChromosomalModel")
importFrom("aroma.core", "Explorer")
importFrom("aroma.core", "SampleAnnotationSet")

## Importing generics
importFrom("aroma.core", "allocate")
importFrom("aroma.core", "as.CopyNumberDataSetTuple")
importFrom("aroma.core", "byChipType")
importFrom("aroma.core", "exportTotalCnRatioSet")
importFrom("aroma.core", "findByChipType")
importFrom("aroma.core", "findUnitsTodo")
importFrom("aroma.core", "fit")
importFrom("aroma.core", "fixSearchPath")
importFrom("aroma.core", "getAlias")
importFrom("aroma.core", "getAM")
importFrom("aroma.core", "getAromaUflFile")
importFrom("aroma.core", "getAromaUgpFile")
importFrom("aroma.core", "getArraysOfInput")
importFrom("aroma.core", "getAverageFile")
importFrom("aroma.core", "getChipType")
importFrom("aroma.core", "getChromosomes")
importFrom("aroma.core", "getDefaultExtension")
importFrom("aroma.core", "getExpectedOutputFullnames")
importFrom("aroma.core", "getImage")
importFrom("aroma.core", "getInputDataSet")
importFrom("aroma.core", "getListOfUnitNamesFiles")
importFrom("aroma.core", "getListOfUnitTypesFiles")
importFrom("aroma.core", "getMainPath")
importFrom("aroma.core", "getNameOfInput")
importFrom("aroma.core", "getNumberOfFilesAveraged")
importFrom("aroma.core", "getOutputDataSet")
importFrom("aroma.core", "getOutputFiles")
importFrom("aroma.core", "getParameters")
importFrom("aroma.core", "getPlatform")
importFrom("aroma.core", "getPloidy")
importFrom("aroma.core", "getPositions")
importFrom("aroma.core", "getReference")
importFrom("aroma.core", "getRegions")
importFrom("aroma.core", "getRootPath")
importFrom("aroma.core", "getSetTuple")
importFrom("aroma.core", "getTagsOfInput")
importFrom("aroma.core", "getUnitNames")
importFrom("aroma.core", "getUnitNamesFile")
importFrom("aroma.core", "getUnitsOnChromosome")
importFrom("aroma.core", "getUnitsOnChromosomes")
importFrom("aroma.core", "getUnitTypes")
importFrom("aroma.core", "getUnitTypesFile")
importFrom("aroma.core", "getWeights")
importFrom("aroma.core", "getXAM")
importFrom("aroma.core", "hasAlleleBFractions")
importFrom("aroma.core", "hasStrandiness")
importFrom("aroma.core", "importFrom")
importFrom("aroma.core", "importFromGenericTabularFile")
importFrom("aroma.core", "isMissing")
importFrom("aroma.core", "nbrOfArrays")
importFrom("aroma.core", "nbrOfCells")
importFrom("aroma.core", "nbrOfChipTypes")
importFrom("aroma.core", "nbrOfEnzymes")
importFrom("aroma.core", "nbrOfUnits")
importFrom("aroma.core", "process")
importFrom("aroma.core", "readHeader")
importFrom("aroma.core", "rescale")
importFrom("aroma.core", "setAlias")
importFrom("aroma.core", "setArrays")
importFrom("aroma.core", "setReference")
importFrom("aroma.core", "setup")
importFrom("aroma.core", "stextChipType")
importFrom("aroma.core", "updateSetupExplorerFile")
importFrom("aroma.core", "writeImage")
importFrom("aroma.core", "writeRegions")
importFrom("R.filesets", "byName")
importFrom("R.filesets", "byPath")
importFrom("R.filesets", "extractMatrix")
importFrom("R.filesets", "findByName")
importFrom("R.filesets", "fromFile")
importFrom("R.filesets", "getAsteriskTags")
importFrom("R.filesets", "getAttribute")
importFrom("R.filesets", "getColumnNames")
importFrom("R.filesets", "getDefaultColumnNames")
importFrom("R.filesets", "getDefaultFullName")
importFrom("R.filesets", "getExtensionPattern")
importFrom("R.filesets", "getFileClass")
importFrom("R.filesets", "getFilenameExtension")
importFrom("R.filesets", "getFullName")
importFrom("R.filesets", "getFullNames")
importFrom("R.filesets", "getHeader")
importFrom("R.filesets", "getReadArguments")
importFrom("R.filesets", "getTags")
importFrom("R.filesets", "hasColumnHeader")
importFrom("R.filesets", "nbrOfColumns")
importFrom("R.filesets", "nbrOfRows")
importFrom("R.filesets", "readDataFrame")
importFrom("R.filesets", "setTags")
importFrom("R.filesets", "translateColumnNames")
importFrom("R.filesets", "translateFullName")
importFrom("R.filesets", "update2")
importFrom("R.filesets", "verify")
importFrom("R.oo", "clearCache") ## Multi-sources: R.oo, R.cache, R.filesets
importFrom("R.oo", "clone") ## Multi-sources: R.oo, R.filesets, oligoClasses
importFrom("R.oo", "getCalls")
importFrom("R.oo", "getFields")
importFrom("R.oo", "getName") ## Multi-sources: R.oo, R.filesets
importFrom("R.oo", "getPath") ## Multi-sources: R.oo, R.filesets
importFrom("R.oo", "getPosition")
importFrom("R.utils", "getLabel")
importFrom("R.utils", "setLabel")
importFrom("R.utils", "validate") ## Multi-sources: R.utils, R.filesets

## Importing functions
importFrom("aroma.apd", "readApd")
importFrom("aroma.apd", "writeApd")
importFrom("aroma.core", "allocateFromUnitNamesFile")
importFrom("aroma.core", "backtransformGenotypeCone")
importFrom("aroma.core", "backtransformMultiDimensionalCone")
importFrom("aroma.core", "countBases")
importFrom("aroma.core", "display")
importFrom("aroma.core", "extractGenotypes")
importFrom("aroma.core", "findAnnotationDataByChipType")
importFrom("aroma.core", "findPngDevice")
importFrom("aroma.core", "fitGenotypeCone")
importFrom("aroma.core", "fitMultiDimensionalCone")
importFrom("aroma.core", "fitSplineBlockPolish")
importFrom("aroma.core", "fitWHLAPLM.matrix")
importFrom("aroma.core", "fixSearchPathInternal")
importFrom("aroma.core", "getArrays")
importFrom("aroma.core", "getCacheKey")
importFrom("aroma.core", "getChipTypes")
importFrom("aroma.core", "getDataFileMatrix")
importFrom("aroma.core", "getParametersAsString")
importFrom("aroma.core", "getParentPath")
importFrom("aroma.core", "getProbeLength")
importFrom("aroma.core", "getProbePositionEffectDesignMatrix")
importFrom("aroma.core", "getRam")
importFrom("aroma.core", "getReferenceSetTuple")
importFrom("aroma.core", "getTableOfArrays")
importFrom("aroma.core", "getUnitsAt")
importFrom("aroma.core", "groupBySnpNucleotides")
importFrom("aroma.core", "isAverageFile")
importFrom("aroma.core", "isHeterozygous")
importFrom("aroma.core", "lapplyInChunks")
importFrom("aroma.core", "locallyUnique")
importFrom("aroma.core", "mergeBoxplotStats")
importFrom("aroma.core", "processTime")
importFrom("aroma.core", "readFooter")
importFrom("aroma.core", "readSequenceMatrix")
importFrom("aroma.core", "readTargetStrands")
importFrom("aroma.core", "smoothWRMA")
importFrom("aroma.core", "smoothWSA")
importFrom("aroma.core", "splitInChunks")
importFrom("aroma.core", "stextLabels")
importFrom("aroma.core", "stextSize")
importFrom("aroma.core", "updateGenotypes")
importFrom("aroma.core", "updateSequenceMatrix")
importFrom("aroma.core", "updateSequences")
importFrom("aroma.core", "updateTargetStrands")
importFrom("aroma.core", "writeFooter")
importFrom("matrixStats", "colMaxs")
importFrom("matrixStats", "colMedians")
importFrom("matrixStats", "colQuantiles")
importFrom("matrixStats", "indexByRow")
importFrom("matrixStats", "colAlls")
importFrom("matrixStats", "rowAnys")
importFrom("matrixStats", "rowMads")
importFrom("matrixStats", "rowMedians") ## Multi-sources: matrixStats, Biobase
importFrom("matrixStats", "rowSds")
importFrom("matrixStats", "rowSums2")
importFrom("methods", "new")
importFrom("R.cache", "getChecksum") ## Multi-sources: R.cache, R.filesets
importFrom("R.cache", "loadCache")
importFrom("R.cache", "saveCache")
importFrom("R.devices", "devDone")
importFrom("R.filesets", "copyTo")
importFrom("R.filesets", "dropRootPathTags")
importFrom("R.filesets", "getFile")
importFrom("R.filesets", "getFiles")
importFrom("R.filesets", "getFileSize")
importFrom("R.filesets", "getNames")
importFrom("R.filesets", "getOneFile")
importFrom("R.filesets", "getPathname")
importFrom("R.filesets", "getPathnames")
importFrom("R.filesets", "getSets")
importFrom("R.filesets", "hasTag")
importFrom("R.filesets", "indexOf")
importFrom("R.filesets", "readColumns")
importFrom("R.filesets", "readRawHeader")
importFrom("R.filesets", "renameTo")
importFrom("R.filesets", "setAttributesBy")
importFrom("R.filesets", "setAttributesByTags")
importFrom("R.methodsS3", "appendVarArgs")
importFrom("R.oo", "attachLocally")
importFrom("R.oo", "equals")
importFrom("R.oo", "getDate")
importFrom("R.oo", "getEnvironment")
importFrom("R.oo", "getKnownSubclasses")
importFrom("R.oo", "getVersion")
importFrom("R.oo", "isAbstract")
importFrom("R.oo", "isOlderThan")
importFrom("R.oo", "isVisible")
importFrom("R.oo", "ll")
importFrom("R.oo", "newInstance")
importFrom("R.oo", "objectSize")
importFrom("R.oo", "startupMessage")
importFrom("R.oo", "trim")
importFrom("R.utils", "callHooks")
importFrom("R.utils", "capitalize")
importFrom("R.utils", "capture")
importFrom("R.utils", "cat") ## Multi-sources: R.utils, base
importFrom("R.utils", "createLink")
importFrom("R.utils", "dataFrame")
importFrom("R.utils", "dimNA<-")
importFrom("R.utils", "doCall")
importFrom("R.utils", "enter")
importFrom("R.utils", "exit")
importFrom("R.utils", "extract") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "filePath")
importFrom("R.utils", "findFiles") ## Multi-sources: R.utils, affxparser
importFrom("R.utils", "getFilename") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "getLeaves")
importFrom("R.utils", "getOption") ## Multi-sources: R.utils, base
importFrom("R.utils", "getParent")
importFrom("R.utils", "getThreshold")
importFrom("R.utils", "hasOption")
importFrom("R.utils", "hpaste")
importFrom("R.utils", "hsize")
importFrom("R.utils", "increase")
importFrom("R.utils", "insert")
importFrom("R.utils", "isDirectory")
importFrom("R.utils", "isDone")
importFrom("R.utils", "isFile") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "isPackageInstalled")
importFrom("R.utils", "isPackageLoaded") ## Multi-sources: R.utils, oligoClasses
importFrom("R.utils", "isZero")
importFrom("R.utils", "less")
importFrom("R.utils", "loadObject")
importFrom("R.utils", "loadToEnv")
importFrom("R.utils", "more")
importFrom("R.utils", "moveInSearchPath")
importFrom("R.utils", "popState")
importFrom("R.utils", "popTemporaryFile")
importFrom("R.utils", "printf")
importFrom("R.utils", "pushState")
importFrom("R.utils", "pushTemporaryFile")
importFrom("R.utils", "readTable")
importFrom("R.utils", "reset")
importFrom("R.utils", "saveObject")
importFrom("R.utils", "seqToHumanReadable")
importFrom("R.utils", "setOption")
importFrom("R.utils", "stext")
importFrom("R.utils", "subplots")
importFrom("R.utils", "toAsciiRegExprPattern")
importFrom("R.utils", "toCamelCase")
importFrom("R.utils", "wrap")
importFrom("R.utils", "writeRaw")
importFrom("R.utils", "CmdArgsFunction")

## Manually adjusted
## Cannot import explicitly from 'base';
## importFrom("base", "parse") ## Multi-sources: R.utils, R.rsp, base
## importFrom("base", "readLines") ## Multi-sources: R.filesets, base
## importFrom("base", "gc") ## Multi-sources: R.oo, base
## importFrom("base", "warnings") ## Multi-sources: R.utils, base

## Importing other objects
importFrom("aroma.core", "aromaSettings")

## Manual imports
importFrom("R.utils", "Arguments")
importFrom("R.filesets", "append")

importFrom("grDevices",
           "boxplot.stats", "col2rgb", "gray.colors", "rainbow")

importFrom("graphics",
           "abline", "axis", "box", "bxp", "image", "layout", "lines",
           "mtext", "par", "plot", "points", "smoothScatter", "text")

importFrom("methods", "as")

importFrom("stats",
           "approx", "coef", "coefficients", "density",
           "dnorm", "glm", "lm", "lowess", "mad", "median",
           "medpolish", "na.omit", "predict", "quantile", "residuals",
           "rnorm", "sd", "smooth.spline", "t.test", "var")

importFrom("utils",
           "capture.output", "compareVersion", "data", "head",
           "object.size", "packageDescription", "packageVersion",
           "read.table", "str", "tail", "write.table")

importFrom("listenv", "listenv")
importFrom("future", "%<-%")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Several packages are only optional or suggested for now, so
# we cannot assume they are available for import.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (FALSE) {
  importFrom("aroma.light", "calibrateMultiscan")
  importFrom("aroma.light", "normalizeFragmentLength")
  importFrom("aroma.light", "normalizeQuantileSpline")
  importFrom("aroma.light", "robustSmoothSpline")

  importFrom("Biobase", "annotation") ## Multi-sources: Biobase, oligo, oligoClasses
  importFrom("Biobase", "annotation<-")
  importFrom("Biobase", "assayData")
  importFrom("Biobase", "featureNames<-")
  importFrom("Biobase", "phenoData<-")
  importFrom("Biobase", "sampleNames<-") ## Multi-sources: Biobase, oligoClasses

  importFrom("affxparser", "applyCdfGroups")
  importFrom("affxparser", "cdfHeaderToCelHeader")
  importFrom("affxparser", "cdfMergeAlleles")
  importFrom("affxparser", "compareCdfs")
  importFrom("affxparser", "convertCdf")
  importFrom("affxparser", "convertCel")
  importFrom("affxparser", "createCel")
  importFrom("affxparser", "findCdf")
  importFrom("affxparser", "invertMap")
  importFrom("affxparser", "readBpmap")
  importFrom("affxparser", "readBpmapHeader")
  importFrom("affxparser", "readCcg")
  importFrom("affxparser", "readCcgHeader")
  importFrom("affxparser", "readCdf")
  importFrom("affxparser", "readCdfCellIndices")
  importFrom("affxparser", "readCdfGroupNames")
  importFrom("affxparser", "readCdfHeader")
  importFrom("affxparser", "readCdfIsPm")
  importFrom("affxparser", "readCdfNbrOfCellsPerUnitGroup")
  importFrom("affxparser", "readCdfQc")
  importFrom("affxparser", "readCdfUnitNames")
  importFrom("affxparser", "readCdfUnits")
  importFrom("affxparser", "readCel")
  importFrom("affxparser", "readCelHeader")
  importFrom("affxparser", "readCelRectangle")
  importFrom("affxparser", "readCelUnits")
  importFrom("affxparser", "readPgfEnv")
  importFrom("affxparser", "readPgfHeader")
  importFrom("affxparser", "updateCel")
  importFrom("affxparser", "updateCelUnits")
  importFrom("affxparser", "writeCdfHeader")
  importFrom("affxparser", "writeCdfQcUnits")
  importFrom("affxparser", "writeCdfUnits")

  importFrom("affy", "bg.adjust")
  importFrom("affy", "cleancdfname")
  importFrom("affy", "close") ## Multi-sources: affy, oligoClasses, base
  importFrom("affy", "featureNames") ## Multi-sources: affy, Biobase
  importFrom("affy", "fit.li.wong")
  importFrom("affy", "image") ## Multi-sources: affy, oligo

  importFrom("affyPLM", "summary") ## Multi-sources: affyPLM, DBI, base

  importFrom("oligo", "cleanPlatformName")
  importFrom("oligo", "coef")
  importFrom("oligo", "db") ## Multi-sources: oligo, oligoClasses
  importFrom("oligo", "geometry") ## Multi-sources: oligo, oligoClasses
  importFrom("oligo", "getPlatformDesign")
  importFrom("oligo", "ncol") ## Multi-sources: oligo, base
  importFrom("oligo", "read.celfiles")
  importFrom("oligo", "residuals")

  importFrom("oligoClasses", "getM")
  importFrom("oligoClasses", "mean") ## Multi-sources: oligoClasses, base

  importFrom("DBI", "dbGetQuery")
  importFrom("DBI", "dbListTables")
} # if (FALSE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# EXPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export all public methods, that is, those without a preceeding dot
# in their names.
exportPattern("^[^\\.]")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# DECLARATIONS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
S3method("doASCRMAv1", "default")
S3method("doASCRMAv2", "default")
S3method("doCRMAv1", "default")
S3method("doCRMAv2", "default")
S3method("doFIRMA", "default")
S3method("doGCRMA", "default")
S3method("doRMA", "default")

S3method("doCRMAv1", "AffymetrixCelSet")
S3method("doCRMAv2", "AffymetrixCelSet")
S3method("doFIRMA", "AffymetrixCelSet")
S3method("doGCRMA", "AffymetrixCelSet")
S3method("doRMA", "AffymetrixCelSet")

S3method("justRMA", "AffymetrixCelSet")


S3method("addColorMap", "ArrayExplorer")
S3method("addColorMap", "SpatialReporter")
S3method("addExclCells", "DChipQuantileNormalization")
S3method("allocate", "AromaCellMatchScoreFile")
S3method("allocate", "CrlmmParametersFile")
S3method("allocateFromCdf", "AffymetrixCelFile")
S3method("allocateFromCdf", "AromaCellCpgFile")
S3method("allocateFromCdf", "AromaCellMatchScoreFile")
S3method("allocateFromCdf", "AromaCellPositionFile")
S3method("allocateFromCdf", "AromaCellSequenceFile")
S3method("allocateFromCdf", "AromaUfcFile")
S3method("allocateFromCdf", "AromaUflFile")
S3method("allocateFromCdf", "AromaUnitGcContentFile")
S3method("allocateFromCdf", "AromaUnitTabularBinaryFile")
S3method("annotateMvsA", "AffymetrixCelFile")
S3method("append", "AffymetrixCelSet")
S3method("append", "CnagCfhSet")
S3method("applyAnyOrder", "CopyNumberChromosomalModel")
S3method("applyCCF0", "CopyNumberChromosomalModel")
S3method("applyCFC0", "CopyNumberChromosomalModel")
S3method("applyToUnitIntensities", "AffymetrixCelSet")
S3method("as.AffymetrixCelSet", "AffymetrixCelSet")
S3method("as.AffymetrixCelSet", "default")
S3method("as.AffymetrixCelSet", "list")
S3method("as.AffymetrixCnChpSet", "AffymetrixCnChpSet")
S3method("as.AffymetrixCnChpSet", "default")
S3method("as.AffymetrixCnChpSet", "list")
S3method("as.AffymetrixFileSet", "AffymetrixFileSet")
S3method("as.AffymetrixFileSet", "default")
S3method("as.AffymetrixFileSet", "list")
S3method("as.ChipEffectSetTuple", "ChipEffectSetTuple")
S3method("as.ChipEffectSetTuple", "default")
S3method("as.CnChipEffectSetTuple", "CnChipEffectSetTuple")
S3method("as.CnChipEffectSetTuple", "default")
S3method("as.CnagCfhSet", "CnagCfhSet")
S3method("as.CnagCfhSet", "default")
S3method("as.CnagCfhSet", "list")
S3method("as.CopyNumberDataSetTuple", "CnChipEffectSet")
S3method("as.DChipDcpSet", "DChipDcpSet")
S3method("as.DChipDcpSet", "default")
S3method("as.DChipDcpSet", "list")
S3method("as.character", "AffymetrixCdfFile")
S3method("as.character", "AffymetrixCelFile")
S3method("as.character", "AffymetrixCelSet")
S3method("as.character", "AffymetrixCelSetReporter")
S3method("as.character", "AffymetrixCnChpFile")
S3method("as.character", "AffymetrixCnChpSet")
S3method("as.character", "AffymetrixPgfFile")
S3method("as.character", "AffymetrixProbeTabFile")
S3method("as.character", "AromaChipTypeAnnotationFile")
S3method("as.character", "ArrayExplorer")
S3method("as.character", "ChipEffectFile")
S3method("as.character", "ChipEffectSet")
S3method("as.character", "CnagCfhFile")
S3method("as.character", "CnagCfhSet")
S3method("as.character", "DChipCdfBinFile")
S3method("as.character", "DChipDcpFile")
S3method("as.character", "DChipDcpSet")
S3method("as.character", "DChipQuantileNormalization")
S3method("as.character", "FirmaModel")
S3method("as.character", "GenericReporter")
S3method("as.character", "GenomeInformation")
S3method("as.character", "Model")
S3method("as.character", "ProbeAffinityFile")
S3method("as.character", "QualityAssessmentModel")
S3method("as.character", "ResidualFile")
S3method("as.character", "ResidualSet")
S3method("as.character", "SmoothMultiarrayModel")
S3method("as.character", "SnpInformation")
S3method("as.character", "SpatialReporter")
S3method("as.character", "TransformReport")
S3method("as.character", "WeightsFile")
S3method("as.character", "WeightsSet")
S3method("assertAnnotationData", "ASCRMAv2")
S3method("averageQuantile", "AffymetrixCelSet")
S3method("boxplotStats", "ChipEffectSet")
S3method("bpmapCluster2Cdf", "default")
S3method("byChipType", "AffymetrixCsvGenomeInformation")
S3method("byChipType", "AffymetrixProbeTabFile")
S3method("byChipType", "AffymetrixTabularFile")
S3method("byChipType", "AffymetrixTsvFile")
S3method("byChipType", "AromaCellMatchScoreFile")
S3method("byChipType", "AromaChipTypeAnnotationFile")
S3method("byChipType", "DChipCdfBinFile")
S3method("byChipType", "DChipGenomeInformation")
S3method("byChipType", "DChipSnpInformation")
S3method("byChipType", "GenomeInformation")
S3method("byChipType", "SnpInformation")
S3method("byChipType", "UflSnpInformation")
S3method("byChipType", "UgpGenomeInformation")
S3method("byName", "AffymetrixCelSet")
S3method("byName", "AffymetrixCnChpSet")
S3method("byName", "AromaChipTypeAnnotationFile")
S3method("byName", "CnagCfhSet")
S3method("byName", "CrlmmParametersSet")
S3method("byName", "DChipDcpSet")
S3method("byPath", "AffymetrixCelSet")
S3method("byPath", "AffymetrixCelSetTuple")
S3method("byPath", "AffymetrixCnChpSet")
S3method("byPath", "AffymetrixFileSet")
S3method("byPath", "ChipEffectSet")
S3method("byPath", "CnChipEffectSet")
S3method("byPath", "CnagCfhSet")
S3method("byPath", "CrlmmParametersSet")
S3method("byPath", "DChipDcpSet")
S3method("byPath", "ExonChipEffectSet")
S3method("byPath", "FirmaSet")
S3method("byPath", "ResidualSet")
S3method("byPath", "SnpChipEffectSet")
S3method("byPath", "WeightsSet")
S3method("calcRawCnStats", "CopyNumberChromosomalModel")
S3method("calcRawCnStats", "default")
S3method("calculateAffinities", "GcRmaBackgroundCorrection")
S3method("calculateAverages", "FragmentEquivalentClassNormalization")
S3method("calculateBaseline", "ChipEffectSet")
S3method("calculateConfidenceScores", "CrlmmModel")
S3method("calculateFieldBoxplotStats", "ChipEffectSet")
S3method("calculateMargins", "SpatialReporter")
S3method("calculateNuseBoxplotStats", "ChipEffectSet")
S3method("calculateParametersGsb", "AffymetrixCelSet")
S3method("calculateResidualSet", "FirmaModel")
S3method("calculateResidualSet", "ProbeLevelModel")
S3method("calculateRleBoxplotStats", "ChipEffectSet")
S3method("calculateTargetDistribution", "QuantileNormalization")
S3method("calculateWeights", "ExonRmaPlm")
S3method("calculateWeights", "FirmaModel")
S3method("calculateWeights", "ProbeLevelModel")
S3method("calibrateOne", "ReseqCrosstalkCalibration")
S3method("clearCache", "AffymetrixCelSet")
S3method("clearData", "AffymetrixCelFile")
S3method("clone", "AffymetrixCelFile")
S3method("clone", "AffymetrixCelSet")
S3method("clone", "AffymetrixCnChpFile")
S3method("clone", "CnagCfhFile")
S3method("clone", "CnagCfhSet")
S3method("compare", "AffymetrixCdfFile")
S3method("computeAffinities", "AffymetrixCdfFile")
S3method("computeAffinitiesByACS", "AffymetrixCdfFile")
S3method("convert", "AffymetrixCdfFile")
S3method("convertToUnique", "AffymetrixCelSet")
S3method("convertUnits", "AffymetrixCdfFile")
S3method("createExonByTranscriptCdf", "AffymetrixCdfFile")
S3method("createFrom", "AffymetrixCelFile")
S3method("createMonocellCdf", "AffymetrixCdfFile")
S3method("createOutputTuple", "SmoothMultiarrayModel")
S3method("createParamCdf", "ChipEffectFile")
S3method("createParamCdf", "FirmaFile")
S3method("createUniqueCdf", "AffymetrixCdfFile")
S3method("decode", "ParameterCelFile")
S3method("dim", "DChipDcpFile")
S3method("encode", "ParameterCelFile")
S3method("excludeChrXFromFit", "DChipQuantileNormalization")
S3method("exportAromaSignalBinaryFileList", "CnChipEffectFile")
S3method("exportTotalAndFracB", "CnChipEffectFile")
S3method("exportTotalAndFracB", "CnChipEffectSet")
S3method("exportTotalAndFracB", "DChipDcpSet")
S3method("exportTotalAndFracB", "SnpChipEffectFile")
S3method("exportTotalAndFracB", "SnpChipEffectSet")
S3method("exportTotalCnRatioSet", "AffymetrixCnChpSet")
S3method("extractAffyBatch", "AffymetrixCelSet")
S3method("extractAffyBatch", "ChipEffectSet")
S3method("extractAlleleSet", "SnpChipEffectSet")
S3method("extractCNT", "SnpChipEffectFile")
S3method("extractCNT", "SnpChipEffectSet")
S3method("extractChromosomalDataFrame", "ChipEffectFile")
S3method("extractChromosomalDataFrame", "ChipEffectSet")
S3method("extractDataFrame", "ParameterCelFile")
S3method("extractDataFrame", "ParameterCelSet")
S3method("extractExpressionSet", "ChipEffectSet")
S3method("extractFeatureSet", "AffymetrixCelSet")
S3method("extractLogRatios", "AffymetrixCnChpFile")
S3method("extractLogRatios", "AffymetrixCnChpSet")
S3method("extractMatrix", "AffymetrixCelFile")
S3method("extractMatrix", "AffymetrixCelSet")
S3method("extractMatrix", "ChipEffectFile")
S3method("extractMatrix", "ChipEffectSet")
S3method("extractMatrix", "FirmaFile")
S3method("extractMatrix", "FirmaSet")
S3method("extractMatrix", "ParameterCelFile")
S3method("extractMatrix", "ParameterCelSet")
S3method("extractSnpCnvQSet", "SnpChipEffectSet")
S3method("extractSnpFeatureSet", "AffymetrixCelSet")
S3method("extractSnpQSet", "SnpChipEffectSet")
S3method("extractTheta", "ChipEffectFile")
S3method("extractTheta", "ChipEffectSet")
S3method("extractTheta", "CnChipEffectFile")
S3method("extractTheta", "CnChipEffectSet")
S3method("extractTheta", "DChipDcpFile")
S3method("extractTheta", "DChipDcpSet")
S3method("extractTheta", "SnpChipEffectFile")
S3method("extractTheta", "SnpChipEffectSet")
S3method("extractTheta", "SnpCnvQSet")
S3method("extractTheta", "SnpQSet")
S3method("extractTotalAndFracB", "SnpChipEffectFile")
S3method("extractTotalAndFreqB", "CnChipEffectFile")
S3method("extractTotalAndFreqB", "CnChipEffectSet")
S3method("extractTotalAndFreqB", "SnpChipEffectSet")
S3method("extractTotalAndFreqB", "default")
S3method("findByCdf2", "default")
S3method("findByChipType", "AffymetrixCdfFile")
S3method("findByChipType", "AffymetrixCsvFile")
S3method("findByChipType", "AffymetrixCsvGenomeInformation")
S3method("findByChipType", "AffymetrixNetAffxCsvFile")
S3method("findByChipType", "AffymetrixPgfFile")
S3method("findByChipType", "AffymetrixProbeTabFile")
S3method("findByChipType", "AffymetrixTabularFile")
S3method("findByChipType", "AffymetrixTsvFile")
S3method("findByChipType", "AromaChipTypeAnnotationFile")
S3method("findByChipType", "DChipCdfBinFile")
S3method("findByChipType", "DChipGenomeInformation")
S3method("findByChipType", "DChipSnpInformation")
S3method("findByChipType", "UflSnpInformation")
S3method("findByChipType", "UgpGenomeInformation")
S3method("findByName", "AffymetrixCelSet")
S3method("findByName", "AffymetrixCnChpSet")
S3method("findByName", "ChipEffectSet")
S3method("findByName", "CnagCfhSet")
S3method("findByName", "DChipDcpSet")
S3method("findTargetDistributionFile", "QuantileNormalization")
S3method("findUnitsTodo", "AlleleSummation")
S3method("findUnitsTodo", "ChipEffectFile")
S3method("findUnitsTodo", "ChipEffectSet")
S3method("findUnitsTodo", "CrlmmModel")
S3method("findUnitsTodo", "CrlmmParametersFile")
S3method("findUnitsTodo", "CrlmmParametersSet")
S3method("findUnitsTodo", "ExonChipEffectSet")
S3method("findUnitsTodo", "FirmaFile")
S3method("findUnitsTodo", "FirmaModel")
S3method("findUnitsTodo", "FirmaSet")
S3method("findUnitsTodo", "ProbeLevelModel")
S3method("findUnitsTodo", "QualityAssessmentFile")
S3method("findUnitsTodo", "ResidualFile")
S3method("findUnitsTodo", "ResidualSet")
S3method("findUnitsTodo", "UnitModel")
S3method("findUnitsTodo", "WeightsFile")
S3method("findUnitsTodo", "WeightsSet")
S3method("fit", "CrlmmModel")
S3method("fit", "FirmaModel")
S3method("fit", "Model")
S3method("fit", "ProbeLevelModel")
S3method("fit", "SingleArrayUnitModel")
S3method("fit", "SmoothMultiarrayModel")
S3method("fitCnProbes", "UnitModel")
S3method("fitOne", "AbstractProbeSequenceNormalization")
S3method("fitOne", "BaseCountNormalization")
S3method("fitOne", "LinearModelProbeSequenceNormalization")
S3method("fitOne", "MatNormalization")
S3method("fitOne", "ReseqCrosstalkCalibration")
S3method("fitOne", "ScaleNormalization3")
S3method("fitOne", "UnitTypeScaleNormalization")
S3method("fitOneArray", "SingleArrayUnitModel")
S3method("fitOneChromosome", "SmoothMultiarrayModel")
S3method("fitPlasqUnit", "matrix")
S3method("fitQuantileNormFcn", "AffymetrixCelFile")
S3method("fixSearchPath", "AromaAffymetrix")
S3method("fromCdf", "AffymetrixProbeTabFile")
S3method("fromCdf", "GenomeInformation")
S3method("fromCdf", "SnpInformation")
S3method("fromDataFile", "ChipEffectFile")
S3method("fromDataFile", "FirmaFile")
S3method("fromDataFile", "ResidualFile")
S3method("fromDataFile", "WeightsFile")
S3method("fromDataSet", "ChipEffectSet")
S3method("fromDataSet", "FirmaSet")
S3method("fromDataSet", "GenomeInformation")
S3method("fromDataSet", "ResidualSet")
S3method("fromDataSet", "SnpInformation")
S3method("fromDataSet", "WeightsSet")
S3method("fromFile", "AffymetrixCdfFile")
S3method("fromFile", "AffymetrixCelFile")
S3method("fromFile", "AffymetrixCnChpFile")
S3method("fromFile", "AffymetrixPgfFile")
S3method("fromFile", "AromaChipTypeAnnotationFile")
S3method("fromFile", "CnagCfhFile")
S3method("fromFile", "DChipCdfBinFile")
S3method("fromFile", "DChipDcpFile")
S3method("getACSFile", "AffymetrixCdfFile")
S3method("getAM", "ChipEffectFile")
S3method("getAM", "ChipEffectSet")
S3method("getAlias", "ArrayExplorer")
S3method("getAlias", "GenericReporter")
S3method("getAlias", "Model")
S3method("getAlias", "TransformReport")
S3method("getAlleleCellPairs", "AffymetrixCdfFile")
S3method("getAlleleProbePairs", "AffymetrixCdfFile")
S3method("getAlleleProbePairs2", "AffymetrixCdfFile")
S3method("getAlleleProbePairs3", "AffymetrixCdfFile")
S3method("getAm", "AffymetrixCelFile")
S3method("getAromaCellMatchScoreFile", "MatNormalization")
S3method("getAromaCellPositionFile", "MatSmoothing")
S3method("getAromaCellSequenceFile", "AbstractProbeSequenceNormalization")
S3method("getAromaCellSequenceFile", "AffymetrixCdfFile")
S3method("getAromaUfcFile", "FragmentEquivalentClassNormalization")
S3method("getAromaUflFile", "UflSnpInformation")
S3method("getAromaUgpFile", "UgpGenomeInformation")
S3method("getAromaUnitFracBCnBinarySet", "default")
S3method("getAromaUnitTotalCnBinarySet", "default")
S3method("getArrayNames", "AffymetrixAptSummaryFile")
S3method("getArraysOfInput", "ArrayExplorer")
S3method("getAsFullCelFile", "ChipEffectFile")
S3method("getAsFullCelSet", "ChipEffectSet")
S3method("getAsteriskTags", "AdditiveCovariatesNormalization")
S3method("getAsteriskTags", "AffineCnPlm")
S3method("getAsteriskTags", "AffinePlm")
S3method("getAsteriskTags", "AffineSnpPlm")
S3method("getAsteriskTags", "AlleleSummation")
S3method("getAsteriskTags", "AllelicCrosstalkCalibration")
S3method("getAsteriskTags", "ArrayExplorer")
S3method("getAsteriskTags", "AvgCnPlm")
S3method("getAsteriskTags", "AvgPlm")
S3method("getAsteriskTags", "AvgSnpPlm")
S3method("getAsteriskTags", "BaseCountNormalization")
S3method("getAsteriskTags", "BasePositionNormalization")
S3method("getAsteriskTags", "CrlmmModel")
S3method("getAsteriskTags", "ExonRmaPlm")
S3method("getAsteriskTags", "FirmaModel")
S3method("getAsteriskTags", "FragmentEquivalentClassNormalization")
S3method("getAsteriskTags", "FragmentLengthNormalization")
S3method("getAsteriskTags", "GenericReporter")
S3method("getAsteriskTags", "HetLogAddCnPlm")
S3method("getAsteriskTags", "HetLogAddPlm")
S3method("getAsteriskTags", "HetLogAddSnpPlm")
S3method("getAsteriskTags", "LimmaBackgroundCorrection")
S3method("getAsteriskTags", "MatNormalization")
S3method("getAsteriskTags", "MbeiCnPlm")
S3method("getAsteriskTags", "MbeiPlm")
S3method("getAsteriskTags", "MbeiSnpPlm")
S3method("getAsteriskTags", "Model")
S3method("getAsteriskTags", "NormExpBackgroundCorrection")
S3method("getAsteriskTags", "ProbeLevelModel")
S3method("getAsteriskTags", "ProbeLevelTransform3")
S3method("getAsteriskTags", "QualityAssessmentModel")
S3method("getAsteriskTags", "ReseqCrosstalkCalibration")
S3method("getAsteriskTags", "RmaCnPlm")
S3method("getAsteriskTags", "RmaPlm")
S3method("getAsteriskTags", "RmaSnpPlm")
S3method("getAsteriskTags", "ScaleNormalization")
S3method("getAsteriskTags", "SmoothMultiarrayModel")
S3method("getAsteriskTags", "SmoothRmaModel")
S3method("getAsteriskTags", "SmoothSaModel")
S3method("getAsteriskTags", "SnpChipEffectGroupMerge")
S3method("getAsteriskTags", "UnitModel")
S3method("getAverage", "AffymetrixCelSet")
S3method("getAverage", "CnagCfhSet")
S3method("getAverageAsinh", "AffymetrixCelSet")
S3method("getAverageAsinh", "CnagCfhSet")
S3method("getAverageFile", "AffymetrixCelSet")
S3method("getAverageFile", "ChipEffectSet")
S3method("getAverageFile", "CnChipEffectSet")
S3method("getAverageFile", "CnagCfhSet")
S3method("getAverageFile", "ExonChipEffectSet")
S3method("getAverageFile", "ResidualSet")
S3method("getAverageFile", "SnpChipEffectSet")
S3method("getAverageFile", "WeightsSet")
S3method("getAverageLog", "AffymetrixCelSet")
S3method("getAverageLog", "CnagCfhSet")
S3method("getBandwidth", "SmoothMultiarrayModel")
S3method("getBaseline", "ChipEffectSet")
S3method("getBaseline", "CnChipEffectSet")
S3method("getBaseline", "SnpChipEffectSet")
S3method("getBlockSizes", "SpatialRowColumnNormalization")
S3method("getCalculateResidualsFunction", "AvgPlm")
S3method("getCalculateResidualsFunction", "ProbeLevelModel")
S3method("getCalculateResidualsFunction", "RmaPlm")
S3method("getCallSet", "CrlmmModel")
S3method("getCalls", "DChipDcpFile")
S3method("getCdf", "AdditiveCovariatesNormalization")
S3method("getCdf", "AffymetrixCelFile")
S3method("getCdf", "AffymetrixCelSet")
S3method("getCdf", "AffymetrixCnChpFile")
S3method("getCdf", "AffymetrixCnChpSet")
S3method("getCdf", "AffymetrixProbeTabFile")
S3method("getCdf", "AffymetrixTsvFile")
S3method("getCdf", "AromaUnitTabularBinaryFile")
S3method("getCdf", "ChipEffectGroupMerge")
S3method("getCdf", "CnagCfhFile")
S3method("getCdf", "CnagCfhSet")
S3method("getCdf", "FirmaModel")
S3method("getCdf", "FragmentEquivalentClassNormalization")
S3method("getCdf", "FragmentLengthNormalization")
S3method("getCdf", "GcContentNormalization")
S3method("getCdf", "Model")
S3method("getCdf", "QualityAssessmentModel")
S3method("getCdf", "TransformReport")
S3method("getCdfBin", "DChipDcpSet")
S3method("getCellDim", "DChipCdfBinFile")
S3method("getCellIndices", "AffymetrixCdfFile")
S3method("getCellIndices", "ChipEffectFile")
S3method("getCellIndices", "ChipEffectSet")
S3method("getCellIndices", "CnChipEffectFile")
S3method("getCellIndices", "CnPlm")
S3method("getCellIndices", "CnProbeAffinityFile")
S3method("getCellIndices", "ExonChipEffectFile")
S3method("getCellIndices", "ExonProbeAffinityFile")
S3method("getCellIndices", "ExonRmaPlm")
S3method("getCellIndices", "FirmaFile")
S3method("getCellIndices", "FirmaSet")
S3method("getCellIndices", "ProbeAffinityFile")
S3method("getCellIndices", "ResidualFile")
S3method("getCellIndices", "ResidualSet")
S3method("getCellIndices", "SnpChipEffectFile")
S3method("getCellIndices", "SnpPlm")
S3method("getCellIndices", "SnpProbeAffinityFile")
S3method("getCellIndices", "UnitModel")
S3method("getCellIndices", "WeightsFile")
S3method("getCellIndices", "WeightsSet")
S3method("getCellMapForMainCdf", "ChipEffectFile")
S3method("getCellQuartets", "AffymetrixCdfFile")
S3method("getCellsTo", "ProbeLevelTransform3")
S3method("getCellsToFit", "ProbeLevelTransform3")
S3method("getCellsToInternal", "ProbeLevelTransform3")
S3method("getCellsToUpdate", "ProbeLevelTransform3")
S3method("getChipEffectFileClass", "ChipEffectSet")
S3method("getChipEffectFileClass", "CnChipEffectSet")
S3method("getChipEffectFileClass", "ExonChipEffectSet")
S3method("getChipEffectFileClass", "SnpChipEffectSet")
S3method("getChipEffectSet", "AlleleSummation")
S3method("getChipEffectSet", "CnPlm")
S3method("getChipEffectSet", "ExonRmaPlm")
S3method("getChipEffectSet", "ProbeLevelModel")
S3method("getChipEffectSet", "QualityAssessmentModel")
S3method("getChipEffectSet", "SnpPlm")
S3method("getChipEffectSetClass", "AlleleSummation")
S3method("getChipEffectSetClass", "CnPlm")
S3method("getChipEffectSetClass", "ExonRmaPlm")
S3method("getChipEffectSetClass", "ProbeLevelModel")
S3method("getChipEffectSetClass", "SnpPlm")
S3method("getChipType", "AffymetrixAptSummaryFile")
S3method("getChipType", "AffymetrixCdfFile")
S3method("getChipType", "AffymetrixCelFile")
S3method("getChipType", "AffymetrixCelSet")
S3method("getChipType", "AffymetrixCelSetReporter")
S3method("getChipType", "AffymetrixCnChpFile")
S3method("getChipType", "AffymetrixPgfFile")
S3method("getChipType", "AffymetrixProbeTabFile")
S3method("getChipType", "AffymetrixTsvFile")
S3method("getChipType", "AromaChipTypeAnnotationFile")
S3method("getChipType", "CnagCfhFile")
S3method("getChipType", "CrlmmModel")
S3method("getChipType", "DChipCdfBinFile")
S3method("getChipType", "DChipDcpSet")
S3method("getChipType", "GenomeInformation")
S3method("getChipType", "SnpInformation")
S3method("getChipType", "UflSnpInformation")
S3method("getChipType", "UgpGenomeInformation")
S3method("getChromosomeStats", "GenomeInformation")
S3method("getChromosomes", "GenomeInformation")
S3method("getChromosomes", "UgpGenomeInformation")
S3method("getCnNames", "AffymetrixCdfFile")
S3method("getColorMaps", "ArrayExplorer")
S3method("getColorMaps", "SpatialReporter")
S3method("getColumnNames", "AffymetrixProbeTabFile")
S3method("getCombineAlleles", "CnChipEffectSet")
S3method("getCombineAlleles", "CnPlm")
S3method("getConfidenceScoreSet", "CrlmmModel")
S3method("getCovariates", "AdditiveCovariatesNormalization")
S3method("getCovariates", "GcContentNormalization2")
S3method("getCrlmmParametersSet", "CrlmmModel")
S3method("getCrlmmPriors", "CrlmmModel")
S3method("getCrlmmSNPs", "CrlmmModel")
S3method("getCrlmmSNPsOnChrX", "CrlmmModel")
S3method("getCrlmmSplineParameters", "CrlmmModel")
S3method("getData", "AffymetrixCelFile")
S3method("getData", "AffymetrixCelSet")
S3method("getData", "AffymetrixCnChpFile")
S3method("getData", "AffymetrixProbeTabFile")
S3method("getData", "AffymetrixTsvFile")
S3method("getData", "CnagCfhSet")
S3method("getData", "GenomeInformation")
S3method("getData", "SnpInformation")
S3method("getData", "UflSnpInformation")
S3method("getData", "UgpGenomeInformation")
S3method("getDataColumns", "GenomeInformation")
S3method("getDataColumns", "UflSnpInformation")
S3method("getDataColumns", "UgpGenomeInformation")
S3method("getDataFlat", "ChipEffectFile")
S3method("getDataFlat", "FirmaFile")
S3method("getDataFlat", "ResidualFile")
S3method("getDataFlat", "WeightsFile")
S3method("getDataPairs", "AllelicCrosstalkCalibration")
S3method("getDataSet", "AffymetrixCelSetReporter")
S3method("getDataSet", "ArrayExplorer")
S3method("getDataSet", "FirmaModel")
S3method("getDataSet", "Model")
S3method("getDataSet", "QualityAssessmentModel")
S3method("getDefaultColumnNames", "AromaCellMatchScoreFile")
S3method("getDefaultColumnNames", "AromaUfcFile")
S3method("getDefaultExtension", "AffymetrixCdfFile")
S3method("getDefaultExtension", "AffymetrixCsvFile")
S3method("getDefaultExtension", "AffymetrixCsvGenomeInformation")
S3method("getDefaultExtension", "AffymetrixNetAffxCsvFile")
S3method("getDefaultExtension", "AffymetrixPgfFile")
S3method("getDefaultExtension", "AffymetrixTsvFile")
S3method("getDefaultExtension", "AromaCellMatchScoreFile")
S3method("getDefaultExtension", "AromaChipTypeAnnotationFile")
S3method("getDefaultFullName", "AffymetrixFileSet")
S3method("getDefaultFullName", "CnagCfhSet")
S3method("getDefaultSettings", "AromaAffymetrix")
S3method("getDefaultSettings", "Package")
S3method("getDesignMatrix", "BaseCountNormalization")
S3method("getDesignMatrix", "BasePositionNormalization")
S3method("getDesignMatrix", "LinearModelProbeSequenceNormalization")
S3method("getDesignMatrix", "MatNormalization")
S3method("getDimension", "AffymetrixCdfFile")
S3method("getDimension", "AffymetrixPgfFile")
S3method("getExclCells", "DChipQuantileNormalization")
S3method("getExclCells", "QuantileNormalization")
S3method("getExcludes", "DChipDcpFile")
S3method("getExclusiveUnitSubsets", "FragmentEquivalentClassNormalization")
S3method("getExpandedCellMap", "ChipEffectFile")
S3method("getExpandedCellMap", "CnChipEffectFile")
S3method("getExpandedCellMap", "SnpChipEffectFile")
S3method("getExpectedOutputFullnames", "MatSmoothing")
S3method("getExtensionPattern", "AffymetrixCdfFile")
S3method("getExtensionPattern", "AffymetrixCelFile")
S3method("getExtensionPattern", "AffymetrixCnChpFile")
S3method("getExtensionPattern", "AffymetrixCsvFile")
S3method("getExtensionPattern", "AffymetrixPgfFile")
S3method("getExtensionPattern", "AffymetrixTsvFile")
S3method("getExtensionPattern", "AromaCellMatchScoreFile")
S3method("getExtensionPattern", "AromaUfcFile")
S3method("getExtensionPattern", "CnagCfhFile")
S3method("getExtensionPattern", "DChipDcpFile")
S3method("getField", "AffymetrixTsvFile")
S3method("getFields", "SnpInformation")
S3method("getFields", "UflSnpInformation")
S3method("getFileClass", "FirmaSet")
S3method("getFileFormat", "AffymetrixCdfFile")
S3method("getFileFormat", "AffymetrixCelFile")
S3method("getFileFormat", "AffymetrixCnChpFile")
S3method("getFileFormat", "DChipCdfBinFile")
S3method("getFileFormat", "DChipDcpFile")
S3method("getFileSet", "AffymetrixFileSetReporter")
S3method("getFileSetClass", "FirmaModel")
S3method("getFilenameExtension", "AromaCellMatchScoreFile")
S3method("getFilenameExtension", "AromaUfcFile")
S3method("getFilteredFragmentLengths", "FragmentLengthNormalization")
S3method("getFirmaScores", "FirmaModel")
S3method("getFirmaSet", "FirmaModel")
S3method("getFirstCellIndices", "AffymetrixCdfFile")
S3method("getFirstCellPerUnitIndices", "ExonChipEffectSet")
S3method("getFit", "BasePositionNormalization")
S3method("getFitSingleCellUnitFunction", "UnitModel")
S3method("getFitUnitFunction", "CnPlm")
S3method("getFitUnitFunction", "FirmaModel")
S3method("getFitUnitFunction", "MultiArrayUnitModel")
S3method("getFitUnitFunction", "SingleArrayUnitModel")
S3method("getFitUnitFunction", "UnitModel")
S3method("getFitUnitGroupFunction", "AffinePlm")
S3method("getFitUnitGroupFunction", "AvgPlm")
S3method("getFitUnitGroupFunction", "ExonRmaPlm")
S3method("getFitUnitGroupFunction", "FirmaModel")
S3method("getFitUnitGroupFunction", "HetLogAddPlm")
S3method("getFitUnitGroupFunction", "MbeiPlm")
S3method("getFitUnitGroupFunction", "MultiArrayUnitModel")
S3method("getFitUnitGroupFunction", "RmaPlm")
S3method("getFitUnitGroupFunction", "SingleArrayUnitModel")
S3method("getFitUnitGroupFunction", "SmoothMultiarrayModel")
S3method("getFitUnitGroupFunction", "SmoothRmaModel")
S3method("getFitUnitGroupFunction", "SmoothSaModel")
S3method("getFragmentLengths", "AffymetrixTsvFile")
S3method("getFragmentLengths", "SnpInformation")
S3method("getFragmentLengths", "UflSnpInformation")
S3method("getFragmentStarts", "SnpInformation")
S3method("getFragmentStarts", "UflSnpInformation")
S3method("getFragmentStops", "SnpInformation")
S3method("getFragmentStops", "UflSnpInformation")
S3method("getFullName", "GenericReporter")
S3method("getFullName", "Model")
S3method("getFullName", "QualityAssessmentModel")
S3method("getFullName", "TransformReport")
S3method("getFullNames", "ChipEffectSetTuple")
S3method("getGc", "AffymetrixTsvFile")
S3method("getGcContent", "GcContentNormalization")
S3method("getGenomeBuild", "AffymetrixNetAffxCsvFile")
S3method("getGenomeInformation", "AffymetrixCdfFile")
S3method("getGroupDirections", "AffymetrixCdfFile")
S3method("getHeader", "AffymetrixCdfFile")
S3method("getHeader", "AffymetrixCelFile")
S3method("getHeader", "AffymetrixCnChpFile")
S3method("getHeader", "AffymetrixPgfFile")
S3method("getHeader", "AromaChipTypeAnnotationFile")
S3method("getHeader", "CnagCfhFile")
S3method("getHeader", "DChipCdfBinFile")
S3method("getHeader", "DChipDcpFile")
S3method("getHeaderAttributes", "AffymetrixNetAffxCsvFile")
S3method("getHeaderLength", "CnagCfhFile")
S3method("getHeaderV3", "AffymetrixCelFile")
S3method("getIdentifier", "AffymetrixCelFile")
S3method("getIdentifier", "AffymetrixCelSet")
S3method("getIdentifier", "AffymetrixFileSet")
S3method("getIdentifier", "CnagCfhFile")
S3method("getIdentifier", "CnagCfhSet")
S3method("getImage", "AffymetrixCdfFile")
S3method("getImage", "AffymetrixCelFile")
S3method("getImage", "AromaUnitTabularBinaryFile")
S3method("getImage", "ResidualFile")
S3method("getImage", "WeightsFile")
S3method("getIndexToRowMap", "AffymetrixProbeTabFile")
S3method("getInputDataSet", "TransformReport")
S3method("getInputName", "AffymetrixFileSetReporter")
S3method("getInputName", "GenericReporter")
S3method("getInputTags", "AffymetrixFileSetReporter")
S3method("getInputTags", "GenericReporter")
S3method("getIntensities", "AffymetrixCelSet")
S3method("getLabel", "Model")
S3method("getListOfCdfs", "AffymetrixCelSetTuple")
S3method("getListOfGenomeInformations", "ChromosomalModel")
S3method("getListOfPriors", "MultiArrayUnitModel")
S3method("getListOfReporters", "ArrayExplorer")
S3method("getListOfUnitNamesFiles", "AffymetrixCelSetTuple")
S3method("getListOfUnitNamesFiles", "ArrayExplorer")
S3method("getListOfUnitTypesFiles", "AffymetrixCelSetTuple")
S3method("getListOfUnitTypesFiles", "ArrayExplorer")
S3method("getMainCdf", "AffymetrixCdfFile")
S3method("getMainPath", "GenericReporter")
S3method("getMergeFunction", "ChipEffectGroupMerge")
S3method("getMergeFunction", "SnpChipEffectGroupMerge")
S3method("getMergeGroups", "ExonChipEffectSet")
S3method("getMergeStrands", "SnpChipEffectSet")
S3method("getMergeStrands", "SnpPlm")
S3method("getMonocellCdf", "AffymetrixCdfFile")
S3method("getName", "AffymetrixPlatform")
S3method("getName", "FirmaModel")
S3method("getName", "GenericReporter")
S3method("getName", "Model")
S3method("getName", "QualityAssessmentModel")
S3method("getName", "TransformReport")
S3method("getNameOfInput", "ArrayExplorer")
S3method("getNetAffxBuild", "AffymetrixNetAffxCsvFile")
S3method("getNetAffxDate", "AffymetrixNetAffxCsvFile")
S3method("getNormalEquations", "LinearModelProbeSequenceNormalization")
S3method("getNormalizeSignalsOne", "ScaleNormalization3")
S3method("getNormalizeSignalsOne", "UnitTypeScaleNormalization")
S3method("getNormalizedIntensities", "DChipDcpFile")
S3method("getNumberOfFilesAveraged", "CnChipEffectFile")
S3method("getOrderedFragmentPairMap", "AromaUfcFile")
S3method("getOrderedFragmentPairs", "AromaUfcFile")
S3method("getOutputDataSet", "Transform")
S3method("getOutputDataSet", "TransformReport")
S3method("getOutputDataSet00", "AdditiveCovariatesNormalization")
S3method("getOutputDataSet00", "FragmentEquivalentClassNormalization")
S3method("getOutputDataSet00", "FragmentLengthNormalization")
S3method("getOutputDataSet00", "GcContentNormalization")
S3method("getOutputFiles", "Transform")
S3method("getOutputIdentifier", "QuantileNormalization")
S3method("getOutputTuple", "SmoothMultiarrayModel")
S3method("getParameter", "AffymetrixAptSummaryFile")
S3method("getParameters", "AbstractProbeSequenceNormalization")
S3method("getParameters", "AdditiveCovariatesNormalization")
S3method("getParameters", "AllelicCrosstalkCalibration")
S3method("getParameters", "AvgPlm")
S3method("getParameters", "BackgroundCorrection")
S3method("getParameters", "BaseCountNormalization")
S3method("getParameters", "BasePositionNormalization")
S3method("getParameters", "ChipEffectFile")
S3method("getParameters", "ChipEffectGroupMerge")
S3method("getParameters", "CnChipEffectFile")
S3method("getParameters", "CnPlm")
S3method("getParameters", "CrlmmModel")
S3method("getParameters", "DChipQuantileNormalization")
S3method("getParameters", "ExonChipEffectFile")
S3method("getParameters", "ExonRmaPlm")
S3method("getParameters", "FragmentEquivalentClassNormalization")
S3method("getParameters", "FragmentLengthNormalization")
S3method("getParameters", "GcContentNormalization")
S3method("getParameters", "GcRmaBackgroundCorrection")
S3method("getParameters", "LimmaBackgroundCorrection")
S3method("getParameters", "MatNormalization")
S3method("getParameters", "MatSmoothing")
S3method("getParameters", "NormExpBackgroundCorrection")
S3method("getParameters", "OpticalBackgroundCorrection")
S3method("getParameters", "ProbeAffinityFile")
S3method("getParameters", "ProbeLevelTransform3")
S3method("getParameters", "QuantileNormalization")
S3method("getParameters", "ReseqCrosstalkCalibration")
S3method("getParameters", "ResidualFile")
S3method("getParameters", "ResidualSet")
S3method("getParameters", "RmaBackgroundCorrection")
S3method("getParameters", "RmaPlm")
S3method("getParameters", "ScaleNormalization")
S3method("getParameters", "ScaleNormalization3")
S3method("getParameters", "SnpChipEffectFile")
S3method("getParameters", "SnpChipEffectGroupMerge")
S3method("getParameters", "SnpPlm")
S3method("getParameters", "SpatialRowColumnNormalization")
S3method("getParameters", "UnitModel")
S3method("getParameters", "UnitTypeScaleNormalization")
S3method("getParameters", "WeightsFile")
S3method("getParameters", "WeightsSet")
S3method("getPath", "AffymetrixCelSetReporter")
S3method("getPath", "GenericReporter")
S3method("getPath", "Model")
S3method("getPath", "QualityAssessmentModel")
S3method("getPath", "TransformReport")
S3method("getPcuTheta", "ChromosomalModel")
S3method("getPlatform", "AffymetrixCdfFile")
S3method("getPlatform", "AffymetrixCelFile")
S3method("getPlatform", "AffymetrixCelSet")
S3method("getPlatform", "AffymetrixPgfFile")
S3method("getPlatform", "AromaChipTypeAnnotationFile")
S3method("getPlatform", "DChipCdfBinFile")
S3method("getPlatformDesignDB", "CrlmmModel")
S3method("getPlm", "FirmaModel")
S3method("getPlm", "QualityAssessmentModel")
S3method("getPosition", "AffymetrixTsvFile")
S3method("getPositionChipTypeUnit", "ChromosomalModel")
S3method("getPositionChipTypeUnit", "CopyNumberSegmentationModel")
S3method("getPositions", "GenomeInformation")
S3method("getProbeAffinityFile", "AffinePlm")
S3method("getProbeAffinityFile", "AvgPlm")
S3method("getProbeAffinityFile", "CnPlm")
S3method("getProbeAffinityFile", "ExonRmaPlm")
S3method("getProbeAffinityFile", "MbeiPlm")
S3method("getProbeAffinityFile", "ProbeLevelModel")
S3method("getProbeAffinityFile", "RmaPlm")
S3method("getProbeAffinityFile", "SnpPlm")
S3method("getProbeSequenceData", "AffymetrixCdfFile")
S3method("getProbesetIds", "AffymetrixAptSummaryFile")
S3method("getQuantificationScale", "AffymetrixAptSummaryFile")
S3method("getRawIntensities", "DChipDcpFile")
S3method("getReadArguments", "AffymetrixAptSummaryFile")
S3method("getRectangle", "AffymetrixCelFile")
S3method("getReference", "SpatialReporter")
S3method("getRegions", "profileCGH")
S3method("getReportSet", "GenericReporter")
S3method("getReportSet", "SpatialReporter")
S3method("getResidualFileClass", "ResidualSet")
S3method("getResidualSet", "ProbeLevelModel")
S3method("getResidualSetClass", "ProbeLevelModel")
S3method("getResiduals", "QualityAssessmentModel")
S3method("getRestructor", "AffymetrixCdfFile")
S3method("getRlmFitFunctions", "RmaPlm")
S3method("getRootPath", "AlleleSummation")
S3method("getRootPath", "ChipEffectTransform")
S3method("getRootPath", "CrlmmModel")
S3method("getRootPath", "FirmaModel")
S3method("getRootPath", "GenericReporter")
S3method("getRootPath", "Model")
S3method("getRootPath", "ProbeLevelModel")
S3method("getRootPath", "ProbeLevelTransform")
S3method("getRootPath", "QualityAssessmentModel")
S3method("getRootPath", "SmoothMultiarrayModel")
S3method("getRootPath", "SmoothRmaModel")
S3method("getRootPath", "TransformReport")
S3method("getSetTuple", "ArrayExplorer")
S3method("getSetsOfProbes", "AllelicCrosstalkCalibration")
S3method("getSetsOfProbes", "ReseqCrosstalkCalibration")
S3method("getSettings", "Package")
S3method("getSignalTransform", "BasePositionNormalization")
S3method("getSignalTransform", "LinearModelProbeSequenceNormalization")
S3method("getSnpInformation", "AffymetrixCdfFile")
S3method("getSnpNames", "AffymetrixCdfFile")
S3method("getSpar", "SpatialRowColumnNormalization")
S3method("getSteps", "ASCRMAv2")
S3method("getSteps", "AromaPipeline")
S3method("getSubsetOfCellIndices", "AffymetrixCdfFile")
S3method("getSubsetOfUnits", "AffymetrixCdfFile")
S3method("getSubsetToAvg", "AllelicCrosstalkCalibration")
S3method("getSubsetToAvg", "QuantileNormalization")
S3method("getSubsetToAvg", "ReseqCrosstalkCalibration")
S3method("getSubsetToAvg", "ScaleNormalization")
S3method("getSubsetToFit", "AdditiveCovariatesNormalization")
S3method("getSubsetToFit", "FragmentEquivalentClassNormalization")
S3method("getSubsetToFit", "FragmentLengthNormalization")
S3method("getSubsetToFit", "GcContentNormalization")
S3method("getSubsetToUpdate", "BackgroundCorrection")
S3method("getSubsetToUpdate", "DChipQuantileNormalization")
S3method("getSubsetToUpdate", "QuantileNormalization")
S3method("getSubsetToUpdate", "ScaleNormalization")
S3method("getSubsetToUpdate0", "LimmaBackgroundCorrection")
S3method("getTags", "FirmaModel")
S3method("getTags", "GenericReporter")
S3method("getTags", "Model")
S3method("getTags", "QualityAssessmentModel")
S3method("getTags", "TransformReport")
S3method("getTagsOfInput", "ArrayExplorer")
S3method("getTargetAverages", "FragmentEquivalentClassNormalization")
S3method("getTargetDistribution", "QuantileNormalization")
S3method("getTargetDistributionIdentifier", "QuantileNormalization")
S3method("getTargetDistributionPathname", "QuantileNormalization")
S3method("getTargetFile", "AbstractProbeSequenceNormalization")
S3method("getTargetFunction", "GcContentNormalization")
S3method("getTargetFunctions", "AdditiveCovariatesNormalization")
S3method("getTargetFunctions", "FragmentLengthNormalization")
S3method("getThetaStds", "DChipDcpFile")
S3method("getThetas", "DChipDcpFile")
S3method("getThetasAB", "DChipDcpFile")
S3method("getTimeStamp", "AffymetrixAptSummaryFile")
S3method("getTimestamp", "AffymetrixCelFile")
S3method("getTimestamp", "AffymetrixCnChpFile")
S3method("getTimestamp", "CnagCfhFile")
S3method("getTimestamps", "AffymetrixCelSet")
S3method("getTimestamps", "CnagCfhSet")
S3method("getUniqueCdf", "AffymetrixCdfFile")
S3method("getUnitGroupCellArrayMap", "ChipEffectFile")
S3method("getUnitGroupCellChromosomePositionMap", "AffymetrixCdfFile")
S3method("getUnitGroupCellChromosomePositionMap", "ChipEffectFile")
S3method("getUnitGroupCellMap", "AffymetrixCdfFile")
S3method("getUnitGroupCellMap", "AffymetrixCelSet")
S3method("getUnitGroupCellMap", "ChipEffectFile")
S3method("getUnitGroupCellMap", "FirmaFile")
S3method("getUnitGroupCellMap", "ResidualFile")
S3method("getUnitGroupCellMap", "WeightsFile")
S3method("getUnitGroupCellMapWithMonocell", "AffymetrixCdfFile")
S3method("getUnitGroupCellMapWithUnique", "AffymetrixCdfFile")
S3method("getUnitGroupCellMatrixMap", "ChipEffectFile")
S3method("getUnitGroupNamesFromUgcMap", "AffymetrixCdfFile")
S3method("getUnitIndices", "GenomeInformation")
S3method("getUnitIntensities", "AffymetrixCelSet")
S3method("getUnitNames", "AffymetrixCdfFile")
S3method("getUnitNames", "AffymetrixNetAffxCsvFile")
S3method("getUnitNames", "AffymetrixPgfFile")
S3method("getUnitNames", "DChipCdfBinFile")
S3method("getUnitNamesFile", "AffymetrixCdfFile")
S3method("getUnitNamesFile", "AffymetrixCelFile")
S3method("getUnitNamesFile", "AffymetrixCelSet")
S3method("getUnitNamesFile", "AffymetrixCnChpFile")
S3method("getUnitNamesFile", "AffymetrixPgfFile")
S3method("getUnitNamesFile", "AffymetrixPlatform")
S3method("getUnitNamesFile", "TransformReport")
S3method("getUnitReadMap", "AffymetrixCnChpFile")
S3method("getUnitSizes", "DChipCdfBinFile")
S3method("getUnitTypes", "AffymetrixCdfFile")
S3method("getUnitTypesFile", "AffymetrixCdfFile")
S3method("getUnitTypesFile", "AffymetrixCelFile")
S3method("getUnitTypesFile", "AffymetrixCelSet")
S3method("getUnitTypesFile", "AffymetrixCnChpFile")
S3method("getUnitTypesFile", "AffymetrixPlatform")
S3method("getUnitTypesFile", "TransformReport")
S3method("getUnitsOnChromosome", "GenomeInformation")
S3method("getUnitsOnChromosome", "UgpGenomeInformation")
S3method("getUnitsOnChromosomes", "GenomeInformation")
S3method("getUnitsTo", "ProbeLevelTransform3")
S3method("getUnitsToFit", "CrlmmModel")
S3method("getUnitsToFit", "ProbeLevelTransform3")
S3method("getUnitsToUpdate", "ProbeLevelTransform3")
S3method("getWeights", "QualityAssessmentModel")
S3method("getWeightsFileClass", "WeightsSet")
S3method("getWeightsSet", "ProbeLevelModel")
S3method("getWeightsSetClass", "ProbeLevelModel")
S3method("getXAM", "ChipEffectFile")
S3method("getXAM", "ChipEffectSet")
S3method("getYY", "TransformReport")
S3method("groupUnitsByDimension", "AffymetrixCdfFile")
S3method("hasAlleleBFractions", "CnChipEffectFile")
S3method("hasAlleleBFractions", "CnChipEffectSet")
S3method("hasAlleleBFractions", "CnChipEffectSetTuple")
S3method("hasColumnHeader", "AffymetrixProbeTabFile")
S3method("hasMbeiData", "DChipDcpFile")
S3method("hasNormalizedData", "DChipDcpFile")
S3method("hasStrandiness", "CnChipEffectFile")
S3method("hasStrandiness", "CnChipEffectSet")
S3method("hasStrandiness", "CnChipEffectSetTuple")
S3method("hasUnitReadMap", "AffymetrixCnChpFile")
S3method("hasUnitTypes", "AffymetrixCdfFile")
S3method("highlight", "AffymetrixCelFile")
S3method("identifyCells", "AffymetrixCdfFile")
S3method("image270", "AffymetrixCelFile")
S3method("importFrom", "AromaUnitTabularBinaryFile")
S3method("importFromAffymetrixNetAffxCsvFile", "AromaUflFile")
S3method("importFromAffymetrixNetAffxCsvFile", "AromaUgpFile")
S3method("importFromAffymetrixNetAffxCsvFile", "AromaUnitGcContentFile")
S3method("importFromAffymetrixNetAffxCsvFile", "AromaUnitTabularBinaryFile")
S3method("importFromAffymetrixProbeTabFile", "AromaCellSequenceFile")
S3method("importFromAffymetrixTabularFile", "AromaUfcFile")
S3method("importFromAffymetrixTabularFile", "AromaUgpFile")
S3method("importFromAffymetrixTabularFile", "AromaUnitTabularBinaryFile")
S3method("importFromApt", "CnChipEffectSet")
S3method("importFromBpMap", "AromaCellMatchScoreFile")
S3method("importFromBpMap", "AromaCellSequenceFile")
S3method("importFromDChip", "AffymetrixCelSet")
S3method("importFromDChip", "CnChipEffectSet")
S3method("importFromDChipGenomeInformation", "AromaUnitTabularBinaryFile")
S3method("importFromGenericTabularFile", "AromaUnitTabularBinaryFile")
S3method("importFromGenomeInformation", "AromaUgpFile")
S3method("importFromGenomeInformation", "AromaUnitTabularBinaryFile")
S3method("indexOfMissingSequences", "AbstractProbeSequenceNormalization")
S3method("inferMmFromPm", "AromaCellSequenceFile")
S3method("inferParameters", "CnChipEffectSet")
S3method("inferParameters", "SnpChipEffectSet")
S3method("isCompatibleWithCdf", "GenomeInformation")
S3method("isCompatibleWithCdf", "SnpInformation")
S3method("isCompatibleWithCdf", "UflSnpInformation")
S3method("isCompatibleWithCdf", "UgpGenomeInformation")
S3method("isDuplicated", "AffymetrixCelSet")
S3method("isDuplicated", "CnagCfhSet")
S3method("isMissing", "AromaCellMatchScoreFile")
S3method("isMonocellCdf", "AffymetrixCdfFile")
S3method("isPm", "AffymetrixCdfFile")
S3method("isResequenceChip", "AffymetrixCdfFile")
S3method("isSnpChip", "AffymetrixCdfFile")
S3method("isUniqueCdf", "AffymetrixCdfFile")
S3method("isUnitGroupCellMap", "data.frame")
S3method("isUnitGroupCellMap", "default")
S3method("isUnitGroupCellMap", "matrix")
S3method("justRMA", "default")
S3method("justSNPRMA", "AffymetrixCelSet")
S3method("justSNPRMA", "character")
S3method("mapToUnitNamesFile", "DChipCdfBinFile")
S3method("mergeGroups", "ChipEffectFile")
S3method("mergeStrands", "CnChipEffectFile")
S3method("mergeStrands", "SnpChipEffectFile")
S3method("migrateTool", "CopyNumberSegmentationModel")
S3method("nbrOfArrays", "AffymetrixAptSummaryFile")
S3method("nbrOfArrays", "AffymetrixCelSet")
S3method("nbrOfArrays", "AffymetrixCelSetReporter")
S3method("nbrOfArrays", "AffymetrixCnChpSet")
S3method("nbrOfArrays", "CnagCfhSet")
S3method("nbrOfArrays", "DChipDcpSet")
S3method("nbrOfArrays", "QualityAssessmentModel")
S3method("nbrOfArrays", "TransformReport")
S3method("nbrOfCells", "AffymetrixCdfFile")
S3method("nbrOfCells", "AffymetrixCelFile")
S3method("nbrOfCells", "AffymetrixPgfFile")
S3method("nbrOfCells", "CnagCfhFile")
S3method("nbrOfCells", "DChipCdfBinFile")
S3method("nbrOfCells", "DChipDcpFile")
S3method("nbrOfCellsPerUnit", "AffymetrixCdfFile")
S3method("nbrOfCellsPerUnitGroup", "AffymetrixCdfFile")
S3method("nbrOfChipTypes", "ArrayExplorer")
S3method("nbrOfColumns", "AffymetrixCdfFile")
S3method("nbrOfColumns", "AffymetrixPgfFile")
S3method("nbrOfEnzymes", "AromaUfcFile")
S3method("nbrOfEnzymes", "SnpInformation")
S3method("nbrOfEnzymes", "UflSnpInformation")
S3method("nbrOfGroupsPerUnit", "AffymetrixCdfFile")
S3method("nbrOfQcUnits", "AffymetrixCdfFile")
S3method("nbrOfRows", "AffymetrixCdfFile")
S3method("nbrOfRows", "AffymetrixPgfFile")
S3method("nbrOfSnps", "AffymetrixCdfFile")
S3method("nbrOfSnps", "CnagCfhFile")
S3method("nbrOfSteps", "AromaPipeline")
S3method("nbrOfUnits", "AffymetrixCdfFile")
S3method("nbrOfUnits", "AffymetrixPgfFile")
S3method("nbrOfUnits", "DChipCdfBinFile")
S3method("nbrOfUnits", "DChipDcpFile")
S3method("nbrOfUnits", "GenomeInformation")
S3method("nbrOfUnits", "SnpInformation")
S3method("nbrOfUnits", "UflSnpInformation")
S3method("nbrOfUnits", "UgpGenomeInformation")
S3method("normalizeOneArrayVector", "FragmentEquivalentClassNormalization")
S3method("normalizeQuantile", "AffymetrixCelFile")
S3method("normalizeQuantile", "AffymetrixCelSet")
S3method("plotAllelePairs", "AllelicCrosstalkCalibration")
S3method("plotBasepair", "AllelicCrosstalkCalibration")
S3method("plotBoxplot", "ChipEffectSet")
S3method("plotBoxplotStats", "list")
S3method("plotCovariateEffects", "GcContentNormalization2")
S3method("plotDensity", "AffymetrixCelFile")
S3method("plotDensity", "AffymetrixCelSet")
S3method("plotDensity", "GenomeInformation")
S3method("plotImage", "AffymetrixCelFile")
S3method("plotMargins", "SpatialReporter")
S3method("plotMvsA", "AffymetrixCelFile")
S3method("plotMvsX", "AffymetrixCelFile")
S3method("plotNuse", "QualityAssessmentModel")
S3method("plotRle", "QualityAssessmentModel")
S3method("plotXYCurve", "TransformReport")
S3method("plotXYCurveLog2", "TransformReport")
S3method("predictOne", "AbstractProbeSequenceNormalization")
S3method("predictOne", "BaseCountNormalization")
S3method("predictOne", "LinearModelProbeSequenceNormalization")
S3method("predictOne", "MatNormalization")
S3method("process", "AbstractProbeSequenceNormalization")
S3method("process", "AdditiveCovariatesNormalization")
S3method("process", "AlleleSummation")
S3method("process", "AllelicCrosstalkCalibration")
S3method("process", "AromaPipeline")
S3method("process", "ArrayExplorer")
S3method("process", "BackgroundCorrection")
S3method("process", "ChipEffectGroupMerge")
S3method("process", "DChipQuantileNormalization")
S3method("process", "FragmentEquivalentClassNormalization")
S3method("process", "FragmentLengthNormalization")
S3method("process", "GcContentNormalization")
S3method("process", "GcRmaBackgroundCorrection")
S3method("process", "GenericReporter")
S3method("process", "LimmaBackgroundCorrection")
S3method("process", "MatNormalization")
S3method("process", "MatSmoothing")
S3method("process", "OpticalBackgroundCorrection")
S3method("process", "QuantileNormalization")
S3method("process", "ReseqCrosstalkCalibration")
S3method("process", "RmaBackgroundCorrection")
S3method("process", "ScaleNormalization")
S3method("process", "ScaleNormalization3")
S3method("process", "SpatialReporter")
S3method("process", "SpatialRowColumnNormalization")
S3method("process", "UnitTypeScaleNormalization")
S3method("range", "AffymetrixCelFile")
S3method("range", "AffymetrixCelSet")
S3method("range", "CnagCfhFile")
S3method("range", "CnagCfhSet")
S3method("read10K", "DChipSnpInformation")
S3method("read250K", "DChipSnpInformation")
S3method("read250KHg17", "DChipGenomeInformation")
S3method("read50K", "DChipSnpInformation")
S3method("read50KHg17", "DChipGenomeInformation")
S3method("readArrays", "AffymetrixAptSummaryFile")
S3method("readCfhHeader", "default")
S3method("readCfhUnits", "default")
S3method("readCfnHeader", "default")
S3method("readCfnUnits", "default")
S3method("readDataFrame", "AffymetrixCdfFile")
S3method("readDataFrame", "AffymetrixCsvGenomeInformation")
S3method("readDataFrame", "AffymetrixTsvFile")
S3method("readDataFrame", "AromaUfcFile")
S3method("readDataFrame", "DChipCdfBinFile")
S3method("readDataFrame", "DChipGenomeInformation")
S3method("readDataFrame", "DChipSnpInformation")
S3method("readDataFrame", "GenomeInformation")
S3method("readDataFrame", "SnpInformation")
S3method("readDataFrame", "UflSnpInformation")
S3method("readDataFrame", "UgpGenomeInformation")
S3method("readDataFrame2", "AffymetrixProbeTabFile")
S3method("readDataUnitChromosomePosition", "AffymetrixNetAffxCsvFile")
S3method("readDataUnitFragmentLength", "AffymetrixNetAffxCsvFile")
S3method("readGeneAssignments", "AffymetrixNetAffxCsvFile")
S3method("readGenomeWideSNP", "DChipGenomeInformation")
S3method("readHeader", "AffymetrixAptSummaryFile")
S3method("readMatchScores", "AromaCellMatchScoreFile")
S3method("readMouse430", "DChipGenomeInformation")
S3method("readMouse430KenHardwired", "DChipGenomeInformation")
S3method("readParameter", "CrlmmParametersFile")
S3method("readPlasqTypes", "AffymetrixCdfFile")
S3method("readPriorsByUnits", "MultiArrayUnitModel")
S3method("readProbesetIds", "AffymetrixAptSummaryFile")
S3method("readRawData", "AffymetrixCelFile")
S3method("readRawData", "AffymetrixCnChpFile")
S3method("readRawData", "AffymetrixPgfFile")
S3method("readRawDataRectangle", "AffymetrixCelFile")
S3method("readRawDataRectangle", "SpatialReporter")
S3method("readSequenceDataFrame", "AffymetrixProbeTabFile")
S3method("readTableInternal", "GenomeInformation")
S3method("readTableInternal", "SnpInformation")
S3method("readUnitNames", "AffymetrixNetAffxCsvFile")
S3method("readUnits", "AffymetrixCdfFile")
S3method("readUnits", "AffymetrixCelFile")
S3method("readUnits", "AffymetrixCelSet")
S3method("readUnits", "ChipEffectFile")
S3method("readUnits", "ChipEffectSet")
S3method("readUnits", "CnChipEffectFile")
S3method("readUnits", "CnagCfhFile")
S3method("readUnits", "CnagCfhSet")
S3method("readUnits", "ExonChipEffectFile")
S3method("readUnits", "FirmaFile")
S3method("readUnits", "FirmaSet")
S3method("readUnits", "MultiArrayUnitModel")
S3method("readUnits", "ParameterCelFile")
S3method("readUnits", "ProbeAffinityFile")
S3method("readUnits", "ResidualFile")
S3method("readUnits", "ResidualSet")
S3method("readUnits", "SingleArrayUnitModel")
S3method("readUnits", "SnpChipEffectFile")
S3method("readUnits", "WeightsFile")
S3method("readUnits", "WeightsSet")
S3method("readUnitsByQuartets", "AffymetrixCdfFile")
S3method("rescale", "AllelicCrosstalkCalibration")
S3method("rescaleByAll", "AllelicCrosstalkCalibration")
S3method("rescaleByAll", "ReseqCrosstalkCalibration")
S3method("rescaleByGroups", "AllelicCrosstalkCalibration")
S3method("restruct", "AffymetrixCdfFile")
S3method("seq", "TransformReport")
S3method("setAlias", "ArrayExplorer")
S3method("setAlias", "GenericReporter")
S3method("setAlias", "Model")
S3method("setAlias", "TransformReport")
S3method("setArrays", "ArrayExplorer")
S3method("setBandwidth", "SmoothMultiarrayModel")
S3method("setCdf", "AffymetrixCelFile")
S3method("setCdf", "AffymetrixCelSet")
S3method("setCdf", "AffymetrixCnChpFile")
S3method("setCdf", "AffymetrixCnChpSet")
S3method("setCdf", "CnagCfhFile")
S3method("setCdf", "CnagCfhSet")
S3method("setColorMaps", "ArrayExplorer")
S3method("setColorMaps", "SpatialReporter")
S3method("setCombineAlleles", "CnChipEffectSet")
S3method("setCombineAlleles", "CnPlm")
S3method("setCombineAlleles", "CnProbeAffinityFile")
S3method("setDecodeFunction", "ParameterCelFile")
S3method("setEncodeFunction", "ParameterCelFile")
S3method("setGenomeInformation", "AffymetrixCdfFile")
S3method("setLabel", "Model")
S3method("setListOfPriors", "MultiArrayUnitModel")
S3method("setMergeFunction", "ChipEffectGroupMerge")
S3method("setMergeGroups", "ExonChipEffectSet")
S3method("setMergeGroups", "ExonProbeAffinityFile")
S3method("setMergeGroups", "ExonRmaPlm")
S3method("setMergeStrands", "SnpChipEffectSet")
S3method("setMergeStrands", "SnpPlm")
S3method("setMergeStrands", "SnpProbeAffinityFile")
S3method("setReference", "SpatialReporter")
S3method("setRestructor", "AffymetrixCdfFile")
S3method("setSettings", "Package")
S3method("setSnpInformation", "AffymetrixCdfFile")
S3method("setTags", "Model")
S3method("setUnitReadMap", "AffymetrixCnChpFile")
S3method("setup", "GenericReporter")
S3method("setupExampleData", "AromaAffymetrix")
S3method("smoothScatterMvsA", "AffymetrixCelFile")
S3method("stextChipType", "AffymetrixCdfFile")
S3method("transformAffine", "AffymetrixCelFile")
S3method("transformAffine", "AffymetrixCelSet")
S3method("translateColumnNames", "AffymetrixAptSummaryFile")
S3method("translateColumnNames", "AffymetrixProbeTabFile")
S3method("translateColumnNames", "AffymetrixTabularFile")
S3method("translateFullName", "AffymetrixProbeTabFile")
S3method("update", "AromaAffymetrix")
S3method("update2", "AffymetrixCelSet")
S3method("updateDataFlat", "ChipEffectFile")
S3method("updateDataFlat", "FirmaFile")
S3method("updateDataFlat", "ResidualFile")
S3method("updateDataFlat", "WeightsFile")
S3method("updateMatchScores", "AromaCellMatchScoreFile")
S3method("updateParameter", "CrlmmParametersFile")
S3method("updateSampleAnnotationSet", "AffymetrixCelSet")
S3method("updateSettings", "Package")
S3method("updateSetupExplorerFile", "ArrayExplorer")
S3method("updateUnits", "AffymetrixCelFile")
S3method("updateUnits", "ChipEffectFile")
S3method("updateUnits", "ChipEffectSet")
S3method("updateUnits", "FirmaFile")
S3method("updateUnits", "FirmaSet")
S3method("updateUnits", "ParameterCelFile")
S3method("updateUnits", "ProbeAffinityFile")
S3method("updateUnits", "ResidualFile")
S3method("updateUnits", "ResidualSet")
S3method("updateUnits", "WeightsFile")
S3method("updateUnits", "WeightsSet")
S3method("validate", "AffymetrixCdfFile")
S3method("validate", "AvgPlm")
S3method("validate", "MultiArrayUnitModel")
S3method("verify", "AffymetrixCsvGenomeInformation")
S3method("verify", "AffymetrixTsvFile")
S3method("verify", "DChipGenomeInformation")
S3method("verify", "DChipSnpInformation")
S3method("verify", "GenomeInformation")
S3method("verify", "SnpInformation")
S3method("verify", "UflSnpInformation")
S3method("verify", "UgpGenomeInformation")
S3method("writeAsFullCelFile", "ChipEffectFile")
S3method("writeCNT", "SnpChipEffectFile")
S3method("writeCNT", "SnpChipEffectSet")
S3method("writeCdf", "AffyGenePDInfo")
S3method("writeCdf", "DBPDInfo")
S3method("writeCdf", "PDInfoList")
S3method("writeCdf", "default")
S3method("writeCdfByExcludingCells", "AffymetrixCdfFile")
S3method("writeImage", "AffymetrixCelFile")
S3method("writeImage", "ResidualFile")
S3method("writeImage", "WeightsFile")
S3method("writeImageCombined", "TransformReport")
S3method("writeImages", "SpatialReporter")
S3method("writeImages", "TransformReport")
S3method("writeRegions", "profileCGH")
S3method("writeSgr", "AffymetrixCelSet")
S3method("writeSignals", "ProbeLevelTransform3")
S3method("writeWig", "CnChipEffectSet")

library("aroma.affymetrix")
ovars <- ls(all.names=TRUE)
oplan <- future::plan()

message("*** RmaBackgroundCorrection ...")

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
csR <- csR[1:3]
print(csR)

cdf <- getCdf(csR)
acs <- getAromaCellSequenceFile(cdf)
print(acs)

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  }
}

checksum <- NULL

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  message("- RmaBackgroundCorrection() ...")
  bg <- RmaBackgroundCorrection(csR, tags=tags)
  print(bg)
  csB <- process(bg, verbose=verbose)
  print(csB)

  csBz <- getChecksumFileSet(csB)
  print(csBz[[1]])
  checksumT <- readChecksum(csBz[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))
  message("- RmaBackgroundCorrection() ... DONE")

  message("- NormExpBackgroundCorrection() ...")
  bg <- NormExpBackgroundCorrection(csR, tags=tags)
  print(bg)
  csB <- process(bg, verbose=verbose)
  print(csB)

  csBz <- getChecksumFileSet(csB)
  print(csBz[[1]])
  checksumT <- readChecksum(csBz[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))
  message("- NormExpBackgroundCorrection() ... DONE")

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}

message("*** RmaBackgroundCorrection ... DONE")

## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "GenomeWideSNP_6"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

verbose && exit(verbose)

library("aroma.core");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);
ar <- AromaRepository(verbose=TRUE);

verbose && enter(verbose, "Downloading annotation data");


##########################################################################
# Annotation data:
# Hs_PromPR_v02/
#   Hs_PromPR_v02.cdf
#   Hs_PromPR_v02.acs
#   Hs_PromPR_v02.acm
#   Hs_PromPR_v02,unique.acp
##########################################################################
chipType <- "Hs_PromPR_v02";
verbose && cat(verbose, "Chip type: ", chipType);

pathname <- downloadCDF(ar, chipType);
verbose && cat(verbose, "CDF: ", pathname);

#pathname <- downloadACS(ar, chipType, tags=".*");
pathname <- downloadACS(ar, chipType);
verbose && cat(verbose, "ACS: ", pathname);

#pathname <- downloadACM(ar, chipType, tags=".*");
pathname <- downloadACM(ar, chipType);
verbose && cat(verbose, "ACM: ", pathname);

pathname <- downloadACP(ar, chipType, tags="unique");
verbose && cat(verbose, "ACP: ", pathname);

verbose && exit(verbose);

##########################################################################
# AS-CRMAv2 and Paired PSCBS
##########################################################################
future::plan("multisession")
library("aroma.affymetrix")
library("aroma.cn");  # PairedPscbsModel
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE12702"
chipType <- "Mapping250K_Sty"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)

dsN <- exportAromaUnitPscnBinarySet(dsNList)
print(dsN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cmt <- CalMaTeCalibration(dsNList)
print(cmt)

dsCList <- process(cmt, verbose=verbose)
print(dsCList)

dsC <- exportAromaUnitPscnBinarySet(dsCList)
print(dsC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Group samples by name and type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AD HOC: For now, just hardwire the path.
path <- file.path("testScripts/complete/dataSets", dataSet)
db <- TabularTextFile(sprintf("%s,samples.txt", dataSet), path=path)
setColumnNamesTranslator(db, function(names, ...) {
  names <- gsub("id", "fixed", names)
  names <- gsub("fullname", "replacement", names)
  names
})
df <- readDataFrame(db, colClasses=c("*"="character"))
setFullNamesTranslator(dsC, df)

# Identify unique sample names
sampleNames <- unique(getNames(dsC))

dsList <- lapply(sampleNames, FUN=function(sampleName) {
  ds <- dsC[sampleName]
  lapply(c(T="T", N="N"), FUN=function(type) {
    ds[sapply(ds, hasTag, type)]
  })
})
names(dsList) <- sampleNames


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract (single) tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dfTList <- lapply(dsList, FUN=function(dsList) { dsList$T[[1]] })
dsT <- newInstance(dsList[[1]]$T, dfTList)
dfNList <- lapply(dsList, FUN=function(dsList) { dsList$N[[1]] })
dsN <- newInstance(dsList[[1]]$T, dfNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segment tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sm <- PairedPscbsModel(dsT=dsT, dsN=dsN, gapMinLength=2e6)
print(sm)

res <- fit(sm, verbose=verbose)
print(res)

sms <- getOutputDataSet(sm)
print(sms)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Call segments to be in ROH, AB and LOH.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
caller <- PairedPscbsCaller(sms)
print(caller)
scs <- process(caller, verbose=verbose)
print(scs)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Generate report (just to check)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setOption("PSCBS::reports/pscnSegmentationTransitions", TRUE)

# Generate reports for tumor-normal pairs
for (ii in 1:min(length(scs),5)) {
  df <- scs[[ii]]
  fit <- loadObject(df)
  pathname <- report(fit, studyName=getFullName(dsT), verbose=verbose)
  print(pathname)
} # for (ii ...)

library("aroma.affymetrix")
ovars <- ls(all.names=TRUE)
oplan <- future::plan()

message("*** GcRmaBackgroundCorrection ...")

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
csR <- csR[1:6]
print(csR)

cdf <- getCdf(csR)
acs <- getAromaCellSequenceFile(cdf)
print(acs)

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  }
}

checksum <- NULL

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  bg <- GcRmaBackgroundCorrection(csR, seed=0xBEEF, tags=tags)
  print(bg)
  csB <- process(bg, verbose=verbose)
  print(csB)

  csBz <- getChecksumFileSet(csB)
  print(csBz[[1]])
  checksumT <- readChecksum(csBz[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}

message("*** GcRmaBackgroundCorrection ... DONE")

## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

library("aroma.affymetrix")

verbose <- Verbose(threshold=-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# A tuple
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")

dsList <- lapply(chipTypes, FUN=function(chipType) {
  AffymetrixCelSet$byName(dataSet, chipType=chipType)
})
print(dsList)
dsTuple <- AffymetrixCelSetTuple(dsList)
dsTuple <- GenericDataFileSetList(dsList)
print(dsTuple)
print(getNames(dsTuple));  # HMM... == NULL?!?


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Same tuple with fullname translators
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
for (ds in getSets(dsTuple)) {
  fnts <- getAromaFullNameTranslatorSet(ds)
  appendFullNamesTranslator(ds, fnts)
}
print(dsTuple)
print(getNames(dsTuple))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Attributes
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ds <- dsList[[1]]
n23 <- sapply(ds, getAttribute, "n23")
n24 <- sapply(ds, getAttribute, "n24")
isFemale <- (n23 == 2 & n24 == 0)
dsXX <- ds[isFemale]
print(dsXX)

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)


dataSetName <- "Affymetrix_2006-TumorNormal"
chipTypes <- c("Mapping250K_Nsp", "Mapping250K_Sty")

pairs <- matrix(c(
  "CRL-2325D", "CRL-2324D",
  "CRL-5957D", "CRL-5868D",
  "CCL-256.1D", "CCL-256D",
  "CRL-2319D", "CRL-2320D",
  "CRL-2362D", "CRL-2321D",
  "CRL-2337D", "CRL-2336D",
  "CRL-2339D", "CRL-2338D",
  "CRL-2341D", "CRL-2340D",
  "CRL-2346D", "CRL-2314D"
), ncol=2, byrow=TRUE)
colnames(pairs) <- c("normal", "tumor")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csRList <- list()
for (chipType in chipTypes) {
  cs <- AffymetrixCelSet$byName(dataSetName, chipType=chipType, verbose=log)
  print(cs)
  stopifnot(all(getNames(cs) %in% pairs))
  csRList[[chipType]] <- cs
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- csRList
csCList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  acc <- AllelicCrosstalkCalibration(cs)
  print(acc)
  csC <- process(acc, verbose=log)
  print(csC)
  stopifnot(identical(getNames(csC), getNames(cs)))
  csCList[[chipType]] <- csC
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test (for CN analysis)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- csCList
cesCnList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  plm <- RmaCnPlm(cs, mergeStrands=TRUE, combineAlleles=TRUE, shift=300)
  print(plm)
  fit(plm, verbose=log)
  ces <- getChipEffectSet(plm)
  print(ces)
  stopifnot(identical(getNames(ces), getNames(cs)))
  cesCnList[[chipType]] <- ces
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fragment-length normalization test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesCnList <- cesCnList
cesNList <- list()
for (chipType in names(csList)) {
  ces <- cesCnList[[chipType]]
  fln <- FragmentLengthNormalization(ces)
  print(fln)
  cesN <- process(fln, verbose=log)
  print(cesN)
  stopifnot(identical(getNames(cesN), getNames(ces)))
  cesNList[[chipType]] <- cesN
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup a paired CBS model
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Split data set in (tumor, normal) pairs
sets <- list(tumor=list(), normal=list())
for (chipType in names(cesNList)) {
  ces <- cesNList[[chipType]]
  for (type in colnames(pairs)) {
    idxs <- match(pairs[,type], getNames(ces))
    sets[[type]][[chipType]] <- ces[idxs]
  }
}
cns <- CbsModel(sets$tumor, sets$normal, maxNAFraction=1/5)
print(cns)

# Link the ChromosomeExplorer to the segmentation model
ce <- ChromosomeExplorer(cns)
print(ce)

# Fit the model for a few chromosomes
process(ce, arrays=1:2, chromosomes=c(2, 19), verbose=log)

# The X chromosome is very noisy and generates quite a few missing values
process(ce, arrays=1:2, chromosomes=23, verbose=log)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6,Full"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot allele pairs before and after calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- res$acc
for (what in c("input", "output")) {
  toPNG(getFullName(acc), tags=c("allelePairs", what), aspectRatio=0.7, {
    plotAllelePairs(acc, array=1, what=what, verbose=verbose)
  })
}

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "CytoScanHD_Array";
nbrOfEnzymes <- 1;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);
setOption(aromaSettings, "user/initials", "HB");
setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
setOption(aromaSettings, "user/email", obf);
saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
genomeVersions <- c("30"="hg18", "31"="hg19", "32"="hg19");
naVersions <- names(genomeVersions);
choices <- sprintf("na%s (%s)", naVersions, genomeVersions);
choice <- textMenu(choices, title="Choose NetAffx version: ", value=FALSE);
naVersion <- naVersions[choice];
genomeVersion <- genomeVersions[naVersion];
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=verbose);
  str(units);
  ## CytoScanHD_Array.na<XX>.annot.csv:  int [1:?] ? ? ...
  ## CytoScanHD_Array.cn.na<XX>.annot.csv: int [1:2020591] 2116816 1458524
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ufl);
footer$createdBy <- list(
  fullname = fullname, 
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);

print(ufl);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na32
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ufl <- AromaUflFile$byChipType(chipType, tags="na32");
x <- summaryOfUnits(ufl);

print(x);

## CytoScanHD_Array,na32,hg19,HB20111108.ufl
             snp cnp affxSnp   other   total
enzyme1-only   0   0       0 2819458 2819458
missing        0   0       0    2667    2667
total          0   0       0 2822125 2822125

stop()

# Differences
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(ufl[,cc] != ufl0[,cc], na.rm=TRUE);
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc], 
                       ufl[units,cc]-ufl0[units,cc]);
    colnames(df)[ncol(df)] <- "delta";
    print(df);
  }
}

# Differences in NAs
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(is.na(ufl[,cc]) != is.na(ufl0[,cc]));
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc]);
    str(df);
  }
}

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "27.1";
user <- "HB";
datestamp <- "20090519";

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(".na%s", naVersion),
#      cn=sprintf(".cn.na%s", naVersion)
      cn=sprintf(".cn.na%s", as.integer(naVersion))
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=log);
  str(units);
  ## GenomeWideSNP_6.na26.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na26.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
## AromaUgpFile:
## Name: GenomeWideSNP_6
## Tags: Full,na27.1,HB20090519
## Full name: GenomeWideSNP_6,Full,na27.1,HB20090519
## Pathname: annotationData/chipTypes/GenomeWideSNP_6/GenomeWideSNP_6,Full,na27.1,HB20090519.ugp
## File size: 8.97 MB (9407869 bytes)
## RAM: 0.01 MB
## Number of data rows: 1881415
## File format: v1
## Dimensions: 1881415x2
## Column classes: integer, integer
## Number of bytes per column: 1, 4
## Footer: <createdOn>20090519 18:56:13 PDT</createdOn><platform>Affymetrix</platform><chipType>GenomeWideSNP_6,Full</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>GenomeWideSNP_6,Full.CDF</filename><filesize>493291745</filesize><checksum>3fbe0f6e7c8a346105238a3f3d10d4ec</checksum></srcFile1><srcFile2><filename>GenomeWideSNP_6.na27.1.annot.csv</filename><filesize>1473437359</filesize><checksum>2b1cc87850a4c5e762b52c157689f570</checksum></srcFile2><srcFile3><filename>GenomeWideSNP_6.cn.na27.annot.csv</filename><filesize>490970502</filesize><checksum>2ad99a80d26b0af8f14b1a5e6d92d81c</checksum></srcFile3></srcFiles>
## Chip type: GenomeWideSNP_6,Full
## Platform: Affymetrix
getChromosomeStats(ugp);
## GenomeWideSNP_6,Full,na26,HB20080821:


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na26 -> na27
#   Two units (932039, 1872834) where moved from ChrX to ChrY.
#   Same location.
# o na24 -> na26
#   Only minor modifications for non-missing values:
#   - three loci changed chromosomes
#   - an additional 23 loci changed positions, of which only 17 moved
#     more than 2 base pairs.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ugp <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na27.1");
ugp2 <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na26");
cdf <- AffymetrixCdfFile$byChipType(getChipType(ugp));

options(width=60);
print(table(ugp[,1], exclude=NULL));
##       1      2      3      4      5      6      7      8
##  146401 153663 127766 120296 115672 112825 100996  98277
##       9     10     11     12     13     14     15     16
##   82168  93592  89525  87321  66067  57103  53556  54182
##      17     18     19     20     21     22     23     24
##   46632  52093  30299  43628  25111  24484  87200   9483
##      25   <NA>
##     445   2630

print(table(ugp2[,1], exclude=NULL));
##       1      2      3      4      5      6      7      8
##  146401 153663 127766 120296 115672 112825 100996  98277
##       9     10     11     12     13     14     15     16
##   82168  93592  89525  87321  66067  57103  53556  54182
##      17     18     19     20     21     22     23     24
##   46632  52093  30299  43628  25111  24484  87198   9485
##      25   <NA>
##     445   2630

rr <- whichVector(ugp[,1] != ugp2[,1]);
print(rr);
## [1] 932039 1872834;
print(cbind(ugp[rr,], ugp2[rr,]));
##   chromosome position chromosome position
## 1         23   169542         24   169542
## 2         23  2675210         24  2675210

rr <- whichVector(ugp[,2] != ugp2[,2]);
print(rr);
## integer(0)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-50, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080916";

chipType <- "Mapping250K_Nsp";

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags);
}
print(ufl);


enzyme <- gsub("Mapping250K_(Nsp|Sty)", "\\1I", getChipType(ufl));
print(enzyme);
stopifnot(nchar(enzyme) == 4);
units <- importFrom(ufl, csv, enzymes=enzyme, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);
x <- summaryOfUnits(ufl);
print(x);

##  AromaUflFile:
##  Name: Mapping250K_Nsp
##  Tags: na26,HB20080916
##  Pathname: annotationData/chipTypes/Mapping250K_Nsp/Mapping250K_Nsp,na26,HB20080916.ufl
##  File size: 512.98kB
##  RAM: 0.00MB
##  Number of data rows: 262338
##  File format: v1
##  Dimensions: 262338x1
##  Column classes: integer
##  Number of bytes per column: 2
##  Footer: <platform>Affymetrix</platform><chipType>Mapping250K_Nsp</chipType><createdOn>20080916 17:23:12 PDT</createdOn><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping250K_Nsp.cdf</filename><filesize>194455495</filesize><checksum>59ae263311a2cf63b8d1b9b4cc7d663b</checksum></srcFile1><srcFile2><filename>Mapping250K_Nsp.na26.annot.csv</filename><filesize>447194757</filesize><checksum>5f651b351a0d97e5e9e657f123e6ed05</checksum></srcFile2></srcFiles>
##  Chip type: Mapping250K_Nsp
##  Platform: Affymetrix

##                  snp cnp affxSnp other  total
##  enzyme1-only 261563   0       0     0 261563
##  missing         701   0       0    74    775
##  total        262264   0       0    74 262338

library("aroma.core")
library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "GenomeWideSNP_6"
tags <- "Full"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadCDF(ar, chipType, tags=tags)
verbose && cat(verbose, "CDF: ", pathname)

# Affymetrix NetAffx CSV file
path <- "analysis/downloads/na35/genotyping"
pathnameS <- file.path(path, "GenomeWideSNP_6.na35.annot.csv")
pathname <- downloadAffymetrixNetAffxCsvFile(pathnameS)
verbose && cat(verbose, "NetAffx CSV: ", pathname)

pathnameS <- file.path(path, "GenomeWideSNP_6.cn.na35.annot.csv")
pathname <- downloadAffymetrixNetAffxCsvFile(pathnameS)
verbose && cat(verbose, "NetAffx CN CSV: ", pathname)

verbose && exit(verbose)

library("aroma.affymetrix")
log <- verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSetName <- "Affymetrix_2006-TumorNormal"
chipType <- "Mapping250K_Nsp"

pairs <- matrix(c(
  "CRL-2325D", "CRL-2324D",
  "CRL-5957D", "CRL-5868D",
  "CCL-256.1D", "CCL-256D",
  "CRL-2319D", "CRL-2320D",
  "CRL-2362D", "CRL-2321D",
  "CRL-2337D", "CRL-2336D",
  "CRL-2339D", "CRL-2338D",
  "CRL-2341D", "CRL-2340D",
  "CRL-2346D", "CRL-2314D"
), ncol=2, byrow=TRUE)
colnames(pairs) <- c("normal", "tumor")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSetName, cdf=cdf)
print(csR)

# Reorder arrays according to 'pairs' matrix
csR <- csR[indexOf(csR, pairs)]

acc <- AllelicCrosstalkCalibration(csR, model="CRMAv2")
print(acc)

csC <- process(acc, verbose=log)
print(csC)

bpn <- BasePositionNormalization(csC, target="zero")
print(bpn)

csN <- process(bpn, verbose=log)
print(csN)

plm <- RmaCnPlm(csN, mergeStrands=TRUE, combineAlleles=FALSE)
print(plm)

fit(plm, verbose=log)

ces <- getChipEffectSet(plm)
print(ces)

fln <- FragmentLengthNormalization(ces, target="zero")
print(fln)

cesN <- process(fln, verbose=log)
print(cesN)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080822";

chipType <- "GenomeWideSNP_5";
cdfTags <- "Full,r2";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(   ".na%s", naVersion),
      cn=sprintf(".cn.na%s", naVersion)
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);

  units <- importFrom(ugp, csv, verbose=log);
  str(units);
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naVersion <- "27.1";
user <- "HB";
datestamp <- "20090519";

chipType <- "GenomeWideSNP_6";

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("cdfD")) {
  cdfD <- AffymetrixCdfFile$byChipType(chipType);
}
print(cdfD);

if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags="Full");
}
print(cdf);


unitNamesD <- getUnitNames(cdfD);
unitMap <- indexOf(cdf, names=unitNamesD);
# Sanity check
stopifnot(!anyMissing(unitMap));

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate UFL and UGP for the default CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naTag <- sprintf("na%s", naVersion);
tags <- sprintf("%s,%s%s", naTag, user, datestamp);

ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=naTag);
uflD <- AromaUflFile$allocateFromCdf(cdfD, tags=tags, nbrOfEnzymes=nbrOfEnzymes(ufl));
print(uflD);

ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=naTag);
ugpD <- AromaUgpFile$allocateFromCdf(cdfD, tags=tags);
print(ugpD);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
for (what in c("ufl", "ugp")) {
  af <- get(what);
  afD <- get(sprintf("%sD", what));
  for (cc in seq_len(nbrOfColumns(afD))) {
    afD[,cc] <- af[unitMap,cc];
  }
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("srcFileTags", mode="list")) {
  srcFiles <- list(cdfD=cdfD, cdf=cdf, ufl=ufl, ugp=ugp);
  srcFileTags <- lapply(srcFiles, FUN=function(srcFile) {
    list(
      filename=getFilename(srcFile),
      filesize=getFileSize(srcFile),
      checksum=getChecksum(srcFile)
    );
  });
  print(srcFileTags);
}

for (what in c("ufl", "ugp")) {
  af <- get(what);
  afD <- get(sprintf("%sD", what));
  footer <- readFooter(afD);
  footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
  footer$createdBy = list(
    fullname = "Henrik Bengtsson",
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  );
  keep <- (names(srcFileTags) %in% c("cdfD", "cdf", what));
  srcFileTagsT <- srcFileTags[keep];
  names(srcFileTagsT) <- sprintf("srcFile%d", seq_along(srcFileTagsT));
  footer$srcFiles <- srcFileTagsT;
  writeFooter(afD, footer);
}

library("aroma.affymetrix")
verbose <- Verbose(threshold=-10, timestamp=TRUE)
options(width=60)

chipType <- "GenomeWideSNP_6"
cdfTags <- "Full"
nbrOfEnzymes <- 2


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
fullname <- "Henrik Bengtsson"
user <- "HB"
email <- getOption(aromaSettings, "user/email")
if (is.null(email)) {
  email <- "JohnDoe@email.com"
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "32"
genomeVersion <- "hg19"
datestamp <- format(Sys.Date(), format="%Y%m%d")



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags)
print(cdf)

csvList <- list()

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
)

for (key in names(tagsList)) {
  tags <- tagsList[[key]]
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags)
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname)
  }
  rm(tags)
}
print(csvList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp)
tags <- c("TEST-ONLY", tags)
ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes, overwrite=TRUE)
print(ufl)

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]]
  print(csv)
  units <- importFrom(ufl, csv, verbose=verbose)
  str(units)
  ## GenomeWideSNP_6.na<XX>.annot.csv:  int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list()
srcFiles <- c(list(cdf), csvList)
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]]
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  )
  srcFileTags[[kk]] <- tags
}
print(srcFileTags)

footer <- readFooter(ufl)
footer$createdBy <- list(
  fullname = fullname, 
  email = email
)
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags))
footer$srcFiles <- srcFileTags
writeFooter(ufl, footer)


# Try to load the created annotation file
ufl <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="TEST-ONLY")
print(ufl)
x <- summaryOfUnits(ufl)
print(x)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Local function
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sourceTestScript <- function(pathname, devel=FALSE, ...) {
  # Argument 'devel':
  devel <- Arguments$getLogical(devel)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Enable support for sibling root paths?
  if (devel) {
    key <- "devel/dropRootPathTags"
    oopts <- setOption(aromaSettings, key, TRUE)
    on.exit({
      setOption(aromaSettings, key, oopts)
    }, add=TRUE)
    # Print settings
    print(getOption(aromaSettings, key))
  }

  # Use special file cache for testing
  library("R.cache")
  opath <- getCacheRootPath()
  on.exit({
    setCacheRootPath(opath)
  }, add=TRUE)
  setCacheRootPath(".Rcache")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Process
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  cat("** PATHNAME: ", pathname, "\n", sep="")
  tryCatch({
    pathname <- Arguments$getReadablePathname(pathname)
    source(pathname, echo=TRUE)
    cat("** PATHNAME DONE: ", pathname, "\n", sep="")
  }, error = function(ex) {
    cat("************************************************\n")
    cat("** ", rep(c(" ER", "ROR "), times=6), " **\n", sep="")
    print(ex)
    print(sessionInfo())
    cat("************************************************\n")
    cat("** PATHNAME FAILED: ", pathname, "\n", sep="")
  })
  gc()
} # sourceTestScript()


sourceTestSet <- function(path, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'path':
  path <- Arguments$getReadablePath(path)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # For each test script...
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  pathnames <- list.files(path=path, pattern="[.]R$", full.names=TRUE)
  cat("TEST SCRIPTS: \n")
  print(pathnames)

  for (pathname in pathnames) {
    if (regexpr("hetero", pathname) != -1)
      next
    if (regexpr("expectile", pathname) != -1)
      next
    sourceTestScript(pathname, ...)
  } # for (pathname ...)
} # sourceTestSet()


sourceTestGroups <- function(groups, pattern=".*", order=c("auto", "asis", "reverse", "random"), nbrOfSets=NULL, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'groups':
  groups <- Arguments$getCharacters(groups)

  # Argument 'pattern':
  pattern <- Arguments$getRegularExpression(pattern)

  # Argument 'order':
  order <- match.arg(order)

  # Argument 'nbrOfSets':
  if (!is.null(nbrOfSets)) {
    nbrOfSets <- Arguments$getInteger(nbrOfSets, range=c(1,Inf))
    if (order == "auto") order <- "random"
  }

  if (order == "auto") {
    order <- "asis"
  }

  rootPath <- Arguments$getReadablePath("testScripts/")
  for (group in groups) {
    path <- file.path(rootPath, group)
    path <- Arguments$getReadablePath(path)

    # Find all test sets
    pathnames <- list.files(path=path, recursive=TRUE, full.names=TRUE)
    paths <- dirname(pathnames)
    paths <- unique(paths)
    paths <- paths[sapply(paths, FUN=isDirectory)]

    # Filter
    paths <- grep(pattern, paths, value=TRUE)
    cat("Filtered test sets:\n")
    print(paths)

    if (order == "reverse") {
      paths <- rev(paths)
    } else if (order == "random") {
      paths <- sample(paths)
    }
    cat("All test sets:\n")
    print(paths)

    if (!is.null(nbrOfSets)) {
      cat("Subsetted test sets:\n")
      paths <- paths[1:nbrOfSets]
      print(paths)
    }

    # For each test set...
    for (path in paths) {
      sourceTestSet(path, ...)
    }
  } # for (groups ...)
} # sourceTestGroups()


launchTestGroups <- function(groups="system", ...) {
  sourceTestGroups(groups=groups, ...)
} # launchTestGroups()



############################################################################
# HISTORY:
# 2012-10-19
# o BUG FIX: The temporary cache directory was set to 'TRUE'.
# 2012-09-14
# o Created.
############################################################################

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# Affymetrix-CytoScanHD/
#  GenomeWideSNP_5/
#    []
#
# Overall design:
#
# URL: https://www.affymetrix.com/support/technical/sample_data/genomewide_snp5_data.affx
##########################################################################
dataSet <- "Affymetrix-HapMap,CEU,set1"
chipType <- "GenomeWideSNP_5"

ds <- downloadAffymetrixDataSet(dataSet, chipType=chipType, pathname="support/downloads/data/GW_SNP5_GCOS_CEL_1.zip")
print(ds)
## AffymetrixCelSet:
## Name: Affymetrix-HapMap
## Tags: CEU,testSet
## Path: rawData/Affymetrix-HapMap,CEU,testSet/GenomeWideSNP_5
## Platform: Affymetrix
## Chip type: GenomeWideSNP_5,Full,r2
## Number of arrays: 22
## Names: NA06985_Op1_011206_VnV_D10_r1, NA06991_Op1_011206_VnV_D01_r1, NA06993_Op1_011206_VnV_B01_r1, ..., NA11832_Op1_011206_VnV_B08_r1 [22]
## Time period: 2006-12-02 12:10:28 -- 2006-12-03 14:11:33
## Total file size: 986.06MB
## RAM: 0.03MB


verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-3, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-HeartBrain"
chipType <- "HuEx-1_0-st-v2"
cdf <- AffymetrixCdfFile$byChipType(chipType, tags="coreR3,A20071112,EP")
print(cdf)

# Setup CEL set using the core CDF.
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only cerebellum and heart
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
types <- c("cerebellum", "heart")
csR <- csR[indexOf(csR, patterns=types)]

setFullName(csR, sprintf("%s,%s", dataSet, paste(types, collapse="+")))
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Background correction and normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdfS <- AffymetrixCdfFile$byChipType(getChipType(cdf, fullname=FALSE))
setCdf(csR, cdfS)
bc <- GcRmaBackgroundCorrection(csR, type="affinities")
print(bc)

csB <- process(bc, verbose=verbose)
print(csB)
setCdf(csB, cdf)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "CytoScanHD_Array";

createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Get required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
print(cdf);

ptb <- AffymetrixProbeTabFile$byChipType(chipType);
print(ptb);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate aroma cell sequence file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acs <- AromaCellSequenceFile$allocateFromCdf(cdf, tags="HB20111008");
print(acs);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import data from the Affymetrix probe-tab file (contains only PMs)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# There is a tiny fraction of probes with 19-23 base pairs.
importFrom(acs, ptb, keepSequenceLengths=25, verbose=log);

# Only for chip types with MMs:
# Infer MM from PM sequences?  Will give an error if no MMs
# inferMmFromPm(acs, cdf=cdf, verbose=log);

ftr <- readFooter(acs);
ftr$createdBy <- createdBy;
writeFooter(acs, ftr);

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the gcRMA
# chip-effect estimates as estimated by gcrma.
#
# Author: Mark Robinson and Henrik Bengtsson
# Created: 2009-05-17
# Last modified: 2012-09-01
###########################################################################
library("aroma.affymetrix")
library("gcrma")  # gcrma()
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# Avoid being masked by affy::plotDensity()
plotDensity <- aroma.light::plotDensity


# ----------------------------------
# Dataset
# ----------------------------------
dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# ----------------------------------
# RMA estimates by aroma.affymetrix
# ----------------------------------
verbose && enter(verbose, "gcRMA by aroma.affymetrix")

res <- doGCRMA(csR, drop=FALSE, verbose=verbose)
print(res)

# Extract chip effects on the log2 scale
ces <- res$ces
theta <- extractMatrix(ces)
rownames(theta) <- getUnitNames(cdf)
theta <- log2(theta)

verbose && exit(verbose)


# ------------------------
# gcRMA estimates by gcrma
# ------------------------
verbose && enter(verbose, "gcRMA by gcrma")
verbose && print(verbose, sessionInfo())

raw <- ReadAffy(filenames=getPathnames(csR))
verbose && print(verbose, raw)

es <- gcrma(raw, verbose=TRUE)
verbose && print(verbose, es)

theta0 <- exprs(es)
verbose && exit(verbose)


# --------------------------------
# Compare the two implementations
# --------------------------------
# Reorder the aroma.affymetrix estimates
o <- match(rownames(theta0), rownames(theta))
theta <- theta[o,]

# Calculate statistics
rho <- diag(cor(theta, theta0))
print(rho)
print(range(rho))
e <- (theta - theta0)
print(summary(e))

# (a) Visual comparison
toPNG(getFullName(csR), tags=c("doGCRMA_vs_gcrma"), width=800, {
  par(mar=c(5,5,4,2)+0.1, cex.main=2, cex.lab=2, cex.axis=1.5)

  layout(matrix(1:16, ncol=4, byrow=TRUE))

  xlab <- expression(log[2](theta[gcrma]))
  ylab <- expression(log[2](theta[aroma.affymetrix]))
  for (kk in seq_len(ncol(theta))) {
    main <- colnames(theta)[kk]
    plot(theta0[,kk], theta[,kk], pch=".", xlab=xlab, ylab=ylab, main=main)
    abline(0,1, col="blue")
    stext(side=3, pos=0, line=-1.1, cex=1.2, substitute(rho==x, list(x=rho[kk])))
  }

  xlab <- expression(log[2](theta[aroma.affymetrix]/theta[gcrma]))
  plotDensity(e, xlab=xlab)
})

# (b) Assert correlations
stopifnot(all(rho > 0.9999))

# (c) Assert differences
stopifnot(mean(as.vector(e^2)) < 0.001)
stopifnot(sd(as.vector(e^2)) < 0.003)
stopifnot(quantile(abs(e), 0.99) < 0.10)
stopifnot(max(abs(e)) < 0.30)


verbose && print(verbose, sessionInfo())

###########################################################################
# HISTORY:
# 2012-09-01 [HB]
# o Updated to use a GEO data set.
# 2012-08-30 [HB]
# o Updated to utilize toPNG().
# 2010-02-05 [HB]
# o Harmonized with the corresponding RMA test script.
# 2009-05-17 [HB]
# o Adopted from Mark Robinson's test script.
###########################################################################

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "GenomeWideSNP_6";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdfD <- AffymetrixCdfFile$byChipType(chipType);
print(cdfD);

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="Full");
print(cdf);

unitNamesD <- getUnitNames(cdfD);
unitMap <- indexOf(cdf, names=unitNamesD);
# Sanity check
stopifnot(!anyMissing(unitMap));

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate UFL and UGP for the default CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naTag <- sprintf("na%s", naVersion);
tags <- sprintf("%s,%s,%s%s", naTag, genomeVersion, user, datestamp);

ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=naTag);
uflD <- AromaUflFile$allocateFromCdf(cdfD, tags=tags, nbrOfEnzymes=nbrOfEnzymes(ufl));
print(uflD);

ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=naTag);
ugpD <- AromaUgpFile$allocateFromCdf(cdfD, tags=tags);
print(ugpD);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
for (what in c("ufl", "ugp")) {
  af <- get(what);
  afD <- get(sprintf("%sD", what));
  for (cc in seq_len(nbrOfColumns(afD))) {
    afD[,cc] <- af[unitMap,cc];
  }
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("srcFileTags", mode="list")) {
  srcFiles <- list(cdfD=cdfD, cdf=cdf, ufl=ufl, ugp=ugp);
  srcFileTags <- lapply(srcFiles, FUN=function(srcFile) {
    list(
      filename=getFilename(srcFile),
      filesize=getFileSize(srcFile),
      checksum=getChecksum(srcFile)
    );
  });
  print(srcFileTags);
}

for (what in c("ufl", "ugp")) {
  af <- get(what);
  afD <- get(sprintf("%sD", what));
  footer <- readFooter(afD);
  footer$createdBy = list(
    fullname = fullname,
    email = email
  );
  keep <- (names(srcFileTags) %in% c("cdfD", "cdf", what));
  srcFileTagsT <- srcFileTags[keep];
  names(srcFileTagsT) <- sprintf("srcFile%d", seq_along(srcFileTagsT));
  footer$srcFiles <- srcFileTagsT;
  writeFooter(afD, footer);
}

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)

ab <- extractAffyBatch(csR, verbose=verbose)
print(ab)

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=log)
keep <- 1:6
csR <- csR[keep]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR, flavor="expectile")
print(acc)

csC <- process(acc, verbose=log)
print(csC)

stopifnot(identical(getNames(csC), getNames(csR)))

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080915";

chipType <- "Mapping250K_Sty";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
##  AromaUgpFile:
##  Name: Mapping250K_Sty
##  Tags: na26,HB20080915
##  Pathname: annotationData/chipTypes/Mapping250K_Sty/Mapping250K_Sty,na26,HB20080915.ugp
##  File size: 1.14MB
##  RAM: 0.00MB
##  Number of data rows: 238378
##  File format: v1
##  Dimensions: 238378x2
##  Column classes: integer, integer
##  Number of bytes per column: 1, 4
##  Footer: <createdOn>20080915 21:55:14 PDT</createdOn><platform>Affymetrix</platform><chipType>Mapping250K_Sty</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping250K_Sty.cdf</filename><filesize>184371335</filesize><checksum>8c7ffa88bb444d953214f601bb998e51</checksum></srcFile1><srcFile2><filename>Mapping250K_Sty.na26.annot.csv</filename><filesize>412941971</filesize><checksum>eb1ced7bd45aa7c6f6edf9fb708c7441</checksum></srcFile2></srcFiles>
##  Chip type: Mapping250K_Sty
##  Platform: Affymetrix

print(summary(ugp));
##  chromosome        position
##  Min.   :  1.000   Min.   :     2994
##  1st Qu.:  4.000   1st Qu.: 31306881
##  Median :  8.000   Median : 67082398
##  Mean   :  9.117   Mean   : 77333484
##  3rd Qu.: 13.000   3rd Qu.:114799352
##  Max.   : 23.000   Max.   :247135059
##  NA's   :677.000   NA's   :      677

print(table(ugp[,1]));
##      1     2     3     4     5     6     7     8     9    10
##  20273 19147 15396 13236 14854 14296 11822 12601 10900 14190
##     11    12    13    14    15    16    17    18    19    20
##  12928 11863  8052  7531  7323  8272  6403  6726  3670  6555
##     21    22    23
##   3182  3669  4812

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE8605/
#   HG-Focus/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
#   Mapping10K_Xba142/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
#
# Overall design:
#  [Ten] cervival cancer cell lines were hybridized to Affymetrix 
#  Focus arrays in duplicate. Correlations were made with copynumber 
#  profiles from arrayCGH and SNP arrays.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE8605
##########################################################################
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType,
                            chipTypeAliases=c("Focus"="HG-Focus"))
verbose && print(verbose, ds)
## AffymetrixCelSet:
## Name: GSE8605
## Tags:
## Path: rawData/GSE8605/Mapping10K_Xba142
## Platform: Affymetrix
## Chip type: Mapping10K_Xba142
## Number of arrays: 10
## Names: GSM226867, GSM226868, GSM226869, ..., GSM226876 [10]
## Time period: 2005-05-24 11:26:07 -- 2005-05-24 15:20:20
## Total file size: 41.38MB
## RAM: 0.01MB

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "HuGene-1_0-st-v1";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Get required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- ".na31.hg19.transcript";
#tags <- ".na31.hg19.probeset";
pattern <- sprintf("^%s%s([.]|_)(annot[.]|)(csv|CSV)$", chipType, tags);
nax <- AffymetrixNetAffxCsvFile$byChipType(chipType, tags=tags, pattern=pattern);
nbrOfLines(nax); # Count number of lines (once!)
print(nax);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Read data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
data <- readGeneAssignments(nax, verbose=-10);

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# SNPRMA according to aroma.affymetrix
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
eSet <- justSNPRMA(csR, normalizeToHapmap=TRUE, verbose=verbose)
print(eSet)

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");

verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "Mapping50K_Hind240";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## email <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
## setOption(aromaSettings, "user/email", email);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
genomeVersions <- c("30"="hg18", "31"="hg19");
naVersions <- names(genomeVersions);
choices <- sprintf("na%s (%s)", naVersions, genomeVersions);
choice <- textMenu(choices, title="Choose NetAffx version: ", value=FALSE);
naVersion <- naVersions[choice];
genomeVersion <- genomeVersions[naVersion];
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
print(cdf);

tags <- sprintf(".na%s", naVersion);
pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
if (isFile(pathname)) {
  csv <- AffymetrixNetAffxCsvFile(pathname);
}
rm(tags);
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=verbose);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- list(cdf, csv);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = fullname, 
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
print(summary(ugp));
print(table(ugp[,1]));

## Mapping50K_Hind240,na31,hg19,HB20110328
##    1    2    3    4    5    6    7    8    9   10   11   12
## 4537 5067 3959 4339 4213 3946 3447 3546 2356 2740 2464 2589
##   13   14   15   16   17   18   19   20   21   22   23   24
## 2646 1931 1439 1142  985 1730  324  992  879  430 1160    1

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-10, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE37861"
chipType <- "MoGene-1_0-st-v1"

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="r3")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
csR <- csR[1:6]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# gcRMA-style background correction
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Currently, you must use the standard CDF file.
bc <- GcRmaBackgroundCorrection(csR, type="affinities")
print(bc)

# This should throw "Error: Cannot perform GCRMA background
# (type="affinities") correction: The number (0) of negative
# control is too small."
tryCatch({
  csB <- process(bc, verbose=verbose)
}, error = function(ex) {
  print(ex)
})

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)


dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR, mergeShifts=FALSE)
print(acc)
csC <- process(acc, verbose=log)
print(csC)

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the justRMA()
# chip-effect estimates as estimated by the affy package.
#
# Author: Henrik Bengtsson
# Created: 2014-04-28
###########################################################################
library("aroma.affymetrix")
library("affy")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# Avoid being masked by affy::plotDensity()
plotDensity <- aroma.light::plotDensity

# ----------------------------------
# Dataset
# ----------------------------------
dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# ----------------------------------
# affy
# ----------------------------------
verbose && enter(verbose, "justRMA() by aroma.affymetrix")
eset0 <- justRMA(filenames=getPathnames(csR))
print(eset0)
verbose && exit(verbose)


# ----------------------------------
# aroma.affymetrix
# ----------------------------------
verbose && enter(verbose, "justRMA() by aroma.affymetrix")
eset <- justRMA(csR, verbose=verbose)
print(eset)
verbose && exit(verbose)


# --------------------------------
# Compare the two implementations
# --------------------------------
# Sample names
sampleNames0 <- sampleNames(eset0)
sampleNames <- sampleNames(eset)
stopifnot(identical(sampleNames, tools::file_path_sans_ext(sampleNames0)))

# Feature names
stopifnot(identical(featureNames(eset), featureNames(eset0)))

# Annotation
stopifnot(identical(annotation(eset), annotation(eset0)))

# Expression estimates
theta0 <- exprs(eset0)
theta <- exprs(eset)

# Calculate statistics
rho <- diag(cor(theta, theta0))
print(rho)
print(range(rho))
e <- (theta - theta0)
print(summary(e))

# (a) Visual comparison
toPNG(getFullName(csR), tags=c("justRMA", "aroma.affymetrix_vs_affy"), width=800, {
  par(mar=c(5,5,4,2)+0.1, cex.main=2, cex.lab=2, cex.axis=1.5)

  layout(matrix(1:16, ncol=4, byrow=TRUE))

  xlab <- expression(log[2](theta[affy]))
  ylab <- expression(log[2](theta[aroma.affymetrix]))
  for (kk in seq_len(ncol(theta))) {
    main <- colnames(theta)[kk]
    plot(theta0[,kk], theta[,kk], pch=".", xlab=xlab, ylab=ylab, main=main)
    abline(0,1, col="blue")
    stext(side=3, pos=0, line=-1.1, cex=1.2, substitute(rho==x, list(x=rho[kk])))
  }

  xlab <- expression(log[2](theta[aroma.affymetrix]/theta[affy]))
  plotDensity(e, xlab=xlab)
})

# (b) Assert correlations
print(rho)
print(range(rho))
stopifnot(all(rho > 0.9998))

# (c) Assert differences
stopifnot(mean(as.vector(e^2)) < 0.002)
stopifnot(sd(as.vector(e^2)) < 0.003)
stopifnot(quantile(abs(e), 0.99) < 0.11)
stopifnot(max(abs(e)) < 0.35)


verbose && print(verbose, sessionInfo())


###########################################################################
# HISTORY:
# 2014-04-28 [HB]
# o Created from '11.doRMA_vs_affyPLM.R'.
###########################################################################

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-50, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080916";

chipType <- "Mapping10K_Xba131";

enzyme <- "XbaI";
print(enzyme);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags);
}
print(ufl);


stopifnot(!is.na(enzyme));
units <- importFrom(ufl, csv, enzymes=enzyme, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);
x <- summaryOfUnits(ufl);
print(x);

##  AromaUflFile:
##  Name: Mapping10K_Xba131
##  Tags: na26,HB20080916
##  Pathname: annotationData/chipTypes/Mapping10K_Xba131/Mapping10K_Xba131,na26,HB20080916.ufl
##  File size: 23.19kB
##  RAM: 0.00MB
##  Number of data rows: 11564
##  File format: v1
##  Dimensions: 11564x1
##  Column classes: integer
##  Number of bytes per column: 2
##  Footer: <platform>Affymetrix</platform><chipType>Mapping10K_Xba131</chipType><createdOn>20080916 18:52:16 PDT</createdOn><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping10K_Xba131.cdf</filename><filesize>11311508</filesize><checksum>a18490aadbdc6407332ac3bb12d55a75</checksum></srcFile1><srcFile2><filename>Mapping10K_Xba131.na26.annot.csv</filename><filesize>18345600</filesize><checksum>4d21244a2f48e0484c01cbf50659a9ef</checksum></srcFile2></srcFiles>
##  Chip type: Mapping10K_Xba131
##  Platform: Affymetrix

##                 snp cnp affxSnp other total
##  enzyme1-only 11431   0       0     0 11431
##  missing        129   0       0     4   133
##  total        11560   0       0     4 11564

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";
nbrOfEnzymes <- 2;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
genomeVersions <- c("30"="hg18", "31"="hg19");
naVersions <- names(genomeVersions);
choices <- sprintf("na%s (%s)", naVersions, genomeVersions);
choice <- textMenu(choices, title="Choose NetAffx version: ", value=FALSE);
naVersion <- naVersions[choice];
genomeVersion <- genomeVersions[naVersion];
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=verbose);
  str(units);
  ## GenomeWideSNP_6.na<XX>.annot.csv:  int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ufl);
footer$createdBy <- list(
  fullname = fullname, 
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);

print(ufl);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na30 -> na31
#   - Lots of differences; Affymetrix no longer filter for us.
# o na27.1 -> na30
#   - No changes.
# o na27 -> na27.1
#   - No changes.
# o na26 -> na27
#   - No changes.
# o na24 -> na26
#   - All changes are for SNP units.
#   - There are 6 NspI and 14 StyI changes in SNP fragment lengths,
#     which some are only minor.
#   - There are 1108 more SNPs that now have missing values.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ufl <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na31");
ufl0 <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na30");
x <- summaryOfUnits(ufl);
x0 <- summaryOfUnits(ufl0);

print(x);
print(x0);

## GenomeWideSNP_6,na31,hg19,HB20110328.ufl
##                 snp    cnp affxSnp other   total
## enzyme1-only    577   9609       0     0   10186
## enzyme2-only    502  23432       0     0   23934
## both         929322 912574       0     0 1841896
## missing        1545    211    3022   621    5399
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na30,hg18,HB20100215.ufl
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na27.1,hg??,HB20??????.ufl
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

print(x-x0);
##               snp cnp affxSnp other total
##  enzyme1-only   0   0       0     0     0
##  enzyme2-only   0   0       0     0     0
##  both           0   0       0     0     0
##  missing        0   0       0     0     0
##  total          0   0       0     0     0

# Differences
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(ufl[,cc] != ufl0[,cc], na.rm=TRUE);
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc], 
                       ufl[units,cc]-ufl0[units,cc]);
    colnames(df)[ncol(df)] <- "delta";
    print(df);
  }
}

# Differences in NAs
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(is.na(ufl[,cc]) != is.na(ufl0[,cc]));
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc]);
    str(df);
  }
}

installPkg <- function(pkg, ...) {
  # Parse 'pkg'
  pattern <- "^([^:]*):([^:]*)$"
  if (regexpr(pattern, pkg) != -1) {
    repos <- gsub(pattern, "\\1", pkg)
    pkg <- gsub(pattern, "\\2", pkg)
  } else {
    repos <- "CRAN"
  }

  # Nothing to do?
  if (isPackageInstalled(pkg)) return()

  # Assert known repository
  repos <- match.arg(repos, choices=c("CRAN", "BioC", "R-Forge"))

  tryCatch({
    if (repos == "CRAN") {
      install.packages(pkg)
    } else if (repos == "BioC") {
      if (getRversion() < "3.5.0") {
        source("https://www.bioconductor.org/biocLite.R")
        biocLite(pkg, suppressUpdates=TRUE, ask=FALSE)
      } else {
        if (!requireNamespace("BiocManager", quietly = TRUE)) {
          install.packages("BiocManager")
        }
        BiocManager::install(pkg)
      }
    } else if (repos == "R-Forge") {
      install.packages(pkg, repos="https://R-Forge.R-project.org")
    }
  }, error = function(ex) {
    print(ex)
  })
} # installPkg()


############################################################################
# HISTORY:
# 2012-09-01
# o Added installPkg(), which installs *some* known packages by their
#   names without having to specify the repository.
# o Created.
############################################################################

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "MoGene-1_0-st-v1"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType, tags="r3")
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadACS(ar, chipType, tags=".*")
verbose && cat(verbose, "ACS: ", pathname)

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-50, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "31";
user <- "HB";
datestamp <- "20101007";

chipType <- "Mapping250K_Sty";

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags);
}
print(ufl);


enzyme <- gsub("Mapping250K_(Nsp|Sty)", "\\1I", getChipType(ufl));
print(enzyme);
stopifnot(nchar(enzyme) == 4);
units <- importFrom(ufl, csv, enzymes=enzyme, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);
x <- summaryOfUnits(ufl);
print(x);

##  AromaUflFile:
##  Name: Mapping250K_Nsp
##  Tags: na26,HB20080916
##  Pathname: annotationData/chipTypes/Mapping250K_Nsp/Mapping250K_Nsp,na26,HB20080916.ufl
##  File size: 512.98kB
##  RAM: 0.00MB
##  Number of data rows: 262338
##  File format: v1
##  Dimensions: 262338x1
##  Column classes: integer
##  Number of bytes per column: 2
##  Footer: <platform>Affymetrix</platform><chipType>Mapping250K_Nsp</chipType><createdOn>20080916 17:23:12 PDT</createdOn><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping250K_Nsp.cdf</filename><filesize>194455495</filesize><checksum>59ae263311a2cf63b8d1b9b4cc7d663b</checksum></srcFile1><srcFile2><filename>Mapping250K_Nsp.na26.annot.csv</filename><filesize>447194757</filesize><checksum>5f651b351a0d97e5e9e657f123e6ed05</checksum></srcFile2></srcFiles>
##  Chip type: Mapping250K_Nsp
##  Platform: Affymetrix

##                  snp cnp affxSnp other  total
##  enzyme1-only 261563   0       0     0 261563
##  missing         701   0       0    74    775
##  total        262264   0       0    74 262338

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the SNPRMA 
# chip-effect estimates as estimated by oligo.
# It verifies that they give the same results whether or not one
# is normalizing towards the HapMap reference (as defined by oligo).
#
# Author: Henrik Bengtsson
# Created: 2008-12-04
# Last modified: 2010-09-01
###########################################################################
library("aroma.affymetrix")
library("oligo")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Local functions
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
compareESets <- function(eSet1, eSet2, tolerance=1e-4) {
  # Default
  res <- all.equal(eSet1, eSet2, tolerance=tolerance)
  if (!isTRUE(res)) return(res)

  # Compare assayData()
  data1 <- assayData(eSet1)
  data2 <- assayData(eSet2)
  data1 <- as.list(data1)
  data2 <- as.list(data2)
  res <- all.equal(data1, data2, tolerance=tolerance)
  if (!isTRUE(res)) return(res)
  TRUE
} # compareESets()


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)

# Assert that the correct Platform Design package is installed
pdPkgName <- cleanPlatformName(chipType)
library(pdPkgName, character.only=TRUE)

for (normalizeToHapmap in c(FALSE, TRUE)) {
  verbose && enter(verbose, sprintf("justSNPRMA(..., normalizeToHapMap=%s)", normalizeToHapmap))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # SNPRMA according to aroma.affymetrix
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  eSet <- justSNPRMA(csR, normalizeToHapmap=normalizeToHapmap, verbose=verbose)
  print(eSet)
  
  
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # SNPRMA according to oligo
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  eSet0 <- justSNPRMA(getPathnames(csR), normalizeToHapmap=normalizeToHapmap, verbose=as.logical(verbose))
  print(eSet0)
  
  if (!normalizeToHapmap) {
    # CLEAN UP: justSNPRMA() stores a target distribution file
    # in the working directory that we don't need
    filename <- sprintf("%s.quantileReference.rda", pdPkgName)
    if (isFile(filename)) {
      file.remove(filename)
    }
  }

 
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Compare
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  res <- compareESets(eSet, eSet0)
  verbose && print(verbose, res)

  # Sanity check
  stopifnot(compareESets(eSet, eSet0))

  verbose && exit(verbose)
} # for (normalizeToHapmap ...)

library("aroma.affymetrix")
library("matrixStats"); # rowMedians()
log <- Arguments$getVerbose(-4, timestamp=TRUE)


dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Xba240"

# Expected sample names
sampleNames <- c("NA06985", "NA06991", "NA06993",
                 "NA06994", "NA07000", "NA07019")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cs <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
keep <- 1:6
cs <- cs[keep]
sampleNames <- sampleNames[keep]
print(cs)
stopifnot(identical(getNames(cs), sampleNames))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(cs)
print(acc)
csC <- process(acc, verbose=log)
print(csC)
stopifnot(identical(getNames(csC), getNames(cs)))



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test (for allele-specific CN analysis)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- RmaCnPlm(csC, mergeStrands=TRUE, combineAlleles=FALSE, shift=300)
print(plm)

fit(plm, verbose=log)
ces <- getChipEffectSet(plm)
print(ces)
stopifnot(identical(getNames(ces), getNames(cs)))



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plotting allele B frequences and raw copy numbers
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- getCdf(ces)
gi <- getGenomeInformation(cdf)
units <- getUnitsOnChromosome(gi, 2)
data <- extractDataFrame(ces, units=units, addNames=TRUE, verbose=log)
data[,"x"] <- getPositions(gi, data[,"unit"])

keep <- match(getNames(ces), colnames(data))
theta <- as.matrix(data[,keep])
data <- data[,-keep]

isA <- (data$group==1)
isB <- (data$group==2)
thetaA <- theta[isA,]
thetaB <- theta[isB,]

# Total raw copy numbers
theta <- thetaA + thetaB
thetaR <- rowMedians(theta, na.rm=TRUE)
M <- log2(theta/thetaR)

# Allele B frequences
B <- thetaB/theta

# Position (in Mb)
x <- data[isA,"x"] / 1e6

#layout(matrix(1:(2*ncol(M)), ncol=2))
layout(matrix(1:4, ncol=2))
par(mar=c(2,4,2,2)+0.1)
xlim <- range(x, na.rm=TRUE)
xlab <- "Physical position (in Mb)"
Blab <- expression(theta[B]/theta)
Mlab <- expression(log[2](theta/theta[R]))

for (cc in 1:ncol(M)) {
  name <- colnames(M)[cc]
  plot(NA, xlim=xlim, ylim=c(0,1), main=name, xlab=xlab, ylab=Blab)
  abline(h=1/2, col="#cccccc")
  points(x,B[,cc], pch=".")
  plot(NA, xlim=xlim, ylim=c(-1,1)*3, xlab=xlab, ylab=Mlab)
  abline(h=0, col="#cccccc")
  points(x,M[,cc], pch=".")
}

devDone()

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# RMA
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doRMA(csR, drop=FALSE, verbose=verbose)
print(res)

# The estimated chip effects
ces <- res$ces
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fit "another" sample based on above PLM priors
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Get PLM priors
plm <- res$plm
pf <- getProbeAffinityFile(plm)
print(pf)

# RMA probe summarization (there are no NAs in this data set) on
# a "new" sample based on its background corrected signals
csN <- res$csN
csT <- csN[1]
print(csT)
listOfPriors <- list(probeAffinities=pf)
plmP <- RmaPlm(csT, tags="*,priors", listOfPriors=listOfPriors)
print(plmP)

# Assert that list of prior (data files) exists
priorList <- getListOfPriors(plmP)
print(priorList)

# Test to read a subset of priors
priors <- readPriorsByUnits(plmP, units=101:105)
str(priors)

# Fit the model (for this single-sample data set)
fit(plmP, verbose=verbose)

# The "new" estimated chip effects
cesP <- getChipEffectSet(plmP)
print(cesP)

# Compare
theta <- extractTheta(ces[1], drop=TRUE)
thetaP <- extractTheta(cesP, drop=TRUE)

# The estimates are not identical, ...
print(all.equal(thetaP, theta))
# ...but correlation is high.
rho <- cor(thetaP, theta)
print(rho)
# Sanity check
stopifnot(rho > 0.995)

toPNG(getFullName(cesP), tags=c(getNames(cesP), class(plmP)[1], "withAndWithoutPriors"), {
  plot(theta, thetaP, xlab="original", ylab="priors", main="RMA chip effect estimates")
  abline(a=0, b=1)
})


###########################################################################
# HISTORY:
# 2012-01-14 [HB]
# o Now sctipt also fits PLM with prior parameters.
# o Now the script is only one sample for the PLM prior part.
# 2009-04-28 [HB]
# o Added to test priors.
###########################################################################

#!/usr/bin/env Rscript

library("aroma.affymetrix")

pathT <- system.file("testScripts", package="aroma.affymetrix")
pathT <- Arguments$getReadablePath(pathT)

path <- "testScripts/"
path <- filePath(path, expandLinks="any")
if (!isDirectory(path)) {
  createLink(target=pathT)
}
path <- Arguments$getReadablePath(path)

pathname <- "menu.Rex"
if (!isFile(pathname)) {
  code <- c(
    'if (interactive()) savehistory()',
    'library("R.menu")',
    'launchMenu("testScripts")'
  )
  cat(file=pathname, code, sep="\n")
}
pathname <- Arguments$getReadablePathname(pathname)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# SNPRMA
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ces <- justSNPRMA(csR, normalizeToHapmap=TRUE, returnESet=FALSE, verbose=verbose)
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRLMM
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
recalibrate <- TRUE
crlmm <- CrlmmModel(ces, tags="*,oligo", recalibrate=recalibrate)
print(crlmm)

units <- fit(crlmm, ram="oligo", verbose=verbose)
str(units)

callSet <- getCallSet(crlmm)
print(callSet)

confSet <- getConfidenceScoreSet(crlmm)
print(confSet)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot along genome
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
chr <- 2
chrTag <- sprintf("Chr%02d", chr)
ugp <- getAromaUgpFile(cdf)
units <- getUnitsOnChromosome(ugp, chromosome=chr)
pos <- getPositions(ugp, units=units)/1e6

toPNG(getFullName(ces), tags=c(chrTag), {
  layout(matrix(seq_along(ces), ncol=2, byrow=TRUE))
  par(mar=c(3.5,4,1.5,1), mgp=c(1.8,0.5,0), pch=".")
  for (ii in seq_along(ces)) {
    ce <- ces[[ii]]
    gc <- callSet[[ii]]
    data <- extractTotalAndFracB(ce, units=units, drop=TRUE)
    calls <- extractGenotypes(gc, units=units, drop=TRUE)
    col <- c(AA=1, AB=2, BB=3)[calls]
    plot(pos, data[,"freqB"], col=col, cex=4, ylim=c(0,1))
    stext(side=3, pos=0, getName(ce))
    stext(side=3, pos=1, chrTag)
  } # for (ii ...)
})

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE8605/
#   Mapping10K_Xba142/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
#
# Overall design:
#  [Ten] cervival cancer cell lines were hybridized to Affymetrix
#  Focus arrays in duplicate. Correlations were made with copynumber
#  profiles from arrayCGH and SNP arrays.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE8605
##########################################################################
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType,
                            chipTypeAliases=c("Focus"="HG-Focus"))
verbose && print(verbose, ds)
## AffymetrixCelSet:
## Name: GSE8605
## Tags:
## Path: rawData/GSE8605/Mapping10K_Xba142
## Platform: Affymetrix
## Chip type: Mapping10K_Xba142
## Number of arrays: 10
## Names: GSM226867, GSM226868, GSM226869, ..., GSM226876 [10]
## Time period: 2005-05-24 11:26:07 -- 2005-05-24 15:20:20
## Total file size: 41.38MB
## RAM: 0.01MB

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-50, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080916";

chipType <- "Mapping50K_Hind240";

enzyme <- c("Mapping50K_Hind240"="HindIII", "Mapping50K_Xba240"="XbaI")[chipType];
print(enzyme);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags);
}
print(ufl);


stopifnot(!is.na(enzyme));
units <- importFrom(ufl, csv, enzymes=enzyme, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);
x <- summaryOfUnits(ufl);
print(x);

## AromaUflFile:
## Name: Mapping50K_Hind240
## Tags: na26,HB20080916
## Pathname: annotationData/chipTypes/Mapping50K_Hind240/Mapping50K_Hind240,na26,HB20080916.ufl
## File size: 112.52kB
## RAM: 0.00MB
## Number of data rows: 57299
## File format: v1
## Dimensions: 57299x1
## Column classes: integer
## Number of bytes per column: 2
## Footer: <platform>Affymetrix</platform><chipType>Mapping50K_Hind240</chipType><createdOn>20080916 18:31:24 PDT</createdOn><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping50K_Hind240.CDF</filename><filesize>56029390</filesize><checksum>84239fce7a443dd528e060731a8df77e</checksum></srcFile1><srcFile2><filename>Mapping50K_Hind240.na26.annot.csv</filename><filesize>92433908</filesize><checksum>fc9a48388f38491b5be7ffaf1fdc3861</checksum></srcFile2></srcFiles>
## Chip type: Mapping50K_Hind240
## Platform: Affymetrix

##                snp cnp affxSnp other total
## enzyme1-only 56933   0       0     0 56933
## missing        311   0       0    55   366
## total        57244   0       0    55 57299
## There were 15 warnings (use warnings() to see them)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRLMM
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ces <- res$cesN
print(ces)

# This should throw "Exception: Cannot fit CRLMM model: CRLMM 
# requires that the probe-level model was fitted without
# merging the strands (mergeStrands=FALSE)."
tryCatch({
  crlmm <- CrlmmModel(ces, tags="*,oligo", recalibrate=TRUE)
}, error = function(ex) {
  print(ex)
})

library("aroma.affymetrix")
library("matrixStats"); # rowMedians()
verbose <- Arguments$getVerbose(-3, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-HeartBrain"
chipType <- "HuEx-1_0-st-v2"
cdf <- AffymetrixCdfFile$byChipType(chipType, tags="coreR3,A20071112,EP")
print(cdf)

# Setup CEL set using the core CDF.
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only cerebellum and heart
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
types <- c("cerebellum", "heart")
csR <- csR[indexOf(csR, patterns=types)]

setFullName(csR, sprintf("%s,%s", dataSet, paste(types, collapse="+")))
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# FIRMA
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doFIRMA(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# PLMs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plmList <- list(
  merge   = res$plm,                               # all exons together
  noMerge = ExonRmaPlm(res$csN, mergeGroups=FALSE) # each exon separately
)
print(plmList)

# Fit the per-exon PLM
fit(plmList$noMerge, verbose=verbose)

# Chip effects
cesList <- lapply(plmList, FUN=getChipEffectSet)
print(cesList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# RLE/NUSE for first 100 units
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# The reason for observing a small difference is scores below,
# is that when saving to file the estimates are rounded of to
# floats, whereas the estimates calculated in memory are kept
# in full precision.
tol <- 1e-5

units <- 1:100

for (key in names(cesList)) {
  verbose && enter(verbose, key)

  ces <- cesList[[key]]

  # Assert correctness of unit-specific RLE scores
  theta <- extractMatrix(ces, field="theta", units=units)
  thetaR <- 2^rowMedians(log2(theta), na.rm=TRUE)
  rle0 <- log2(theta/thetaR)
  rle1 <- extractMatrix(ces, field="RLE", units=units, verbose=verbose)
  stopifnot(all.equal(rle1, rle0, tolerance=tol))

  # Assert correctness of boxplot statistics of RLE scores
  stats0 <- boxplot.stats(rle0[,1])
  stats1 <- boxplotStats(ces, type="RLE", arrays=1:2, subset=units)
  stopifnot(all.equal(stats1[[1]], stats0, tolerance=tol))

  # Assert correctness of unit-specific NUSE scores
  se <- extractMatrix(ces, field="sdTheta", units=units)
  seR <- 2^rowMedians(log2(se), na.rm=TRUE)
  nuse0 <- log2(se)/log2(seR)
  nuse1 <- extractMatrix(ces, field="NUSE", units=units, verbose=verbose)
  stopifnot(all.equal(nuse1, nuse0, tolerance=tol))

  # Assert correctness of boxplot statistics of NUSE scores
  stats0 <- boxplot.stats(nuse0[,1])
  stats1 <- boxplotStats(ces, type="NUSE", arrays=1:2, subset=units)
  stopifnot(all.equal(stats1[[1]], stats0, tolerance=tol))

  verbose && exit(verbose)
} # for (key in ...)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (interactive()) savehistory();
library("aroma.affymetrix");

# Use a nicer palette of colors
colors <- RColorBrewer::brewer.pal(12, "Paired");
palette(colors);

# Default width of plots
width <- 7;

devNew2 <- function(..., width=7, height=width) {
  imgFormat <- c("x11", "png")[2];
  if (imgFormat == "x11") {
    devNew("x11", width=width, height=height, label=fig);
  } else {
    # Rescale for PNG
    c <- 640/7;
    width <- c*width
    height <- c*height;
    figPath <- "figures";
    mkdirs(figPath);
    filename <- sprintf("%s.png", fig);
    pathname <- filePath(figPath, filename);
    devNew("png", file=pathname, width=width, height=height, label=fig);
  }
}

# Setup the Verbose object
verbose <- Arguments$getVerbose(-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup of raw data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType("Mapping50K_Hind240");
  print(cdf);

  gi <- getGenomeInformation(cdf);
  print(gi);

  si <- getSnpInformation(cdf);
  print(si);

  acs <- AromaCellSequenceFile$byChipType(getChipType(cdf, fullname=FALSE));
  print(acs);
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup of raw data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName("HapMap,CEU,testSet", cdf=cdf);
print(getFullNames(csR));

## [1] "NA06985_Hind_B5_3005533"  "NA06991_Hind_B6_3005533"
## [3] "NA06993_Hind_B4_4000092"  "NA06994_Hind_A7_3005533"
## [5] "NA07000_Hind_A8_3005533"  "NA07019_Hind_A12_4000092"
## [7] "NA07022_Hind_A10_4000092" "NA07029_Hind_A9_4000092"
## [9] "NA07034_Hind_B1_4000092"  "NA07048_Hind_B3_4000092"


# The CEL files downloaded from HapMap has file names such as
# NA07000_Hind_A8_3005533.CEL.  In order for aroma.affymetrix to identify
# 'NA07000' as the sample name, and 'A8' and '3005533' as tags (ignore
# the 'Hind' part), we will utilize so called fullname translators that
# translates the full name to a comma-separated fullname, e.g.
# 'NA07000_Hind_A8_3005533' to 'NA07000,A8,3005533'.

setFullNamesTranslator(csR, function(names, ...) {
  # Turn into comma-separated tags
  names <- gsub("_", ",", names);
  # Drop any Hind/Xba tags
  names <- gsub(",(Hind|Xba)", "", names);
  names;
})
print(getFullNames(csR));

## [1] "NA06985,B5,3005533"  "NA06991,B6,3005533"
## [3] "NA06993,B4,4000092"  "NA06994,A7,3005533"
## [5] "NA07000,A8,3005533"  "NA07019,A12,4000092"
## [7] "NA07022,A10,4000092" "NA07029,A9,4000092"
## [9] "NA07034,B1,4000092"  "NA07048,B3,4000092"

print(csR);

## AffymetrixCelSet:
## Name: HapMap
## Tags: CEU,testSet
## Path: rawData/HapMap,CEU,testSet/Mapping50K_Hind240
## Platform: Affymetrix
## Chip type: Mapping50K_Hind240
## Number of arrays: 10
## Names: NA06985, NA06991, ..., NA07048
## Time period: 2004-01-14 14:02:08 -- 2004-02-13 11:51:01
## Total file size: 244.78MB
## RAM: 0.01MB


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Verifying ChrX and ChrY ploidies
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extracting attributes 'n23' and 'n24' from the set
nXY <- t(sapply(csR, function(cf) getAttributes(cf)[c("n23", "n24")]));
rownames(nXY) <- getNames(csR);
print(nXY);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calibration for crosstalk between alleles
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR);
print(acc);
csC <- process(acc, verbose=verbose);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe summarization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- RmaCnPlm(csC, mergeStrands=TRUE, combineAlleles=TRUE);
print(plm);

fit(plm, verbose=verbose);

# The estimated chip effects
ces <- getChipEffectSet(plm);
print(ces);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalize for PCR fragment-length effects
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fln <- FragmentLengthNormalization(ces);
print(fln);

cesN <- process(fln, verbose=verbose);
print(cesN);

# Verify
nXY <- t(sapply(cesN, function(cf) getAttributes(cf)[c("n23", "n24")]));
rownames(nXY) <- getNames(cesN);
print(nXY);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calculate sex-chromosome bias-corrected reference signals
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# For Chr1-22 and ChrX the copy-neutral ploidy should be two.
# If the ploidy of a sample is unknown, assume the default is two.
ceRef <- calculateBaseline(cesN, chromosomes=1:23, ploidy=2,
                                       defaultPloidy=2, verbose=verbose);

# For ChrY the ploidy of the reference should be one.  Currently our model
# cannot adjust it to be two, because there must be at least one sample
# with the target ploidy.
# ceRef <- calculateBaseline(cesN, chromosomes=24, ploidy=1, verbose=verbose);


# To later retrieve this baseline reference, do:
ceRef <- getBaseline(cesN);
print(ceRef);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation using the above copy-netural reference
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cbs <- CbsModel(cesN, ceRef);
print(cbs);

# Verify that the ChrX CNs are bias corrected
M <- NULL;
for (kk in 1:nbrOfArrays(cbs)) {
  rawCNs <- extractRawCopyNumbers(cbs, array=kk, chromosome=23);
  rawCNs <- as.data.frame(rawCNs)$cn;
  M <- cbind(M, rawCNs);
}
colnames(M) <- getArrays(cbs);

n23 <- sapply(cesN, getAttribute, "n23");
col <- c("blue", "red")[n23];
Mlab <- expression(log[2](theta/theta[R]));
Mlim <- c(-3.5,1.5);

fig <- "ChrX,biasCorrected";
if (!devIsOpen(fig)) {
  devNew2("png", width=width, height=0.618*width, label=fig);
  boxplot(as.data.frame(M), col=col, ylim=Mlim, ylab=Mlab, las=2);
  abline(h=0, lty=4);
  title("Copy numbers on ChrX\n(bias corrected)");
  devDone();
}



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation without correcting for ChrX biases
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cbs2 <- CbsModel(cesN);
print(cbs2);

# Verify that the ChrX CNs are bias corrected
M2 <- NULL;
for (kk in 1:nbrOfArrays(cbs2)) {
  rawCNs <- extractRawCopyNumbers(cbs2, array=kk, chromosome=23);
  rawCNs <- as.data.frame(rawCNs)$cn;
  M2 <- cbind(M2, rawCNs);
}
colnames(M2) <- getArrays(cbs2);

fig <- "ChrX,nonCorrected";
if (!devIsOpen(fig)) {
  devNew2("png", width=width, height=0.618*width, label=fig);
  boxplot(as.data.frame(M2), col=col, ylim=Mlim, ylab=Mlab, las=2);
  abline(h=0, lty=4);
  title("Copy numbers on ChrX\n(non-bias corrected)");
  devDone();
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation using only females for the reference
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesXX <- cesN[(n23 == 2)];
stopifnot(all(sapply(cesXX, getAttribute, "n23") == 2));
ceXX <- getAverageFile(cesXX);

# NOTE: This used the females for all chromosomes - here we only use
# it to illustrate the ChrX estimates.
cbs3 <- CbsModel(cesN, ceXX);
print(cbs3);

# Verify that the ChrX CNs are bias corrected
M3 <- NULL;
for (kk in 1:nbrOfArrays(cbs3)) {
  rawCNs <- extractRawCopyNumbers(cbs3, array=kk, chromosome=23);
  rawCNs <- as.data.frame(rawCNs)$cn;
  M3 <- cbind(M3, rawCNs);
}
colnames(M3) <- getArrays(cbs3);

fig <- "ChrX,XXreference";
if (!devIsOpen(fig)) {
  devNew2("png", width=width, height=0.618*width, label=fig);
  boxplot(as.data.frame(M3), col=col, ylim=Mlim, ylab=Mlab, las=2);
  abline(h=0, lty=4);
  title("Copy numbers on ChrX\n(reference based on XX samples)");
  devDone();
}

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080722";

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";
nbrOfEnzymes <- 2;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(   ".na%s", naVersion),
      cn=sprintf(".cn.na%s", naVersion)
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=log);
  str(units);
  ## GenomeWideSNP_6.na26.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na26.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);

x <- summaryOfUnits(ufl);
print(x);
## GenomeWideSNP_6,Full,na26,HB20080722:
##                 snp    cnp affxSnp other   total
## enzyme1-only 246080 451191       0     0  697271
## enzyme2-only 160899      0       0     0  160899
## both         522472 494615       0     0 1017087
## missing        2495     20    3022   621    6158
## total        931946 945826    3022   621 1881415


## GenomeWideSNP_6,na26,HB20080821:
##                 snp    cnp affxSnp other   total
## enzyme1-only 240001 451191       0     0  691192
## enzyme2-only 154884      0       0     0  154884
## both         510330 494615       0     0 1004945
## missing        1385     20    3022   621    5048
## total        906600 945826    3022   621 1856069


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na24 -> na26
#   - All changes are for SNP units.
#   - There are 6 NspI and 14 StyI changes in SNP fragment lengths,
#     which some are only minor.
#   - There are 1108 more SNPs that now have missing values.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ufl <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na26");
ufl2 <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na24");
x <- summaryOfUnits(ufl);
x2 <- summaryOfUnits(ufl2);

print(x);
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415
print(x2);
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246340 451191       0     0  697531
##  enzyme2-only 161064      0       0     0  161064
##  both         523155 494615       0     0 1017770
##  missing        1387     20    3022   621    5050
##  total        931946 945826    3022   621 1881415

print(x-x2);
##               snp cnp affxSnp other total
## enzyme1-only -260   0       0     0  -260
## enzyme2-only -165   0       0     0  -165
## both         -683   0       0     0  -683
## missing      1108   0       0     0  1108
## total           0   0       0     0     0

# Differences
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(ufl[,cc] != ufl2[,cc], na.rm=FALSE);
  df <- cbind(units, ufl[units,cc], ufl2[units,cc], 
                     ufl[units,cc]-ufl2[units,cc]);
  colnames(df)[ncol(df)] <- "delta";
  print(df);
}

##      units length length delta
##  1  159802    611    641   -30
##  2  191853    481   1025  -544
##  3  289265    974    976    -2
##  4  510015   1128   1132    -4
##  5  671142    964    226   738
##  6  879970   1187   1474  -287
##  
##      units length.02 length.02 delta
##  1  159802       385      1015  -630
##  2  191853      1007       953    54
##  3  200432       737       744    -7
##  4  205447       747       742     5
##  5  240336       739       684    55
##  6  351955       534       495    39
##  7  415362       744      1228  -484
##  8  446535       741       744    -3
##  9  671142      1217      1516  -299
##  10 783865      1070       857   213
##  11 786653       279       415  -136
##  12 817336       844       951  -107
##  13 821426       485       637  -152
##  14 879970       740       748    -8

# Differences in NAs
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(is.na(ufl[,cc]) != is.na(ufl2[,cc]));
  df <- cbind(units, ufl[units,cc], ufl2[units,cc]);
  str(df);
}

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WORKAROUNDS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# The 'GenomeWideSNP_6.cn.na25.annot.csv' [474,602,222 bytes] contains
# a duplicated column header "Fragment Enzyme Type Length Start Stop",
# which needs to be deleted before running this script.  The new file
# length is 474,602,181 bytes. /HB 2008-04-25


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "25";
user <- "HB";
datestamp <- "20080424";

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";
nbrOfEnzymes <- 2;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
#    main=sprintf(   ".na%s", naVersion),
      cn=sprintf(".cn.na%s", naVersion)
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csv <- AffymetrixNetAffxCsvFile(pathname);
      csvList[[key]] <- csv;
      rm(csv);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=log);
  str(units);
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);

x <- summaryOfUnits(ufl, enzymes=c("NspI", "StyI"));
print(x);
##                 snp    cnp affxSnp other   total
## enzyme1-only 246080 451191       0     0  697271
## enzyme2-only 160899      0       0     0  160899
## both         522472 494615       0     0 1017087
## missing        2495     20    3022   621    6158
## total        931946 945826    3022   621 1881415

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)


dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")
#chipTypes <- chipTypes[2]

# Expected sample names
sampleNames <- c("NA06985", "NA06991", "NA06993", 
                 "NA06994", "NA07000", "NA07019")
tags <- "ACC,-XY,RMA,+300,A+B,FLN,-XY"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesList <- list()
for (chipType in chipTypes) {
  ces <- CnChipEffectSet$byName(dataSet, tags=tags, chipType=chipType)
  print(ces)
  stopifnot(identical(getNames(ces), sampleNames))
  cesList[[chipType]] <- ces
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired GLAD model
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired CN anlysis, by setting up some fake (test,control) pairs
testList <- lapply(cesList, FUN=extract, 1:3)
refList <- lapply(cesList, FUN=extract, 4:6)
glad <- GladModel(testList, refList)
print(glad)

fit(glad, arrays=1, chromosomes=19, verbose=log)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ChromosomeExplorer test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ce <- ChromosomeExplorer(glad)
print(ce)
process(ce, arrays=1:2, chromosomes=c(19,22), verbose=log)
## process(ce, verbose=log)

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "CytoScanHD_Array"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadACS(ar, chipType, tags=".*")
verbose && cat(verbose, "ACS: ", pathname)

pathname <- downloadUFL(ar, chipType, tags=".*")
verbose && cat(verbose, "UFL: ", pathname)

pathname <- downloadUGP(ar, chipType, tags=".*")
verbose && cat(verbose, "UGP: ", pathname)

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080916";

chipType <- "Mapping50K_Hind240";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
print(summary(ugp));
print(table(ugp[,1]));

## AromaUgpFile:
## Name: Mapping50K_Hind240
## Tags: na26,HB20080916
## Pathname: annotationData/chipTypes/Mapping50K_Hind240/Mapping50K_Hind240,na26,HB20080916.ugp
## File size: 280.39kB
## RAM: 0.00MB
## Number of data rows: 57299
## File format: v1
## Dimensions: 57299x2
## Column classes: integer, integer
## Number of bytes per column: 1, 4
## Footer: <createdOn>20080916 18:11:33 PDT</createdOn><platform>Affymetrix</platform><chipType>Mapping50K_Hind240</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping50K_Hind240.CDF</filename><filesize>56029390</filesize><checksum>84239fce7a443dd528e060731a8df77e</checksum></srcFile1><srcFile2><filename>Mapping50K_Hind240.na26.annot.csv</filename><filesize>92433908</filesize><checksum>fc9a48388f38491b5be7ffaf1fdc3861</checksum></srcFile2></srcFiles>
## Chip type: Mapping50K_Hind240
## Platform: Affymetrix

##  chromosome        position
##  Min.   :  1.000   Min.   :    48603
##  1st Qu.:  4.000   1st Qu.: 34667112
##  Median :  7.000   Median : 72677621
##  Mean   :  8.402   Mean   : 80405004
##  3rd Qu.: 12.000   3rd Qu.:114826216
##  Max.   : 23.000   Max.   :246727435
##  NA's   :363.000   NA's   :      363

##    1    2    3    4    5    6    7    8    9   10   11   12
## 4541 5072 3962 4342 4215 3968 3444 3549 2357 2743 2466 2592
##   13   14   15   16   17   18   19   20   21   22   23
## 2661 1931 1440 1145  985 1731  326  993  883  433 1157

library("aroma.core");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);
ar <- AromaRepository(verbose=TRUE);

verbose && enter(verbose, "Downloading annotation data");

chipType <- "Mapping50K_Hind240";
verbose && cat(verbose, "Chip type: ", chipType);

pathname <- downloadCDF(ar, chipType);
verbose && cat(verbose, "CDF: ", pathname);

chipType <- "Mapping50K_Xba240";
verbose && cat(verbose, "Chip type: ", chipType);

pathname <- downloadCDF(ar, chipType);
verbose && cat(verbose, "CDF: ", pathname);

verbose && exit(verbose);

library("aroma.affymetrix")
library("matrixStats"); # rowMedians()
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6,Full"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot (TCN,BAF) on Chr2:75-90Mb in Array #1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesN <- res$cesN
ce <- cesN[[1]]
sampleName <- getName(ce)

# Calculate reference signals
ceR <- getAverage(cesN, verbose=verbose)
print(ceR)

# Get annotation data
cdf <- getCdf(cesN)
ugp <- getAromaUgpFile(cdf)
ufl <- getAromaUflFile(cdf)


chr <- 2
chrTag <- sprintf("Chr%02d", chr)
units <- getUnitsOnChromosome(ugp, chromosome=2, region=c(75,90)*1e6)
pos <- getPositions(ugp, units=units) / 1e6

# Get (TCN,BAF) signals
thetaR <- extractTotalAndFreqB(ceR, units=units)[,"total"]
data <- extractTotalAndFreqB(ce, units=units)
data[,"total"] <- 2*data[,"total"] / thetaR
C <- data[,"total"]
B <- data[,"freqB"]

# Find genotype clusters in BAF
okB <- which(is.finite(B))
fit <- kmeans(B[okB], centers=c(0,1/2,1))

toPNG(getFullName(cesN), tags=c(sampleName, "PSCN,tracks"), {
  layout(matrix(1:2, ncol=1))
  par(mar=c(3,4,2,1)+0.1, pch=".")
  xlim <- range(pos, na.rm=TRUE)

  # Plot TCN track
  plot(NA, xlim=xlim, ylim=c(0,4), xlab="pos", ylab=expression(C))
  abline(h=0:4, lty=3, lwd=2, col="#999999")
  abline(h=median(C, na.rm=TRUE), lwd=2, col="red")
  points(pos,C, cex=3)
  lines(smooth.spline(pos,C), lwd=2, col="blue")
  abline(v=c(83.1,83.7))
  stext(side=3, pos=0, sampleName)
  stext(side=3, pos=1, chrTag)

  # Plot BAF track
  plot(NA, xlim=xlim, ylim=c(0,1), xlab="pos", ylab=expression(beta))
  abline(h=fit$centers, lwd=2, col="black")
  points(pos[okB], B[okB], cex=3, col=fit$cluster+1)
  abline(v=c(83.1,83.7))
})


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot (TCN,BAF) on Chr2 in Array #1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
units <- getUnitsOnChromosome(ugp, chromosome=2)
pos <- getPositions(ugp, units=units) / 1e6

# Get (TCN,BAF) signals
thetaR <- extractTotalAndFreqB(ceR, units=units)[,"total"]
data <- extractTotalAndFreqB(ce, units=units)
data[,"total"] <- 2*data[,"total"] / thetaR
C <- data[,"total"]
B <- data[,"freqB"]

# Find genotype clusters in BAF
okB <- which(is.finite(B))
fit <- kmeans(B[okB], centers=c(0,1/2,1))

# Identify non-polymorphic loci
isCN <- (getUnitTypes(cdf, units=units) == 5)

toPNG(getFullName(cesN), tags=c(sampleName, "PSCN,tracks,SNPsAndNonSNPs"), {
  layout(matrix(1:3, ncol=1))
  par(mar=c(3,4,2,1)+0.1, pch=".")
  xlim <- range(pos, na.rm=TRUE)

  # Plot TCN track for SNPs
  plot(NA, xlim=xlim, ylim=c(0,4), xlab="pos", ylab=expression(C))
  abline(h=0:4, lty=3, lwd=2, col="#999999")
  abline(h=median(C, na.rm=TRUE), lwd=2, col="red")
  x <- pos[!isCN]
  y <- C[!isCN]
  points(x,y, cex=3)
  lines(smooth.spline(x,y), lwd=2, col="blue")
  abline(v=c(83.1,83.7))
  stext(side=3, pos=0, sampleName)
  stext(side=3, pos=1, chrTag)

  # Plot TCN track for non-polymorphic loci
  plot(NA, xlim=xlim, ylim=c(0,4), xlab="pos", ylab=expression(C))
  abline(h=0:4, lty=3, lwd=2, col="#999999")
  abline(h=median(C, na.rm=TRUE), lwd=2, col="red")
  x <- pos[isCN]
  y <- C[isCN]
  points(x,y, cex=3)
  lines(smooth.spline(x,y), lwd=2, col="blue")
  abline(v=c(83.1,83.7))
  stext(side=3, pos=0, sampleName)
  stext(side=3, pos=1, chrTag)

  # Plot BAF track
  plot(NA, xlim=xlim, ylim=c(0,1), xlab="pos", ylab=expression(beta))
  abline(h=fit$centers, lwd=2, col="black")
  points(pos[okB], B[okB], cex=3, col=fit$cluster+1)
  abline(v=c(83.1,83.7))
})


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot TCN vs fragment length stratified by SNP & non-polymorphic loci
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Identify non-polymorphic loci
isCN <- (getUnitTypes(cdf, units=units) == 5)
fl <- ufl[units,]
nbrOfEnzymes <- ncol(fl)

toPNG(getFullName(cesN), tags=c(sampleName, "TCNvsFragmentLength"), {
  layout(matrix(1:4, ncol=1))
  par(mar=c(1,1,1,1)+0.1, pch=".")
  xlim <- c(0,2000)
  Clim <- c(0,4)

  # For SNPs and non-polymorphic loci
  for (type in c("SNP", "CN")) {
    if (type == "SNP") {
      idxs <- whichVector(!isCN)
    } else {
      idxs <- whichVector(isCN)
    }

    # For each enzyme
    for (ee in 1:nbrOfEnzymes) {
      x <- fl[idxs,ee]
      y <- C[idxs]
      ok <- whichVector(is.finite(x) & is.finite(y))
      x <- x[ok]
      y <- y[ok]
      plot(x,y, cex=2, xlim=xlim, ylim=Clim)
      lines(smooth.spline(x,y), lwd=2, col="red")
    } # for (ee ...)
  } # for (kk ...)
})


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot density of BAF stratified by TCN
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
breaks <- quantile(C, probs=seq(0,1,by=0.1), na.rm=TRUE)
cuts <- cut(C, breaks=c(0,1.4,1.68,10))
cuts <- as.integer(cuts)
ucuts <- unique(cuts)

toPNG(getFullName(cesN), tags=c(sampleName, "BAFDensityByTCN"), {
  cols <- terrain.colors(length(ucuts))
  plot(NA, xlim=c(0,1), ylim=c(0,3), xlab="BAF", ylab="density")

  # For each TCN bin...
  for (kk in seq_along(ucuts)) {
    idxs <- whichVector(cuts == kk)
    zkk <- na.omit(B[idxs])
    if (length(zkk) > 1) {
      printf("Number of loci: %d\n", length(zkk))
      d <- density(zkk, adjust=0.6, kernel="biweight")
      lines(d, lwd=2, col=cols[kk])
    }
  } # for (kk ...)
})


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Analyze autosomal chromosomes
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
units <- getUnitsOnChromosomes(ugp, 1:22)
theta <- extractTheta(cesN, units=units)
thetaR <- rowMedians(theta[,1,]+theta[,2,], na.rm=TRUE)

# (TCN,BAF) and (CA,CB) across all arrays
C <- 2*(theta[,1,]+theta[,2,])/thetaR
CA <- 2*theta[,1,]/thetaR
CB <- 2*theta[,2,]/thetaR
B <- CB/C

# Average TCN & (CA,CB) per array
mu <- colMedians(C, na.rm=TRUE)
muA <- colMedians(CA, na.rm=TRUE)
muB <- colMedians(CB, na.rm=TRUE)

Clim <- c(-0.2,3.2)
xlab <- "BAF"
Clab <- "TCN"
CAlab <- "CA"
CBlab <- "CB"

toPNG(getFullName(cesN), tags=c("ASCN"), {
  layout(matrix(1:9, nrow=3, byrow=TRUE))
  par(mar=c(4,4,0.5,0.5)+0.1)
  centers <- matrix(c(0,2, 1,1, 2,0), nrow=3, ncol=2, byrow=TRUE)

  # For each array...
  for (ii in 1:ncol(C)) {
    xx <- CA[,ii]
    yy <- CB[,ii]
    X <- cbind(xx,yy)
    ok <- (is.finite(X) & -1 < X & X < 30)
    ok <- ok[,1] & ok[,2]
    X <- X[ok,]
    smoothScatter(X, xlim=Clim, ylim=Clim, xlab=CAlab, ylab=CBlab)
    abline(h=0:3, lty=3, lwd=1)
    abline(v=0:3, lty=3, lwd=1)

    # Plot centers
    fit <- kmeans(X, centers=centers)
    print(fit$centers)
    points(fit$centers, pch=19, col="red")
  } # for (ii ...)
})


toPNG(getFullName(cesN), tags=c("TCNvsBAF"), {
  layout(matrix(1:9, nrow=3, byrow=TRUE))
  par(mar=c(4,4,0.5,0.5)+0.1)
  centers <- matrix(c(0,2, 1/2,2, 1,2), nrow=3, ncol=2, byrow=TRUE)

  # For each array...
  for (ii in 1:ncol(C)) {
    xx <- B[,ii]
    yy <- C[,ii]
    X <- cbind(xx,yy)
    ok <- (is.finite(X) & -1 < X & X < 30)
    ok <- ok[,1] & ok[,2]
    X <- X[ok,]
    smoothScatter(X, xlim=c(0,1), ylim=Clim, xlab=xlab, ylab=Clab)
    abline(h=0:3, lty=3, lwd=1)
    abline(v=0:2/2, lty=3, lwd=1)

    # Plot centers
    fit <- kmeans(X, centers=centers)
    print(fit$centers)
    points(fit$centers, pch=19, col="red")
  } # for (ii ...)
})

library("aroma.affymetrix")
library("matrixStats"); # rowMedians()

# Avoid being masked by affy::plotDensity()
plotDensity <- aroma.light::plotDensity

log <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup of annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CDF
cdf <- AffymetrixCdfFile$byChipType(chipType)

# Assert existence of probe-sequence annotation files
acs <- AromaCellSequenceFile$byChipType(chipType)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR)
print(acc)
csC <- process(acc, verbose=log)
print(csC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Base-position normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
bpn <- BasePositionNormalization(csC, shift=+300)
print(bpn)

csN <- process(bpn, verbose=log)
print(csN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allele-specific chip effect estimates
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- RmaCnPlm(csN, mergeStrands=TRUE, combineAlleles=FALSE)
print(plm)
fit(plm, verbose=log)
ces <- getChipEffectSet(plm)
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fragment-length normalization test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fln <- FragmentLengthNormalization(ces)
print(fln)
cesN <- process(fln, verbose=log)
print(cesN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract (thetaA, thetaB) for copy-neutral chromosomes
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- getCdf(cesN)
gi <- getGenomeInformation(cdf)
units <- getUnitsOnChromosomes(gi, 1:22)
theta <- extractTheta(cesN, units=units)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Estimate copy numbers on the natural scale
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
thetaR <- rowMedians(theta[,1,]+theta[,2,], na.rm=TRUE)
C <- 2*(theta[,1,]+theta[,2,])/thetaR
CA <- 2*theta[,1,]/thetaR
CB <- 2*theta[,2,]/thetaR
freqB <- CB/C

mu <- colMedians(C, na.rm=TRUE)
muA <- colMedians(CA, na.rm=TRUE)
muB <- colMedians(CB, na.rm=TRUE)

Clim <- c(-0.2,3.2)
xlab <- "Freq B (thetaB/theta)"
Clab <- "Copy number"
CAlab <- "Copy number (Allele A)"
CBlab <- "Copy number (Allele B)"
col <- "green"

fig <- 1
if (!devIsOpen(fig <- fig + 1)) {
  devNew()
  layout(matrix(1:9, nrow=3, byrow=TRUE))
  par(mar=c(4,4,0.5,0.5)+0.1)
  centers <- matrix(c(0,2, 1,1, 2,0), nrow=3, ncol=2, byrow=TRUE)
  for (cc in 1:ncol(C)) {
    xx <- CA[,cc]
    yy <- CB[,cc]
    X <- cbind(xx,yy)
    ok <- (is.finite(X) & -1 < X & X < 30)
    ok <- ok[,1] & ok[,2]
    X <- X[ok,]
    smoothScatter(X, xlim=Clim, ylim=Clim, xlab=CAlab, ylab=CBlab)
    abline(h=0:3, lty=3, lwd=1)
    abline(v=0:3, lty=3, lwd=1)
    abline(a=2, b=-1, lty=1, lwd=1, col="white")
    abline(a=2, b=-1, lty=2, lwd=1)

    # Plot centers
    fit <- kmeans(X, centers=centers, algorithm="Lloyd", iter.max=30)
    print(fit$centers)
    lines(fit$centers[c(1,3),], col=col, lwd=1)
    points(fit$centers, pch=21, col="white", bg=col, lwd=1.5)
  }
  devDone()
}

if (!devIsOpen(fig <- fig + 1)) {
  devNew()
  layout(matrix(1:9, nrow=3, byrow=TRUE))
  par(mar=c(4,4,0.5,0.5)+0.1)
  centers <- matrix(c(0,2, 1/2,2, 1,2), nrow=3, ncol=2, byrow=TRUE)
  for (cc in 1:ncol(C)) {
    xx <- freqB[,cc]
    yy <- C[,cc]
    X <- cbind(xx,yy)
    ok <- (is.finite(X) & -1 < X & X < 30)
    ok <- ok[,1] & ok[,2]
    X <- X[ok,]
    smoothScatter(X, xlim=c(0,1), ylim=Clim, xlab=xlab, ylab=Clab)
    abline(h=0:3, lty=3, lwd=1)
    abline(v=0:2/2, lty=3, lwd=1)

    # Plot centers
    fit <- kmeans(X, centers=centers, algorithm="Lloyd", iter.max=30)
    print(fit$centers)
    lines(fit$centers[c(1,3),], col=col, lwd=1)
    points(fit$centers, pch=21, col="white", bg=col, lwd=1.5)
  }
  plotDensity(freqB, lwd=2, xlim=c(0,1), ylim=c(0,2.2))
  abline(v=c(0,1/2,1), lty=3, lwd=1)
  abline(h=c(0,1,2), lty=3, lwd=1)
  devDone()
}

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "Canine_2";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Get required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
print(cdf);

ptb <- AffymetrixProbeTabFile$byChipType(chipType);
print(ptb);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate aroma cell sequence file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acs <- AromaCellSequenceFile$allocateFromCdf(cdf, tags="HB20100918");
print(acs);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import data from the Affymetrix probe-tab file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom(acs, ptb, verbose=log);

# Infer MM from PM sequences?  Will give an error if no MMs
inferMmFromPm(acs, cdf=cdf, verbose=log);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (interactive()) savehistory()
library("aroma.affymetrix")

# Avoid being masked by affy::plotDensity()
plotDensity <- aroma.light::plotDensity

# Use a nicer palette of colors
colors <- RColorBrewer::brewer.pal(12, "Paired")
palette(colors)

# Default width of plots
width <- 7

devNew2 <- function(...) {
  imgFormat <- c("x11", "png")[2]
  if (imgFormat == "x11") {
    devNew("x11", width=width, height=height, label=fig)
  } else {
    # Rescale for PNG
    c <- 640/7
    width <- c*width
    height <- c*height
    figPath <- "figures"
    mkdirs(figPath)
    filename <- sprintf("%s.png", fig)
    pathname <- filePath(figPath, filename)
    devNew("png", file=pathname, width=width, height=height, label=fig)
  }
}

# Setup the Verbose object
verbose <- Arguments$getVerbose(-10, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup of raw data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType("Mapping50K_Hind240")
  print(cdf)

  gi <- getGenomeInformation(cdf)
  print(gi)

  si <- getSnpInformation(cdf)
  print(si)

  acs <- AromaCellSequenceFile$byChipType(getChipType(cdf, fullname=FALSE))
  print(acs)
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup of raw data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName("HapMap,CEU,testSet", cdf=cdf)
print(getFullNames(csR))

## [1] "NA06985_Hind_B5_3005533"  "NA06991_Hind_B6_3005533"
## [3] "NA06993_Hind_B4_4000092"  "NA06994_Hind_A7_3005533"
## [5] "NA07000_Hind_A8_3005533"  "NA07019_Hind_A12_4000092"
## [7] "NA07022_Hind_A10_4000092" "NA07029_Hind_A9_4000092"
## [9] "NA07034_Hind_B1_4000092"  "NA07048_Hind_B3_4000092"


# The CEL files downloaded from HapMap has file names such as
# NA07000_Hind_A8_3005533.CEL.  In order for aroma.affymetrix to identify
# 'NA07000' as the sample name, and 'A8' and '3005533' as tags (ignore
# the 'Hind' part), we will utilize so called fullname translators that
# translates the full name to a comma-separated fullname, e.g.
# 'NA07000_Hind_A8_3005533' to 'NA07000,A8,3005533'.

setFullNamesTranslator(csR, function(names, ...) {
  # Turn into comma-separated tags
  names <- gsub("_", ",", names)
  # Drop any Hind/Xba tags
  names <- gsub(",(Hind|Xba)", "", names)
  names
})
print(getFullNames(csR))

## [1] "NA06985,B5,3005533"  "NA06991,B6,3005533"
## [3] "NA06993,B4,4000092"  "NA06994,A7,3005533"
## [5] "NA07000,A8,3005533"  "NA07019,A12,4000092"
## [7] "NA07022,A10,4000092" "NA07029,A9,4000092"
## [9] "NA07034,B1,4000092"  "NA07048,B3,4000092"

print(csR)

## AffymetrixCelSet:
## Name: HapMap
## Tags: CEU,testSet
## Path: rawData/HapMap,CEU,testSet/Mapping50K_Hind240
## Platform: Affymetrix
## Chip type: Mapping50K_Hind240
## Number of arrays: 10
## Names: NA06985, NA06991, ..., NA07048
## Time period: 2004-01-14 14:02:08 -- 2004-02-13 11:51:01
## Total file size: 244.78MB
## RAM: 0.01MB


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Brief about different types of probes
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

# On Affymetrix arrays, there are different types of probes (cells).
# The most well known are perfect-match (PM) and mismatch (MM) probes.
# In addition to these, there are also QC probes, e.g. so called
# landing-light probes and chequered-flag probes etc.

# One can query the CDF for the indices of the cells for each type.
# If one ask for "all", then all cells on the array are returned.

types <- c("all", "pmmm", "pm", "mm")
cells <- lapply(types, FUN=function(type) identifyCells(cdf, types=type))
names(cells) <- types
str(cells)
##  $ all : int [1:2560000] 1 2 3 4 5 6 7 8 9 10 ...
##  $ pmmm: int [1:2291560] 1606 1607 1609 1610 1611 1613 1614 1615
##  $ pm  : int [1:1145780] 1606 1607 1609 1610 1611 1613 1614 1615
##  $ mm  : int [1:1145780] 3206 3207 3209 3210 3211 3213 3214 3215


# As we will see next, one can specify these types also when plotting
# the empirical densities and when doing quantile normalization.


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Raw probe-signal densities
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# The plotDensity() method for an AffymetrixCelSet estimates and draws
# smooth empirical density functions for each array in set.  It is
# possible to stratify by probe type (see above) by setting the 'types'
# argument.  For instance, types="all" uses all probes on the chip,
# types="pmmm" uses all PM & MM probes, types="pm" only the PM probes etc.
# Internally, the stats::density() function is used.
height <- 0.618*width
cols <- seq_along(types)

fig <- "plotDensity,raw"
if (!devIsOpen(fig) && FALSE) {
  devNew2(width=width, height=height, label=fig)
  for (kk in seq_along(types)) {
    plotDensity(csR, types=types[kk], col=cols[kk], subset=NULL,
                lwd=2, ylim=c(0,0.45), add=(kk > 1))
  }
  legend("topleft", col=cols, lwd=4, types)
  title("Raw probe signals")
  devDone()
}



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Rank-based quantile normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

# The QuantileNormalization class provide methods for doing rank-based quantile normalization of probe signals.  By specifying argument 'typesToUpdates' one can specify what type of probes should be normalized (and used in the model fitting).  All other probe signals are left unchanged.  The default is typesToUpdates="all", but any of "pmmm", "pm" and "mm" can also be used.  We will here show the how they produce different results.


for (type in types) {
  verbose && enter(verbose, "Rank-based quantile normalization on ",
                                                        type, " probes")
  verbose && cat(verbose, "typesToUpdate: ", type)

  qn <- QuantileNormalization(csR, typesToUpdate=type, tags=c("*", type))
  print(qn)
  csN <- process(qn, verbose=verbose)

  fig <- sprintf("plotDensity,QN,%s", type)
  if (!devIsOpen(fig)) {
    devNew2(width=width, height=height, label=fig)

    # Plot the type normalized by last.
    kks <- match(c(setdiff(types, type), type), types)
    for (kk in kks) {
      plotDensity(csN, types=types[kk], subset=NULL,
                  col=cols[kk], lwd=2, ylim=c(0,0.45), add=(kk != kks[1]))
    }
    legend("topleft", col=cols, lwd=4, types)
    title(sprintf("QuantileNormalization(..., typesToUpdate=\"%s\")", type))

    devDone()
  }

  verbose && exit(verbose)
}



# TO DO: identifyCells(cdf, types="qc") returns an empty vector.

##########################################################################
# Allele-specific CRMAv2 and Paired PSCBS
#
# Author: Henrik Bengtsson
# Created on: 2011-11-11
# Last updated: 2012-09-02
##########################################################################
library("aroma.affymetrix")
library("PSCBS")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# Graphics options
devOptions("png", width=840)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE12702"
chipType <- "Mapping250K_Nsp"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract a single tumor-normal pair
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract tumor-normal pair
pair <- c(T="GSM318736", N="GSM318737")
csR <- csR[indexOf(csR, pair)]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired PSCBS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Get (chromosome, position) annotation data
dsT <- dsNList$total
ugp <- getAromaUgpFile(dsT)
chromosome <- ugp[,1,drop=TRUE]
x <- ugp[,2,drop=TRUE]

# Extract (total,beta) estimates for the tumor-normal pair
data <- extractPSCNArray(dsT)
dimnames(data)[[3]] <- names(pair)
str(data)

CT <- 2 * (data[,"total","T"] / data[,"total","N"])
betaT <- data[,"fracB","T"]
betaN <- data[,"fracB","N"]

# Setup data structure for Paired PSCBS
df <- data.frame(chromosome=chromosome, x=x, CT=CT, betaT=betaT, betaN=betaN)

# Segment Chr 8.
dfT <- subset(df, chromosome == 8)
str(dfT)

# Paired PSCBS
fit <- segmentByPairedPSCBS(dfT, verbose=verbose)
print(fit)

# Plot segmentation results
pairName <- paste(pair, collapse="vs")
chrTag <- sprintf("Chr%s", seqToHumanReadable(getChromosomes(fit)))
toPNG(pairName, tags=c(chrTag, "PairedPSCBS"), aspectRatio=0.6, {
  plotTracks(fit)
  stext(side=3, pos=0, pairName)
  stext(side=3, pos=1, chrTag)
  stext(side=4, pos=1, sprintf("n=%d", nbrOfLoci(fit)))
  stext(side=4, pos=1, getChipType(dsT))
})

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic-crosstalk calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR)
print(acc)

csC <- process(acc, verbose=verbose)
print(csC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Base-count normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
bcn <- BaseCountNormalization(csC, shift=+300, bootstrap=TRUE)
print(bcn)

csN <- process(bcn, verbose=verbose)
print(csN)

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "Mm_PromPR_v02"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080916";

chipType <- "Mapping10K_Xba142";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
print(summary(ugp));
print(table(ugp[,1]));

##  AromaUgpFile:
##  Name: Mapping10K_Xba142
##  Tags: na26,HB20080916
##  Pathname: annotationData/chipTypes/Mapping10K_Xba142/Mapping10K_Xba142,na26,HB20080916.ugp
##  File size: 50.45kB
##  RAM: 0.00MB
##  Number of data rows: 10208
##  File format: v1
##  Dimensions: 10208x2
##  Column classes: integer, integer
##  Number of bytes per column: 1, 4
##  Footer: <createdOn>20080916 18:46:43 PDT</createdOn><platform>Affymetrix</platform><chipType>Mapping10K_Xba142</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping10K_Xba142.cdf</filename><filesize>9995717</filesize><checksum>ad6ef2568ad7c629c4218b3f402a5cf4</checksum></srcFile1><srcFile2><filename>Mapping10K_Xba142.na26.annot.csv</filename><filesize>16140044</filesize><checksum>666197b57c567684d370cfa8e68057d2</checksum></srcFile2></srcFiles>
##  Chip type: Mapping10K_Xba142
##  Platform: Affymetrix
##   chromosome        position
##   Min.   :  1.000   Min.   :    93683
##   1st Qu.:  4.000   1st Qu.: 33818850
##   Median :  8.000   Median : 70698761
##   Mean   :  8.811   Mean   : 79654836
##   3rd Qu.: 13.000   3rd Qu.:115978598
##   Max.   : 23.000   Max.   :246860369
##   NA's   :113.000   NA's   :      113

##    1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
##  781 843 708 696 702 694 514 473 487 532 551 480 438 357 284
##   16  17  18  19  20  21  22  23
##  226 167 306 149 204 164  76 263

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naVersions <- c(30:33, 35)
naVersion <- textMenu(naVersions, title="Choose NetAffx version: ", value=TRUE);
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);

genomeVersion <- getHeaderAttributes(csvList[[1]])[["genome-version"]];
genomeVersion <- Arguments$getCharacter(genomeVersion, nchar=4, length=c(1,1));
dbSNPVersion <- getHeaderAttributes(csvList[[1]])[["dbSNP-version"]];
dbSNPVersion <- Arguments$getInteger(dbSNPVersion);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
tags <- sprintf("na%s,%s,dbSNP%d,%s%s", naVersion, genomeVersion, dbSNPVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=verbose);
  str(units);
  ## GenomeWideSNP_6.na<XX>.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile),
    filesize=getFileSize(srcFile),
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugp);
footer$createdBy <- list(
  fullname = fullname,
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
print(ugp);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# WHAT'S NEW:
#
# o na32 -> na33 (hg19, dbSNP 132 -> dbSNP 137)
#   No differences.
# o na31 -> na32 (hg19, dbSNP 131 -> dbSNP 132)
#   89 SNPs have jumped chromosomes. 422 SNPs have moved within
#   chromosomes.  This is most likely due to updates in dbSNP.
#   In addition there are several migrations from/to being NA.
# o na30 -> na31
#   Lots of changes, especially large changes in positions.
# o na27.1 -> na30
#   No differences
# o na27 -> na27.1
#   No differences
# o na26 -> na27
#   Two units (932039, 1872834) where moved from ChrX to ChrY.
#   Same location.
# o na24 -> na26
#   Only minor modifications for non-missing values:
#   - three loci changed chromosomes
#   - an additional 23 loci changed positions, of which only 17 moved
#     more than 2 base pairs.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ugp <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na33");
ugp0 <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na32");

print(table(ugp[,1], exclude=NULL));
print(table(ugp0[,1], exclude=NULL));

## GenomeWideSNP_6,Full,na33,hg19,dbSNP137,HB20140117
##      1      2      3      4      5      6      7      8
## 146458 153641 127776 120351 115709 112858 100828  98274
##      9     10     11     12     13     14     15     16
##  82178  93627  89604  87336  66091  57118  53554  54181
##     17     18     19     20     21     22     23     24
##  46590  52103  30362  43647  25091  24405  87102   9442
##     25   <NA>
##    411   2678

## GenomeWideSNP_6,Full,na32,hg19,dbSNP132,HB20140118
##      1      2      3      4      5      6      7      8
## 146458 153641 127776 120351 115709 112858 100828  98274
##      9     10     11     12     13     14     15     16
##  82178  93627  89604  87336  66091  57118  53554  54181
##     17     18     19     20     21     22     23     24
##  46590  52103  30362  43647  25091  24405  87102   9442
##     25   <NA>
##    411   2678

## GenomeWideSNP_6,Full,na31,hg19,HB20110328
##      1      2      3      4      5      6      7      8
## 146626 153717 127767 120377 115735 112727 100925  98308
##      9     10     11     12     13     14     15     16
##  82300  93635  89598  87341  65927  57115  53596  54111
##     17     18     19     20     21     22     23     24
##  46609  52102  30365  43649  25105  24438  87271   9688
##     25   <NA>
##    455   1928



units <- whichVector(ugp[,1] != ugp0[,1]);
str(units);
## int(0)

units <- whichVector(ugp[,2] != ugp0[,2]);
str(units);
## int(0)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-3, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-HeartBrain"
chipType <- "HuEx-1_0-st-v2"
cdf <- AffymetrixCdfFile$byChipType(chipType, tags="coreR3,A20071112,EP")
print(cdf)

# Setup CEL set using the core CDF.
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only cerebellum and heart
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
types <- c("cerebellum", "heart")
csR <- csR[indexOf(csR, patterns=types)]

setFullName(csR, sprintf("%s,%s", dataSet, paste(types, collapse="+")))
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# FIRMA
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doFIRMA(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# PLMs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plmList <- list(
  merge   = res$plm,                               # all exons together
  noMerge = ExonRmaPlm(res$csN, mergeGroups=FALSE) # each exon separately
)
print(plmList)

# Fit the per-exon PLM
fit(plmList$noMerge, verbose=verbose)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# PLM residuals (also calculated by FIRMA)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
resList <- lapply(plmList, FUN=calculateResidualSet, verbose=verbose)
print(resList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# PLM weights
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
weightList <- lapply(plmList, FUN=calculateWeights, verbose=verbose)
print(weightList)

library("aroma.affymetrix")

ovars <- ls(all.names=TRUE)
oplan <- future::plan()

## Setup dataset
dataset <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6,Full"

csR <- AffymetrixCelSet$byName(dataset, chipType=chipType)
csR <- csR[1:2]
print(csR)

checksum <- NULL

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  }
}

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  ## (a) Process a single array
  bpn <- BasePositionNormalization(csR[1], target="zero", tags=c(tags, "one-array"))
  print(bpn)
  csC1 <- process(bpn, verbose=-10)
  print(csC1)
  csC1z <- getChecksumFileSet(csC1)
  print(csC1z[[1]])

  ## Compare file checksum to previous runs
  checksumT <- readChecksum(csC1z[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))


  ## (b) Process two arrays
  bpn <- BasePositionNormalization(csR, target="zero", tags=tags)
  print(bpn)
  csC <- process(bpn, verbose=-10)
  print(csC)
  csCz <- getChecksumFileSet(csC)
  print(csCz[[1]])
  res <- equals(csC1z[[1]], csCz[[1]])
  if (!res) throw(res)

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}


## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE9890/
#   HG-U133_Plus_2/
#    GSM249671.CEL, ..., GSM249680.CEL [10]
#
# Overall design:
#  [Ten] cervival cancer cell lines were hybridized to Affymetrix 
#  Focus arrays in duplicate. Correlations were made with copynumber 
#  profiles from arrayCGH and SNP arrays.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE8605
##########################################################################
dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType,
                                   chipTypeAliases=c("Focus"="HG-Focus"))
print(ds)
## AffymetrixCelSet:
## Name: GSE9890
## Tags:
## Path: rawData/GSE9890/HG-U133_Plus_2
## Platform: Affymetrix
## Chip type: HG-U133_Plus_2
## Number of arrays: 10
## Names: GSM249671, GSM249672, GSM249673, ..., GSM249680 [10]
## Time period: 2006-12-12 15:27:01 -- 2007-06-28 10:55:52
## Total file size: 129.36MB
## RAM: 0.01MB


verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

cdf <- AffymetrixCdfFile$byChipType("Mapping10K_Xba142")
print(cdf)

# Read CDF data per probe as a data.frame
data <- readDataFrame(cdf, units=1024:1058)
str(data)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-HapMap,CEU,set1"
chipType <- "GenomeWideSNP_5"

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="Full,r2")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)

# Split up into names and tags
setFullNamesTranslator(csR, function(names, ...) {
  gsub("^(NA[0-9]+)_(.*)", "\\1,\\2", names)
})

# Drop duplicates
keep <- !duplicated(getNames(csR))
csR <- csR[keep]

# Keep only certain samples
sampleNames <- c("NA06985", "NA06991", "NA06993",
                 "NA07019", "NA07022", "NA07056")
csR <- csR[sampleNames]

print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Residuals
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- res$plm
rs <- calculateResidualSet(plm, verbose=verbose)
print(rs)

ae <- ArrayExplorer(rs)
setColorMaps(ae, c("log2,log2neg,rainbow", "log2,log2pos,rainbow"))
print(ae)
process(ae, arrays=1:2, verbose=verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naVersions <- 30:33;
naVersion <- textMenu(naVersions, title="Choose NetAffx version: ", value=TRUE);
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);

genomeVersion <- getHeaderAttributes(csvList[[1]])[["genome-version"]];
genomeVersion <- Arguments$getCharacter(genomeVersion, nchar=4, length=c(1,1));
dbSNPVersion <- getHeaderAttributes(csvList[[1]])[["dbSNP-version"]];
dbSNPVersion <- Arguments$getInteger(dbSNPVersion);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
tags <- sprintf("na%s,%s,dbSNP%d,%s%s", naVersion, genomeVersion, dbSNPVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=verbose);
  str(units);
  ## GenomeWideSNP_6.na<XX>.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile),
    filesize=getFileSize(srcFile),
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugp);
footer$createdBy <- list(
  fullname = fullname,
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
print(ugp);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# WHAT'S NEW:
#
# o na32 -> na33 (hg19, dbSNP 132 -> dbSNP 137)
#   No differences.
# o na31 -> na32 (hg19, dbSNP 131 -> dbSNP 132)
#   89 SNPs have jumped chromosomes. 422 SNPs have moved within
#   chromosomes.  This is most likely due to updates in dbSNP.
#   In addition there are several migrations from/to being NA.
# o na30 -> na31
#   Lots of changes, especially large changes in positions.
# o na27.1 -> na30
#   No differences
# o na27 -> na27.1
#   No differences
# o na26 -> na27
#   Two units (932039, 1872834) where moved from ChrX to ChrY.
#   Same location.
# o na24 -> na26
#   Only minor modifications for non-missing values:
#   - three loci changed chromosomes
#   - an additional 23 loci changed positions, of which only 17 moved
#     more than 2 base pairs.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ugp <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na33");
ugp0 <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na32");

print(table(ugp[,1], exclude=NULL));
print(table(ugp0[,1], exclude=NULL));

## GenomeWideSNP_6,Full,na33,hg19,dbSNP137,HB20140117
##      1      2      3      4      5      6      7      8
## 146458 153641 127776 120351 115709 112858 100828  98274
##      9     10     11     12     13     14     15     16
##  82178  93627  89604  87336  66091  57118  53554  54181
##     17     18     19     20     21     22     23     24
##  46590  52103  30362  43647  25091  24405  87102   9442
##     25   <NA>
##    411   2678

## GenomeWideSNP_6,Full,na32,hg19,dbSNP132,HB20140118
##      1      2      3      4      5      6      7      8
## 146458 153641 127776 120351 115709 112858 100828  98274
##      9     10     11     12     13     14     15     16
##  82178  93627  89604  87336  66091  57118  53554  54181
##     17     18     19     20     21     22     23     24
##  46590  52103  30362  43647  25091  24405  87102   9442
##     25   <NA>
##    411   2678

## GenomeWideSNP_6,Full,na31,hg19,HB20110328
##      1      2      3      4      5      6      7      8
## 146626 153717 127767 120377 115735 112727 100925  98308
##      9     10     11     12     13     14     15     16
##  82300  93635  89598  87341  65927  57115  53596  54111
##     17     18     19     20     21     22     23     24
##  46609  52102  30365  43649  25105  24438  87271   9688
##     25   <NA>
##    455   1928



units <- whichVector(ugp[,1] != ugp0[,1]);
str(units);
## int(0)

units <- whichVector(ugp[,2] != ugp0[,2]);
str(units);
## int(0)

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)



dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")

# Expected sample names
sampleNames <- c("NA06985", "NA06991", "NA06993", 
                 "NA06994", "NA07000", "NA07019")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csRList <- list()
for (chipType in chipTypes) {
  cs <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
  print(cs)
  stopifnot(identical(getNames(cs), sampleNames))
  csRList[[chipType]] <- cs
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test #1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Do it on the raw data so that we can validate the results
csList <- csRList;  

plmList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  plm <- RmaPlm(cs)
  print(plm)
  fit(plm, verbose=log)
  ces <- getChipEffectSet(plm)
  print(ces)
  stopifnot(identical(getNames(ces), getNames(cs)))

  # Assert a few results
  if (chipType == "Mapping250K_Nsp") {
    unit <- 100
    theta <- readUnits(ces, units=unit, verbose=log)
    data <- unlist(theta, use.names=FALSE)
    data <- sum(data, na.rm=TRUE)
    if (!isZero(data - 57448.85473633, eps=.Machine$float.eps)) {
      print(theta)
      throw("Non-reproducible chip-effect estimates detected for unit ", unit)
    }
  }

  plmList[[chipType]] <- plm
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# PLM residual test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
rsList <- list()
for (chipType in names(plmList)) {
  plm <- plmList[[chipType]]
  print(plm)
  rs <- calculateResidualSet(plm, verbose=log)
  print(rs)
  stopifnot(identical(getNames(rs), getNames(cs)))

  # Assert a few results
  if (chipType == "Mapping50K_Hind240") {
    cs <- getDataSet(plm)
    ces <- getChipEffectSet(plm)
    paf <- getProbeAffinityFile(plm)
    unit <- 500
    y <- readUnits(plm, units=unit, verbose=log)
    theta <- readUnits(ces, units=unit, verbose=log)
    phi <- readUnits(paf, units=unit, verbose=log)
    resids <- readUnits(rs, units=unit, verbose=log)
    str(resids)
  }

  rsList[[chipType]] <- rs
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial residual plots test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ae <- ArrayExplorer(rsList)
setColorMaps(ae, c("log2,log2neg,rainbow", "log2,log2pos,rainbow"))
print(ae)
stopifnot(identical(unname(getArrays(ae)), getNames(cs)))
process(ae, arrays=1:2, interleaved="auto", verbose=log)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# PLM weights (from residuals) test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
for (chipType in names(plmList)[1]) {
  plm <- plmList[[chipType]]
  print(plm)
  rs <- getResidualSet(plm, verbose=log)
  print(rs)
  stopifnot(identical(getNames(rs), getNames(cs)))

  ws <- calculateWeights(plm, verbose=log)
  print(rs)

  rsList[[chipType]] <- rs
}

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-3, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-HeartBrain"
chipType <- "HuEx-1_0-st-v2"
cdf <- AffymetrixCdfFile$byChipType(chipType, tags="coreR3,A20071112,EP")
print(cdf)

# Setup CEL set using the core CDF.
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only cerebellum and heart
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
types <- c("cerebellum", "heart")
csR <- csR[indexOf(csR, patterns=types)]

setFullName(csR, sprintf("%s,%s", dataSet, paste(types, collapse="+")))
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# FIRMA
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doFIRMA(csR, drop=FALSE, verbose=verbose)
print(res)


# Extract FIRMA scores
fs <- res$fs
data <- extractDataFrame(fs, units=1:100, addNames=TRUE)
fields <- colnames(data)
cc <- which(fields == "cell")
data[,-(1:cc)] <- log2(data[,-(1:cc)])
fields <- gsub("unit", "transcript", fields)
fields <- gsub("group", "exon", fields)
colnames(data) <- fields

library("aroma.affymetrix")

verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# RMA/NormExp background correction
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
bg1 <- RmaBackgroundCorrection(csR)
print(bg1)
csB1 <- process(bg1, verbose=verbose)
print(csB1)


# Alternative, which gives identical results
bg2 <- NormExpBackgroundCorrection(csR)
print(bg2)
csB2 <- process(bg2, verbose=verbose)
print(csB2)

Y1 <- extractMatrix(csB1)
Y2 <- extractMatrix(csB2)
stopifnot(identical(Y1, Y2))

# Same model, but fitted with a maximum-likelihood estimator
bg3 <- NormExpBackgroundCorrection(csR, method="mle")
print(bg3)
csB3 <- process(bg3, verbose=verbose)
print(csB3)

Y3 <- extractMatrix(csB3)
# The MLE estimator does not give identical results...
print(all.equal(Y3, Y1))
# ...but highly correlated ones!
cor <- diag(cor(Y3,Y1))
print(cor)
stopifnot(all(cor > 0.9999))



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# GCRMA background correction
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# GCRMA background correction requires an ACS file
cdf <- getCdf(csR)
acs <- getAromaCellSequenceFile(cdf)
print(acs)

bg4 <- GcRmaBackgroundCorrection(csR)
print(bg4)
csB4 <- process(bg4, verbose=verbose)
print(csB4)

Y4 <- extractMatrix(csB4)
cor <- diag(cor(Y4,Y1))
print(cor)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "31";
user <- "HB";
datestamp <- "20101007";

chipType <- "Mapping250K_Nsp";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
## AromaUgpFile:
## Name: Mapping250K_Nsp
## Tags: na31,HB20101007
## Full name: Mapping250K_Nsp,na31,HB20101007
## Pathname: annotationData/chipTypes/Mapping250K_Nsp/Mapping250K_Nsp,na31,HB20101007.ugp
## File size: 1.25 MB (1312308 bytes)
## RAM: 0.01 MB
## Number of data rows: 262338
## File format: v1
## Dimensions: 262338x2
## Column classes: integer, integer
## Number of bytes per column: 1, 4
## Footer: <createdOn>20101007 14:59:46 PDT</createdOn><platform>Affymetrix</platform><chipType>Mapping250K_Nsp</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping250K_Nsp.cdf</filename><filesize>194455495</filesize><checksum>59ae263311a2cf63b8d1b9b4cc7d663b</checksum></srcFile1><srcFile2><filename>Mapping250K_Nsp.na31.annot.csv</filename><filesize>400278099</filesize><checksum>dbd9299c348e1b688f752343dc9e8e57</checksum></srcFile2></srcFiles>
## Chip type: Mapping250K_Nsp
## Platform: Affymetrix

print(summary(ugp));
##  chromosome        position
##  Min.   :  1.000   Min.   :    18901
##  1st Qu.:  4.000   1st Qu.: 32979020
##  Median :  8.000   Median : 71259947
##  Mean   :  8.759   Mean   : 79599960
##  3rd Qu.: 13.000   3rd Qu.:114973065
##  Max.   : 24.000   Max.   :249143646
##  NA's   :357.000   NA's   :      357

print(table(ugp[,1]))
##     1     2     3     4     5     6     7     8     9    10
## 19858 22206 18359 19053 17153 17106 13932 14835 11942 14264
##    11    12    13    14    15    16    17    18    19    20
## 13290 13047 11075  8175  7003  7010  4844  8145  2691  5839
##    21    22    23    24
##  3936  2499  5714     5

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6,Full"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# GC-content normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesN <- res$cesN
gcn <- GcContentNormalization2(cesN, target="zero")
print(gcn)
cesN2 <- process(gcn, verbose=verbose)
print(cesN2)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# GC-content effects before and after normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- getCdf(cesN)
ugp <- getAromaUgpFile(cdf)
units <- getUnitsOnChromosomes(ugp, 1:22)

# Down sample
units <- units[seq(from=1, to=length(units), by=4)]

# Before
toPNG(getFullName(gcn), tags=c("BeforeGCN"), {
  par(mar=c(4,3,1,1)+0.1, mgp=c(2.0,0.7,0))
  plotCovariateEffects(gcn, units=units, ylim=c(0,16), verbose=verbose)
})

# After
toPNG(getFullName(gcn), tags=c("AfterGCN"), {
  par(mar=c(4,3,1,1)+0.1, mgp=c(2.0,0.7,0))
  gcn2 <- GcContentNormalization2(cesN2, target="zero")
  plotCovariateEffects(gcn2, units=units, ylim=c(0,16), verbose=verbose)
})

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE12019,testset"
chipType <- "Mapping250K_Sty"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) CRMAv2 - six arrays
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (b) CRMAv2 - single array
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup a single array
csR1 <- csR[1]

# Rename data set in order to not pick up existing results
setFullName(csR1, sprintf("%s,singleArray", getFullName(csR1)))

dsNList1 <- doASCRMAv2(csR1, verbose=verbose)
print(dsNList1)


# Sanity checks
dsNList0 <- lapply(dsNList, FUN=extract, 1)
for (key in names(dsNList1)) {
  print(key)
  dsN0 <- dsNList0[[key]]
  dsN1 <- dsNList1[[key]]
  stopifnot(getFullNames(dsN1) == getFullNames(dsN0))
  data0 <- extractMatrix(dsN0)
  data1 <- extractMatrix(dsN1)
  rho <- cor(data1, data0, use="complete.obs")
  print(rho)
  res <- all.equal(data1, data0)
  print(res)

  # Sanity check
  stopifnot(all.equal(data1, data0))
} # for (key ...)

library("aroma.affymetrix")
verbose <- Verbose(threshold=-10, timestamp=TRUE)
options(width=60)

chipType <- "GenomeWideSNP_6"
cdfTags <- "Full"


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
fullname <- "Henrik Bengtsson"
user <- "HB"
email <- getOption(aromaSettings, "user/email")
if (is.null(email)) {
  email <- "JohnDoe@email.com"
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "32"
genomeVersion <- "hg19"
datestamp <- format(Sys.Date(), format="%Y%m%d")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags)
rm(csvList)
print(cdf)

csvList <- list()

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
)

for (key in names(tagsList)) {
  tags <- tagsList[[key]]
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags)
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname)
  }
  rm(tags)
}
print(csvList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp)
tags <- c("TEST-ONLY", tags)
ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags, overwrite=TRUE)
print(ugp)


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]]
  print(csv)
  units <- importFrom(ugp, csv, verbose=verbose)
  str(units)
  ## GenomeWideSNP_6.na<XX>.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list()
srcFiles <- c(list(cdf), csvList)
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]]
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  )
  srcFileTags[[kk]] <- tags
}
print(srcFileTags)

footer <- readFooter(ugp)
footer$createdBy <- list(
  fullname = fullname, 
  email = email
)
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags))
footer$srcFiles <- srcFileTags
writeFooter(ugp, footer)


# Try to load the created annotation file
ugp <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="TEST-ONLY")
print(ugp)
print(table(ugp[,1], exclude=NULL))

library("aroma.affymetrix")
library("matrixStats"); # rowMedians()
log <- Arguments$getVerbose(-4, timestamp=TRUE)


dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=log)
keep <- 1:6
csR <- csR[keep]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fragment-length normalization (toward a constant effect)
# Note, this a pure single-array approach.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fln <- res$fln
print(fln)
cesN <- res$cesN
print(cesN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fragment-length normalization (toward an average effect)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ces <- res$ces
fln2 <- FragmentLengthNormalization(ces, tags="*,avg")
print(fln2)
cesN2 <- process(fln2, verbose=verbose)
print(cesN2)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
theta <- extractTheta(cesN, drop=TRUE)
thetaR <- rowMedians(theta, na.rm=TRUE)
M <- log2(theta/thetaR)

theta <- extractTheta(cesN2, drop=TRUE)
thetaR <- rowMedians(theta, na.rm=TRUE)
M2 <- log2(theta/thetaR)

# When calculating the log-ratios, the above two approaches should
# give equals results, because the effects should cancel out regardless.
dM <- M2-M
avgDM <- mean(abs(dM), na.rm=TRUE)
print(avgDM)
# Sanity check
stopifnot(avgDM < 1e-3)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial intensity plots
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ae <- ArrayExplorer(csR)
setColorMaps(ae, "sqrt,yellow")
print(ae)

process(ae, verbose=verbose)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial probe log-ratio plots
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cfR <- getAverageFile(csR, verbose=verbose)
reporter <- SpatialReporter(csR, reference=cfR)
addColorMap(reporter, "log2center,rainbow")
process(reporter, zrange=c(-2,2), verbose=verbose)

ylab <- expression(log[2](y/y[R]))
for (ii in seq_along(csR)) {
  df <- csR[[ii]]

  toPNG(getFullName(df), tags="spatial,rowMedians", width=300, aspectRatio=8/3, {
    plotMargins(reporter, array=ii, ylim=c(-1,1)*0.2, ylab=ylab, margins="rows", rotate=90)
  })

  toPNG(getFullName(df), tags="spatial,colMedians", width=800, aspectRatio=3/8, {
    plotMargins(reporter, array=ii, ylim=c(-1,1)*0.2, ylab=ylab, margins="columns", rotate=0)
  })
} # for (ii ...)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial residual plots test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
plm <- res$plm
print(plm)

# Calculate PLM residuals
rs <- calculateResidualSet(plm, verbose=verbose)
print(rs)

ae <- ArrayExplorer(rs)
setColorMaps(ae, c("log2,log2neg,rainbow", "log2,log2pos,rainbow"))
print(ae)

process(ae, interleaved="auto", verbose=verbose)

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the estimates
# of the MAT (Model-based Analysis of Tiling arrays) algorithm.
#
# Author: Mark Robinson and Henrik Bengtsson
# Created: 2008-12-09
# Last modified: 2012-09-02
###########################################################################
library("aroma.affymetrix")
library("matrixStats"); # colMedians()
library("limma");  # makeContrast()
verbose <- Arguments$getVerbose(-20, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE24546"
tags <- "testset"
chipType <- "Hs_PromPR_v02"
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
)

cdf <- AffymetrixCdfFile$byChipType(chipType)
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, tags=tags, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalize the data using the MAT model
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
mn <- MatNormalization(csR)
csM <- process(mn, verbose=more(verbose, 3))
print(csM)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Convert data set such that it maps to the "unique" CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csU <- convertToUnique(csM, verbose=verbose)
print(csU)

# Rename
setFullNamesTranslator(csU, function(names, ...) { sampleNamesMap[names] })


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MatSmoothing: Design #1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sampleNames <- getNames(csU)

design1 <- makeContrasts(Prec1_MeDNA_IP1-Prec1_MeDNA_Input1, levels=sampleNames)
colnames(design1) <- "Prec1_IP1_minus_Input"
print(design1)

ms1 <- MatSmoothing(csU, design=design1, probeWindow=600, tag="singleIP")
csMS1 <- process(ms1, units=NULL, verbose=verbose)
print(csMS1)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MatSmoothing: Design #2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sampleNames <- getNames(csU)

design2 <- makeContrasts(Prec1_MeDNA_IP1 + Prec1_MeDNA_IP2-Prec1_MeDNA_Input1, levels=sampleNames)
colnames(design2) <- "Prec1_IPs_minus_Input"

ms2 <- MatSmoothing(csU, design=design2, probeWindow=800, tag="multipleIP")
csMS2 <- process(ms2, units=NULL,verbose=verbose)
print(csMS2)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare to precomputed estimates from external MAT software
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare common units with prefix "chr1F".
cdfU <- getCdf(csU)
units <- indexOf(cdfU, "^chr1F")
cells <- getCellIndices(cdfU, units=units, stratifyBy="pm",
                        unlist=TRUE, useNames=FALSE)

# Get the chromosomal positions of these cells
acp <- AromaCellPositionFile$byChipType(getChipType(cdfU))
pos <- acp[cells,2,drop=TRUE]

# Order cells by chromsomal position
o <- order(pos)
pos <- pos[o]
cells <- cells[o]

# Extract the corresponding signals
Y1 <- extractMatrix(csMS1, cells=cells, verbose=verbose)
Y2 <- extractMatrix(csMS2, cells=cells, verbose=verbose)
Y <- cbind(Y1, Y2)
# Compare on the log2 scale
Y <- log2(Y)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loat external signals generated by the MAT software
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# files with native-MAT summarized signals
summaryFiles <- c("Prec1_MeDNA_600_IP1-Input.bar.txt",
                  "Prec1_MeDNA_800_IPs-Input.bar.txt")
barList <- lapply(summaryFiles, FUN=function(filename) {
  columnNames <- c("chromosome", "position", "signal")
  TabularTextFile(filename, path=getPath(csR), columnNames=columnNames)
})
print(barList)

YMAT <- sapply(barList, FUN=function(bar) {
  columnNames <- c("chromosome", "position", "signal")
  data <- readDataFrame(bar, colClasses=colClasses("cin"), nrow=435000)

  # Extract the subset available in the aroma.affymetrix estimate
  data <- subset(data, chromosome == "chr1" & position %in% pos)

  # Order by position
  o <- order(data$position)
  data <- data[o,,drop=FALSE]

  # Extract the external estimates
  y <- data$signal

  # External score that are exactly zero, they are NAs
  y[y == 0] <- NA

  y
})


# Sanity check
stopifnot(identical(dim(YMAT), dim(Y)))
colnames(YMAT) <- colnames(Y)

# Graphical comparison
designNames <- colnames(Y)
for (key in designNames) {
  toPNG(getFullName(csU), tags=c(key, "MatSmoothing_vs_MAT"), {
    xlab <- expression(log[2](y[MAT]))
    ylab <- expression(log[2](y))
    plot(YMAT[,key], Y[,key], pch=".", xlab=xlab, ylab=ylab)
    abline(a=0, b=1, col="red", lwd=2, lty=3)
    stext(side=3, pos=0, key)
    stext(side=3, pos=1, "Chr01")
    stext(side=4, pos=1, sprintf("n=%d", nrow(Y)))
    stext(side=4, pos=0, getFullName(csU))
  })
}


# Numerical comparison
D2 <- (Y - YMAT)^2
avgDiff <- colMedians(D2, na.rm=TRUE)
names(avgDiff) <- colnames(D2)
cat("Average differences:\n")
print(avgDiff)

# Sanity check
stopifnot(all(avgDiff < 0.003))


print(sessionInfo())

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-CytoSampleData"
chipType <- "Cytogenetics_Array"

cdf <- AffymetrixCdfFile$byChipType(chipType)
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic-crosstalk calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR)
print(acc)
csC <- process(acc, verbose=verbose)
print(csC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot allele pairs before and after calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
for (what in c("input", "output")) {
  toPNG(getFullName(acc), tags=c("allelePairs", what), aspectRatio=0.7, {
    plotAllelePairs(acc, array=1, what=what, verbose=verbose)
  })
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level summarization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- AvgSnpPlm(csC, mergeStrands=TRUE)
print(plm)
if (length(findUnitsTodo(plm)) > 0) {
  # Fit CN probes quickly (~5-10s/array + some overhead)
  units <- fitCnProbes(plm, verbose=verbose)
  str(units)
  # int [1:2377527] 401698 401699 401700 401701 401702 401703 ...

  # Fit remaining units, i.e. SNPs (~5-10min/array)
  units <- fit(plm, verbose=verbose)
  str(units)
  # int [1:418181] 1 2 3 4 5 6 7 8 9 10 ...
}

ces <- getChipEffectSet(plm)
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export (theta, beta) for all arrays
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsList <- exportTotalAndFracB(ces, verbose=verbose)
print(dsList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# TCN Segmentation and plotting
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cns <- CbsModel(dsList$total)
print(cns)

ce <- ChromosomeExplorer(cns, zooms=2^(0:5))
print(ce)
process(ce, chromosomes=c(19, 22, 23), verbose=verbose)

############################################################################
# Author: Henrik Bengtsson
# Created on: 2010-05-26
# Last updated: 2010-05-26
#
# USAGE:
# path <- "downloadScripts/chipTypes/Mapping50K_Hind240,Xba240";
# filename <- "HapMap,testSet,100K.R";
# pathname <- system.file(path, filename, package="aroma.affymetrix");
# source(pathname);
#
# DOWNLOADS:
# rawData/
#  HapMap,testSet/
#   Mapping50K_Hind240/
#    CEU_NA06985_HIND.CEL, CEU_NA06991_HIND.CEL, CEU_NA06993_HIND.CEL,
#    CEU_NA06994_HIND.CEL, CEU_NA07000_HIND.CEL, CEU_NA07019_HIND.CEL
#   Mapping50K_Xba240/
#    CEU_NA06985_XBA.CEL, CEU_NA06991_XBA.CEL, CEU_NA06993_XBA.CEL,
#    CEU_NA06994_XBA.CEL, CEU_NA07000_XBA.CEL, CEU_NA07019_XBA.CEL
############################################################################
library("R.filesets");
verbose <- Arguments$getVerbose(-5, timestamp=TRUE);

urlPath <- "ftp://ftp.ncbi.nlm.nih.gov/hapmap/raw_data/affy100k/";

files <- list(
  "Mapping50K_Hind240" = c(
    "CEU_NA06985_HIND.CEL.gz", 
    "CEU_NA06991_HIND.CEL.gz", 
    "CEU_NA06993_HIND.CEL.gz", 
    "CEU_NA06994_HIND.CEL.gz", 
    "CEU_NA07000_HIND.CEL.gz", 
    "CEU_NA07019_HIND.CEL.gz"
  ),
  "Mapping50K_Xba240" = c(
    "CEU_NA06985_XBA.CEL.gz", 
    "CEU_NA06991_XBA.CEL.gz", 
    "CEU_NA06993_XBA.CEL.gz", 
    "CEU_NA06994_XBA.CEL.gz", 
    "CEU_NA07000_XBA.CEL.gz", 
    "CEU_NA07019_XBA.CEL.gz"
  )
);

rootPath <- "rawData";
dataSet <- "HapMap,testSet";
chipTypes <- names(files);

dsList <- list();
for (kk in seq_along(chipTypes)) {
  chipType <- chipTypes[kk];
  verbose && enter(verbose, sprintf("Chip type #%d ('%s') of %d", 
                                         kk, chipType, length(chipTypes)));

  path <- file.path(rootPath, dataSet, chipType);
  filenames <- files[[chipType]];

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Download only files if missing (with or without *.gz)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  pathnames <- file.path(path, filenames);
  pathnames <- sapply(pathnames, FUN=filePath, expandLinks="any");

  # Gunzip already downloaded *.gz files
  keep <- sapply(pathnames, FUN=isFile);
  ds <- GenericDataFileSet(lapply(pathnames[keep], FUN=GenericDataFile));
  sapply(ds, gunzip, verbose=TRUE);

  # See what is missing
  pathnames <- gsub(".gz", "", pathnames, fixed=TRUE);
  keep <- !sapply(pathnames, FUN=isFile);
  filenames <- filenames[keep];

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Download and gunzip
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (length(filenames) > 0) {
    # Download
    urls <- paste(urlPath, filenames, sep="");
    pathnamesZ <- sapply(urls, FUN=downloadFile, path=path, verbose=TRUE);
    verbose && print(verbose, pathnamesZ);

    # Gunzip the data files
    ds <- GenericDataFileSet(lapply(pathnamesZ, FUN=GenericDataFile));
    sapply(ds, gunzip, verbose=TRUE);
    verbose && cat(verbose, "Downloaded:");
    verbose && print(verbose, ds);
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup data set
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ds <- GenericDataFileSet(lapply(pathnames, FUN=GenericDataFile));
  verbose && cat(verbose, "Complete file set:");
  verbose && print(verbose, ds);

  dsList[[chipType]] <- ds;

  verbose && exit(verbose);
} # for (chipType ...)

verbose && print(verbose, dsList);


############################################################################
# HISTORY:
# 2010-05-26
# o Created.
############################################################################

#!/usr/bin/env Rscript

############################################################################
# EXAMPLES:
#
# // Run all system test sets for the Test3 chip type
# Rscript testScripts/launch.R --pattern=Test3
#
# // Run a random system (default) test set
# Rscript testScripts/launch.R --order=random --nbrOfSets 1
#
# // Run a random replication test set
# Rscript testScripts/launch.R --group=replication --order=random --nbrOfSets 1
#
# // Run one of the complete analyses
# Rscript testScripts/launch.R --group=complete --pattern=GSE12702
############################################################################
library("R.utils")

cat("==========================================================\n")
cat("BEGIN OF SESSION:\n")

cat("Command line arguments:\n")
args <- cmdArgs()
print(args)

printf("Hostname: %s\n", System$getHostname())
printf("Username: %s\n", System$getUsername())
printf("Current directory: %s\n", getwd())

cat("R system environment variables:\n")
sysenv <- c("R_LIBS", "R_LIBS_USER", "R_LIBS_SITE")
sysenv <- sapply(sysenv, FUN=Sys.getenv, USE.NAMES=TRUE, simplify=FALSE)
str(sysenv)

cat(".libPaths():\n")
print(.libPaths())

print(sessionInfo())

cat("Memory statistics:\n")
print(gc())
if (.Platform$OS.type == "windows") {
  printf("Current memory usage: %g MB\n", memory.size(max=FALSE))
  printf("Maximum memory usage: %g MB\n", memory.size(max=TRUE))
  printf("Maximum memory limit: %g MB\n", memory.size(max=NA))
}
cat("==========================================================\n")


# Load aroma.affymetrix (in a fault-tolerant way)
kk <- 1L
while (kk < 10L) {
  printf("#%02d. Trying to load aroma.affymetrix...\n", kk)
  tryCatch({
    library("aroma.affymetrix")
    break
  }, error = function(ex) {
    print(traceback())
    print(ex)
    # Sleep for a while and try again
    Sys.sleep(10)
    FALSE
  })
  kk <- kk + 1L
} # while()
if (kk >= 10L) throw("Failed to load aroma.affymetrix.")

path <- Arguments$getReadablePath("testScripts/R", mustExist=FALSE)
if (!isDirectory(path)) {
  path <- system.file(package="aroma.affymetrix")
  path <- file.path(path, "testScripts", "R")
}
path <- Arguments$getReadablePath(path)

pathname <- file.path(path, "launchUtils.R")
pathname <- Arguments$getReadablePathname(pathname)

source(pathname)

do.call(launchTestGroups, args)


cat("==========================================================\n")
cat("END OF SESSION:\n")
# Override default settings with command line arguments
args <- commandArgs(asValues=TRUE)
print(args)

printf("Hostname: %s\n", System$getHostname())
printf("Username: %s\n", System$getUsername())
printf("Current directory: %s\n", getwd())

cat("R system environment variables:\n")
sysenv <- c("R_LIBS", "R_LIBS_USER", "R_LIBS_SITE")
sysenv <- sapply(sysenv, FUN=Sys.getenv, USE.NAMES=TRUE, simplify=FALSE)
str(sysenv)

cat(".libPaths():\n")
print(.libPaths())

print(sessionInfo())

cat("Memory statistics:\n")
print(gc())
if (.Platform$OS.type == "windows") {
  printf("Current memory usage: %g MB\n", memory.size(max=FALSE))
  printf("Maximum memory usage: %g MB\n", memory.size(max=TRUE))
  printf("Maximum memory limit: %g MB\n", memory.size(max=NA))
}
cat("==========================================================\n")


############################################################################
# HISTORY:
# 2014-01-28
# o Now the testScripts/launch.R script looks for a "local"
#   ./testScripts/R/ directory first before turning to ditto in the
#   installed packages.
# o BUG FIX: Using R.utils::cmdArgs(), which also drops the R executable,
#   which R.utils::commandArgs() used before did not.
# 2012-11-30
# o Now outputting session information useful for debugging.
# 2012-11-21
# o Now using R.cache root path specific to the aroma tests.
# 2012-10-19
# o ROBUSTNESS: Better pathname validation.
# o Adding system details to output at the beginning.
# 2012-09-14
# o Created.
############################################################################

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
dsNList <- doASCRMAv2(dataSet, chipType=chipType, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
seg <- HaarSegModel(dsNList$total)
print(seg)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ChromsomeExplorer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ce <- ChromosomeExplorer(seg, zooms=2^(0:5))
print(ce)
process(ce, arrays=1:2, chromosomes=c(1:2,19,23), verbose=verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE13372/
#   GenomeWideSNP_6/
#     *.CEL [68]
#
# Overall design:
#  21 replicates of HCC1143 (breast ductal carcinoma), 21 replicates
#  of HCC1143BL (matched normal), 13 replicates of HCC1954 (breast
#  ductal carcinoma), 11 replicates of HCC1954BL (matched normal),
#  1 replicate of NCI-H2347 (lung adenocarcinoma), 1 replicate of
#  NCI-H2347BL (matched normal).
#  http://www.broad.mit.edu/cancer/pub/solexa_copy_numbers/
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE13372
##########################################################################
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6"

sampleNamesMap <- c(
  GSM337641="HCC1143_GLEYS_A02",
#  GSM337646="HCC1143_TRIBE_H11",
  GSM337662="HCC1143BL_GLEYS_A01",
#  GSM337666="HCC1143BL_TRIBE_D02",
#  GSM337668="HCC1143BL_GHATS_H04",
#  GSM337674="HCC1143BL_TRIGS_G07",
  GSM337683="HCC1954_GLEYS_B02",
#  GSM337688="HCC1954_TRIBE_G12",
  GSM337696="HCC1954BL_GLEYS_B01",
#  GSM337700="HCC1954BL_TRIBE_B01",
#  GSM337702="HCC1954BL_GHATS_G10",
#  GSM337703="HCC1954BL_TRIGS_G11",
  GSM337707="NCI-H2347",
  GSM337708="NCI-H2347BL"
)
sampleNames <- names(sampleNamesMap)

ds <- downloadGeoRawDataFiles(dataSet, chipType=chipType, sampleNames=sampleNames)
print(ds)
## AffymetrixCelSet:
## Name: GSE13372
## Tags: testset
## Path: rawData/GSE13372,testset/GenomeWideSNP_6
## Platform: Affymetrix
## Chip type: GenomeWideSNP_6
## Number of arrays: 6
## Names: GSM337641, GSM337662, GSM337683, ..., GSM337708 [6]
## Time period: 2007-05-17 16:13:28 -- 2008-09-11 21:06:39
## Total file size: 395.33MB
## RAM: 0.01MB

verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)

# Process only the first six arrays (and in reverse order)
subset <- 6:1
csR <- csR[subset]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRMAv1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doCRMAv1(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Scale normalization test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ces <- res$ces
sn <- ScaleNormalization3(ces)
print(sn)

cesN <- process(sn, verbose=verbose)
print(cesN)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "installUtils.R")
source(pathname)

library("R.utils")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Install
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Installing test-specific packages")

pkgs <- c("BioC:oligo", "BioC:pd.mapping50k.hind240")
for (pkg in pkgs) {
  verbose && cat(verbose, "Package: ", pkg)
  installPkg(pkg)
}

verbose && exit(verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE8605/
#   Mapping10K_Xba142/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
#
# Overall design:
#  [Ten] cervival cancer cell lines were hybridized to Affymetrix 
#  Focus arrays in duplicate. Correlations were made with copynumber 
#  profiles from arrayCGH and SNP arrays.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE8605
##########################################################################
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType,
                            chipTypeAliases=c("Focus"="HG-Focus"))
verbose && print(verbose, ds)
## AffymetrixCelSet:
## Name: GSE8605
## Tags:
## Path: rawData/GSE8605/Mapping10K_Xba142
## Platform: Affymetrix
## Chip type: Mapping10K_Xba142
## Number of arrays: 10
## Names: GSM226867, GSM226868, GSM226869, ..., GSM226876 [10]
## Time period: 2005-05-24 11:26:07 -- 2005-05-24 15:20:20
## Total file size: 41.38MB
## RAM: 0.01MB

verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Verbose(threshold=-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "Affymetrix-HapMap,CEU,set1"
chipType <- "GenomeWideSNP_5"

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="Full,r2")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)

# Split up into names and tags
setFullNamesTranslator(csR, function(names, ...) {
  gsub("^(NA[0-9]+)_(.*)", "\\1,\\2", names)
})

# Drop duplicates
keep <- !duplicated(getNames(csR))
csR <- csR[keep]

# Keep only certain samples
sampleNames <- c("NA06985", "NA06991", "NA06993",
                 "NA07019", "NA07022", "NA07056")
csR <- csR[sampleNames]

print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- res$dsNList

seg <- CbsModel(dsNList$total)
print(seg)

ce <- ChromosomeExplorer(seg)
print(ce)
process(ce, arrays=1, chromosomes=c(19,23), verbose=verbose)

###########################################################################/**
# File type test
#
# Description:
# This test verifies that aroma.affymetrix can create AromaCellCpgFile
# and AromaCellPositionFile objects for the (promoter) tiling array.
#
# Author: Mark Robinson
# Created: 2010-02-22
# Last modified: 2012-09-02
#*/###########################################################################
library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup the chip type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- AffymetrixCdfFile$byChipType("Hs_PromPR_v02")
print(cdf)

cdfU <- getUniqueCdf(cdf)
print(cdfU)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Test allocation, writing and reading of 'acp' object
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate
acp <- AromaCellPositionFile$allocateFromCdf(cdfU, tags=c("*", "test"), 
                                            overwrite=TRUE, verbose=verbose)
print(acp)

nbrOfRandomCells <- 20
cells <- sample(nbrOfCells(cdfU), size=nbrOfRandomCells)
chr <- sample(1:22, size=nbrOfRandomCells)
pos <- sample(1:1e6, size=nbrOfRandomCells)

# Write
acp[cells,1] <- chr
acp[cells,2] <- pos

# Read
cp <- acp[cells,]

# Sanity check
stopifnot((cp[,1] == chr) & (cp[,2] == pos))

# Clean up
rm(chr, pos, cp)
file.remove(getPathname(acp))

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Test allocation, writing and reading of 'acc' object
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate
acc <- AromaCellCpgFile$allocateFromCdf(cdfU, tags=c("*", "test"), 
                                            overwrite=TRUE, verbose=verbose)
print(acc)

cells <- sample(nbrOfCells(cdfU), size=nbrOfRandomCells)
cpg <- rnorm(nbrOfRandomCells)

# Write
acc[cells,1] <- 2^cpg

# Read
cpg2 <- acc[cells,1,drop=TRUE]

d <- (log2(cpg2) - cpg)^2
print(summary(d))

# Sanity check
stopifnot(sum(d) < 1e-8)

# Clean up
file.remove(getPathname(acc))

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "installUtils.R")
source(pathname)

library("R.utils")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Install
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Installing test-specific packages")

pkgs <- c("BioC:gcrma")
pkgs <- c(pkgs, "BioC:affy", "BioC:limma")
pkgs <- c(pkgs, "BioC:oligo")
pkgs <- c(pkgs, "BioC:hgu133plus2cdf")
pkgs <- c(pkgs, "BioC:hgu133plus2.db")
pkgs <- c(pkgs, "BioC:pd.hg.u133.plus.2")

for (pkg in pkgs) {
  verbose && cat(verbose, "Package: ", pkg)
  installPkg(pkg)
}

verbose && exit(verbose)

##########################################################################
# AS-CRMAv2 and Paired PSCBS
##########################################################################
future::plan("multisession")
library("aroma.affymetrix")
library("aroma.cn");  # PairedPscbsModel
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372"
chipType <- "GenomeWideSNP_6,Full"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)

dsN <- exportAromaUnitPscnBinarySet(dsNList)
print(dsN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Group samples by name and type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AD HOC: For now, just hardwire the path.
path <- file.path("testScripts/complete/dataSets", dataSet)
db <- TabularTextFile(sprintf("%s,samples.txt", dataSet), path=path)
setColumnNamesTranslator(db, function(names, ...) {
  names <- gsub("id", "fixed", names)
  names <- gsub("fullname", "replacement", names)
  names
})
df <- readDataFrame(db, colClasses=c("*"="character"))
setFullNamesTranslator(dsN, df)

# Identify unique sample names
sampleNames <- unique(getNames(dsN))

dsList <- lapply(sampleNames, FUN=function(sampleName) {
  ds <- dsN[sampleName]
  lapply(c(T="T", N="N"), FUN=function(type) {
    ds[sapply(ds, hasTag, type)]
  })
})
names(dsList) <- sampleNames


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
R <- 4; # Number of replicates
dsList2 <- list()
for (key in names(dsList)) {
  dsListKK <- dsList[[key]]
  dsT <- dsListKK$T
  dsN <- dsListKK$N

  # (a) Replicated tumor vs same normal
  dsTa <- dsT[1:min(length(dsT),R)]
  dsNa <- dsN[rep(1L, times=length(dsTa))]

  # (b) Same tumor vs replicated normals
  dsNb <- dsN[1:min(length(dsN),R)]
  dsTb <- dsT[rep(1L, times=length(dsNb))]

  # (c) Merge
  dsT <- append(dsTa, dsTb)
  dsN <- append(dsNa, dsNb)

  # (d) Drop duplicated tumor-normal pairs
  nT <- getFullNames(dsT)
  nN <- getFullNames(dsN)
  nP <- paste(nT, nN, sep="_vs_")
  dups <- duplicated(nP)
  dsT <- dsT[!dups]
  dsN <- dsN[!dups]
  stopifnot(length(dsT) == length(dsN))

  dsList2[[key]] <- list(T=dsT, N=dsN)
} # for kk ...)

dsT <- Reduce(append, lapply(dsList2, FUN=function(x) x$T))
dsN <- Reduce(append, lapply(dsList2, FUN=function(x) x$N))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segment tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sm <- PairedPscbsModel(dsT=dsT, dsN=dsN, gapMinLength=2e6)
print(sm)

res <- fit(sm, verbose=verbose)
print(res)

sms <- getOutputDataSet(sm)
print(sms)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Call segments to be in ROH, AB and LOH.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## caller <- PairedPscbsCaller(sms)
## print(caller)
## sms <- process(caller, verbose=verbose)
## print(sms)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Generate report (just to check)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setOption("PSCBS::reports/pscnSegmentationTransitions", TRUE)

# Generate reports for tumor-normal pairs
for (ii in 1:min(length(sms),5)) {
  ff <- sms[[ii]]
  fit <- loadObject(df)
  sampleName <- getFullName(df)
  pathname <- report(fit, sampleName=sampleName, studyName=getFullName(dsT), verbose=verbose)
  print(pathname)
} # for (ii ...)

library("R.utils")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


verbose && enter(verbose, "Installing additional packages for all tests")

verbose && enter(verbose, "Scanning tests")
path <- system.file("testScripts", package="aroma.affymetrix")
verbose && cat(verbose, "Path to testScripts: ", path)

pattern <- "installPackages.R$"
pathnames <- list.files(path=path, pattern=pattern, full.names=TRUE, recursive=TRUE)

nbrOfTestSets <- length(pathnames)
for (kk in seq_len(nbrOfTestSets)) {
  pathname <- pathnames[kk]
  dropPattern <- sprintf("^%s/", path)
  testSet <- gsub(dropPattern, "", dirname(pathname))
  verbose && enter(verbose, sprintf("Test set #%s ('%s') of %s", kk, testSet, nbrOfTestSets))
  sourceTo(pathname, envir=new.env(), echo=as.logical(verbose))
  verbose && exit(verbose)
} # for (kk ...)

verbose && exit(verbose)


verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process arrays in random order
subset <- sample(seq_along(csR))
res <- doASCRMAv2(csR, arrays=subset, drop=FALSE, verbose=verbose)
print(res)


# Sanity checks
# Assert same output as input arrays (in the same order)
sampleNames <- getNames(csR)[subset]
for (key in names(res)[-1]) {
  ds <- res[[key]]
  if (!inherits(ds, "GenericDataFileSet")) next
  stopifnot(getNames(ds) == sampleNames)
}



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (b) CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only the first six arrays (and in reverse order)
subset <- c(2,5,3)
dsNList <- doASCRMAv2(csR, arrays=subset, verbose=verbose)
print(dsNList)


# Sanity checks
# Assert same output as input arrays (in the same order)
sampleNames <- getNames(csR)[subset]
stopifnot(getNames(dsNList$total) == sampleNames)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (c) CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only the first six arrays (and in reverse order)
subset <- c(2,5,3)
dsNList2 <- doASCRMAv2(dataSet, chipType=chipType, arrays=subset, verbose=verbose)
print(dsNList2)

# Sanity checks
for (key in names(dsNList2)) {
  stopifnot(equals(dsNList2[[key]], dsNList[[key]]))
}

library("R.utils")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

## utils::download.file() will timeout after 60 seconds
options(timeout=6*60)

verbose && enter(verbose, "Downloading raw data for all tests")

verbose && enter(verbose, "Scanning tests")
path <- system.file("testScripts", package="aroma.affymetrix")
verbose && cat(verbose, "Path to testScripts: ", path)

pattern <- "downloadRawData.R$"
pathnames <- list.files(path=path, pattern=pattern, full.names=TRUE, recursive=TRUE)

nbrOfTestSets <- length(pathnames)
for (kk in seq_len(nbrOfTestSets)) {
  pathname <- pathnames[kk]
  dropPattern <- sprintf("^%s/", path)
  testSet <- gsub(dropPattern, "", dirname(pathname))
  verbose && enter(verbose, sprintf("Test set #%s ('%s') of %s", kk, testSet, nbrOfTestSets))
  sourceTo(pathname, envir=new.env(), echo=as.logical(verbose))
  verbose && exit(verbose)
} # for (kk ...)

verbose && exit(verbose)


verbose && exit(verbose)

#!/usr/bin/env Rscript

if (interactive()) {
  savehistory()
} else {
  # GLAD v1.12.0 depends on the 'tcltk' package, but that
  # cannot be loaded if there is no display.  A workaround
  # is to fake that the 'tcltk' package is loaded:
  attach(list(), name="package:tcltk")
}
library(aroma.affymetrix)
#source("init.R")

# Use special file cache for testing
options("R.cache::rootPath"="~/.Rcache,scratch")
options("R.cache::touchOnLoad"=TRUE)


args <- commandArgs(asValues=TRUE, excludeReserved=TRUE, excludeEnvVars=TRUE)
print(args)

if (isTRUE(args$devel)) {
  setOption(aromaSettings, "devel/dropRootPathTags", TRUE)
}
print(getOption(aromaSettings, "devel/dropRootPathTags"))


paths <- c()
allPaths <- c("testScripts/replication/chipTypes", 
              "testScripts/system/chipTypes")
for (path in allPaths) {
  path <- Arguments$getReadablePath(path, mustExist=TRUE)
  paths0 <- list.files(path=path, full.names=TRUE)
  paths <- c(paths, paths0)
}

..pathnames <- lapply(paths, FUN=list.files, pattern="[.]R$", full.names=TRUE)
names(..pathnames) <- basename(paths)
#..pathnames <- ..pathnames[names(..pathnames)]

..chipTypes <- c("Mapping10K_Xba142",
                 "Test3",
                 "HG-U133_Plus_2",
                 "Mapping50K_Hind240",
                 "Hs_PromPR_v02",
                 "Mapping250K_Nsp",
                 "Mapping250K_Sty",
                 "HuEx-1_0-st-v2",
                 "GenomeWideSNP_5",
                 "GenomeWideSNP_6",
                 "Cytogenetics_Array",
                 "MOUSEDIVm520650")


if (!is.null(args$chipTypes)) {
  cat("User-specified chip types:\n")
  ..chipTypes <- trim(unlist(strsplit(args$chipTypes, split="")))
  print(..chipTypes)
}

if (isTRUE(args$reverse)) {
  cat("Reversing chip types:\n")
  ..chipTypes <- rev(..chipTypes)
  print(..chipTypes)
}

if (isTRUE(args$shuffle)) {
  cat("Reshuffling chip types:\n")
  ..chipTypes <- sample(..chipTypes)
  print(..chipTypes)
}

cat("Processing chip types:\n")
print(..chipTypes)


for (..chipType in ..chipTypes) {
  keep <- (names(..pathnames) == ..chipType)
  ..pathnamesT <- unlist(..pathnames[keep], use.names=FALSE)
  cat("PATHNAMES CHIPTYPE: \n")
  print(..pathnamesT)
  for (pathname in ..pathnamesT) {
    if (regexpr("hetero", pathname) != -1)
      next
    if (regexpr("expectile", pathname) != -1)
      next

    cat("** PATHNAME: ", pathname, "\n", sep="")
    tryCatch({
      source(pathname, echo=TRUE)
      cat("** PATHNAME DONE: ", pathname, "\n", sep="")
    }, error = function(ex) {
      cat("************************************************\n")
      cat("** ", rep(c(" ER", "ROR "), times=6), " **\n", sep="")
      print(ex)
      print(sessionInfo())
      cat("************************************************\n")
      cat("** PATHNAME FAILED: ", pathname, "\n", sep="")
    })
    
    rm(list=setdiff(ls(), c("..chipType", "..chipTypes", 
                    "pathname", "..pathnames", "..pathnamesT")))
    gc()
  }
}

library("aroma.affymetrix")
library("Biobase")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)

ces <- doRMA(csR, verbose=verbose)
print(ces)

eset <- extractExpressionSet(ces, verbose=verbose)
print(eset)
print(sampleNames(eset))

# Sanity checks
stopifnot(identical(sampleNames(eset), getNames(ces)))
stopifnot(identical(featureNames(eset), getUnitNames(getCdf(ces))))


# Add 'annotation' slot
eset <- extractExpressionSet(ces, annotationPkg="PDInfo", verbose=verbose)
print(eset)
print(annotation(eset))
stopifnot(annotation(eset) == "pd.hg.u133.plus.2")

eset <- extractExpressionSet(ces, annotationPkg="cdf", verbose=verbose)
print(eset)
print(annotation(eset))
stopifnot(annotation(eset) == "hgu133plus2cdf")

eset <- extractExpressionSet(ces, annotationPkg="ChipDb", verbose=verbose)
print(eset)
print(annotation(eset))
stopifnot(annotation(eset) == "hgu133plus2")

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSetName <- "Affymetrix-CytoScanHD"
chipType <- "CytoScanHD_Array"

csR <- AffymetrixCelSet$byName(dataSetName, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allele-specific CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Average TCN signals
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dfR <- getAverageFile(dsNList$total)
thetaR <- extractMatrix(dfR, drop=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract (TCN,BAF) for a single array
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
array <- 3
dfList <- lapply(dsNList, FUN=getFile, array)
sampleName <- getFullName(dfList$total)

data <- sapply(dfList, FUN=extractMatrix)
data[,"total"] <- 2 * data[,"total"] / thetaR
str(data)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot along genome
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ugp <- getAromaUgpFile(dsNList$total)

chr <- 8
chrTag <- sprintf("Chr%02d", chr)

units <- getUnitsOnChromosome(ugp, chr)
x <- ugp[units,2,drop=TRUE]
x <- x/1e6

dataT <- data[units,]
C <- dataT[,"total"]
B <- dataT[,"fracB"]

toPNG(sampleName, tags=c(chrTag, "TCN+BAF"), width=1024, aspectRatio=0.5, {
  par(mar=c(2.2,3,1.2,1))
  subplots(2, ncol=1)
  plot(x, C, pch=".", ylim=c(0,6))
  stext(side=3, pos=0, sampleName)
  stext(side=3, pos=1, chrTag)
  plot(x, B, pch=".", ylim=c(0,1))
})

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) CRMAv2 - six arrays
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (b) CRMAv2 - single array
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup a single array
csR1 <- csR[1]

# Rename data set in order to not pick up existing results
setFullName(csR1, sprintf("%s,singleArray", getFullName(csR1)))

dsNList1 <- doASCRMAv2(csR1, verbose=verbose)
print(dsNList1)


# Sanity checks
dsNList0 <- lapply(dsNList, FUN=`[`, 1)
for (key in names(dsNList1)) {
  print(key)
  dsN0 <- dsNList0[[key]]
  dsN1 <- dsNList1[[key]]
  stopifnot(getFullNames(dsN1) == getFullNames(dsN0))
  data0 <- extractMatrix(dsN0)
  data1 <- extractMatrix(dsN1)
  rho <- cor(data1, data0, use="complete.obs")
  print(rho)
  res <- all.equal(data1, data0)
  print(res)

  # Sanity check
  stopifnot(all.equal(data1, data0))
} # for (key ...)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE20403/
#   MoEx-1_0-st-v1/
#     GSM511136.CEL, ..., GSM511147.CEL [12]
#
# Overall design:
#  Mouse BMDMs were stimulated with 10 U/ml recombinant mouse 
#  interferon-beta (Ifn-beta) and harvested 1, 2, 4, 8 and 24 h following
#  treatment or collected pre-treatment (0 h). RNA from two biological
#  replicates per time-point were processed using the Affymetrix WT cDNA
#  Synthesis and WT Terminal Labeling Kit and the Mouse Exon 1.0 ST Array
#  platform. Array data was processed using the Affymetrix Expression
#  Console Software and analysed used the Bioconductor package with R and
#  the network-based visualisation tool BioLayout Express3D.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE20403
##########################################################################
dataSet <- "GSE20403"
chipType <- "MoEx-1_0-st-v1"
verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType)
print(ds)
## AffymetrixCelSet:
## Name: GSE20403
## Tags:
## Path: rawData/GSE20403/MoEx-1_0-st-v1
## Platform: Affymetrix
## Chip type: MoEx-1_0-st-v1
## Number of arrays: 12
## Names: GSM511136, GSM511137, GSM511138, ..., GSM511147 [12]
## Time period: 2009-06-22 13:48:03 -- 2009-06-22 21:41:41
## Total file size: 756.62MB
## RAM: 0.02MB

verbose && exit(verbose)

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the SNPRMA 
# chip-effect estimates as estimated by oligo.
# It verifies that they give the same results whether or not one
# is normalizing towards the HapMap reference (as defined by oligo).
#
# Author: Henrik Bengtsson
# Created: 2008-12-04
# Last modified: 2010-09-01
###########################################################################
library("aroma.affymetrix")
library("oligo")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Local functions
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
compareESets <- function(eSet1, eSet2, tolerance=1e-4) {
  # Default
  res <- all.equal(eSet1, eSet2, tolerance=tolerance)
  if (!isTRUE(res)) return(res)

  # Compare assayData()
  data1 <- assayData(eSet1)
  data2 <- assayData(eSet2)
  data1 <- as.list(data1)
  data2 <- as.list(data2)
  res <- all.equal(data1, data2, tolerance=tolerance)
  if (!isTRUE(res)) return(res)
  TRUE
} # compareESets()


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE34754"
chipType <- "Mapping250K_Nsp"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)

# Assert that the correct Platform Design package is installed
pdPkgName <- cleanPlatformName(chipType)
library(pdPkgName, character.only=TRUE)

for (normalizeToHapmap in c(FALSE, TRUE)) {
  verbose && enter(verbose, sprintf("justSNPRMA(..., normalizeToHapMap=%s)", normalizeToHapmap))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # SNPRMA according to aroma.affymetrix
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  eSet <- justSNPRMA(csR, normalizeToHapmap=normalizeToHapmap, verbose=verbose)
  print(eSet)
  
  
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # SNPRMA according to oligo
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  eSet0 <- justSNPRMA(getPathnames(csR), normalizeToHapmap=normalizeToHapmap, verbose=as.logical(verbose))
  print(eSet0)
  
  if (!normalizeToHapmap) {
    # CLEAN UP: justSNPRMA() stores a target distribution file
    # in the working directory that we don't need
    filename <- sprintf("%s.quantileReference.rda", pdPkgName)
    if (isFile(filename)) {
      file.remove(filename)
    }
  }

 
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Compare
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  res <- compareESets(eSet, eSet0)
  verbose && print(verbose, res)

  # Sanity check
  stopifnot(compareESets(eSet, eSet0))

  verbose && exit(verbose)
} # for (normalizeToHapmap ...)

if (interactive()) savehistory();
library("aroma.affymetrix");


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Allocate UGC file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "Mapping250K_Nsp";
chipType <- "Mapping250K_Sty";
cdf <- AffymetrixCdfFile$byChipType(chipType);
ugc <- AromaUnitGcContentFile$allocateFromCdf(cdf, tags="na28,h=500kb,HB20090602");
print(ugc);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import GC contents from NetAffx files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
csv <- AffymetrixNetAffxCsvFile$byChipType(chipType, tags=".na28");

colClasses <- c("^(probeSetID|%GC)$"="character");
data <- readDataFrame(csv, colClasses=colClasses);
units <- indexOf(cdf, names=data$probeSetID);
stopifnot(all(is.finite(units)));
values <- as.double(data[["%GC"]]);
ugc[units,1] <- values;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- c(list(cdf), list(csv));
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugc);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
footer$gcBinWidth <- as.integer(500e3);
writeFooter(ugc, footer);


print(ugc);
print(summary(ugc));
print(range(ugc[,1], na.rm=TRUE));

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)

res <- doRMA(csR, drop=FALSE, verbose=verbose)
print(res)

plm <- res$plm
rs <- calculateResidualSet(plm, verbose=verbose)
print(rs)

ae <- ArrayExplorer(rs)
setColorMaps(ae, c("log2,log2neg,rainbow", "log2,log2pos,rainbow"))
print(ae)

process(ae, arrays=1:2, interleaved="auto", verbose=verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# Affymetrix-CytoSampleData/
#  Cytogenetics_Array/
#    S_111.CEL, ..., S_178.CEL [5]
#
# Overall design:
#
# URL: https://www.affymetrix.com/support/technical/byproduct.affx?product=cytogenetics_array
##########################################################################
dataSet <- "Affymetrix-CytoSampleData"
chipType <- "Cytogenetics_Array"

ds <- downloadAffymetrixDataSet(dataSet, chipType=chipType, pathname="support/downloads/data/cytogenetics2_7m_sampledata.zip")
print(ds)
## AffymetrixCelSet:
## Name: Affymetrix-CytoSampleData
## Tags:
## Path: rawData/Affymetrix-CytoSampleData/Cytogenetics_Array
## Platform: Affymetrix
## Chip type: Cytogenetics_Array
## Number of arrays: 5
## Names: S_111, S_113, S_125, S_129, S_178 [5]
## Time period: 2009-02-17 14:02:08 -- 2009-03-12 14:08:41
## Total file size: 194.71MB
## RAM: 0.01MB


verbose && exit(verbose)

source("init.R");

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naVersion <- "25";
user <- "HB";
datestamp <- "20080424";

chipType <- "GenomeWideSNP_5";
cdfTags <- "Full,r2";
nbrOfEnzymes <- 2;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();
  tags <- sprintf(".na%s", naVersion);
  csv <- AffymetrixNetAffxCsvFile$byChipType(chipType, tags=tags);
  csvList[["main"]] <- csv;
  tags <- sprintf(".cn.na%s", naVersion);
  csv <- AffymetrixNetAffxCsvFile$byChipType(chipType, tags=tags);
  csvList[["CN"]] <- csv;
  rm(csv, tags);
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=log);
  str(units);
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
x <- summaryOfUnits(ufl, enzymes=c("NspI", "StyI"));
print(x);
##                  snp    cnp affxSnp other  total
##  enzyme1-only 116979 140099       0     0 257078
##  enzyme2-only  74135   1208       0     0  75343
##  both         248980 171077       0     0 420057
##  missing       60474 104885    3022    69 168450
##  total        500568 417269    3022    69 920928

cdf2 <- AffymetrixCdfFile$byChipType("GenomeWideSNP_6", tags="Full");
tags <- sprintf("na%s,%s%s", naVersion, user);
ufl2 <- AromaUflFile$byChipType(getChipType(cdf2), tags=tags);

units2 <- match(getUnitNames(cdf), getUnitNames(cdf2));
keep <- is.finite(units2);
print(summary(keep));
units <- which(keep);
units2 <- units2[keep];
for (ee in 1:nbrOfEnzymes(ufl))
 ufl[units,ee] <- ufl2[units2,ee];

##                 snp    cnp affxSnp other  total
## enzyme1-only 129848 148340       0     0 278188
## enzyme2-only  90353   1208       0     0  91561
## both         273682 181097       0     0 454779
## missing        6685  86624    3022    69  96400
## total        500568 417269    3022    69 920928

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# Affymetrix-HeartBrain/
#  HuEx-1_0-st-v2/
#   huex_wta_breast_A.CEL, ..., huex_wta_tissue_mix4_E.CEL [53]
#
# Overall design:
#
# URL: https://www.affymetrix.com/support/technical/sample_data/exon_array_data.affx
##########################################################################
dataSet <- "Affymetrix-HeartBrain"
chipType <- "HuEx-1_0-st-v2"


ds <- downloadAffymetrixDataSet(dataSet, chipType=chipType, pathname="support/downloads/demo_data/HuEx-1_0-st-v2.tissue-mixture-data-set.gcos-files.zip")
print(ds)
## AffymetrixCelSet:
## Name: Affymetrix-HeartBrain
## Tags:
## Path: rawData/Affymetrix-HeartBrain/HuEx-1_0-st-v2
## Platform: Affymetrix
## Chip type: HuEx-1_0-st-v2
## Number of arrays: 53
## Names: huex_wta_breast_A, huex_wta_breast_B, huex_wta_breast_C, ..., huex_wta_tissue_mix4_E [53]
## Time period: 2005-06-23 12:52:43 -- 2005-07-07 20:54:06
## Total file size: 3360.35MB
## RAM: 0.06MB

verbose && exit(verbose)

############################################################################
# ROBUSTNESS TEST
############################################################################
library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
csR <- csR[1:6]
print(csR)

cesN <- doASCRMAv1(csR, verbose=verbose, drop=FALSE)$cesN

# This should throw "Exception: Unsupported chip effects. ..."
cbs <- NULL
tryCatch({
  cbs <- CbsModel(cesN)
}, error = function(ex) {
  print(ex)
})
print(cbs)

# Sanity check
stopifnot(is.null(cbs))


############################################################################
# HISTORY:
# 2012-08-30
# o Simplified test script to utilize doASCRMAv1().
# 2009-11-13
# o Created.  Thanks to Pierre Neuvial for the report.
############################################################################

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

csR <- AffymetrixCelSet$byName("GSE8605", chipType="Mapping10K_Xba142")
print(csR)

cesN <- doASCRMAv2(csR, arrays=1:6, drop=FALSE, verbose=verbose)$cesN
print(cesN)

ceR <- getAverage(cesN, verbose=verbose)
ce <- cesN[[1]]

ugp <- getAromaUgpFile(csR)
print(ugp)

for (chr in getChromosomes(ugp)) {
  units <- getUnitsOnChromosome(ugp, chr)
  pos <- getPositions(ugp, units=units) / 1e6
  thetaR <- extractTotalAndFreqB(ceR, units=units)[,"total"]
  data <- extractTotalAndFreqB(ce, units=units)
  data[,"total"] <- 2*data[,"total"] / thetaR

  chrTag <- sprintf("Chr%02d", chr)
  toPNG(getFullName(cesN), tags=c(getFullName(ce), chrTag, "TCN"), aspectRatio=1, {
    layout(matrix(1:2, ncol=1))
    par(mar=c(3,4,2,1)+0.1, pch=".")

    # TCN tracks
    cn <- RawCopyNumbers(data[,"total"], pos, chromosome=chr)
    plot(cn, col="gray", cex=0.8, ylim=c(0,4))
    cnS <- gaussianSmoothing(cn, xOut=seq(xMin(cn), xMax(cn), by=1/2), sd=1)
    points(cnS, col="black")
    stext(side=3, pos=0, getName(ce))
    stext(side=3, pos=1, chrTag)

    # BAF tracks
    plot(pos, data[,"freqB"], cex=3, ylim=c(0,1))
    box(col="blue")
    stext(side=3, pos=0, getTags(cesN, collapse=","))
  })
} # for (chr ...)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSetName <- "Affymetrix-CytoScanHD"
chipType <- "CytoScanHD_Array"

csR <- AffymetrixCelSet$byName(dataSetName, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allele-specific CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
seg <- CbsModel(dsNList$total)
print(seg)

ce <- ChromosomeExplorer(seg)
print(ce)

process(ce, arrays=1, chromosomes=1:2, verbose=verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "30";
genomeVersion <- "hg18";
user <- "HB";
datestamp <- "20100215";

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";
nbrOfEnzymes <- 2;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(".na%s", naVersion),
#      cn=sprintf(".cn.na%s", naVersion)
      cn=sprintf(".cn.na%s", as.integer(naVersion))
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=log);
  str(units);
  ## GenomeWideSNP_6.na30.annot.csv:  int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na30.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdBy <- list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);

print(ufl);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na27.1 -> na30
#   - No changes.
# o na27 -> na27.1
#   - No changes.
# o na26 -> na27
#   - No changes.
# o na24 -> na26
#   - All changes are for SNP units.
#   - There are 6 NspI and 14 StyI changes in SNP fragment lengths,
#     which some are only minor.
#   - There are 1108 more SNPs that now have missing values.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ufl <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na30");
ufl0 <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na27.1");
x <- summaryOfUnits(ufl);
x0 <- summaryOfUnits(ufl0);

print(x);
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415
print(x0);
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

print(x-x0);
##               snp cnp affxSnp other total
##  enzyme1-only   0   0       0     0     0
##  enzyme2-only   0   0       0     0     0
##  both           0   0       0     0     0
##  missing        0   0       0     0     0
##  total          0   0       0     0     0

# Differences
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(ufl[,cc] != ufl0[,cc], na.rm=TRUE);
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc], 
                       ufl[units,cc]-ufl0[units,cc]);
    colnames(df)[ncol(df)] <- "delta";
    print(df);
  }
}

# Differences in NAs
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(is.na(ufl[,cc]) != is.na(ufl0[,cc]));
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc]);
    str(df);
  }
}

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the estimates
# of the MAT (Model-based Analysis of Tiling arrays) algorithm.
#
# Author: Mark Robinson and Henrik Bengtsson
# Created: 2008-12-09
# Last modified: 2012-09-02
###########################################################################
library("aroma.affymetrix")
library("limma");  # makeContrast()
verbose <- Arguments$getVerbose(-20, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE24546"
tags <- "testset"
chipType <- "Hs_PromPR_v02"
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
)

cdf <- AffymetrixCdfFile$byChipType(chipType)
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, tags=tags, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalize the data using the MAT model
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
mn <- MatNormalization(csR)
csM <- process(mn, verbose=more(verbose, 3))
print(csM)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Convert data set such that it maps to the "unique" CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csU <- convertToUnique(csM, verbose=verbose)
print(csU)

# Rename
setFullNamesTranslator(csU, function(names, ...) { sampleNamesMap[names] })


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MatSmoothing: Design #1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sampleNames <- getNames(csU)

design1 <- makeContrasts(Prec1_MeDNA_IP1-Prec1_MeDNA_Input1, levels=sampleNames)
colnames(design1) <- "Prec1_IP1_minus_Input"
print(design1)

ms1 <- MatSmoothing(csU, design=design1, probeWindow=600, tag="singleIP")
csMS1 <- process(ms1, units=NULL, verbose=verbose)
print(csMS1)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MatSmoothing: Design #2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sampleNames <- getNames(csU)

design2 <- makeContrasts(Prec1_MeDNA_IP1 + Prec1_MeDNA_IP2-Prec1_MeDNA_Input1, levels=sampleNames)
colnames(design2) <- "Prec1_IPs_minus_Input"

ms2 <- MatSmoothing(csU, design=design2, probeWindow=800, tag="multipleIP")
csMS2 <- process(ms2, units=NULL,verbose=verbose)
print(csMS2)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# Affymetrix-CytoScanHD/
#  CytoScanHD_Array/
#    []
#
# Overall design:
#
# URL: https://www.affymetrix.com/estore/browse/products.jsp?productId=prod520004#1_3
##########################################################################
dataSet <- "Affymetrix-CytoScanHD"
chipType <- "CytoScanHD_Array"

ds <- downloadAffymetrixDataSet(dataSet, chipType=chipType, pathname="support/downloads/data/cytoscan_demo_data.zip")
print(ds)
## AffymetrixCelSet:
## Name: Affymetrix-HeartBrain
## Tags:
## Path: rawData/Affymetrix-HeartBrain/CytoScanHD_Array
## Platform: Affymetrix
## Chip type: CytoScanHD_Array
## Number of arrays: 7
## Names: 09-1420_B2_Phase4CustomerPanel_CytoScan_PS_20110228, 11-0810_LC_ONC13B_A6_PoP#2_CytoScan-PS_20110511, 11-0816_LC_ONC134B_B10_PoP#2_CytoScan-PS_20110511, ..., C474_A8_CytoScanHD_LabCorp_BetaTest-1_CB_06022011 [7]
## Time period: 2011-03-01 19:07:35 -- 2011-06-07 16:28:18
## Total file size: 460.90MB
## RAM: 0.01MB


verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
verbose <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "30";
genomeVersion <- "mm9";
user <- "HB";
datestamp <- "20100603";

chipType <- "MOUSEDIVm520650";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(".na%s", naVersion),
      cn=sprintf(".cn.na%s", as.integer(naVersion))
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup/Allocate UGP
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=verbose);
  str(units);
  ## *.na30.annot.csv:  int [1:623124] 800990 808457 907857 ...
  ## *.cn.na30.annot.csv: int [1:1832538] 1542481 1542480 1542479 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdBy <- list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
## AromaUgpFile:
## Name: MOUSEDIVm520650
## Tags: na30,mm9,HB20190603
## Full name: MOUSEDIVm520650,na30,mm9,HB20190603
## Pathname: annotationData/chipTypes/MOUSEDIVm520650/MOUSEDIVm520650,na30,mm9,HB20190603.ugp
## File size: 11.72 MB (12294266 bytes)
## RAM: 0.01 MB
## Number of data rows: 2458697
## File format: v1
## Dimensions: 2458697x2
## Column classes: integer, integer
## Number of bytes per column: 1, 4
## Footer: <createdOn>20100603 05:49:21 PDT</createdOn><platform>Affymetrix</platform><chipType>MOUSEDIVm520650</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>MOUSEDIVm520650.CDF</filename><filesize>668362285</filesize><checksum>1d83d7dde5e4816f4be315f6863f6a7c</checksum></srcFile1><srcFile2><filename>MOUSEDIVm520650.na30.annot.csv</filename><filesize>358437027</filesize><checksum>e3ef35245954d5a08ae299b95666fc3a</checksum></srcFile2><srcFile3><filename>MOUSEDIVm520650.cn.na30.annot.csv</filename><filesize>795251151</filesize><checksum>5b5bbdb60ed443b2616358beea06ddaf</checksum></srcFile3></srcFiles>
## Chip type: MOUSEDIVm520650
## Platform: Affymetrix


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o ... -> na30
#   - First one for this chip type.  We note that SNP CSV file uses "M"
#     for mitochondrial DNA, whereas the CN CSV uses "MT".  This import
#     script recognizes both.  The CN CSV also contains 227,740 "NA":s,
#     which is interpreted as "unknown" locations.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ugp <- AromaUgpFile$byChipType("MOUSEDIVm520650", tags="na30");

options(width=60);
print(table(ugp[,1], exclude=NULL));

##      1      2      3      4      5      6      7      8
## 136405 170236 107112 142492 133169 108251 171812 100077
##      9     10     11     12     13     14     15     16
## 106036  88738 135094 108539  89828 108188  79179  64466
##     17     18     19     23     24     25   <NA>
##  90052  58269  63067 165816    987    109 230775

library("aroma.affymetrix")
ovars <- ls(all.names=TRUE)
oplan <- future::plan()

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE24546,testset"
chipType <- "Hs_PromPR_v02"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
csR <- csR[1:2]
print(csR)

checksum <- NULL

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  } else if (any(grepl("SGE_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_sge")
  }
}

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  ## (a) Process a single array
  mn <- MatNormalization(csR[1], tags=c(tags, "one-array"))
  print(mn)
  csM1 <- process(mn, verbose=-10)
  print(csM1)
  csM1z <- getChecksumFileSet(csM1)
  print(csM1z[[1]])
  checksumT <- readChecksum(csM1z[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))

  ## (b) Process two arrays
  mn <- MatNormalization(csR, tags=tags)
  print(mn)
  csM <- process(mn, verbose=-10)
  print(csM)
  csMz <- getChecksumFileSet(csM)
  print(csMz[[1]])
  res <- equals(csM1z[[1]], csMz[[1]])
  if (!res) throw(res)

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}

## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "HuEx-1_0-st-v2"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadACS(ar, chipType, tags=".*")
verbose && cat(verbose, "ACS: ", pathname)

pathname <- downloadCDF(ar, chipType, tags="coreR3,A20071112,EP")
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadCDF(ar, chipType, tags="fullR3,A20071112,EP")
verbose && cat(verbose, "CDF: ", pathname)

#pathname <- downloadCDF(ar, chipType, tags="extendedR3,A20071112,EP")
#verbose && cat(verbose, "CDF: ", pathname)

verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Verbose(threshold=-4, timestamp=TRUE)

dataSet <- "FusionSDK_Test3"
chipType <- "Test3"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)

cdf <- getCdf(csR)
print(cdf)

ae <- ArrayExplorer(csR)
setColorMaps(ae, "log2,yellow")
process(ae, verbose=verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "CytoScanHD_Array";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);
setOption(aromaSettings, "user/initials", "HB");
setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
setOption(aromaSettings, "user/email", obf);
saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
genomeVersions <- c("30"="hg18", "31"="hg19", "32"="hg19");
naVersions <- names(genomeVersions);
choices <- sprintf("na%s (%s)", naVersions, genomeVersions);
choice <- textMenu(choices, title="Choose NetAffx version: ", value=FALSE);
naVersion <- naVersions[choice];
genomeVersion <- genomeVersions[naVersion];
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=verbose);
  str(units);
  ## CytoScanHD_Array.na<XX>.annot.csv:    int [1:      ?] ? ? ...
  ## CytoScanHD_Array.cn.na<XX>.annot.csv: int [1:2020591] 2116816 1458524...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugp);
footer$createdBy <- list(
  fullname = fullname, 
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na32
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ugp <- AromaUgpFile$byChipType(chipType, tags="na32");

print(table(ugp[,1], exclude=NULL));

## CytoScanHD_Array,na32,hg19,HB20111108
##      1      2      3      4      5      6      7      8
## 231306 214138 183098 158093 157876 159597 159463 128463
##      9     10     11     12     13     14     15     16
## 104017 139159 145336 135175  99730  90206  86409  77837
##     17     18     19     20     21     22     23     24
##  77435  68530  51628  57854  34623  43800 195919  19776
##     25   <NA>
##     26   2631

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080723";

chipType <- "GenomeWideSNP_5";
cdfTags <- "Full,r2";
nbrOfEnzymes <- 2;

chipType6 <- "GenomeWideSNP_6,Full";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("cdf6")) {
  cdf6 <- AffymetrixCdfFile$byChipType(chipType6);
}
print(cdf6);

if (!exists("ufl6")) {
  ufl6Tags <- sprintf("na%s", naVersion);
  ufl6 <- AromaUflFile$byChipType(getChipType(cdf6), tags=ufl6Tags);
}
print(ufl6);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup UFL file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s+,%s%s", naVersion, user, datestamp);
if (!exists("ufl")) {
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}
print(ufl);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import from the GWS6 file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Identify units with missing UFL data
isMissing <- (is.na(ufl[,1]) & is.na(ufl[,2]));
print(summary(drop(isMissing)));
##    Mode   FALSE    TRUE
## logical  752478  168450

units <- which(isMissing);
unitNames <- getUnitNames(cdf, units=units);

# Identify which exists in GWS6
units6 <- match(unitNames, getUnitNames(cdf6));
keep <- is.finite(units6);
print(summary(keep));
##    Mode   FALSE    TRUE
## logical   92097   76353
units <- which(keep);
units6 <- units6[keep];
rm(keep);

# Import data
for (ee in 1:nbrOfEnzymes(ufl)) {
 ufl[units,ee] <- ufl6[units6,ee];
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
footer <- readFooter(ufl);
srcFile <- list(
  filename=getFilename(ufl6), 
  filesize=getFileSize(ufl6), 
  checksum=getChecksum(ufl6)
);
footer$srcFiles <- c(footer$srcFiles, list(srcFile=srcFile));
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);
## AromaUflFile:
## Name: GenomeWideSNP_5
## Tags: Full,r2,na26,HB20080723
## Pathname: annotationData/chipTypes/GenomeWideSNP_5/GenomeWideSNP_5,Full,r2,na26,HB20080723.ufl
## File size: 3.51MB
## RAM: 0.00MB
## Number of data rows: 920928
## File format: v1
## Dimensions: 920928x2
## Column classes: integer, integer
## Number of bytes per column: 2, 2
## Footer: <platform>Affymetrix</platform><chipType>GenomeWideSNP_5,Full,r2</chipType><createdOn>20080723 16:09:57 PDT</createdOn><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile><filename>GenomeWideSNP_5.na26.annot.csv</filename><filesize>755337946</filesize><checksum>af59235b6fccada7f871257149a89215</checksum></srcFile><srcFile><filename>GenomeWideSNP_5.na26.annot.csv</filename><filesize>755337946</filesize><checksum>af59235b6fccada7f871257149a89215</checksum></srcFile><srcFile><filename>GenomeWideSNP_5.na26.annot.csv</filename><filesize>755337946</filesize><checksum>af59235b6fccada7f871257149a89215</checksum></srcFile></srcFiles>
## Chip type: GenomeWideSNP_5,Full,r2
## Platform: Affymetrix
print(getChecksum(ufl));
## [1] "9d73f5a7689cac14c331ab661cf50ea9"

x <- summaryOfUnits(ufl, enzymes=c("NspI", "StyI"));
print(x);
## GenomeWideSNP_5,Full,na26+,HB20080723:
##                 snp    cnp affxSnp other  total
## enzyme1-only 102627 140099       0     0 242726
## enzyme2-only  90353   1208       0     0  91561
## both         249553 171077       0     0 420630
## missing       58035 104885    3022    69 166011
## total        500568 417269    3022    69 920928

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE13372/
#   GenomeWideSNP_6/
#     *.CEL [68]
#
# Overall design:
#  21 replicates of HCC1143 (breast ductal carcinoma), 21 replicates
#  of HCC1143BL (matched normal), 13 replicates of HCC1954 (breast
#  ductal carcinoma), 11 replicates of HCC1954BL (matched normal),
#  1 replicate of NCI-H2347 (lung adenocarcinoma), 1 replicate of
#  NCI-H2347BL (matched normal).
#  http://www.broad.mit.edu/cancer/pub/solexa_copy_numbers/
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE13372
##########################################################################
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6"

sampleNamesMap <- c(
  GSM337641="HCC1143_GLEYS_A02",
  GSM337646="HCC1143_TRIBE_H11"
)
sampleNames <- names(sampleNamesMap)

ds <- downloadGeoRawDataFiles(dataSet, chipType=chipType, sampleNames=sampleNames)
print(ds)

verbose && exit(verbose)

library("aroma.affymetrix")

log <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Assert existence of probe-sequence annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acs <- AromaCellSequenceFile$byChipType(chipType)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR)
print(acc)
csC <- process(acc, verbose=log)
print(csC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Base-count normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
bcn <- BaseCountNormalization(csC)
print(bcn)

csN <- process(bcn, verbose=log)
print(csN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot probe sequence base count effects
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ff <- 3

counts <- countBases(acs, verbose=log)

Ms <- list()
whats <- c("raw", "acc", "bcn")
for (what in whats) {
  if (what == "raw") {
    cs <- csR
  } else if (what == "acc") {
    cs <- csC
  } else if (what == "bcn") {
    cs <- csN
  }
  cf <- cs[[ff]]
  cfR <- getAverageFile(cs, verbose=log)
  yR <- readRawData(cfR, fields="intensities", drop=TRUE)
  y <- readRawData(cf, fields="intensities", drop=TRUE)
  M <- log2(y/yR)
  Ms[[what]] <- M
  rm(y, yR, cfR, cs, M)
} # for (what ...)


# Estimate standard deviations for log-ratios
print(sapply(Ms, FUN=function(M) { mad(diff(M), na.rm=TRUE) }))

Mlim <- c(-1,1)
Mlab <- expression(M == log[2](y/y[R]))
xlim <- c(0, 25)

layout(matrix(1:(length(whats)*4), ncol=4, byrow=TRUE))
par(mar=c(5,4,2,1)+0.1)
for (what in names(Ms)) {
  M <- Ms[[what]]

  for (bb in c("A", "C", "G", "T")) {
    xlab <- sprintf("Number of %s:s", bb)
    boxplot(M ~ counts[,bb], outline=FALSE,
            ylim=Mlim, xlim=xlim, ylab=Mlab, xlab=xlab)
    stext(side=3, pos=0, getFullName(cf))
    stext(side=3, pos=0.98, line=-1, cex=2, bb)
    stextChipType(chipType)
  }
  rm(M)
} # for (what ...)
devDone()

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "28";
user <- "HB";
datestamp <- "20090519";

chipType <- "Cytogenetics_Array";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(".na%s", naVersion),
      cn=sprintf(".cn.na%s", naVersion)
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=log);
  str(units);
  ## Cytogenetics_Array.na28.annot.csv:    int [1:400103] 325823 117191
  ## Cytogenetics_Array.cn.na28.annot.csv: int [1:2387593] 2771313 2771325
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
AromaUgpFile:
Name: Cytogenetics_Array
Tags: na28,HB20090519
Full name: Cytogenetics_Array,na28,HB20090519
Pathname: annotationData/chipTypes/Cytogenetics_Array/Cytogenetics_Array,na28,HB20090519.ugp
File size: 13.33 MB (13979333 bytes)
RAM: 0.00 MB
Number of data rows: 2795708
File format: v1
Dimensions: 2795708x2
Column classes: integer, integer
Number of bytes per column: 1, 4
Footer: <createdOn>20090519 23:15:52 PDT</createdOn><platform>Affymetrix</platform><chipType>Cytogenetics_Array</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Cytogenetics_Array.CDF</filename><filesize>564465214</filesize><checksum>17ea0ac70c196f20a1825dff8b5e773c</checksum></srcFile1><srcFile2><filename>Cytogenetics_Array.na28.annot.csv</filename><filesize>141110783</filesize><checksum>eeca051fc6c7822173e276cac14e0ad4</checksum></srcFile2><srcFile3><filename>Cytogenetics_Array.cn.na28.annot.csv</filename><filesize>852047697</filesize><checksum>63490620be89e306767de896e883b5fa</checksum></srcFile3></srcFiles>
Chip type: Cytogenetics_Array
Platform: Affymetrix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na28
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ugp <- AromaUgpFile$byChipType("Cytogenetics_Array", tags="na28");

options(width=60);
print(table(ugp[,1], exclude=NULL));
     1      2      3      4      5      6      7      8
222413 226698 192608 169326 167528 166405 155857 139341
     9     10     11     12     13     14     15     16
121665 132176 130925 124991  89622  86105  83585  81726
    17     18     19     20     21     22     23     24
 84215  72954  59305  60120  33911  37351 132830  14386
    25   <NA>
  1653   8012

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

cdf <- AffymetrixCdfFile$byChipType("Mapping50K_Hind240")
print(cdf)

unitTypes <- getUnitTypes(cdf)
print(table(unitTypes))

units <- which(unitTypes == 2)
str(units)

# Group units by the number of groups and cells per group
sets <- groupUnitsByDimension(cdf, units=units, verbose=verbose)
str(sets)

# Apply cell indices to sets containing "rectangular" unit
cellSets <- lapply(sets$nestedSets, FUN=function(set) {
  nbrOfGroups <- set$nbrOfGroups
  set$sets <- lapply(set$sets, FUN=function(subset) {
    nbrOfCellsPerGroup <- subset$nbrOfCellsPerGroup
    nbrOfCellsPerGroup <- unique(nbrOfCellsPerGroup)
    if (length(nbrOfCellsPerGroup) == 1) {
      nbrOfUnits <- length(subset$units)
      dim <- c(nbrOfCellsPerGroup, nbrOfGroups, nbrOfUnits)
      cells <- getCellIndices(cdf, units=subset$units, 
                                   unlist=TRUE, useNames=FALSE)
      dim(cells) <- dim
      subset$cells <- cells
    }
    subset
  })
  set
})

str(cellSets)

library("aroma.affymetrix")
library("ACNE")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ACNE
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doACNE(csR, fln=TRUE, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segment TCN
dsT <- dsNList$total
seg <- CbsModel(dsT)
print(seg)

fit(seg, arrays=1, chromosomes=19, verbose=verbose)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ChromosomeExplorer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ce <- ChromosomeExplorer(seg)
print(ce)
process(ce, arrays=1:2, chromosomes=c(19,23), verbose=verbose)

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)



dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")

# Expected sample names
sampleNames <- c("NA06985", "NA06991", "NA06993",
                 "NA06994", "NA07000", "NA07019")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csRList <- list()
for (chipType in chipTypes) {
  cs <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
  print(cs)
  stopifnot(identical(getNames(cs), sampleNames))
  csRList[[chipType]] <- cs
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- csRList
csCList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  acc <- AllelicCrosstalkCalibration(cs)
  print(acc)
  csC <- process(acc, verbose=log)
  print(csC)
  stopifnot(identical(getNames(csC), getNames(cs)))
  csCList[[chipType]] <- csC
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test (for CN analysis)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- csCList
cesCnList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  plm <- RmaCnPlm(cs, mergeStrands=TRUE, combineAlleles=TRUE, shift=300)
  print(plm)
  fit(plm, verbose=log)
  ces <- getChipEffectSet(plm)
  print(ces)
  stopifnot(identical(getNames(ces), getNames(cs)))
  cesCnList[[chipType]] <- ces
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extraction test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
thetaList <- list()
cesList <- cesCnList
for (chipType in names(cesList)) {
  ces <- cesList[[chipType]]
  theta <- extractMatrix(ces, verbose=log)
  print(summary(theta))
  thetaList[[chipType]] <- theta
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fragment-length normalization test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesNList <- list()
for (chipType in names(csList)) {
  ces <- cesCnList[[chipType]]
  fln <- FragmentLengthNormalization(ces)
  print(fln)
  cesN <- process(fln, verbose=log)
  print(cesN)
  stopifnot(identical(getNames(cesN), getNames(ces)))
  cesNList[[chipType]] <- cesN
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Raw copy numbers
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Emulate list of ChipEffectSet:s where some arrays on exists in
# one of the sets
for (kk in seq_along(cesNList)) {
  ces <- cesNList[[kk]]
  ces <- ces[setdiff(seq_along(ces), length(ces)+1-kk)]
  cesNList[[kk]] <- ces
}


cnm <- RawCopyNumberModel(cesNList)
print(cnm)

rawCNs <- extractRawCopyNumbers(cnm, array=1, chromosome=1, verbose=log)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Glad model test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#seg <- GladModel(cesNList)
seg <- CbsModel(cesNList)
print(seg)

fit(seg, arrays=1, chromosomes=19, verbose=log)

# Tests the case where one of the set does not have observations.
fit(seg, arrays=nbrOfArrays(seg), chromosomes=19, verbose=log)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ChromosomeExplorer test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ce <- ChromosomeExplorer(seg)
print(ce)
process(ce, arrays=1:2, chromosomes=c(19,23), verbose=log)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")



##########################################################################
# Data set:
# GSE19539
#   GenomeWideSNP_6/
#    *.CEL [139]
#   HuGene-1_0-st/
#    *.CEL [68]
#
# Overall design:
#  2 tumours for copy number analysis with 57 matching blood normals.
#  Out of these 72, 68 produced good quality RNA for expression arrays.
#  These 68 array samples and have been run in 10 batches by the same 
#  user. Batch number is recorded under characteristics.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE19539
##########################################################################
dataSet <- "GSE19539"
chipType <- "GenomeWideSNP_6"

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType, 
                   chipTypeAliases=c("GenomeWideEx_6"="GenomeWideSNP_6"))
print(ds)


verbose && exit(verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")



##########################################################################
# Data set:
# GSE24546,testset/
#   Hs_PromPR_v02/
#     GSM605951.CEL (Prec1_MeDNA_Input1)
#     GSM605952.CEL (Prec1_MeDNA_IP2)
#     GSM605953.CEL (Prec1_MeDNA_IP1)
#
# Overall design:
#  Comparison of MeDIP/MBD for DNA methylation profiling, comparison of
#  whole genome amplification techniques, using tiling array for copy
#  number aberration detection and comparisons of tiling array data to
#  sequencing readouts.
#
# URL: https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE24546
##########################################################################
dataSet <- "GSE24546"
tags <- "testset"
chipType <- "Hs_PromPR_v02"
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
)

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataFiles(dataSet, tags=tags, chipType=chipType, sampleNames=names(sampleNamesMap))
print(ds)
## AffymetrixCelSet:
## Name: GSE24546
## Tags: testset
## Path: rawData/GSE24546,testset/Hs_PromPR_v02
## Platform: Affymetrix
## Chip type: Hs_PromPR_v02
## Number of arrays: 3
## Names: GSM605951, GSM605952, GSM605953 [3]
## Time period: 2007-09-28 13:17:49 -- 2007-09-28 14:26:51
## Total file size: 134.54MB
## RAM: 0.01MB

verbose && exit(verbose)

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the RMA
# chip-effect estimates as estimated by affyPLM.
#
# Author: Mark Robinson and Henrik Bengtsson
# Created: 2007-06-20
# Last modified: 2012-09-01
###########################################################################
library("aroma.affymetrix")
library("affyPLM")          # fitPLM()
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# Avoid being masked by oligo::fitPLM() and affy::plotDensity()
fitPLM <- affyPLM::fitPLM
plotDensity <- aroma.light::plotDensity

# Detach 'oligoClasses' in case it is loaded.  If not, there an error
# related to probeNames() will be thrown.
tryCatch(detach("package:oligoClasses"), error=function(ex) {})


# ----------------------------------
# Dataset
# ----------------------------------
dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# ----------------------------------
# RMA estimates by aroma.affymetrix
# ----------------------------------
verbose && enter(verbose, "RMA by aroma.affymetrix")

res <- doRMA(csR, drop=FALSE, verbose=verbose)
print(res)

# Extract chip effects on the log2 scale
ces <- res$ces
theta <- extractMatrix(ces)
rownames(theta) <- getUnitNames(cdf)
theta <- log2(theta)

verbose && exit(verbose)


# ------------------------
# RMA estimates by affyPLM
# ------------------------
verbose && enter(verbose, "RMA by affyPLM")
verbose && print(verbose, sessionInfo())

raw <- ReadAffy(filenames=getPathnames(csR))
verbose && print(verbose, raw)

fit <- fitPLM(raw, verbosity.level=9)
theta0 <- coefs(fit)

verbose && exit(verbose)


# --------------------------------
# Compare the two implementations
# --------------------------------
# Reorder the aroma.affymetrix estimates
o <- match(rownames(theta0), rownames(theta))
theta <- theta[o,]

# Calculate statistics
rho <- diag(cor(theta, theta0))
print(rho)
print(range(rho))
e <- (theta - theta0)
print(summary(e))

# (a) Visual comparison
toPNG(getFullName(csR), tags=c("doRMA_vs_affyPLM"), width=800, {
  par(mar=c(5,5,4,2)+0.1, cex.main=2, cex.lab=2, cex.axis=1.5)

  layout(matrix(1:16, ncol=4, byrow=TRUE))

  xlab <- expression(log[2](theta[affyPLM]))
  ylab <- expression(log[2](theta[aroma.affymetrix]))
  for (kk in seq_len(ncol(theta))) {
    main <- colnames(theta)[kk]
    plot(theta0[,kk], theta[,kk], pch=".", xlab=xlab, ylab=ylab, main=main)
    abline(0,1, col="blue")
    stext(side=3, pos=0, line=-1.1, cex=1.2, substitute(rho==x, list(x=rho[kk])))
  }

  xlab <- expression(log[2](theta[aroma.affymetrix]/theta[affyPLM]))
  plotDensity(e, xlab=xlab)
})

# (b) Assert correlations
print(rho)
print(range(rho))
stopifnot(all(rho > 0.99995))

# (c) Assert differences
stopifnot(mean(as.vector(e^2)) < 1e-3)
stopifnot(sd(as.vector(e^2)) < 1e-3)
stopifnot(quantile(abs(e), 0.99) < 0.05)
stopifnot(max(abs(e)) < 0.100)


verbose && print(verbose, sessionInfo())


###########################################################################
# HISTORY:
# 2012-09-01 [HB]
# o Now using a GEO data set.
# 2012-08-30 [HB]
# o Updated to utilize toPNG().
# 2010-02-05 [HB]
# o Harmonized with the corresponding gcRMA test script.
# 2010-01-02 [HB]
# o BUG FIX: If loaded, detaching oligoClasses, because otherwise it will
#   cause name conflict with affy::probeNames().
# 2008-07-17 [HB]
# o Added some more quantile-based assertions too.
# o Had to lower the similarity threshold from 1e-4 to 1e-3. I don't know
#   why this is, but the differences are still very small.
###########################################################################

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the estimates
# of the MAT (Model-based Analysis of Tiling arrays) algorithm.
#
# Author: Mark Robinson and Henrik Bengtsson
# Created: 2008-12-09
# Last modified: 2012-09-02
###########################################################################
library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-20, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE24546"
tags <- "testset"
chipType <- "Hs_PromPR_v02"
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
)

cdf <- AffymetrixCdfFile$byChipType(chipType)
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, tags=tags, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalize the data using the MAT model
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
mn <- MatNormalization(csR)
print(mn)

csM <- process(mn, verbose=more(verbose, 3))
print(csM)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Convert data set such that it maps to the "unique" CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csU <- convertToUnique(csM, verbose=verbose)
print(csU)

# Rename
setFullNamesTranslator(csU, function(names, ...) { sampleNamesMap[names] })


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Validate the "unique" estimates
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- list(csM, csU)
for (ii in seq_along(csU)) {
  yList <- lapply(csList, FUN=function(cs) {
    cf <- cs[[ii]]
    cdf <- getCdf(cf)
    units <- indexOf(cdf, "^chr1F")
    cells <- getCellIndices(cdf, units=units, stratifyBy="pm",
                                            unlist=TRUE, useNames=FALSE)
    y <- extractMatrix(cf, cells=cells, drop=TRUE)
    y
  })
  stopifnot(all.equal(yList[[1]], yList[[2]]))
  rm(yList)
} # for (ii ...)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot ratios estimates along a single chromosome
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calculate the average
cfR <- getAverageFile(csU)

cdfU <- getCdf(csU)
acpU <- AromaCellPositionFile$byChipType(getChipType(cdfU))

# Identify cells on Chr21
chr <- 21
chrTag <- sprintf("Chr%02d", chr)
cells <- whichVector(acpU[,1,drop=TRUE] == chr)
str(cells)

# Get the chromosomal positions of these cells
pos <- acpU[cells,2,drop=TRUE]

yR <- extractMatrix(cfR, cells=cells, drop=TRUE, verbose=verbose)
for (ii in seq_along(csU)) {
  cf <- csU[[ii]]
  sampleName <- getName(cf)

  toPNG(getFullName(csU), tags=c(sampleName, "tracks"), aspectRatio=1/2, {
    par(mar=c(3,3,1,1)+0.1, mgp=c(1.8,0.5,0))
    xlab <- "Physical position (Mb)"
    ylab <- expression(log2(PM))

    x <- pos / 1e6
    y <- extractMatrix(cf, cells=cells, drop=TRUE, verbose=verbose)
    M <- log2(y/yR)

    plot(x, M, pch=".", cex=2, xlab=xlab, ylab=ylab)
    stext(side=3, pos=0, cex=0.7, sampleName)
    stext(side=3, pos=1, cex=0.7, chrTag)
    stext(side=4, pos=0, cex=0.7, getFullName(csU))
    stext(side=4, pos=1, cex=0.7, sprintf("n=%d", length(y)))
  })
} # for (ii ...)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic-crosstalk calibration with and without mergeShifts
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR, mergeShifts=TRUE)
print(acc)

csC <- process(acc, verbose=verbose)
print(csC)


acc <- AllelicCrosstalkCalibration(csR, mergeShifts=FALSE)
print(acc)

csC <- process(acc, verbose=verbose)
print(csC)

library("R.utils")
if (interactive()) library("R.menu")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


verbose && enter(verbose, "Removing all generated data")

verbose && cat(verbose, "This will *not* remove annotation data or raw data sets.")

# Root directories to be removed, iff existing
paths <- c(
  "probeData/",
  "plmData/",
  "qcData/",
  "firmaData/",
  "cbsData/",
  "gladData/",
  "haarData/",
  "totalAndFracBData/",
  "totalAndFracBData,txt/",
  "oligoData/",
  "crlmmData/",
  "Data/",
  "rawCnData/",
  "smoothCnData/",
  "reports/",
  "figures/"
)

# Identify which exists
keep <- sapply(paths, FUN=isDirectory)
paths <- paths[keep]

if (length(paths) > 0) {
  if (interactive()) {
    paths <- selectMenu(paths, selected=TRUE, title="Root directories to be removed")
    verbose && cat(verbose, "Root directories to be removed:")
    verbose && cat(verbose, paste(paths, collapse="\n"))
  }
  
  
  for (kk in seq_along(paths)) {
    path <- paths[kk]
    verbose && enter(verbose, sprintf("Root directory #%s ('%s') of %s", kk, path, length(paths)))
    removeDirectory(path, recursive=TRUE)
    verbose && exit(verbose)
  } # for (kk ...)
} else {
  verbose && cat(verbose, "No root directories available. Skipping!")
}

verbose && exit(verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# HapMap,CEU,testset/
#   Mapping50K_Hind240/
#    CEU_NA06985_HIND.CEL, ..., CEU_NA07019_HIND.CEL [6 files]
#   Mapping50K_Xba240/
#    CEU_NA06985_XBA.CEL, ..., CEU_NA07019_XBA.CEL [6 files]
#
# URL: ftp://ftp.ncbi.nlm.nih.gov/hapmap/raw_data/affy100k/
##########################################################################
dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")
sampleNames <- c("CEU_NA06985", "CEU_NA06991", "CEU_NA06993",
                 "CEU_NA06994", "CEU_NA07000", "CEU_NA07019")

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadHapMapSamples(dataSet, chipType=chipTypes[1], sampleNames=sampleNames)
print(ds)
## AffymetrixCelSet:
## Name: HapMap
## Tags: CEU
## Path: rawData/HapMap,CEU/Mapping50K_Hind240
## Platform: Affymetrix
## Chip type: Mapping50K_Hind240
## Number of arrays: 6
## Names: CEU_NA06985_HIND, CEU_NA06991_HIND, CEU_NA06993_HIND, ..., CEU_NA07019_HIND [6]
## Time period: 2004-01-14 14:02:08 -- 2004-01-17 13:53:58
## Total file size: 146.86MB
## RAM: 0.01MB

ds <- downloadHapMapSamples(dataSet, chipType=chipTypes[2], sampleNames=sampleNames)
print(ds)
## AffymetrixCelSet:
## Name: HapMap
## Tags: CEU,testset
## Path: rawData/HapMap,CEU,testset/Mapping50K_Xba240
## Platform: Affymetrix
## Chip type: Mapping50K_Xba240
## Number of arrays: 6
## Names: CEU_NA06985_XBA, CEU_NA06991_XBA, CEU_NA06993_XBA, ..., CEU_NA07019_XBA [6]
## Time period: 2004-01-15 17:45:24 -- 2004-01-23 16:05:32
## Total file size: 146.85MB
## RAM: 0.01MB


verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
setFullNamesTranslator(csR, function(names, ...) {
  # Turn into comma-separated tags
  names <- gsub("_", ",", names)
  # Drop any Hind/Xba tags
  names <- gsub(",(Hind|Xba)", "", names)
  names
})
print(csR)
print(getFullNames(csR))

# Check SAF attributes
nXY <- t(sapply(csR, function(cf) getAttributes(cf)[c("n23", "n24")]))
rownames(nXY) <- getNames(csR)
print(verbose, nXY)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR)
print(acc)
csC <- process(acc, verbose=verbose)
print(csC)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalization for nucleotide-position probe sequence effects
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
bpn <- BasePositionNormalization(csC, target="zero")
print(bpn)
csN <- process(bpn, verbose=verbose)
print(csN)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test (for total CN analysis)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- RmaCnPlm(csN, mergeStrands=TRUE, combineAlleles=TRUE, shift=300)
print(plm)
fit(plm, verbose=verbose)
ces <- getChipEffectSet(plm)
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalize for PCR fragment-length effects
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fln <- FragmentLengthNormalization(ces, target="zero")
print(fln)
cesN <- process(fln, verbose=verbose)
print(cesN)

# The attributes applies to chip effects as well
nXY0 <- nXY
nXY <- t(sapply(cesN, function(cf) getAttributes(cf)[c("n23", "n24")]))
rownames(nXY) <- getNames(cesN)
print(nXY)
stopifnot(identical(nXY, nXY0))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calculate sex-chromosome bias-corrected reference signals
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# For Chr1-22 and ChrX the copy-neutral ploidy should be two.
# If the ploidy of a sample is unknown, assume the default is two.
ceR <- calculateBaseline(cesN, chromosomes=1:23, ploidy=2,
                                       defaultPloidy=2, verbose=verbose)
print(ceR)

# Compare to regular median average
ceRb <- getAverageFile(cesN, verbose=verbose)
print(ceRb)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Verify that the ChrX CNs are bias corrected
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cbs <- CbsModel(cesN, ceR)
print(cbs)

M <- NULL
for (kk in seq_along(cbs)) {
  rawCNs <- extractRawCopyNumbers(cbs, array=kk, chromosome=23)
  rawCNs <- getSignals(rawCNs)
  M <- cbind(M, rawCNs)
}
colnames(M) <- getArrays(cbs)

n23 <- sapply(cesN, getAttribute, "n23")
col <- c("blue", "red")[n23]
Mlab <- expression(log[2](theta/theta[R]))
Mlim <- c(-5,2)

boxplot(M, col=col, ylim=Mlim, ylab=Mlab, las=2)
abline(h=0, lty=4)
title("Copy numbers on ChrX\n(bias corrected)")

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-10, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE20403"
chipType <- "MoEx-1_0-st-v1"

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="coreR1,A20080718,MR")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
csR <- csR[1:6]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# gcRMA-style background correction
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Currently, you must use the standard CDF file.
cdf <- getCdf(csR)
cdfS <- AffymetrixCdfFile$byChipType(getChipType(cdf, fullname=FALSE))
setCdf(csR, cdfS)
bc <- GcRmaBackgroundCorrection(csR, type="affinities")
print(bc)
csB <- process(bc, verbose=verbose)
print(csB)
# Now, use the custom CDF in what follows
setCdf(csB, cdf)
print(csB)

if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "MoGene-1_0-st-v1";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
genomeVersions <- c("32"="mm8");
naVersions <- names(genomeVersions);
choices <- sprintf("na%s (%s)", naVersions, genomeVersions);
choice <- textMenu(choices, title="Choose NetAffx version: ", value=FALSE);
naVersion <- naVersions[choice];
genomeVersion <- genomeVersions[naVersion];
datestamp <- format(Sys.Date(), format="%Y%m%d");



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
print(cdf);

tags <- sprintf(".na%s", naVersion);

pattern <- sprintf("^%s%s.*[.]transcript.csv$", chipType, tags);
pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags, pattern=pattern);
if (isFile(pathname)) {
  csv <- AffymetrixNetAffxCsvFile(pathname);
}
rm(tags);
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);

# Read unit names

colClasses <- c("*"="NULL", "probesetId"="character", "seqname"="character", "(start|stop)"="character");
verbose && enter(verbose, "Read annotation data for all units");
data <- readDataFrame(csv, colClasses=colClasses);
# Coerce to integers
data$start <- as.integer(data$start);
data$stop <- as.integer(data$stop);
verbose && str(verbose, data);
verbose && exit(verbose);

verbose && enter(verbose, "Map to unit names");
units <- indexOf(cdf, names=data$probesetId);
verbose && print(verbose, summary(units));
verbose && str(verbose, units);
verbose && exit(verbose);

verbose && enter(verbose, "Drop unknown units");
keep <- is.finite(units);
units <- units[keep];
data <- data[keep,];
verbose && cat(verbose, "Number of known units: ", length(units));
verbose && str(verbose, data);
verbose && exit(verbose);

verbose && enter(verbose, "Parse annotation data");
chr <- data$seqname;
chr <- gsub("chr", "", chr, fixed=TRUE);
chr <- gsub("_random", "", chr, fixed=TRUE);
chr[chr == "X"] <- 23L;
chr[chr == "Y"] <- 24L;
chr[chr == "M"] <- 25L;
chr <- as.integer(chr);
position <- (data$start + data$stop) / 2;
verbose && print(verbose, table(chr));
verbose && exit(verbose);


verbose && enter(verbose, "Write to file");
ugp[units,1] <- chr;
ugp[units,2] <- position;
verbose && exit(verbose);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- c(list(cdf), list(csv));
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugp);
footer$createdBy <- list(
  fullname = fullname, 
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ugp <- AromaUgpFile$byChipType("MoGene-1_0-st-v1,r3", tags="na32");
ugp0 <- AromaUgpFile$byChipType("MoGene-1_0-st-v1,r3", tags="na32");

print(table(ugp[,1], exclude=NULL));
print(table(ugp0[,1], exclude=NULL));

## GenomeWideSNP_6,Full,na31,hg19,HB20110328
##      1      2      3      4      5      6      7      8
## 146626 153717 127767 120377 115735 112727 100925  98308
##      9     10     11     12     13     14     15     16
##  82300  93635  89598  87341  65927  57115  53596  54111
##     17     18     19     20     21     22     23     24
##  46609  52102  30365  43649  25105  24438  87271   9688
##     25   <NA>
##    455   1928

## GenomeWideSNP_6,na30,hg18,HB20100215.ugp
##      1      2      3      4      5      6      7      8
## 146401 153663 127766 120296 115672 112825 100996  98277
##      9     10     11     12     13     14     15     16
##  82168  93592  89525  87321  66067  57103  53556  54182
##     17     18     19     20     21     22     23     24
##  46632  52093  30299  43628  25111  24484  87200   9483
##     25   <NA>
##    445   2630


rr <- whichVector(ugp[,1] != ugp0[,1]);
str(rr);
## integer(0)

rr <- whichVector(ugp[,2] != ugp0[,2]);
str(rr);
## integer(0)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-10, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE37861"
chipType <- "MoGene-1_0-st-v1"

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="r3")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
csR <- csR[1:6]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# RMA background correction
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Currently, you must use the standard CDF file.
bc <- RmaBackgroundCorrection(csR)
print(bc)

csB <- process(bc, verbose=verbose)
print(csB)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Quantile normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
qn <- QuantileNormalization(csB, typesToUpdate="pm")
csN <- process(qn, verbose=verbose)
print(csN)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")



##########################################################################
# Data set:
# GSE20584
#   GenomeWideSNP_6/
#    *.CEL [2]
#
# Overall design:
#  One lung tumor sample and an adjacent normal sample were assayed on
#  the Affymetrix SNP6.0 array.
#
# Notes:
#  HB 2012-09-15: It doesn't look like there is a patient id available.
#  Lets just name him 'Patient1'.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE20584
#      ftp://ftp.ncbi.nlm.nih.gov/sra/Submissions/SRA012/SRA012097
##########################################################################
dataSet <- "GSE20584"
chipType <- "GenomeWideSNP_6"

sampleNamesMap <- c(
  GSM517071="Patient1,T,lung",
  GSM517072="Patient1,N,adjacent"
)
sampleNames <- names(sampleNamesMap)

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType, 
                   chipTypeAliases=c("GenomeWideEx_6"="GenomeWideSNP_6"))
print(ds)


verbose && exit(verbose)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data sources
#https://www.affymetrix.com/estore/browse/products.jsp?productId=131533
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";
nbrOfEnzymes <- 2;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naVersions <- 30:33;
naVersion <- textMenu(naVersions, title="Choose NetAffx version: ", value=TRUE);
datestamp <- format(Sys.Date(), format="%Y%m%d");


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);

genomeVersion <- getHeaderAttributes(csvList[[1]])[["genome-version"]];
genomeVersion <- Arguments$getCharacter(genomeVersion, nchar=4, length=c(1,1));
dbSNPVersion <- getHeaderAttributes(csvList[[1]])[["dbSNP-version"]];
dbSNPVersion <- Arguments$getInteger(dbSNPVersion);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
tags <- sprintf("na%s,%s,dbSNP%d,%s%s", naVersion, genomeVersion, dbSNPVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=verbose);
  str(units);
  ## GenomeWideSNP_6.na<XX>.annot.csv:  int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile),
    filesize=getFileSize(srcFile),
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ufl);
footer$createdBy <- list(
  fullname = fullname,
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);

print(ufl);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# WHAT'S NEW:
#
# o na32 -> na33
#   - Back to no filtering?  By comparing CSV content for a SNP,
#     I've verified that the parsing is correct.
# o na31 -> na32
#   - Are Affymetrix doing filter for us again?
# o na30 -> na31
#   - Lots of differences; Affymetrix no longer filter for us.
# o na27.1 -> na30
#   - No changes.
# o na27 -> na27.1
#   - No changes.
# o na26 -> na27
#   - No changes.
# o na24 -> na26
#   - All changes are for SNP units.
#   - There are 6 NspI and 14 StyI changes in SNP fragment lengths,
#     which some are only minor.
#   - There are 1108 more SNPs that now have missing values.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ufl <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na33");
ufl0 <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na32");
x <- summaryOfUnits(ufl);
x0 <- summaryOfUnits(ufl0);

print(x);
print(x0);

## GenomeWideSNP_6,Full,na33,hg19,dbSNP137,HB20140117
##                 snp    cnp affxSnp other   total
## enzyme1-only      0 445237       0     0  445237
## enzyme2-only    210      5       0     0     215
## both         929892 500368    3018     0 1433278
## missing        1844    216       4   621    2685
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,Full,na32,hg19,dbSNP132,HB20140118
##                 snp    cnp affxSnp other   total
## enzyme1-only 242858 435414     777     0  679049
## enzyme2-only 158233  19259     620     0  178112
## both         528831 490937    1621     0 1021389
## missing        2024    216       4   621    2865
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na31,hg19,HB20110328.ufl
##                 snp    cnp affxSnp other   total
## enzyme1-only    577   9609       0     0   10186
## enzyme2-only    502  23432       0     0   23934
## both         929322 912574       0     0 1841896
## missing        1545    211    3022   621    5399
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na30,hg18,HB20100215.ufl
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na27.1,hg??,HB20??????.ufl
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

print(x-x0);
##                  snp    cnp affxSnp other   total
## enzyme1-only -242858   9823    -777     0 -233812
## enzyme2-only -158023 -19254    -620     0 -177897
## both          401061   9431    1397     0  411889
## missing         -180      0       0     0    -180
## total              0      0       0     0       0

# Differences
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(ufl[,cc] != ufl0[,cc], na.rm=TRUE);
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc],
                       ufl[units,cc]-ufl0[units,cc]);
    colnames(df)[ncol(df)] <- "delta";
    print(df);
  }
}

##         units length length  delta
## 1       21988   1663    919    744
## 2       82781    445    177    268
## 3       87809    871   1259   -388
## 4      126538   1062   1994   -932
## ...

# Differences in NAs
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(is.na(ufl[,cc]) != is.na(ufl0[,cc]));
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc]);
    str(df);
  }
}

path <- system.file("testScripts/R", package="aroma.affymetrix");
pathname <- file.path(path, "downloadUtils.R");
source(pathname);

verbose && enter(verbose, "Downloading raw data");



##########################################################################
# Data set:
# GSE24546,testset/
#   Hs_PromPR_v02/
#     GSM605951.CEL (Prec1_MeDNA_Input1)
#     GSM605952.CEL (Prec1_MeDNA_IP2)
#     GSM605953.CEL (Prec1_MeDNA_IP1)
#
#     # Validation files (from the aroma project)
#     Prec1_MeDNA_600_IP1-Input.tsv
#     Prec1_MeDNA_600_IP1-Input.bar.txt
#     Prec1_MeDNA_800_IPs-Input.bar.txt 
#
# Overall design:
#  Comparison of MeDIP/MBD for DNA methylation profiling, comparison of
#  whole genome amplification techniques, using tiling array for copy
#  number aberration detection and comparisons of tiling array data to
#  sequencing readouts.
#
# URL: https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE24546
##########################################################################
dataSet <- "GSE24546";
tags <- "testset";
chipType <- "Hs_PromPR_v02";
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
);

verbose && cat(verbose, "Data set: ", dataSet);

ds <- downloadGeoRawDataFiles(dataSet, tags=tags, chipType=chipType, sampleNames=names(sampleNamesMap));
print(ds);
## AffymetrixCelSet:
## Name: GSE24546
## Tags: testset
## Path: rawData/GSE24546,testset/Hs_PromPR_v02
## Platform: Affymetrix
## Chip type: Hs_PromPR_v02
## Number of arrays: 3
## Names: GSM605951, GSM605952, GSM605953 [3]
## Time period: 2007-09-28 13:17:49 -- 2007-09-28 14:26:51
## Total file size: 134.54MB
## RAM: 0.01MB


# Download MAT validation files
path <- getPath(ds);
filenames <- c("Prec1_MeDNA_600_IP1-Input.tsv", "Prec1_MeDNA_600_IP1-Input.bar.txt", "Prec1_MeDNA_800_IPs-Input.bar.txt");
pathnames <- file.path(path, filenames);
missing <- !sapply(pathnames, FUN=isFile);
if (any(missing)) {
  filenames <- filenames[missing];
  filenamesGZ <- sprintf("%s.gz",filenames);
  urlRoot <- "https://aroma-project.org/data";
  urlPath <- file.path(urlRoot, "rawData", getFullName(ds), chipType);
  urls <- file.path(urlPath, filenamesGZ);
  pathnamesD <- sapply(urls, FUN=function(url) {
    pathnameGZ <- downloadFile(url, path=path);
    gunzip(pathnameGZ);
    gsub("[.]gz$", "", pathnameGZ);
  });
}

verbose && exit(verbose);

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)

res <- doRMA(csR, drop=FALSE, verbose=verbose)
print(res)

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "MOUSEDIVm520650"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadACS(ar, chipType, tags=".*")
verbose && cat(verbose, "ACS: ", pathname)

pathname <- downloadUGP(ar, chipType, tags=".*")
verbose && cat(verbose, "UGP: ", pathname)

pathname <- downloadUFL(ar, chipType, tags=".*")
verbose && cat(verbose, "UFL: ", pathname)

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Allocate UGC file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType("GenomeWideSNP_6", tags="Full");
ugc <- AromaUnitGcContentFile$allocateFromCdf(cdf, tags="na27,h=500kb,HB20090322");
print(ugc);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import GC contents from NetAffx files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
csvList <- list(
  AffymetrixNetAffxCsvFile$byChipType("GenomeWideSNP_6", tags=".cn.na27"),
  AffymetrixNetAffxCsvFile$byChipType("GenomeWideSNP_6", tags=".na27.1")
);

colClasses <- c("^(probeSetID|%GC)$"="character");
for (csv in csvList) {
  data <- readDataFrame(csv, colClasses=colClasses);
  units <- indexOf(cdf, names=data$probeSetID);
  ugc[units,1] <- as.double(data[["%GC"]]);
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ugc);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
footer$gcBinWidth <- as.integer(500e3);
writeFooter(ugc, footer);


print(ugc);
print(summary(ugc));
print(range(ugc[,1]));

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080822";

chipType <- "GenomeWideSNP_5";
cdfTags <- "Full,r2";
nbrOfEnzymes <- 2;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(   ".na%s", naVersion),
      cn=sprintf(".cn.na%s", naVersion)
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=log);
  str(units);
  ## GenomeWideSNP_6.na26.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na26.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);

x <- summaryOfUnits(ufl);
print(x);

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "30";
genomeVersion <- "hg18";
user <- "HB";
datestamp <- "20100215";

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(".na%s", naVersion),
#      cn=sprintf(".cn.na%s", naVersion)
      cn=sprintf(".cn.na%s", as.integer(naVersion))
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ugp, csv, verbose=log);
  str(units);
  ## GenomeWideSNP_6.na30.annot.csv:    int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na30.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdBy <- list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
## AromaUgpFile:
## Name: GenomeWideSNP_6
## Tags: Full,na30,hg18,HB20100215
## Full name: GenomeWideSNP_6,Full,na30,hg18,HB20100215
## Pathname: annotationData/chipTypes/GenomeWideSNP_6/GenomeWideSNP_6,Full,na30,hg18,HB20100215.ugp
## File size: 8.97 MB (9407867 bytes)
## RAM: 0.00 MB
## Number of data rows: 1881415
## File format: v1
## Dimensions: 1881415x2
## Column classes: integer, integer
## Number of bytes per column: 1, 4
## Footer: <createdOn>20100215 19:24:13 CET</createdOn><platform>Affymetrix</platform><chipType>GenomeWideSNP_6,Full</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>GenomeWideSNP_6,Full.cdf</filename><filesize>493291745</filesize><checksum>3fbe0f6e7c8a346105238a3f3d10d4ec</checksum></srcFile1><srcFile2><filename>GenomeWideSNP_6.na30.annot.csv</filename><filesize>1418300755</filesize><checksum>892892065e8b27f83874bafa58f64403</checksum></srcFile2><srcFile3><filename>GenomeWideSNP_6.cn.na30.annot.csv</filename><filesize>814504485</filesize><checksum>176369a81250f46aed90a3e9a5c968d5</checksum></srcFile3></srcFiles>
## Chip type: GenomeWideSNP_6,Full
## Platform: Affymetrix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o na27.1 -> na30
#   No differences
# o na27 -> na27.1
#   No differences
# o na26 -> na27
#   Two units (932039, 1872834) where moved from ChrX to ChrY.
#   Same location.
# o na24 -> na26
#   Only minor modifications for non-missing values:
#   - three loci changed chromosomes
#   - an additional 23 loci changed positions, of which only 17 moved
#     more than 2 base pairs.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ugp <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na30");
ugp0 <- AromaUgpFile$byChipType("GenomeWideSNP_6,Full", tags="na27.1");

options(width=60);
print(table(ugp[,1], exclude=NULL));
##      1      2      3      4      5      6      7      8
## 146401 153663 127766 120296 115672 112825 100996  98277
##      9     10     11     12     13     14     15     16
##  82168  93592  89525  87321  66067  57103  53556  54182
##     17     18     19     20     21     22     23     24
##  46632  52093  30299  43628  25111  24484  87200   9483
##     25   <NA>
##    445   2630

print(table(ugp0[,1], exclude=NULL));
##      1      2      3      4      5      6      7      8
## 146401 153663 127766 120296 115672 112825 100996  98277
##      9     10     11     12     13     14     15     16
##  82168  93592  89525  87321  66067  57103  53556  54182
##     17     18     19     20     21     22     23     24
##  46632  52093  30299  43628  25111  24484  87200   9483
##     25   <NA>
##    445   2630

rr <- whichVector(ugp[,1] != ugp0[,1]);
print(rr);
## integer(0)

rr <- whichVector(ugp[,2] != ugp0[,2]);
print(rr);
## integer(0)

if (interactive()) savehistory();
library("aroma.affymetrix");
verbose <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "HuEx-1_0-st-v2";
types <- c("core", "extended", "full");
type <- textMenu(types, value=TRUE);
tags <- "HB20110917";

cdf <- AffymetrixCdfFile$byChipType(chipType);
print(cdf);

pattern <- "na31.hg19.probeset.csv$";
csv <- AffymetrixNetAffxCsvFile$byChipType(chipType, pattern=pattern);
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Build exon-by-transcript CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdfT <- createExonByTranscriptCdf(cdf, csv=csv, type=type, 
                                  tags=c("*", tags), verbose=verbose);
print(cdfT);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Validation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cells <- getCellIndices(cdfT, unlist=TRUE, useNames=FALSE);
if (anyDuplicated(cells)) {
  throw("Detected cell indices that occurs more than once in the CDF: ", 
                                                      getPathname(cdfT));
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data sources
#https://www.affymetrix.com/estore/browse/products.jsp?productId=131533
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (interactive()) savehistory();
library("aroma.affymetrix");
library("R.menu");
verbose <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

chipType <- "GenomeWideSNP_6";
cdfTags <- "Full";
nbrOfEnzymes <- 2;


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## obf <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org");
## setOption(aromaSettings, "user/email", obf);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
naVersions <- c(30:33, 35)
naVersion <- textMenu(naVersions, title="Choose NetAffx version: ", value=TRUE);
datestamp <- format(Sys.Date(), format="%Y%m%d");


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=cdfTags);
rm(csvList);
print(cdf);

csvList <- list();

tagsList <- c(
  main=sprintf(".na%s", naVersion),
  cn=sprintf(".cn.na%s", naVersion)
);

for (key in names(tagsList)) {
  tags <- tagsList[[key]];
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csvList);

genomeVersion <- getHeaderAttributes(csvList[[1]])[["genome-version"]];
genomeVersion <- Arguments$getCharacter(genomeVersion, nchar=4, length=c(1,1));
dbSNPVersion <- getHeaderAttributes(csvList[[1]])[["dbSNP-version"]];
dbSNPVersion <- Arguments$getInteger(dbSNPVersion);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
tags <- sprintf("na%s,%s,dbSNP%d,%s%s", naVersion, genomeVersion, dbSNPVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=verbose);
  str(units);
  ## GenomeWideSNP_6.na<XX>.annot.csv:  int [1:934968] 334945 334944 ...
  ## GenomeWideSNP_6.cn.na<XX>.annot.csv: int [1:945826] 935622 935777 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
srcFileTags <- list();
srcFiles <- c(list(cdf), csvList);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile),
    filesize=getFileSize(srcFile),
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ufl);
footer$createdBy <- list(
  fullname = fullname,
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);

print(ufl);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# WHAT'S NEW:
#
# o na32 -> na33
#   - Back to no filtering?  By comparing CSV content for a SNP,
#     I've verified that the parsing is correct.
# o na31 -> na32
#   - Are Affymetrix doing filter for us again?
# o na30 -> na31
#   - Lots of differences; Affymetrix no longer filter for us.
# o na27.1 -> na30
#   - No changes.
# o na27 -> na27.1
#   - No changes.
# o na26 -> na27
#   - No changes.
# o na24 -> na26
#   - All changes are for SNP units.
#   - There are 6 NspI and 14 StyI changes in SNP fragment lengths,
#     which some are only minor.
#   - There are 1108 more SNPs that now have missing values.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ufl <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na33");
ufl0 <- AromaUflFile$byChipType("GenomeWideSNP_6,Full", tags="na32");
x <- summaryOfUnits(ufl);
x0 <- summaryOfUnits(ufl0);

print(x);
print(x0);

## GenomeWideSNP_6,Full,na33,hg19,dbSNP137,HB20140117
##                 snp    cnp affxSnp other   total
## enzyme1-only      0 445237       0     0  445237
## enzyme2-only    210      5       0     0     215
## both         929892 500368    3018     0 1433278
## missing        1844    216       4   621    2685
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,Full,na32,hg19,dbSNP132,HB20140118
##                 snp    cnp affxSnp other   total
## enzyme1-only 242858 435414     777     0  679049
## enzyme2-only 158233  19259     620     0  178112
## both         528831 490937    1621     0 1021389
## missing        2024    216       4   621    2865
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na31,hg19,HB20110328.ufl
##                 snp    cnp affxSnp other   total
## enzyme1-only    577   9609       0     0   10186
## enzyme2-only    502  23432       0     0   23934
## both         929322 912574       0     0 1841896
## missing        1545    211    3022   621    5399
## total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na30,hg18,HB20100215.ufl
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

## GenomeWideSNP_6,na27.1,hg??,HB20??????.ufl
##                  snp    cnp affxSnp other   total
##  enzyme1-only 246080 451191       0     0  697271
##  enzyme2-only 160899      0       0     0  160899
##  both         522472 494615       0     0 1017087
##  missing        2495     20    3022   621    6158
##  total        931946 945826    3022   621 1881415

print(x-x0);
##                  snp    cnp affxSnp other   total
## enzyme1-only -242858   9823    -777     0 -233812
## enzyme2-only -158023 -19254    -620     0 -177897
## both          401061   9431    1397     0  411889
## missing         -180      0       0     0    -180
## total              0      0       0     0       0

# Differences
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(ufl[,cc] != ufl0[,cc], na.rm=TRUE);
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc],
                       ufl[units,cc]-ufl0[units,cc]);
    colnames(df)[ncol(df)] <- "delta";
    print(df);
  }
}

##         units length length  delta
## 1       21988   1663    919    744
## 2       82781    445    177    268
## 3       87809    871   1259   -388
## 4      126538   1062   1994   -932
## ...

# Differences in NAs
for (cc in 1:nbrOfColumns(ufl)) {
  units <- whichVector(is.na(ufl[,cc]) != is.na(ufl0[,cc]));
  if (length(units) > 0) {
    df <- cbind(units, ufl[units,cc], ufl0[units,cc]);
    str(df);
  }
}

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE34754"
chipType <- "Mapping250K_Nsp"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial intensity plots
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ae <- ArrayExplorer(csR)
setColorMaps(ae, "sqrt,yellow")
print(ae)

process(ae, verbose=verbose)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial probe log-ratio plots
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cfR <- getAverageFile(csR, verbose=verbose)
reporter <- SpatialReporter(csR, reference=cfR)
addColorMap(reporter, "log2center,rainbow")
process(reporter, zrange=c(-2,2), verbose=verbose)

ylab <- expression(log[2](y/y[R]))
for (ii in seq_along(csR)) {
  df <- csR[[ii]]

  toPNG(getFullName(df), tags="spatial,rowMedians", width=300, aspectRatio=8/3, {
    plotMargins(reporter, array=ii, ylim=c(-1,1)*0.2, ylab=ylab, margins="rows", rotate=90)
  })

  toPNG(getFullName(df), tags="spatial,colMedians", width=800, aspectRatio=3/8, {
    plotMargins(reporter, array=ii, ylim=c(-1,1)*0.2, ylab=ylab, margins="columns", rotate=0)
  })
} # for (ii ...)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Spatial residual plots test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv1(csR, drop=FALSE, verbose=verbose)
plm <- res$plm
print(plm)

# Calculate PLM residuals
rs <- calculateResidualSet(plm, verbose=verbose)
print(rs)

ae <- ArrayExplorer(rs)
setColorMaps(ae, c("log2,log2neg,rainbow", "log2,log2pos,rainbow"))
print(ae)

process(ae, interleaved="auto", verbose=verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot allele pairs before and after calibration
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- res$acc
for (what in c("input", "output")) {
  toPNG(getFullName(acc), tags=c("allelePairs", what), aspectRatio=0.7, {
    plotAllelePairs(acc, array=1, what=what, verbose=verbose)
  })
}

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "DogSty06m520431";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Get required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
print(cdf);

ptb <- AffymetrixProbeTabFile$byChipType(chipType);
print(ptb);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate aroma cell sequence file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acs <- AromaCellSequenceFile$allocateFromCdf(cdf, tags="HB20100920");
print(acs);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import data from the Affymetrix probe-tab file (has only PMs)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom(acs, ptb, verbose=log);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Update footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ftr <- readFooter(acs);
ftr <- append(ftr, footer);
writeFooter(acs, ftr);

print(acs);
print(table(as.integer(acs[,1,drop=TRUE])));

##########################################################################
# AS-CRMAv2 and Paired PSCBS
##########################################################################
future::plan("multisession")
library("aroma.affymetrix")
library("aroma.cn");  # PairedPscbsModel
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE34754"
chipType <- "Mapping250K_Nsp"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR)
print(dsNList)

dsN <- exportAromaUnitPscnBinarySet(dsNList)
print(dsN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Group samples by name and type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AD HOC: For now, just hardwire the path.
path <- file.path("testScripts/complete/dataSets", dataSet)
db <- TabularTextFile(sprintf("%s,samples.txt", dataSet), path=path)
setColumnNamesTranslator(db, function(names, ...) {
  names <- gsub("id", "fixed", names)
  names <- gsub("fullname", "replacement", names)
  names
})
df <- readDataFrame(db, colClasses=c("*"="character"))
setFullNamesTranslator(dsN, df)

# Identify unique sample names
sampleNames <- unique(getNames(dsN))

dsList <- lapply(sampleNames, FUN=function(sampleName) {
  ds <- dsN[sampleName]
  lapply(c(T="T", N="N"), FUN=function(type) {
    ds[sapply(ds, hasTag, type)]
  })
})
names(dsList) <- sampleNames


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
R <- 5; # Number of replicates
dsList2 <- list()
for (key in names(dsList)) {
  dsListKK <- dsList[[key]]
  dsT <- dsListKK$T
  dsN <- dsListKK$N

  # (a) Replicated tumor vs same normal
  dsTa <- dsT[1:min(length(dsT),R)]
  dsNa <- dsN[rep(1L, times=length(dsTa))]

  # (b) Same tumor vs replicated normals
  dsNb <- dsN[1:min(length(dsN),R)]
  dsTb <- dsT[rep(1L, times=length(dsNb))]

  # (c) Merge
  dsT <- append(dsTa, dsTb)
  dsN <- append(dsNa, dsNb)

  # (d) Drop duplicated tumor-normal pairs
  nT <- getFullNames(dsT)
  nN <- getFullNames(dsN)
  nP <- paste(nT, nN, sep="_vs_")
  dups <- duplicated(nP)
  dsT <- dsT[!dups]
  dsN <- dsN[!dups]
  stopifnot(length(dsT) == length(dsN))

  dsList2[[key]] <- list(T=dsT, N=dsN)
} # for kk ...)

dsT <- Reduce(append, lapply(dsList2, FUN=function(x) x$T))
dsN <- Reduce(append, lapply(dsList2, FUN=function(x) x$N))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segment tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sm <- PairedPscbsModel(dsT=dsT, dsN=dsN, gapMinLength=2e6)
print(sm)

res <- fit(sm, verbose=verbose)
print(res)

sms <- getOutputDataSet(sm)
print(sms)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Call segments to be in ROH, AB and LOH.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## caller <- PairedPscbsCaller(sms)
## print(caller)
## sms <- process(caller, verbose=verbose)
## print(sms)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Generate report (just to check)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setOption("PSCBS::reports/pscnSegmentationTransitions", TRUE)

# Generate reports for tumor-normal pairs
for (ii in 1:min(length(sms),5)) {
  df <- sms[[ii]]
  fit <- loadObject(df)
  sampleName <- getFullName(df)
  pathname <- report(fit, sampleName=sampleName, studyName=getFullName(dsT), verbose=verbose)
  print(pathname)
} # for (ii ...)

##########################################################################
# Data set:
# GSE8605/
#   Mapping10K_Xba142/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE8605
##########################################################################
library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# doASCRMAv2()
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsList <- doASCRMAv2(dataSet, chipType=chipType, verbose=verbose)
print(dsList)

# Immitate a paired tumor-normal data set
dsT <- dsList$total[1:5]
dsR <- dsList$total[6:10]

dsTCN <- exportTotalCnRatioSet(dsT, dsR, logBase=NULL, verbose=verbose)


# Immitate a paired tumor-normal data set will all pairs being replicates
dfAvg <- getAverageFile(dsTCN, verbose=-10)

dfAvgLog <- getAverageFile(dsTCN, g=log2, h=function(x) 2^x, verbose=-10)
diff <- dfAvg[,1] - dfAvgLog[,1]
stopifnot(all(diff == 0))

# Change the fullname (using a fullname translator)
setFullName(dfAvg, "TumorVsNormal")

# Turn into a data set
dsAvg <- newInstance(dsT, list(dfAvg))


# Segmentation model
cbs <- CbsModel(dsAvg, tags="*,TCN,avg", calculateRatios=FALSE)
print(cbs)

ce <- ChromosomeExplorer(cbs)
process(ce, chromosomes=c(1:5,19,22), verbose=verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
res <- doCRMAv2(dataSet, chipType=chipType, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS on a CnChipEffectSet
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesN <- res$cesN
segA <- CbsModel(cesN, tags="*,cesN")
print(segA)

# Try to segment
fit(segA, arrays=1:2, chromosomes=19, verbose=verbose)

# Write to file
pathnameA <- writeRegions(segA, arrays=1:2, chromosomes=19, skip=FALSE, verbose=verbose)
print(pathnameA)

segTableA <- read.table(pathnameA, header=TRUE)
print(segTableA)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS on an AromaUnitTotalCnBinarySet
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- res$dsNList
dsT <- dsNList; # Hmm... should this have a different name?
segB <- CbsModel(dsT)
print(segB)

# Try to segment
fit(segB, arrays=1:2, chromosomes=19, verbose=verbose)

# Write to file
pathnameB <- writeRegions(segB, arrays=1:2, chromosomes=19, skip=FALSE, verbose=verbose)
print(pathnameB)

segTableB <- read.table(pathnameB, header=TRUE)
print(segTableB)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Sanity check
stopifnot(all.equal(segTableB, segTableA))

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the CRLMM
# genotype estimates as estimated by oligo.
# It verifies that they give the same results whether or not one
# is normalizing towards the HapMap reference (as defined by oligo).
#
# Author: Henrik Bengtsson
# Created: 2008-12-04
# Last modified: 2012-09-01
###########################################################################
library("aroma.affymetrix")
library("oligo")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)

# Assert that the correct Platform Design package is installed
pdPkgName <- cleanPlatformName(chipType)
library(pdPkgName, character.only=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# SNPRMA according to aroma.affymetrix
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ces <- justSNPRMA(csR, normalizeToHapmap=TRUE, returnESet=FALSE, verbose=verbose)
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRLMM according to aroma.affymetrix
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
recalibrate <- TRUE
crlmm <- CrlmmModel(ces, tags="*,oligo", recalibrate=recalibrate)
print(crlmm)

units <- fit(crlmm, ram="oligo", verbose=verbose)
str(units)

callSet <- getCallSet(crlmm)
print(callSet)

confSet <- getConfidenceScoreSet(crlmm)
print(confSet)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRLMM according to oligo
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Create temporary output directory for oligo
path <- file.path("oligoData", dataSet, chipType)
Arguments$getWritablePath(dirname(path)); # Create parent directories
if (!isDirectory(path)) {
  oligo:::justCRLMMv2(getPathnames(csR), tmpdir=path, recalibrate=recalibrate, balance=1.5, verbose=as.logical(verbose))
}
# Files created by oligo
print(list.files(path))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare genotype calls
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
calls0 <- readSummaries("calls", path)

unitNames <- rownames(calls0)
units <- indexOf(cdf, names=unitNames)
calls <- extractGenotypes(callSet, units=units, encoding="oligo")

count <- 0
for (cc in 1:ncol(calls)) {
  idxs <- whichVector(calls[,cc] != calls0[,cc])
  count <- count + length(idxs)
  cat(sprintf("%s: ", getNames(callSet)[cc]))
  if (length(idxs) > 0) {
    map <- c("AA", "AB", "BB")
    cat(paste(map[calls[idxs,cc]], map[calls0[idxs,cc]], sep="!="), sep=", ")
  }
  cat("\n")
}
cat(sprintf("Averages number of discrepances per array: %.1f\n", count/ncol(calls)))
errorRate <- count/length(calls)
cat(sprintf("Concordance rate: %.5f%%\n", 100*(1-errorRate)))
stopifnot(errorRate < 5e-4)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare confidence scores
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
conf <- extractMatrix(confSet, units=units)
conf0 <- readSummaries("conf", path)

res <- all.equal(conf, conf0, check.attributes=FALSE)
print(res)

# Sanity check
stopifnot(all.equal(conf, conf0, check.attributes=FALSE, tolerance=1e-4))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Visual comparison of confidence scores
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
toPNG(getFullName(ces), tags="CRLMM_vs_oligo", aspectRatio=0.8, {
  subplots(ncol(conf))
  par(mar=c(3,2,1,1)+0.1)
  lim <- c(0,1)
  for (cc in 1:ncol(conf)) {
    plot(NA, xlim=lim, ylim=lim)
    abline(a=0, b=1, col="#999999")
    points(conf[,cc], conf0[,cc], pch=".", cex=3)
    rho <- cor(conf[,cc], conf0[,cc])
    stext(side=3, pos=0, line=-1, sprintf("rho=%.4f", rho))
    stext(side=3, pos=0, getNames(confSet)[cc])
    cat(sprintf("Array #%d: Correlation: %.4f\n", cc, rho))
  }
})

library("aroma.affymetrix")
log <- verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

dataSetName <- "Affymetrix_2006-TumorNormal"
tags <- "ACC,-XY,BPN,-XY,RMA,FLN,-XY"
chipType <- "Mapping250K_Nsp"

pairs <- matrix(c(
  "CRL-2325D", "CRL-2324D",
  "CRL-5957D", "CRL-5868D",
  "CCL-256.1D", "CCL-256D",
  "CRL-2319D", "CRL-2320D",
  "CRL-2362D", "CRL-2321D",
  "CRL-2337D", "CRL-2336D",
  "CRL-2339D", "CRL-2338D",
  "CRL-2341D", "CRL-2340D",
  "CRL-2346D", "CRL-2314D"
), ncol=2, byrow=TRUE)
colnames(pairs) <- c("normal", "tumor")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("cesN")) {
  cdf <- AffymetrixCdfFile$byName(chipType)
  gi <- getGenomeInformation(cdf)

  cdfM <- getMonocellCdf(cdf)
  cesN <- SnpChipEffectSet$byName(dataSetName, tags=tags, cdf=cdfM)
  print(cesN)

  # Reorder arrays according to 'pairs' matrix
  cesN <- cesN[indexOf(cesN, pairs)]
  names <- getNames(cesN)
  dim(names) <- dim(pairs)
  print(names)


  Blim <- c(0,1)
  Clim <- c(0,4)
  Clab <- expression(C[T]/C[N])
  BTlab <- expression(beta[T])
  BNlab <- expression(beta[N])
  Flab <- expression(beta[T]-beta[N])
  Flim <- c(-1/2,1/2)
}

# Identify SNPs
chromosome <- 9
units <- getUnitsOnChromosome(gi, chromosome)
pos <- getPositions(gi, units=units)/1e6
o <- order(pos)
units <- units[o]
pos <- pos[o]
str(units)

isSNP <- (getUnitTypes(cdf, units=units) == 2)
units <- units[isSNP]
pos <- pos[isSNP]

data <- extractTotalAndFreqB(cesN, units=units)
dim(data) <- c(dim(data)[1:2], dim(names))
dimnames(data) <- list(NULL, c("total", "freqB"), NULL, colnames(pairs))
C <- data[,"total",,"tumor"] / data[,"total",,"normal"]
B <- data[,"freqB",,]
F <- B[,,"tumor"] - B[,,"normal"]

F2 <- 2*(1/2-abs(B[,,"normal"]-1/2))
dAA <- sqrt((B[,,"normal"]-0)^2)
dBB <- sqrt((B[,,"normal"]-1)^2)
#F[dAA < 0.2 | dBB < 0.2] <- NA


# Plot (x,C) and (x,F) along genome
devSet(2)
subplots(3, ncol=1)
par(mar=c(2,4,1,1)+0.1)
par(ask=TRUE)
for (kk in seq_len(ncol(C))) {
  plot(pos, C[,kk], ylim=Clim, ylab=Clab)
  abline(h=1, lty=3, col="red")
  stext(side=3, pos=0, paste(pairs[kk,], collapse="/"))
  stext(side=3, pos=1, sprintf("Chr %d", chromosome))
  plot(pos, B[,kk,"tumor"], ylim=Blim, ylab=BTlab)
#  smoothScatter(pos, B[,kk,"tumor"], bandwidth=c(1,0.0001), ylim=Blim, ylab=BTlab)
  plot(pos, F[,kk], cex=F2, ylim=Flim, ylab=Flab)
#  smoothScatter(pos, F[,kk], bandwidth=c(1,0.0001), ylim=Flim, ylab=Flab)
  abline(h=0, lty=3, col="red")
}


devSet(3)
BNlab <- expression(beta[N])
BTlab <- expression(beta[T])
unitNames <- getUnitNames(cdf, units=units)
col <- seq_len(ncol(C))
par(ask=TRUE)
for (kk in seq_len(nrow(C))) {
  plot(NA, xlim=Blim, ylim=Blim, xlab=BNlab, ylab=BTlab)
  stext(side=3, pos=0, unitNames[kk])
  points(B[kk,,], col=col, pch=19)
}

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)

# Process only the first six arrays (and in reverse order)
subset <- 6:1
csR <- csR[subset]
print(csR)
sampleNames <- getNames(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRMAv1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doCRMAv1(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Sanity checks
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Assert same output as input arrays (in the same order)
for (key in names(res)[-1]) {
  ds <- res[[key]]
  if (!inherits(ds, "GenericDataFileSet")) next
  stopifnot(getNames(ds) == sampleNames)
}

if (interactive()) savehistory();
library("aroma.affymetrix");
verbose <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "30";
genomeVersion <- "mm9";
user <- "HB";
datestamp <- "20100603";
nbrOfEnzymes <- 2;

chipType <- "MOUSEDIVm520650";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csvList);
}
print(cdf);

if (!exists("csvList", mode="list")) {
  csvList <- list();

  tagsList <- c(
      main=sprintf(".na%s", naVersion),
      cn=sprintf(".cn.na%s", as.integer(naVersion))
  );

  for (key in names(tagsList)) {
    tags <- tagsList[[key]];
    pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
    if (isFile(pathname)) {
      csvList[[key]] <- AffymetrixNetAffxCsvFile(pathname);
    }
    rm(tags);
  }
}
print(csvList);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup/Allocate UFL
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags, nbrOfEnzymes=nbrOfEnzymes);
}
print(ufl);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
for (kk in seq_along(csvList)) {
  csv <- csvList[[kk]];
  print(csv);
  units <- importFrom(ufl, csv, verbose=verbose);
  str(units);
  ## *.na30.annot.csv:  int [1:623124] 800990 808457 907857 ...
  ## *.cn.na30.annot.csv: int [1:1832538] 1542481 1542480 1542479 ...
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- c(list(cdf), csvList);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}


footer <- readFooter(ufl);
footer$createdBy <- list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);

print(ufl);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# WHAT'S NEW:
#
# o ... -> na30
#   - First one for this chip type.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
ufl <- AromaUflFile$byChipType("MOUSEDIVm520650", tags="na30");
x <- summaryOfUnits(ufl);

print(x);
##              snp cnp affxSnp   other   total
## enzyme1-only   0   0       0       0       0
## enzyme2-only   0   0       0       0       0
## both           0   0       0 2227922 2227922
## missing        0   0       0  230775  230775
## total          0   0       0 2458697 2458697

## TODO: summaryOfUnits() should utilize getUnitTypes(cdf).

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# Avoid being masked by affy::plotDensity()
plotDensity <- aroma.light::plotDensity

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test (for CN analysis)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
plm <- res$plm
print(plm)

ces <- getChipEffectSet(plm)
print(ces)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Quality scores via ChipEffectSet
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Boxplots of log2(theta), RLE, and NUSE
toPNG(getFullName(ces), tags=c("QA", "theta", "RLE", "NUSE"), {
  layout(matrix(1:4, ncol=2, byrow=TRUE))
  plotBoxplot(ces, type="theta", transform=log2)
  plotBoxplot(ces, type="RLE", arrays=c(2,4:6))
  plotBoxplot(ces, type="NUSE")
})

# Calculating statistics without plotting
theta <- boxplotStats(ces, type="theta", transform=log2)
nuse <- boxplotStats(ces, type="NUSE")
rle <- boxplotStats(ces, type="RLE")

# Subset of arrays (avoids calculating stats for all arrays)
rleB <- boxplotStats(ces, type="RLE", arrays=c(2,4:6))
for (name in names(rleB)) {
  stopifnot(identical(rleB[name], rle[name]))
}

# Plotting the above statistics
toPNG(getFullName(ces), tags=c("QA", "theta", "RLE", "NUSE", "manual"), {
  layout(matrix(1:4, ncol=2, byrow=TRUE))
  plotBoxplotStats(theta, main="theta")
  plotBoxplotStats(rle[c(2,4:6)], main="RLE")
  plotBoxplotStats(nuse, main="NUSE")
})


# Calculates unit-specific RLE and NUSE scores
units <- 1000+1:5000
theta <- extractMatrix(ces, units=units)
rle <- extractMatrix(ces, units=units, field="RLE")
nuse <- extractMatrix(ces, units=units, field="NUSE")

# Plotting the above statistics
unitsTag <- sprintf("units%s", seqToHumanReadable(units))
toPNG(getFullName(ces), tags=c(unitsTag, "QA", "theta", "RLE", "NUSE"), {
  layout(matrix(1:4, ncol=2, byrow=TRUE))
  plotDensity(log2(theta), main="theta")
  plotDensity(rle[,c(2,4:6)], main="RLE")
  plotDensity(nuse, main="NUSE")
})

# ...same, but basic unit annotation data added
theta <- extractDataFrame(ces, units=units, addNames=TRUE)
print(head(theta))
rle <- extractDataFrame(ces, units=units, field="RLE", addNames=TRUE)
print(head(rle))
nuse <- extractDataFrame(ces, units=units, field="NUSE", addNames=TRUE)
print(head(nuse))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Quality scores via QualityAssessmentModel
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
qa <- QualityAssessmentModel(plm)
print(qa)

toPNG(getFullName(qa), tags=c("RLE", "NUSE"), {
  subplots(4, ncol=2, byrow=FALSE)
  par(mar=c(6,5,3,1))
  plotRle(qa)
  plotNuse(qa)
  # Reordered along x-axis
  arrays <- nbrOfArrays(qa):1
  plotRle(qa, arrays=arrays)
  plotNuse(qa, arrays=arrays)
})

library("aroma.affymetrix")

# Local functions
getDataSet <- function(path, ...) {
  chipType <- basename(path)
  cdf <- tryCatch({
    AffymetrixCdfFile$byChipType(chipType)
  }, error=function(ex) {
    AffymetrixCdfFile$byChipType(chipType, tags=".*")
  })
  ds <- AffymetrixCelSet$byPath(path, cdf=cdf)
  ds
}

getRawDataSetPath <- function(dataSet=NULL, tags=NULL, chipType=NULL, ...) {
  if (is.null(dataSet) && is.null(chipType)) return(NULL)
  dataSetF <- paste(c(dataSet, tags), collapse=",")
  path <- file.path("rawData", dataSetF, chipType)
  path <- Arguments$getWritablePath(path)
  path
} # getRawDataSetPath()



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# HapMap
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
getHapMapUrlPath <- function(chipType=c("Mapping50K_Hind240", "Mapping50K_Xba240", "GenomeWideSNP_6"), ...) {
  # Argument 'chipType':
  chipType <- match.arg(chipType)

  dirs <- c("Mapping50K_Hind240"="affy100k", "Mapping50K_Xba240"="affy100k",
            "GenomeWideSNP_6"="hapmap3_affy6.0")
  dir <- dirs[chipType]

  sprintf("ftp://ftp.ncbi.nlm.nih.gov/hapmap/raw_data/%s", dir)
} # getHapMapUrlPath()
 

# url <- getHapMapUrl("CEU_NA06985", chipType="Mapping50K_Hind240")
getHapMapUrl <- function(sampleName, chipType=c("Mapping50K_Hind240", "Mapping50K_Xba240"), ...) {
  # Argument 'sampleName':
  sampleName <- Arguments$getCharacters(sampleName)

  # Argument 'chipType':
  chipType <- match.arg(chipType)

  tags <- c("Mapping50K_Hind240"="_HIND", "Mapping50K_Xba240"="_XBA")
  tag <- tags[chipType]

  # Create URL
  urlPath <- getHapMapUrlPath(chipType)
  sprintf("%s/%s%s.CEL.gz", urlPath, sampleName, tag)
} # getHapMapUrl()


# downloadHapMapSample(dataSet, chipType=chipType, sampleName=sampleName)
downloadHapMapSample <- function(dataSet, tags=NULL, chipType, sampleName, ..., chipTypeAliases=NULL, gunzip=TRUE, skip=TRUE) {
  path <- getRawDataSetPath(dataSet=dataSet, tags=tags, chipType=chipType, ...)
  url <- getHapMapUrl(sampleName, chipType=chipType)
  filenameGZ <- basename(url)
  filename <- gsub("[.]gz$", "", filenameGZ)
  pathname <- file.path(path, filename)
  if (skip && isFile(pathname)) {
    return(pathname)
  }

  pathD <- dirname(path)
  pathnameGZ <- downloadFile(url, filename=filenameGZ, path=pathD)
  if (regexpr("[.]gz$", pathnameGZ) != -1) {
    gunzip(pathnameGZ)
  } 

  opwd <- getwd()
  on.exit(if (!is.null(opwd)) setwd(opwd))
  setwd(pathD)
  pathname <- arrangeCelFilesByChipType(filename, path=".", aliases=chipTypeAliases)
  setwd(opwd); opwd <- NULL
  pathname <- file.path(path, filename)
  pathname
} # downloadHapMapSample()


downloadHapMapSamples <- function(..., sampleNames) {
  pathnames <- sapply(sampleNames, FUN=function(sampleName) {
    downloadHapMapSample(..., sampleName=sampleName)
  })

  path <- dirname(pathnames[1])
  getDataSet(path)
} # downloadHapMapSamples()


downloadHapMapDataSet <- function(dataSet, tags=NULL, chipType=c("GenomeWideSNP_6"), ..., chipTypeAliases=NULL, skip=TRUE) {
  # Argument 'chipType':
  chipType <- match.arg(chipType)

  population <- dataSet
  dataSet <- paste(c("HapMap", population), collapse=",")
  path <- getRawDataSetPath(dataSet=dataSet, tags=tags, chipType=chipType, ...)
  # Already downloaded?
  ds <- getDataSet(path)
  if (skip && nbrOfFiles(ds) > 0) {
    return(ds)
  }

  urlPath <- getHapMapUrlPath(chipType)
  filenameD <- sprintf("%s.tgz", population)
  pathD <- dirname(path)
  url <- file.path(urlPath, filenameD)
  pathnameD <- downloadFile(url, filename=filenameD, path=pathD)
  untar(pathnameD, exdir=pathD)

  # Arrange by chip type
  opwd <- getwd()
  on.exit(if (!is.null(opwd)) setwd(opwd))
  setwd(pathD)
  pathnames <- list.files(pattern="[.](cel|CEL)$")
  pathnamesD <- arrangeCelFilesByChipType(pathnames, path=".", aliases=chipTypeAliases)
  setwd(opwd); opwd <- NULL

  getDataSet(path)
} # downloadHapMapDataSet()




# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# GEO
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
getGeoDataSetURL <- function(dataSet, ...) {
  filename <- sprintf("%s_RAW.tar", dataSet)
  
  ## Previously:
  # path <- sprintf("ftp://ftp.ncbi.nlm.nih.gov/pub/geo/DATA/supplementary/series/%s", dataSet)
  
  ## Verified 2020-12-02
  dataSetNNN <- gsub("[0-9]{3}$", "nnn", dataSet)
  path <- sprintf("ftp://ftp.ncbi.nlm.nih.gov/geo/series/%s/%s/suppl", dataSetNNN, dataSet)
  
  file.path(path, filename, fsep = "/")
} # getGeoDataSetURL()

getGeoDataFileURL <- function(sampleName, ext, ...) {
  # Argument 'sampleName':
  sampleName <- Arguments$getCharacter(sampleName)
  pattern <- "^GSM[0-9]+$"
  if (regexpr(pattern, sampleName) == -1) {
    throw("Invalid GEO sample name: ", sampleName)
  }

  # Argument 'ext':
  ext <- Arguments$getCharacter(ext)

  # Create GEO download URL
  ## Previously:
  # urlRoot <- "ftp://ftp.ncbi.nlm.nih.gov/pub/geo/DATA/supplementary/samples"
  ## Verified 2020-12-02:
  urlRoot <- "ftp://ftp.ncbi.nlm.nih.gov/geo/samples"
  filename <- sprintf("%s.%s.gz", sampleName, ext)
  sampleSet <- gsub("[0-9]{3}$", "nnn", sampleName)
  url <- file.path(urlRoot, sampleSet, sampleName, filename)

  url
} # getGeoDataFileURL()


downloadGeoRawDataSet <- function(dataSet, tags=NULL, chipType, ..., chipTypeAliases=NULL, url=getGeoDataSetURL(dataSet), gunzip=TRUE, skip=TRUE) {
  path <- getRawDataSetPath(dataSet=dataSet, tags=tags, chipType=chipType, ...)

  # Already downloaded?
  ds <- getDataSet(path)
  if (skip && nbrOfFiles(ds) > 0) {
    return(ds)
  }

  pathname <- downloadFile(url, path="downloads/", ...)
  pathD <- dirname(path)
  untar(pathname, exdir=pathD)
  if (gunzip) {
    pathnames <- list.files(path=pathD, pattern="[.]gz$", full.names=TRUE)
    sapply(pathnames, FUN=gunzip)
  }

  # Arrange by chip type
  opwd <- getwd()
  on.exit(if (!is.null(opwd)) setwd(opwd))
  setwd(pathD)
  pathnames <- list.files(pattern="[.](cel|CEL)$")
  pathnamesD <- arrangeCelFilesByChipType(pathnames, path=".", aliases=chipTypeAliases)
  setwd(opwd); opwd <- NULL

  getDataSet(path)
} # downloadGeoRawDataSet()


downloadGeoRawDataFile <- function(dataSet, tags=NULL, chipType, sampleName, ext="CEL", url=getGeoDataFileURL(sampleName, toupper(ext)), ..., gunzip=TRUE, skip=TRUE) {
  # Argument 'url':
  url <- Arguments$getCharacter(url)

  path <- getRawDataSetPath(dataSet=dataSet, tags=tags, chipType=chipType, ...)

  filenameGZ <- basename(url)
  pathnameGZ <- file.path(path, filenameGZ)
  pathname <- gsub("[.]gz$", "", pathnameGZ)

  # Already downloaded?
  if (skip && isFile(pathname)) {
    return(pathname)
  }

  pathnameGZ <- tryCatch({
    suppressWarnings({
      downloadFile(url, path=path, ...)
    })
  }, error = function(ex) {
    urlL <- getGeoDataFileURL(sampleName, tolower(ext))
    downloadFile(urlL, path=path, ...)
  })

  if (gunzip) {
    gunzip(pathnameGZ)
    pathname <- gsub("[.]gz$", "", pathnameGZ)
  }

  pathname
} # downloadGeoRawDataFile()


downloadGeoRawDataFiles <- function(..., sampleNames, skip=TRUE) {
  # Argument 'sampleNames':
  sampleNames <- Arguments$getCharacters(sampleNames)

  # Already downloaded?
  path <- getRawDataSetPath(...)
  if (skip) {
    ds <- getDataSet(path)
    hasAll <- all(is.element(sampleNames, getNames(ds)))
    if (hasAll) {
      return(ds)
    }
  }

  pathnames <- sapply(sampleNames, FUN=function(sampleName) {
    downloadGeoRawDataFile(..., sampleName=sampleName)
  })

  ds <- getDataSet(path)

  ds
} # downloadGeoRawDataFiles()



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Affymetrix
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
downloadAffymetrixFile <- function(pathname, ..., urlRoot=Sys.getenv("AFFY_URLROOT", "https://www.affymetrix.com/Auth"), skip=TRUE) {
  # Argument 'pathname':
  filename <- basename(pathname)
  filename <- Arguments$getFilename(filename)

  # Download URL
  url <- file.path(urlRoot, pathname)
  downloadFile(url, filename=filename, path="downloads/", skip=skip)
} # downloadAffymetrixFile()


downloadAffymetrixNetAffxCsvFile <- function(pathname, ..., skip=TRUE) {
  # Argument 'pathname':
  filename <- basename(pathname)
  filename <- Arguments$getFilename(filename)
  pattern <- "^([^.]*)[.]((cn[.])*na[0-9]{2})[.].*.csv$"
  stopifnot(regexpr(pattern, filename) != -1L)

  # Infer chip type and NA tag
  chipType <- gsub(pattern, "\\1", filename)
  naTag <- gsub(pattern, "\\2", filename)

  tags <- sprintf(".%s", naTag)

  # Already available?
  pathnameD <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags)
  if (skip && isFile(pathnameD)) {
    return(pathnameD)
  }

  # Destination path
  path <- file.path("annotationData", "chipTypes", chipType)
  path <- Arguments$getWritablePath(path)

  # Download file
  pathnameZ <- sprintf("%s.zip", pathname)
  pathnameZ <- downloadAffymetrixFile(pathnameZ, ...)

  # Unzip to destination
  unzip(pathnameZ, exdir=path)

  # Assert
  pathnameD <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags)
  stopifnot(!is.null(pathnameD))

  pathnameD
} # downloadAffymetrixNetAffxCsvFile()


downloadAffymetrixDataSet <- function(dataSet, tags=NULL, chipType=chipType, ..., skip=TRUE) {
  path <- getRawDataSetPath(dataSet, chipType=chipType)
  ds <- getDataSet(path)
  if (skip && nbrOfArrays(ds) > 0) {
    return(ds)
  }

  pathname <- downloadAffymetrixFile(..., skip=skip)
  pathnames <- unzip(pathname, exdir=path)

  # Did we extract a standalone root directory?  If so, "drop" the root.
  paths <- list.files(path=path, full.names=TRUE)
  if (length(paths) == 1 && isDirectory(paths)) {
    pathS <- paths[1]
    # Move all files in up one level
    pathnamesT <- gsub(pathS, path, pathnames, fixed=TRUE)
    for (kk in seq_along(pathnames)) {
      file.rename(from=pathnames[kk], to=pathnamesT[kk])
    }
  }

  ds <- getDataSet(path)
  ds
} # downloadAffymetrixDataSet()


############################################################################
# HISTORY:
# 2012-11-29
# o Added argument 'path' to downloadAffymetrixFile().
# 2012-11-28
# o Added downloadAffymetrixNetAffxCsvFile().
# 2012-09-12
# o BUG FIX: downloadGeoRawDataFile(..., gunzip=TRUE) would give an
#   error that it could not gunzip the downloaded file, iff the filename
#   extension was lower case, e.g. *.cel.gz instead of *.CEL.gz.
# 2012-09-02
# o Added downloadAffymetrixDataSet().
# o Added downloadGeoRawDataFile().
# 2012-09-01
# o Added argument 'chipTypeAliases' to several download functions.
# 2012-08-31
# o Added as a utility test script of the aroma.affymetrix package.
# 2012-08-23
# o Fixed up HapMap downloader.
# 2012-08-22
# o Added GEO and HapMap downloader.
# o Created.
############################################################################

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")



##########################################################################
# Data set:
# GSE12702/
#   Mapping250K_Nsp/
#    GSM318728.CEL, ..., GSM318767.CEL [40]
#   Mapping250K_Sty/
#    GSM318773.CEL, ..., GSM318812.CEL [40]
#
# Overall design:
#  Profiles were generated on two Affymetrix array chips: 
#  Nsp and Sty, each with ~250K SNPs represented. In all,
#  20 tumors and 20 paired normal samples were profiled,
#  40 profiles in all. Each tumor was centered on its 
#  corresponding normal pair to define copy number alterations
#  (CNA) in that tumor.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE12702
##########################################################################
dataSet <- "GSE12702"
chipTypes <- c("Mapping250K_Nsp", "Mapping250K_Sty")

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipTypes[1])
print(ds)
## AffymetrixCelSet:
## Name: GSE12702
## Tags:
## Path: rawData/GSE12702/Mapping250K_Nsp
## Platform: Affymetrix
## Chip type: Mapping250K_Nsp
## Number of arrays: 40
## Names: GSM318728, GSM318729, GSM318730, ..., GSM318767 [40]
## Time period: 2008-04-03 13:52:53 -- 2008-04-10 20:08:49
## Total file size: 2506.11MB
## RAM: 0.04MB


ds <- downloadGeoRawDataSet(dataSet, chipType=chipTypes[2])
print(ds)
## AffymetrixCelSet:
## Name: GSE12702
## Tags:
## Path: rawData/GSE12702/Mapping250K_Sty
## Platform: Affymetrix
## Chip type: Mapping250K_Sty
## Number of arrays: 40
## Names: GSM318773, GSM318774, GSM318775, ..., GSM318812 [40]
## Time period: 2007-10-03 16:11:06 -- 2008-02-21 15:18:27
## Total file size: 2506.12MB
## RAM: 0.04MB


verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extraction tests - extractMatrix()
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsA <- res$cesN;     # CnChipEffectSet
dsB <- res$dsNList;  # AromaUnitTotalCnBinarySet

dfA <- dsA[[1]]
dfB <- dsB[[1]]

# (a) Single array
yA <- extractMatrix(dfA, verbose=verbose)
print(head(yA))

yB <- extractMatrix(dfB, verbose=verbose)
print(head(yB))

stopifnot(all.equal(yB, yA, check.attributes=TRUE))

# (b) Multiple arrays
YA <- extractMatrix(dsA, verbose=verbose)
print(head(YA))

YB <- extractMatrix(dsB, verbose=verbose)
print(head(YB))

stopifnot(all.equal(YB, YA))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extraction tests - extractDataFrame()
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) Single array
dataA <- extractDataFrame(dfA, addNames=TRUE, verbose=verbose)
print(head(dataA))

# (b) Multiple arrays
dataA <- extractDataFrame(dsA, addNames=TRUE, verbose=verbose)
print(head(dataA))

# Subsetting
dataAs <- extractDataFrame(dsA, units=50:59, addNames=TRUE)
print(head(dataAs))
# Sanity check
stopifnot(all.equal(dataAs, dataA[50:59,], check.attributes=FALSE))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extraction tests - extractTheta()
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
thetaA <- extractTheta(dfA, drop=TRUE, verbose=verbose)
print(head(thetaA))

# Sanity check
stopifnot(all.equal(thetaA, yA[,1]))

thetaA <- extractTheta(dsA, drop=TRUE, verbose=verbose)
print(head(thetaA))

# Sanity check
stopifnot(all.equal(thetaA, YA))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Write tests - writeDataFrame()
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
columns <- c("unitName", "chromosome", "position", "*")
dfBTxt <- writeDataFrame(dfB, columns=columns, overwrite=TRUE, verbose=verbose)
print(dfBTxt)
ddfB <- readDataFrame(dfBTxt, rows=1:100)
print(head(ddfB))
str(ddfB)

dsBTxt <- writeDataFrame(dsB, columns=columns, overwrite=TRUE, verbose=verbose)
print(dsBTxt)
ddsB <- readDataFrame(dsBTxt, rows=1:100)
print(head(ddsB))
str(ddsB)
stopifnot(all.equal(ddsB[,1:ncol(ddfB)], ddfB, check.attributes=FALSE))


columns <- c("*")
dsBTxt2 <- writeDataFrame(dsB, columns=columns, overwrite=TRUE, verbose=verbose)
print(dsBTxt2)
ddsB2 <- readDataFrame(dsBTxt2, rows=1:100)
print(head(ddsB2))
str(ddsB2)
stopifnot(all.equal(ddsB2, ddsB[,-(1:3)], check.attributes=FALSE))

library("aroma.affymetrix")

verbose <- Verbose(threshold=-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# doCBS() with explicit data set tuple
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap,CEU,testset"
tags <- "ACC,-XY,RMA,+300,A+B,FLN,-XY"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")

nbrOfSets <- length(chipTypes)
dsList <- vector("list", nbrOfSets)
for (kk in seq_len(nbrOfSets)) {
  chipType <- chipTypes[kk]
  ds <- CnChipEffectSet$byName(dataSet, tags=tags, chipType=chipType,
                              mergeStrands=TRUE, combineAlleles=TRUE)
  dsList[[kk]] <- ds
}
print(dsList)

dsTuple <- as.CopyNumberDataSetTuple(dsList)
print(dsTuple)

res <- doCBS(dsTuple, arrays=1:2, chromosomes=c(19,21), verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# doCBS() with data set tuple names
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "HapMap270,100K,CEU,testSet"
tags <- "ACC,-XY,RMA,+300,A+B,FLN,-XY"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")

res <- doCBS(dataSet, tags=tags, chipTypes=chipTypes,
             arrays=1:2, chromosomes=c(19,21), verbose=verbose)
print(res)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")



##########################################################################
# Data set:
# GSE24546,testset/
#   Hs_PromPR_v02/
#     GSM605951.CEL (Prec1_MeDNA_Input1)
#     GSM605952.CEL (Prec1_MeDNA_IP2)
#     GSM605953.CEL (Prec1_MeDNA_IP1)
#
# Overall design:
#  Comparison of MeDIP/MBD for DNA methylation profiling, comparison of
#  whole genome amplification techniques, using tiling array for copy
#  number aberration detection and comparisons of tiling array data to
#  sequencing readouts.
#
# URL: https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE24546
##########################################################################
dataSet <- "GSE24546"
tags <- "testset"
chipType <- "Hs_PromPR_v02"
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
)

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataFiles(dataSet, tags=tags, chipType=chipType, sampleNames=names(sampleNamesMap))
print(ds)
## AffymetrixCelSet:
## Name: GSE24546
## Tags: testset
## Path: rawData/GSE24546,testset/Hs_PromPR_v02
## Platform: Affymetrix
## Chip type: Hs_PromPR_v02
## Number of arrays: 3
## Names: GSM605951, GSM605952, GSM605953 [3]
## Time period: 2007-09-28 13:17:49 -- 2007-09-28 14:26:51
## Total file size: 134.54MB
## RAM: 0.01MB

verbose && exit(verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# HapMap,CEU,testset/
#   Mapping50K_Hind240/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
#
# URL: ftp://ftp.ncbi.nlm.nih.gov/hapmap/raw_data/affy100k/
##########################################################################
dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")
sampleNames <- c("CEU_NA06985", "CEU_NA06991", "CEU_NA06993",
                 "CEU_NA06994", "CEU_NA07000", "CEU_NA07019")

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadHapMapSamples(dataSet, chipType=chipTypes[1], sampleNames=sampleNames)
print(ds)
## AffymetrixCelSet:
## Name: HapMap
## Tags: CEU
## Path: rawData/HapMap,CEU/Mapping50K_Hind240
## Platform: Affymetrix
## Chip type: Mapping50K_Hind240
## Number of arrays: 6
## Names: CEU_NA06985_HIND, CEU_NA06991_HIND, CEU_NA06993_HIND, ..., CEU_NA07019_HIND [6]
## Time period: 2004-01-14 14:02:08 -- 2004-01-17 13:53:58
## Total file size: 146.86MB
## RAM: 0.01MB

verbose && exit(verbose)

library("aroma.affymetrix")

log <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "HapMap,CEU,testset"
chipType <- "Mapping50K_Hind240"

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Assert existence of probe-sequence annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acs <- AromaCellSequenceFile$byChipType(chipType)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
acc <- AllelicCrosstalkCalibration(csR)
print(acc)
csC <- process(acc, verbose=log)
print(csC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Base-position normalization
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
bpn <- BasePositionNormalization(csC, shift=+300)
print(bpn)

csN <- process(bpn, verbose=log)
print(csN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot probe sequence base count effects
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ff <- 3

counts <- countBases(acs, verbose=log)

Ms <- list()
whats <- c("raw", "acc", "bcn")
for (what in whats) {
  if (what == "raw") {
    cs <- csR
  } else if (what == "acc") {
    cs <- csC
  } else if (what == "bcn") {
    cs <- csN
  }
  cf <- cs[[ff]]
  cfR <- getAverageFile(cs, verbose=log)
  yR <- readRawData(cfR, fields="intensities", drop=TRUE)
  y <- readRawData(cf, fields="intensities", drop=TRUE)
  M <- log2(y/yR)
  Ms[[what]] <- M
  rm(y, yR, cfR, cs, M)
} # for (what ...)


# Estimate standard deviations for log-ratios
print(sapply(Ms, FUN=function(M) { mad(diff(M), na.rm=TRUE) }))

Mlim <- c(-1,1)
Mlab <- expression(M == log[2](y/y[R]))
xlim <- c(0, 25)

layout(matrix(1:(length(whats)*4), ncol=4, byrow=TRUE))
par(mar=c(5,4,2,1)+0.1)
for (what in names(Ms)) {
  M <- Ms[[what]]

  for (bb in c("A", "C", "G", "T")) {
    xlab <- sprintf("Number of %s:s", bb)
    boxplot(M ~ counts[,bb], outline=FALSE,
            ylim=Mlim, xlim=xlim, ylab=Mlab, xlab=xlab)
    stext(side=3, pos=0, getFullName(cf))
    stext(side=3, pos=0.98, line=-1, cex=2, bb)
    stextChipType(chipType)
  }
  rm(M)
} # for (what ...)
devDone()

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the SNPRMA
# chip-effect estimates as estimated by oligo.
# It verifies that they give the same results whether or not one
# is normalizing towards the HapMap reference (as defined by oligo).
#
# Author: Henrik Bengtsson
# Created: 2008-12-04
# Last modified: 2010-09-01
###########################################################################
library("aroma.affymetrix")
library("oligo")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Local functions
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
compareESets <- function(eSet1, eSet2, tolerance=1e-4) {
  # Default
  res <- all.equal(eSet1, eSet2, tolerance=tolerance)
  if (!isTRUE(res)) return(res)

  # Compare assayData()
  data1 <- assayData(eSet1)
  data2 <- assayData(eSet2)
  data1 <- as.list(data1)
  data2 <- as.list(data2)
  res <- all.equal(data1, data2, tolerance=tolerance)
  if (!isTRUE(res)) return(res)
  TRUE
} # compareESets()


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)

# Process only a subset of the arrays.  Since this data set
# contains many replicates (cf. GEO), they need to be for
# different samples.
sampleNamesMap <- c(
  GSM337641="HCC1143_GLEYS_A02",
#  GSM337646="HCC1143_TRIBE_H11",
  GSM337662="HCC1143BL_GLEYS_A01",
#  GSM337666="HCC1143BL_TRIBE_D02",
#  GSM337668="HCC1143BL_GHATS_H04",
#  GSM337674="HCC1143BL_TRIGS_G07",
  GSM337683="HCC1954_GLEYS_B02",
#  GSM337688="HCC1954_TRIBE_G12",
  GSM337696="HCC1954BL_GLEYS_B01",
#  GSM337700="HCC1954BL_TRIBE_B01",
#  GSM337702="HCC1954BL_GHATS_G10",
#  GSM337703="HCC1954BL_TRIGS_G11",
  GSM337707="NCI-H2347",
  GSM337708="NCI-H2347BL"
)
sampleNames <- names(sampleNamesMap)

sampleNames <- rev(sampleNames)
csR <- csR[sampleNames]
setFullName(csR, sprintf("%s,crlmmSubset", dataSet))
print(csR)

# Assert that the file header of the first CEL file in
# truly a GenomeWideSNP_6 (and not GenomeWideEx_6 because
# oligo::justSNPRMA() cannot handle chip type aliases)
stopifnot(getHeader(csR[[1]])$chiptype == chipType)

# Assert that the correct Platform Design package is installed
pdPkgName <- cleanPlatformName(chipType)
library(pdPkgName, character.only=TRUE)

for (normalizeToHapmap in c(FALSE, TRUE)) {
  verbose && enter(verbose, sprintf("justSNPRMA(..., normalizeToHapMap=%s)", normalizeToHapmap))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # SNPRMA according to aroma.affymetrix
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  eSet <- justSNPRMA(csR, normalizeToHapmap=normalizeToHapmap, verbose=verbose)
  print(eSet)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # SNPRMA according to oligo
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  eSet0 <- justSNPRMA(getPathnames(csR), normalizeToHapmap=normalizeToHapmap, verbose=as.logical(verbose))
  print(eSet0)

  if (!normalizeToHapmap) {
    # CLEAN UP: justSNPRMA() stores a target distribution file
    # in the working directory that we don't need
    filename <- sprintf("%s.quantileReference.rda", pdPkgName)
    if (isFile(filename)) {
      file.remove(filename)
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Compare
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  res <- compareESets(eSet, eSet0, tolerance=0.02)
  verbose && print(verbose, res)

  # Sanity check
  stopifnot(res)

  verbose && exit(verbose)
} # for (normalizeToHapmap ...)

library("aroma.affymetrix")

##########################################################################
# Data set:
# FusionSDK_Test3/
#  Test3/
##########################################################################
dataSet <- "FusionSDK_Test3"
chipType <- "Test3"

path <- file.path("rawData", dataSet, chipType)
path <- Arguments$getWritablePath(path)
ds <- AffymetrixCelSet$byPath(path)
if (nbrOfFiles(ds) == 0) {
  pathT <- system.file(path, "2.Calvin", package="AffymetrixDataTestFiles")
  pathnames <- list.files(pathT, pattern="[.]CEL$", full.names=TRUE)
  for (ii in seq_along(pathnames)) {
    pathname <- pathnames[ii]
    pathnameD <- file.path(path, basename(pathname))
    copyFile(pathname, pathnameD)
  }
  ds <- AffymetrixCelSet$byPath(path)
}
print(ds)
## AffymetrixCelSet:
## Name: FusionSDK_Test3
## Tags:
## Path: rawData/FusionSDK_Test3/Test3
## Platform: Affymetrix
## Chip type: Test3
## Number of arrays: 2
## Names: Test3-1-121502, Test3-2-121502 [2]
## Time period: 2001-08-16 17:28:31 -- 2001-08-16 17:32:06
## Total file size: 0.31MB
## RAM: 0.01MB

library("aroma.affymetrix")
ovars <- ls(all.names=TRUE)
oplan <- future::plan()

message("*** NormExpBackgroundCorrection ...")

dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
csR <- csR[1:3]
print(csR)

cdf <- getCdf(csR)
acs <- getAromaCellSequenceFile(cdf)
print(acs)

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  }
}

checksum <- NULL

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  message("- NormExpBackgroundCorrection(method='mle') ...")
  bg <- NormExpBackgroundCorrection(csR, method="mle", tags=tags)
  print(bg)
  csB <- process(bg, verbose=verbose)
  print(csB)

  csBz <- getChecksumFileSet(csB)
  print(csBz[[1]])
  checksumT <- readChecksum(csBz[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))
  message("- NormExpBackgroundCorrection(method='mle') ... DONE")

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}

message("*** NormExpBackgroundCorrection ... DONE")

## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE34184,testset/
#   HuEx-1_0-st-v2/
#     GSM843555.CEL
#     GSM843556.CEL
#     GSM605957.CEL
#
#
# URL: https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE34184
##########################################################################
dataSet <- "GSE34184"
tags <- "testset"
chipType <- "HuEx-1_0-st-v2"
sampleNamesMap <- c(
  GSM843555="GSM843555_JC-110",
  GSM843556="GSM843556_JC-99",
  GSM843557="GSM843557_C59"
)

verbose && cat(verbose, "Data set: ", dataSet)

urls <- sprintf("ftp://ftp.ncbi.nlm.nih.gov/geo/samples/GSM843nnn/%s/suppl/%s.CEL.gz", names(sampleNamesMap), sampleNamesMap)

dfList <- lapply(urls, FUN = function(url) {
  downloadGeoRawDataFile(dataSet, tags=tags, chipType=chipType, url = url)
})
ds <- AffymetrixCelSet$byName(dataSet, tags=tags, chipType=chipType)
print(ds)
stopifnot(length(ds) == length(sampleNamesMap))
## AffymetrixCelSet:
## Name: GSE34184
## Tags: testset
## Path: rawData/GSE34184,testset/HuEx-1_0-st-v2
## Platform: Affymetrix
## Chip type: HuEx-1_0-st-v2
## Number of arrays: 3
## Names: GSM843555_JC-110, GSM843556_JC-99, GSM843557_C59 [3]
## Time period: 2009-07-31 14:22:16 -- 2009-08-04 20:36:08
## Total file size: 188.61 MiB

verbose && exit(verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix");
pathname <- file.path(path, "downloadUtils.R");
source(pathname);

verbose && enter(verbose, "Downloading raw data");


##########################################################################
# Data set:
# GSE9890/
#   HG-U133_Plus_2/
#    GSM249671.CEL, ..., GSM249680.CEL [10]
#
# Overall design:
#  [Ten] cervival cancer cell lines were hybridized to Affymetrix 
#  Focus arrays in duplicate. Correlations were made with copynumber 
#  profiles from arrayCGH and SNP arrays.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE8605
##########################################################################
dataSet <- "GSE9890";
chipType <- "HG-U133_Plus_2";
verbose && cat(verbose, "Data set: ", dataSet);

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType,
                                   chipTypeAliases=c("Focus"="HG-Focus"));
print(ds);
## AffymetrixCelSet:
## Name: GSE9890
## Tags:
## Path: rawData/GSE9890/HG-U133_Plus_2
## Platform: Affymetrix
## Chip type: HG-U133_Plus_2
## Number of arrays: 10
## Names: GSM249671, GSM249672, GSM249673, ..., GSM249680 [10]
## Time period: 2006-12-12 15:27:01 -- 2007-06-28 10:55:52
## Total file size: 129.36MB
## RAM: 0.01MB


verbose && exit(verbose);

##########################################################################
# Segmentation of total copy-number ratios of tumors where tumors
# are hybridized on one chip type and the reference samples on another.
#
# Author: Henrik Bengtsson
# Created on: 2012-08-25
# Last updated: 2012-08-26
#
# DATA SET:
# GEO data set 'GSE12702'. Affymetrix CEL files are available from:
#
#   https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE12702
#
# Place them in rawData/GSE12702/Mapping250K_{Nsp|Sty}/*.CEL.  In total
# there are 20 tumor-normal pairs (40 CEL files) per chip type.
#
# ANNOTATION DATA [1]:
# annotationData/
#  chipTypes/
#   Mapping250K_Nsp/
#    Mapping250K_Nsp,na31,HB20101007.ugp
#   Mapping250K_Sty/
#    Mapping250K_Sty,na31,HB20101007.ugp
#  (GenericHuman/
#    GenericHuman,10kb,HB20090503.ugp.gz)
#
# [1] https://aroma-project.org/data/annotationData/chipTypes/
##########################################################################
library("aroma.affymetrix")
library("aroma.cn")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE12702"
chipTypes <- c("Mapping250K_Nsp", "Mapping250K_Sty")
dsList <- lapply(chipTypes, FUN=function(chipType) {
  dsNList <- doASCRMAv2(dataSet, chipType=chipType, verbose=verbose)
  dsNList$total
})
names(dsList) <- chipTypes
print(dsList)
## $Mapping250K_Nsp
## AromaUnitTotalCnBinarySet:
## Name: GSE12702
## Tags: ACC,-XY,BPN,-XY,AVG,FLN,-XY
## Full name: GSE12702,ACC,-XY,BPN,-XY,AVG,FLN,-XY
## Number of files: 40
## Names: GSM318728, GSM318729, GSM318730, ..., GSM318767 [40]
## Path (to the first file): totalAndFracBData/GSE12702,ACC,-XY,BPN,-XY,AVG,FLN,
## -XY/Mapping250K_Nsp
## Total file size: 40.05 MB
## RAM: 0.04MB
##
## $Mapping250K_Sty
## AromaUnitTotalCnBinarySet:
## Name: GSE12702
## Tags: ACC,-XY,BPN,-XY,AVG,FLN,-XY
## Full name: GSE12702,ACC,-XY,BPN,-XY,AVG,FLN,-XY
## Number of files: 40
## Names: GSM318773, GSM318774, GSM318775, ..., GSM318812 [40]
## Path (to the first file): totalAndFracBData/GSE12702,ACC,-XY,BPN,-XY,AVG,FLN,
## -XY/Mapping250K_Sty
## Total file size: 36.39 MB
## RAM: 0.04MB


# Sample annotation data according to GEO
sad <- read.table(sep="\t", header=TRUE, stringsAsFactors=FALSE, text="
sampleType	sampleName
GSM318728	T	Patient24
GSM318729	N	Patient24
GSM318730	T	Patient25
GSM318731	N	Patient25
GSM318732	T	Patient27
GSM318733	N	Patient27
GSM318734	T	Patient31
GSM318735	N	Patient31
GSM318736	T	Patient45
GSM318737	N	Patient45
GSM318738	T	Patient52
GSM318739	N	Patient52
GSM318740	T	Patient58
GSM318741	N	Patient58
GSM318742	T	Patient60
GSM318743	N	Patient60
GSM318744	T	Patient75
GSM318745	N	Patient75
GSM318746	T	Patient110
GSM318747	N	Patient110
GSM318748	T	Patient115
GSM318749	N	Patient115
GSM318750	T	Patient122
GSM318751	N	Patient122
GSM318752	T	Patient128
GSM318753	N	Patient128
GSM318754	T	Patient137
GSM318755	N	Patient137
GSM318756	T	Patient138
GSM318757	N	Patient138
GSM318758	T	Patient140
GSM318759	N	Patient140
GSM318760	T	Patient154
GSM318761	N	Patient154
GSM318762	T	Patient167
GSM318763	N	Patient167
GSM318764	T	Patient80
GSM318765	N	Patient80
GSM318766	T	Patient96
GSM318767	N	Patient96
GSM318773	T	Patient24
GSM318774	N	Patient24
GSM318775	T	Patient25
GSM318776	N	Patient25
GSM318777	T	Patient27
GSM318778	N	Patient27
GSM318779	T	Patient31
GSM318780	N	Patient31
GSM318781	T	Patient45
GSM318782	N	Patient45
GSM318783	T	Patient52
GSM318784	N	Patient52
GSM318785	T	Patient58
GSM318786	N	Patient58
GSM318787	T	Patient60
GSM318788	N	Patient60
GSM318789	T	Patient75
GSM318790	N	Patient75
GSM318791	T	Patient110
GSM318792	N	Patient110
GSM318793	T	Patient115
GSM318794	N	Patient115
GSM318795	T	Patient122
GSM318796	N	Patient122
GSM318797	T	Patient128
GSM318798	N	Patient128
GSM318799	T	Patient137
GSM318800	N	Patient137
GSM318801	T	Patient138
GSM318802	N	Patient138
GSM318803	T	Patient140
GSM318804	N	Patient140
GSM318805	T	Patient154
GSM318806	N	Patient154
GSM318807	T	Patient167
GSM318808	N	Patient167
GSM318809	T	Patient80
GSM318810	N	Patient80
GSM318811	T	Patient96
GSM318812	N	Patient96
")

# Apply fullname translators
# this avoids having to rename the actual files
fnt <- function(names, ...) {
  names <- gsub(",total", "", names)
  data <- sad[names,]
  paste(data$sampleName, data$sampleType, names, "total", sep=",")
}
dsList <- lapply(dsList, FUN=setFullNamesTranslator, fnt)

# Example without translators
# the names do not pair up across the two chip types
print(getFullNames(dsList[[1]], translate=FALSE)[1:2])
print(getFullNames(dsList[[2]], translate=FALSE)[1:2])

# Example with translators
# the names *do* pair up across the two chip types
print(getFullNames(dsList[[1]], translate=TRUE)[1:2])
print(getFullNames(dsList[[2]], translate=TRUE)[1:2])


# Order both datasets by <sampleName>,<sampleType>
names <- gsub(",GSM.*", "", getFullNames(dsList[[1]]))
dsList <- lapply(dsList, FUN=`[`, names)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Split up in tumor-normal data sets
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract tumors and normals
dsTList <- lapply(dsList, FUN=function(ds) {
  ds[sapply(ds, FUN=hasTag, "T")]
})

dsNList <- lapply(dsList, FUN=function(ds) {
  ds[sapply(ds, FUN=hasTag, "N")]
})


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (A) Paired tumor-normal segmentation when the tumors and the normals
#     are hybridized on the same (Mapping250K_Nsp) chip type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsT <- dsTList$Mapping250K_Nsp
dsN <- dsNList$Mapping250K_Nsp
seg <- CbsModel(dsT, ref=dsN)
print(seg)

ce <- ChromosomeExplorer(seg)

# Segment Chr8 of tumor GSM318736 (cf. FigS3 of the CalMaTe paper).
sampleName <- sad["GSM318736", "sampleName"]
idx <- match(sampleName, getNames(ce))
process(ce, arrays=idx, chromosomes=c(2,8), verbose=verbose)

# Look at the segmentation in ChromosomeExplorer
display(ce)

# Or open manually in the following directory
path <- print(getParent(getPath(ce), 2))
print(path)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (B) Paired tumor-normal segmentation when the tumors are hybridized
#     on Mapping250K_Nsp and the normals on Mapping250K_Sty
#
# In order to segment, one needs TCN *ratios*. The problem is that the
# TCN ratios are calculated as C=2*T/N, but the tumor signals (T) and
# the normal signal (N) are not observered at the same loci because
# of the different chip types.  NB: T and N are non-ratios here.
#   A solution to this problem is to instead calculate the TCN ratios as
# C'=2*C'_T/C'_N where C'_T and C'_N in turn are TCN *ratios* for the
# tumors (C'_T) and the normals (C'_N) *estimated* at a common set of
# loci.  We use C'_T and C'_N to indicated that the are binned TCN
# *ratios*, where the binning is common to the tumors and the normals.
#   The C'_T ratios are binned based on tumor TCN *ratios* calculated
# as C_T = 2*T/R_T where T is the tumor signal and R_T is a reference
# TCN signal for the same chip type. The C'_N and C_N = 2*N/R_N ratios
# are obtained analogously.
#   The success of this method relies on finding "good" references
# R_T and R_N for the two chip types.  Ideally, R_T is from the same
# batch or lab as T, and likewise for R_N.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Obtaining the reference R_T and R_N
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# We use the pool of a set of samples believed to behave rather normal.
# This can for instance be HapMap samples.  In this example, in order
# avoid making this analysis too big, we simply use the set of normal
# samples in the GSE12702 data.
dsRList <- dsNList

# Calculate the reference as the average across reference samples
dfRList <- lapply(dsRList, FUN=getAverageFile)
print(dfRList)
## $Mapping250K_Nsp
## AromaUnitTotalCnBinaryFile:
## Name: .average-signals-median-mad
## Tags: 2851ec1b0e76f7366fd8b884df353bc9
## Full name: .average-signals-median-mad,2851ec1b0e76f7366fd8b884df353bc9
## Pathname: totalAndFracBData/GSE12702,ACC,-XY,BPN,-XY,AVG,FLN,-XY/Mapping250K_
## Nsp/.average-signals-median-mad,2851ec1b0e76f7366fd8b884df353bc9.asb
## File size: 1.00 MB (1049713 bytes)
## RAM: 0.00 MB
## Number of data rows: 262338
## File format: v1
## Dimensions: 262338x1
## Column classes: double
## Number of bytes per column: 4
## Footer: <createdOn>20120825 17:19:49 PDT</createdOn><platform>Affymetrix</platfo
## rm><chipType>Mapping250K_Nsp</chipType><srcDetails><nbrOfFiles>20</nbrOfFiles><c
## heckSum>39d886127600a8bce196842a61f477c5</checkSum></srcDetails><params><meanNam
## e>median</meanName><sdName>mad</sdName></params>
## Platform: Affymetrix
## Chip type: Mapping250K_Nsp
##
## $Mapping250K_Sty
## AromaUnitTotalCnBinaryFile:
## Name: .average-signals-median-mad
## Tags: 2851ec1b0e76f7366fd8b884df353bc9
## Full name: .average-signals-median-mad,2851ec1b0e76f7366fd8b884df353bc9
## Pathname: totalAndFracBData/GSE12702,ACC,-XY,BPN,-XY,AVG,FLN,-XY/Mapping250K_
## Sty/.average-signals-median-mad,2851ec1b0e76f7366fd8b884df353bc9.asb
## File size: 931.52 kB (953873 bytes)
## RAM: 0.00 MB
## Number of data rows: 238378
## File format: v1
## Dimensions: 238378x1
## Column classes: double
## Number of bytes per column: 4
## Footer: <createdOn>20120825 17:19:58 PDT</createdOn><platform>Affymetrix</platfo
## rm><chipType>Mapping250K_Sty</chipType><srcDetails><nbrOfFiles>20</nbrOfFiles><c
## heckSum>e5860cd91603c1b77757e97b419a3368</checkSum></srcDetails><params><meanNam
## e>median</meanName><sdName>mad</sdName></params>
## Platform: Affymetrix
## Chip type: Mapping250K_Sty

# Here, R_T = dfRList$Mapping250K_Nsp and R_N = dfRList$Mapping250K_Sty


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calculating TCN *ratios* C_T = 2*T/R_T and C_N = 2*N/R_N
# where C_T is from Mapping250_Nsp and C_N is from Mapping250_Sty
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# C_T = 2*T/R_T
dsT <- dsTList$Mapping250K_Nsp
dfRT <- dfRList$Mapping250K_Nsp
dsCT <- exportTotalCnRatioSet(dsT, ref=dfRT)
# Workaround: Currently exportTotalCnRatioSet() returns everything
# it finds in the output directory and not (as it should) only the
# samples corresponding to the input data set.  The following does
# the latter for us, in this particular example (just in case).
names <- gsub(",GSM.*", "", getFullNames(dsT))
dsCT <- dsCT[names]


# C_N = 2*N/R_N
dsN <- dsNList$Mapping250K_Sty
dfRN <- dfRList$Mapping250K_Sty
dsCN <- exportTotalCnRatioSet(dsN, ref=dfRN)
# Same workaround
names <- gsub(",GSM.*", "", getFullNames(dsN))
dsCN <- dsCN[names]


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# TCN binning of C_T and C_N independently but to a common set of loci
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# To bin only one sample, subset dsCT and dsCN here, e.g.
  sampleName <- sad["GSM318736", "sampleName"]; # => Patient45
  dsCT <- dsCT[sampleName]
  dsCN <- dsCN[sampleName]

# Bin one chip type to the other. If one chip type has many more
# loci than another, bin the former to the latter to increase the
# chances for input loci mapping to target bins.
# NB: Despite this, it is likely that there will be target bins
# for which no input loci fall within, particularly if the two
# chip types have approximately the same number of loci. For similar
# reasons, it is likely that for some target bins there will be
# multiple loci mapping.  In other words, the number of loci averaged
# will differ between bins.  The more loci averaged over, the
# more precise the binned estimate will be.  Because of this, these
# bin counts (or standard error estimates) would ideally be passed
# on to the segmentation method to give different bin estimates
# different weights in the segmentation.  This is currently not
# done, mainly because none of the bin counts are recorded by
# TotalCnBinnedSmoothing.
ugpCT <- getAromaUgpFile(dsCT)
ugpCN <- getAromaUgpFile(dsCN)
if (nbrOfUnits(ugpCT) > nbrOfUnits(ugpCN)) {
  targetUgp <- ugpCN
} else {
  targetUgp <- ugpCT
}

# Alternatively, one can bin to uniformly distributed set of loci,
# e.g. 10kb bins.  The downside of this is that both chip types
# have to be binned, which means longer processing times.  Example:
#  targetUgp <- AromaUgpFile$byChipType("GenericHuman", tags="10kb")

# Calculate C'_T by binning C_T ratios
isBinningNeeded <- (!equals(getAromaUgpFile(dsCT), targetUgp))
if (isBinningNeeded) {
  tcsCT <- TotalCnBinnedSmoothing(dsCT, targetUgp=targetUgp)
  print(tcsCT)
  dsCTs <- process(tcsCT, verbose=verbose)
} else {
  dsCTs <- dsCT
}
print(dsCTs)

# Calculate C'_N by binning C_N ratios
isBinningNeeded <- (!equals(getAromaUgpFile(dsCN), targetUgp))
if (isBinningNeeded) {
  tcsCN <- TotalCnBinnedSmoothing(dsCN, targetUgp=targetUgp)
  print(tcsCN)
  dsCNs <- process(tcsCN, verbose=verbose)
  print(dsCNs)
} else {
  dsCNs <- dsCN
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired tumor-normal segmentation of C' = 2*C'_T / C'_N
# (with tumors orginally from Nsp and normals originally from Sty)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Just to short then output names in the segmentation, because
# they'll get really long otherwise.
fnt <- function(names, ...) {
  # Drop GSM... and ref=... tags
  gsub(",GSM[0-9]*,ref=[^,]*,[^,]*", "", names)
}
setFullNamesTranslator(dsCTs, fnt)
setFullNamesTranslator(dsCNs, fnt)

# Add custom tags to segmentation output to indiciate whether
# one or the other chip types was mapped to the other.
segTags <- NULL
if (!equals(dsCTs, dsCT) && !equals(dsCNs, dsCN)) {
} else if (!equals(dsCTs, dsCT)) {
  segTags <- "remappedT"
} else if (!equals(dsCNs, dsCN)) {
  segTags <- "remappedN"
}

# Setup paired tumor-normal segmentation model on binned data
segS <- CbsModel(dsCTs, ref=dsCNs, tags=c(segTags, "*"), maxNAFraction=1)
print(segS)

ce <- ChromosomeExplorer(segS)

# Segment Chr8 of tumor GSM318736 as in FigS3 of the CalMaTe paper.
sampleName <- sad["GSM318736", "sampleName"]
idx <- match(sampleName, getNames(ce))
process(ce, arrays=idx, chromosomes=c(8), verbose=verbose)


##########################################################################
# HISTORY:
# 2012-08-26
# o Added custom segmentation tags.
# o Verified that it works to use a target UGP that maps to one of the
#   two chip types.
# 2012-08-25
# o (Re)created.
##########################################################################

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "installUtils.R")
source(pathname)

library("R.utils")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Install
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Installing test-specific packages")

pkgs <- c("CRAN:calmate", "CRAN:PSCBS", "CRAN:aroma.cn")
for (pkg in pkgs) {
  verbose && cat(verbose, "Package: ", pkg)
  installPkg(pkg)
}

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
verbose <- Verbose(threshold=-50, timestamp=TRUE);
options(width=60);


chipType <- "Mapping50K_Xba240";


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# User settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
## setOption(aromaSettings, "user/initials", "HB");
## setOption(aromaSettings, "user/fullname", "Henrik Bengtsson");
## email <- sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
## setOption(aromaSettings, "user/email", email);
## saveAnywhere(aromaSettings);

fullname <- getOption(aromaSettings, "user/fullname");
stopifnot(!is.null(fullname));
email <- getOption(aromaSettings, "user/email");
stopifnot(!is.null(email));
user <- getOption(aromaSettings, "user/initials");
stopifnot(!is.null(user));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
genomeVersions <- c("30"="hg18", "31"="hg19");
naVersions <- names(genomeVersions);
choices <- sprintf("na%s (%s)", naVersions, genomeVersions);
choice <- textMenu(choices, title="Choose NetAffx version: ", value=FALSE);
naVersion <- naVersions[choice];
genomeVersion <- genomeVersions[naVersion];
datestamp <- format(Sys.Date(), format="%Y%m%d");


enzyme <- c("Mapping50K_Hind240"="HindIII", "Mapping50K_Xba240"="XbaI")[chipType];
print(enzyme);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType);
rm(csv);
print(cdf);

tags <- sprintf(".na%s", naVersion);
pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
if (isFile(pathname)) {
  csv <- AffymetrixNetAffxCsvFile(pathname);
}
rm(tags);
print(csv);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UFL from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s,%s%s", naVersion, genomeVersion, user, datestamp);
ufl <- NULL;
tryCatch({
  ufl <- AromaUflFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ufl)) {
  ufl <- AromaUflFile$allocateFromCdf(cdf, tags=tags);
}
print(ufl);


stopifnot(!is.na(enzyme));
units <- importFrom(ufl, csv, enzymes=enzyme, verbose=verbose);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
srcFileTags <- list();
srcFiles <- list(cdf, csv);
for (kk in seq_along(srcFiles)) {
  srcFile <- srcFiles[[kk]];
  tags <- list(
    filename=getFilename(srcFile), 
    filesize=getFileSize(srcFile), 
    checksum=getChecksum(srcFile)
  );
  srcFileTags[[kk]] <- tags;
}
print(srcFileTags);

footer <- readFooter(ufl);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = fullname, 
  email = email
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ufl, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ufl);
x <- summaryOfUnits(ufl);
print(x);

## AromaUflFile:
## Name: Mapping50K_Xba240
## Tags: na31,hg19,HB20110328
## Full name: Mapping50K_Xba240,na31,hg19,HB20110328
## Pathname: annotationData/chipTypes/Mapping50K_Xba240/Mapping50K_Xba240,na31,hg19
## ,HB20110328.ufl
## File size: 115.87 kB (118649 bytes)
## RAM: 0.01 MB
## Number of data rows: 59015
## File format: v1
## Dimensions: 59015x1
## Column classes: integer
## Number of bytes per column: 2
## Footer: <createdOn>20110328 19:03:23 PDT</createdOn><platform>Affymetrix</platfo
## rm><chipType>Mapping50K_Xba240</chipType><createdBy><fullname>Henrik Bengtsson</
## fullname><email>[...]</email></createdBy><srcFiles><srcFile1><fil
## ename>Mapping50K_Xba240.CDF</filename><filesize>57703961</filesize><checksum>7f0
## 26f6472f7721255717fb3f453be61</checksum></srcFile1><srcFile2><filename>Mapping50
## K_Xba240.na31.annot.csv</filename><filesize>84705402</filesize><checksum>4cc4997
## 35dd13177331994cde4e9f323</checksum></srcFile2></srcFiles>
## Chip type: Mapping50K_Xba240
## Platform: Affymetrix
## 
##                snp cnp affxSnp other total
## enzyme1-only 58530   0       0     0 58530
## missing        430   0       0    55   485
## total        58960   0       0    55 59015

library("aroma.affymetrix")

ovars <- ls(all.names=TRUE)
oplan <- future::plan()

## Setup dataset
dataset <- "GSE8605"
chipType <- "Mapping10K_Xba142"

csR <- AffymetrixCelSet$byName(dataset, chipType=chipType)
csR <- csR[1:2]
print(csR)

## Create unique CDF
cdf <- getCdf(csR)
print(cdf)
cdfU <- getUniqueCdf(cdf)
print(cdfU)

checksum <- NULL

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  } else if (any(grepl("SGE_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_sge")
  }
}

message("Future strategies: ", paste(sQuote(strategies), collapse = ", "))
mprint(future::sessionDetails())
mprint(list(
  availableCores = parallelly::availableCores(which = "all"),
  availableWorkers = parallelly::availableWorkers(which = "all")
))

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  ## (a) Process a single array
  csU1 <- convertToUnique(csR[1], tags=c(tags, "one-array"), verbose=verbose)
  print(csU1)
  csU1z <- getChecksumFileSet(csU1)
  print(csU1z[[1]])

  ## Compare file checksum to previous runs
  checksumT <- readChecksum(csU1z[[1]])
  if (is.null(checksum)) checksum <- checksumT
  ## FIXME: File checksums does not work for comparison since
  ## the CEL header has a timestamp of the creation time.
##  stopifnot(identical(checksumT, checksum))


  ## (b) Process two arrays
  csU <- convertToUnique(csR, tags=tags, verbose=verbose)
  print(csU)
  csUz <- getChecksumFileSet(csU)
  print(csU[[1]])
  res <- equals(csU1z[[1]], csUz[[1]])
  ## FIXME: File checksums does not work for comparison since
  ## the CEL header has a timestamp of the creation time.
##  if (!res) throw(res)  ## FIXME

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}


## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

##########################################################################
# AS-CRMAv2 and Paired PSCBS
##########################################################################
future::plan("multisession")
library("aroma.affymetrix")
library("aroma.cn");  # PairedPscbsModel
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE34754"
chipType <- "Mapping250K_Nsp"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR)
print(dsNList)

dsN <- exportAromaUnitPscnBinarySet(dsNList)
print(dsN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cmt <- CalMaTeCalibration(dsNList)
print(cmt)

dsCList <- process(cmt, verbose=verbose)
print(dsCList)

dsC <- exportAromaUnitPscnBinarySet(dsCList)
print(dsC)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Group samples by name and type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AD HOC: For now, just hardwire the path.
path <- file.path("testScripts/complete/dataSets", dataSet)
db <- TabularTextFile(sprintf("%s,samples.txt", dataSet), path=path)
setColumnNamesTranslator(db, function(names, ...) {
  names <- gsub("id", "fixed", names)
  names <- gsub("fullname", "replacement", names)
  names
})
df <- readDataFrame(db, colClasses=c("*"="character"))
setFullNamesTranslator(dsC, df)

# Identify unique sample names
sampleNames <- unique(getNames(dsC))

dsList <- lapply(sampleNames, FUN=function(sampleName) {
  ds <- dsC[sampleName]
  lapply(c(T="T", N="N"), FUN=function(type) {
    ds[sapply(ds, hasTag, type)]
  })
})
names(dsList) <- sampleNames


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract (single) tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dfTList <- lapply(dsList, FUN=function(dsList) { dsList$T[[1]] })
dsT <- newInstance(dsList[[1]]$T, dfTList)
dfNList <- lapply(dsList, FUN=function(dsList) { dsList$N[[1]] })
dsN <- newInstance(dsList[[1]]$T, dfNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segment tumor-normal pairs
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
sm <- PairedPscbsModel(dsT=dsT, dsN=dsN, gapMinLength=2e6)
print(sm)

res <- fit(sm, verbose=verbose)
print(res)

sms <- getOutputDataSet(sm)
print(sms)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Call segments to be in ROH, AB and LOH.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
caller <- PairedPscbsCaller(sms)
print(caller)
scs <- process(caller, verbose=verbose)
print(scs)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Generate report (just to check)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setOption("PSCBS::reports/pscnSegmentationTransitions", TRUE)

# Generate reports for tumor-normal pairs
for (ii in 1:min(length(scs),5)) {
  df <- scs[[ii]]
  fit <- loadObject(df)
  sampleName <- getFullName(df)
  pathname <- report(fit, sampleName=sampleName, studyName=getFullName(dsT), verbose=verbose)
  print(pathname)
} # for (ii ...)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (b) CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only the first six arrays (and in reverse order)
subset <- c(2,5,3)
dsN <- doCRMAv2(csR, arrays=subset, verbose=verbose)
print(dsN)


# Sanity checks
# Assert same output as input arrays (in the same order)
sampleNames <- getNames(csR)[subset]
stopifnot(getNames(dsN) == sampleNames)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (c) CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process only the first six arrays (and in reverse order)
subset <- c(2,5,3)
dsN2 <- doCRMAv2(dataSet, chipType=chipType, arrays=subset, verbose=verbose)
print(dsN2)

# Sanity checks
stopifnot(equals(dsN2, dsN))

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)

# Process only a subset of the arrays.  Since this data set
# contains many replicates (cf. GEO), they need to be for
# different samples.
sampleNamesMap <- c(
  GSM337641="HCC1143_GLEYS_A02",
#  GSM337646="HCC1143_TRIBE_H11",
  GSM337662="HCC1143BL_GLEYS_A01",
#  GSM337666="HCC1143BL_TRIBE_D02",
#  GSM337668="HCC1143BL_GHATS_H04",
#  GSM337674="HCC1143BL_TRIGS_G07",
  GSM337683="HCC1954_GLEYS_B02",
#  GSM337688="HCC1954_TRIBE_G12",
  GSM337696="HCC1954BL_GLEYS_B01",
#  GSM337700="HCC1954BL_TRIBE_B01",
#  GSM337702="HCC1954BL_GHATS_G10",
#  GSM337703="HCC1954BL_TRIGS_G11",
  GSM337707="NCI-H2347",
  GSM337708="NCI-H2347BL"
)
sampleNames <- names(sampleNamesMap)

sampleNames <- rev(sampleNames)
csR <- csR[sampleNames]
setFullName(csR, sprintf("%s,crlmmSubset", dataSet))
print(csR)

# Assert that the file header of the first CEL file in
# truly a GenomeWideSNP_6 (and not GenomeWideEx_6 because
# oligo::justSNPRMA() cannot handle chip type aliases)
stopifnot(getHeader(csR[[1]])$chiptype == chipType)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# SNPRMA according to aroma.affymetrix
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
eSet <- justSNPRMA(csR, normalizeToHapmap=TRUE, verbose=verbose)
print(eSet)

library("aroma.affymetrix")
library("matrixStats"); # rowMedians()
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Process arrays in random order
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plotting allele B frequences and raw copy numbers
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesN <- res$cesN
cdf <- getCdf(cesN)
ugp <- getAromaUgpFile(cdf)
units <- getUnitsOnChromosome(ugp, 2)
data <- extractDataFrame(cesN, units=units, addNames=TRUE, verbose=verbose)
data[,"x"] <- getPositions(ugp, data[,"unit"])

keep <- match(getNames(cesN), colnames(data))
theta <- as.matrix(data[,keep])
data <- data[,-keep]

isA <- (data$group==1)
isB <- (data$group==2)
thetaA <- theta[isA,]
thetaB <- theta[isB,]

# Total raw copy numbers
theta <- thetaA + thetaB
thetaR <- rowMedians(theta, na.rm=TRUE)
M <- log2(theta/thetaR)

# Allele B frequences
B <- thetaB/theta

# Position (in Mb)
x <- data[isA,"x"] / 1e6

# Array #1
ii <- 1

sampleName <- colnames(M)[ii]
toPNG(getFullName(cesN), tags=c(sampleName, "BAF,LogTCN"), {
  layout(matrix(1:2, nrow=2))
  par(mar=c(5,4,2,2)+0.1)

  xlim <- range(x, na.rm=TRUE)
  xlab <- "Physical position (in Mb)"
  Blab <- expression(theta[B]/theta)
  Mlab <- expression(log[2](theta/theta[R]))

  plot(NA, xlim=xlim, ylim=c(0,1), xlab=xlab, ylab=Blab)
  abline(h=1/2, col="#cccccc")
  points(x,B[,ii], pch=".", cex=2)
  stext(side=3, pos=0, sampleName)

  plot(NA, xlim=xlim, ylim=c(-1,1)*3, xlab=xlab, ylab=Mlab)
  abline(h=0, col="#cccccc")
  points(x,M[,ii], pch=".", cex=2)
})

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE37861/
#   MoGene-1_0-st-v1/
#     GSM929117_RSM01709.CEL, ..., GSM929131_RSM01726.CEL [15]
#
# Overall design:
#  RANKL (receptor acrivator of NFkB ligand) is a member of TNF 
#  superfamily cytokines. In the gastrointestinal tract, RANKL is
#  expressed in the stromal cells of Peyer's patches, and involved in
#  the development of the specialized intestinal epithelial cells,
#  called M cells.  To identify the genes involved in M-cell development,
#  we treated BALB/c mice with recombinant GST-RANKL. After 
#  RANKL-treatment, epithelial cells were isolated from small intestine,
#  and used for microarray analysis.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE37861
##########################################################################
dataSet <- "GSE37861"
chipType <- "MoGene-1_0-st-v1"
verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType)
print(ds)
## AffymetrixCelSet:
## Name: GSE37861
## Tags:
## Path: rawData/GSE37861/MoGene-1_0-st-v1
## Platform: Affymetrix
## Chip type: MoGene-1_0-st-v1,r3
## Number of arrays: 15
## Names: GSM929117_RSM01709, GSM929118_RSM01710, GSM929119_RSM01711, ..., GSM929131_RSM01726 [15]
## Time period: 2009-07-08 13:03:35 -- 2009-07-09 14:51:06
## Total file size: 158.41MB
## RAM: 0.02MB

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);
options(width=60);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "26";
user <- "HB";
datestamp <- "20080916";

chipType <- "Mapping50K_Xba240";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
print(summary(ugp));
print(table(ugp[,1]));

##  AromaUgpFile:
##  Name: Mapping50K_Xba240
##  Tags: na26,HB20080916
##  Pathname: C:/Users/hb/Documents/My Data/annotationData/chipTypes/Mapping50K_Xba2
##  40/Mapping50K_Xba240,na26,HB20080916.ugp
##  File size: 288.77kB
##  RAM: 0.00MB
##  Number of data rows: 59015
##  File format: v1
##  Dimensions: 59015x2
##  Column classes: integer, integer
##  Number of bytes per column: 1, 4
##  Footer: <createdOn>20080916 18:16:09 PDT</createdOn><platform>Affymetrix</platform><chipType>Mapping50K_Xba240</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping50K_Xba240.CDF</filename><filesize>57703961</filesize><checksum>7f026f6472f7721255717fb3f453be61</checksum></srcFile1><srcFile2><filename>Mapping50K_Xba240.na26.annot.csv</filename><filesize>94903244</filesize><checksum>eab081f8e918293016a760c5714d1198</checksum></srcFile2></srcFiles>
##  Chip type: Mapping50K_Xba240
##  Platform: Affymetrix

##   chromosome        position
##   Min.   :  1.000   Min.   :    93683
##   1st Qu.:  4.000   1st Qu.: 34636629
##   Median :  7.000   Median : 72249739
##   Mean   :  8.507   Mean   : 80010574
##   3rd Qu.: 12.000   3rd Qu.:114666170
##   Max.   : 24.000   Max.   :246885089
##   NA's   :390.000   NA's   :      390

##     1    2    3    4    5    6    7    8    9   10   11   12
##  4669 5274 3864 4231 4149 4111 3612 3422 2439 2953 2896 2685
##    13   14   15   16   17   18   19   20   21   22   23   24
##  2567 2083 1590 1245  971 1837  364 1101 1027  330 1204    1

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
dsT <- doCRMAv2(dataSet, chipType=chipType, verbose=verbose)
print(dsT)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
segB <- CbsModel(dsT)
print(segB)

# Try to segment
fit(segB, arrays=1:2, chromosomes=19, verbose=verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)

# Process only the first six arrays (and in reverse order)
subset <- 6:1
csR <- csR[subset]
print(csR)
sampleNames <- getNames(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CRMAv1
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv1(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Sanity checks
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Assert same output as input arrays (in the same order)
for (key in names(res)[-1]) {
  ds <- res[[key]]
  if (!inherits(ds, "GenericDataFileSet")) next
  stopifnot(getNames(ds) == sampleNames)
}

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "GenomeWideSNP_6"
tags <- "Full"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadCDF(ar, chipType, tags=tags)
verbose && cat(verbose, "CDF: ", pathname)

pathname <- downloadACS(ar, chipType, tags=".*")
verbose && cat(verbose, "ACS: ", pathname)

pathname <- downloadUFL(ar, chipType, tags=".*")
verbose && cat(verbose, "UFL: ", pathname)

pathname <- downloadUFL(ar, chipType, tags=c(tags, ".*"))
verbose && cat(verbose, "UFL: ", pathname)

pathname <- downloadUGP(ar, chipType, tags=".*")
verbose && cat(verbose, "UGP: ", pathname)

pathname <- downloadUGP(ar, chipType, tags=c(tags, ".*"))
verbose && cat(verbose, "UGP: ", pathname)

pathname <- downloadUGC(ar, chipType, tags=c(tags, ".*"))
verbose && cat(verbose, "UGC: ", pathname)

verbose && exit(verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")



##########################################################################
# Data set:
# GSE13372
#   GenomeWideSNP_6/
#    GSM337641.CEL, ..., GSM337708.CEL [68]
#
# Overall design:
#  Breast cancer cell lines HCC38 and HCC1143 and paired B 
#  lymphoblastoid cell lines HCC38-BL and HCC1143-BL were
#  purchased from ATCC. [...] To mimic tumor containing normal cells,
#  DNA from HCC38 and HCC1143 cells was mixed with DNA from autologous
#  B lymphoblastoid cells HCC38-BL and HCC1143-BL, respectively,
#  in ratios (w/w) 100:0, 80:20, 60:40, 40:60, and 20:80.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE13372
##########################################################################
dataSet <- "GSE13372"
chipType <- "GenomeWideSNP_6"

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType, 
                   chipTypeAliases=c("GenomeWideEx_6"="GenomeWideSNP_6"))
print(ds)
## AffymetrixCelSet:
## Name: GSE13372
## Tags:
## Path: rawData/GSE13372/GenomeWideSNP_6
## Platform: Affymetrix
## Chip type: GenomeWideSNP_6
## Number of arrays: 68
## Names: GSM337641, GSM337642, GSM337643, ..., GSM337708 [68]
## Time period: 2007-05-17 16:13:28 -- 2008-09-11 21:06:39
## Total file size: 4480.08MB
## RAM: 0.07MB


verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
naVersion <- "31";
user <- "HB";
datestamp <- "20101007";

chipType <- "Mapping250K_Sty";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Setup required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("cdf")) {
  cdf <- AffymetrixCdfFile$byChipType(chipType);
  rm(csv);
}
print(cdf);

if (!exists("csv")) {
  tags <- sprintf(".na%s", naVersion);
  pathname <- AffymetrixNetAffxCsvFile$findByChipType(chipType, tags=tags);
  if (isFile(pathname)) {
    csv <- AffymetrixNetAffxCsvFile(pathname);
  }
  rm(tags);
}
print(csv);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Import UGP from CSV files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
tags <- sprintf("na%s,%s%s", naVersion, user, datestamp);
ugp <- NULL;
tryCatch({
  ugp <- AromaUgpFile$byChipType(getChipType(cdf), tags=tags);
}, error = function(ex) {})
if (is.null(ugp)) {
  ugp <- AromaUgpFile$allocateFromCdf(cdf, tags=tags);
}
print(ugp);


units <- importFrom(ugp, csv, verbose=log);
str(units);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Update the file footer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if (!exists("srcFileTags", mode="list")) {
  srcFileTags <- list();
  srcFiles <- list(cdf, csv);
  for (kk in seq_along(srcFiles)) {
    srcFile <- srcFiles[[kk]];
    tags <- list(
      filename=getFilename(srcFile), 
      filesize=getFileSize(srcFile), 
      checksum=getChecksum(srcFile)
    );
    srcFileTags[[kk]] <- tags;
  }
  print(srcFileTags);
}

footer <- readFooter(ugp);
footer$createdOn <- format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE);
footer$createdBy = list(
  fullname = "Henrik Bengtsson", 
  email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
);
names(srcFileTags) <- sprintf("srcFile%d", seq_along(srcFileTags));
footer$srcFiles <- srcFileTags;
writeFooter(ugp, footer);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Statistics
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
print(ugp);
## AromaUgpFile:
## Name: Mapping250K_Nsp
## Tags: na26,HB20080915
## Pathname: annotationData/chipTypes/Mapping250K_Nsp/Mapping250K_Nsp,na26,HB20080915.ugp
## File size: 1.25MB
## RAM: 0.00MB
## Number of data rows: 262338
## File format: v1
## Dimensions: 262338x2
## Column classes: integer, integer
## Number of bytes per column: 1, 4
## Footer: <createdOn>20080915 22:53:15 PDT</createdOn><platform>Affymetrix</platform><chipType>Mapping250K_Nsp</chipType><createdBy><fullname>Henrik Bengtsson</fullname><email>[...]</email></createdBy><srcFiles><srcFile1><filename>Mapping250K_Nsp.cdf</filename><filesize>194455495</filesize><checksum>59ae263311a2cf63b8d1b9b4cc7d663b</checksum></srcFile1><srcFile2><filename>Mapping250K_Nsp.na26.annot.csv</filename><filesize>447194757</filesize><checksum>5f651b351a0d97e5e9e657f123e6ed05</checksum></srcFile2></srcFiles>
## Chip type: Mapping250K_Nsp
## Platform: Affymetrix

print(summary(ugp));
##  chromosome        position
##  Min.   :  1.000   Min.   :    17408
##  1st Qu.:  4.000   1st Qu.: 32574797
##  Median :  8.000   Median : 70596240
##  Mean   :  8.758   Mean   : 79224244
##  3rd Qu.: 13.000   3rd Qu.:114776301
##  Max.   : 23.000   Max.   :247110269
##  NA's   :775.000   NA's   :      775

print(table(ugp[,1]))
##     1     2     3     4     5     6     7     8     9    10
## 19810 22178 18347 19016 17133 17097 13912 14820 11899 14241
##    11    12    13    14    15    16    17    18    19    20
## 13254 13026 11094  8165  6982  7005  4830  8136  2661  5823
##    21    22    23
##  3927  2511  5696

library("aroma.affymetrix")
log <- Arguments$getVerbose(-4, timestamp=TRUE)



dataSet <- "HapMap,CEU,testset"
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240")

# Expected sample names
sampleNames <- c("NA06985", "NA06991", "NA06993", 
                 "NA06994", "NA07000", "NA07019")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Tests for setting up CEL sets and locating the CDF file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csRList <- list()
for (chipType in chipTypes) {
  cs <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
  print(cs)
  stopifnot(identical(getNames(cs), sampleNames))
  csRList[[chipType]] <- cs
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allelic cross-talk calibration tests
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- csRList
csCList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  acc <- AllelicCrosstalkCalibration(cs)
  print(acc)
  csC <- process(acc, verbose=log)
  print(csC)
  stopifnot(identical(getNames(csC), getNames(cs)))
  csCList[[chipType]] <- csC
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Probe-level modelling test (for CN analysis)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csList <- csCList
cesCnList <- list()
for (chipType in names(csList)) {
  cs <- csList[[chipType]]
  plm <- RmaCnPlm(cs, mergeStrands=TRUE, combineAlleles=TRUE, shift=300)
  print(plm)
  fit(plm, verbose=log)
  ces <- getChipEffectSet(plm)
  print(ces)
  stopifnot(identical(getNames(ces), getNames(cs)))
  cesCnList[[chipType]] <- ces
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Fragment-length normalization test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesNList <- list()
for (chipType in names(csList)) {
  ces <- cesCnList[[chipType]]
  fln <- FragmentLengthNormalization(ces)
  print(fln)
  cesN <- process(fln, verbose=log)
  print(cesN)
  stopifnot(identical(getNames(cesN), getNames(ces)))
  cesNList[[chipType]] <- cesN
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Robust estimate of standard deviation of raw CNs
# (The default is to use a first-order difference variance estimator)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Estimate it for some autosomal chromosomes and ChrX
cns <- CbsModel(cesNList)
res <- estimateSds(cns, chromosomes=c(1:6, 23), verbose=log)
chrX <- which(rownames(res) == "23")

layout(matrix(1:2, nrow=2))
par(mar=c(4,4,0.5,2)+0.1)

xlim <- c(1,(ncol(res)+2))
ylim <- c(0, 1.05*max(res, na.rm=TRUE))
ylab <- expression(hat(sigma)==s[Delta](log2(theta/theta[R])))
cols <- seq_len(nrow(res))
ltys <- rep(1, times=nrow(res))
cols[chrX] <- "blue"
ltys[chrX] <- 4

plot(NA, xlim=xlim, ylim=ylim, xlab="", ylab=ylab)
for (kk in seq_len(nrow(res))) {
  chromosome <- rownames(res)[kk]
  points(res[kk,], col=cols[kk], pch=19)
  lines(res[kk,], col=cols[kk], lty=ltys[kk], lwd=2)
}
legend("topright", col=cols, lty=ltys, pch=19, lwd=2, 
                   legend=sprintf("Chr%s", rownames(res)), bty="n")


df <- as.data.frame(res[-chrX,,drop=FALSE])
colnames(df) <- seq_len(nrow(df))
boxplot(df, ylim=ylim, ylab=ylab, xlab="Array")
points(res[chrX,], col="blue", pch=19, cex=1.5)
legend("bottomright", col=c("black", cols[chrX]), pch=19, lwd=2, 
                   legend=c("Autosomal", "ChrX"), horiz=TRUE, bty="n")
devDone()

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "installUtils.R")
source(pathname)

library("R.utils")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Install
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Installing test-specific packages")

pkgs <- c("CRAN:aroma.cn")
for (pkg in pkgs) {
  verbose && cat(verbose, "Package: ", pkg)
  installPkg(pkg)
}

verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-50, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSetName <- "Affymetrix-CytoScanHD"
chipType <- "CytoScanHD_Array"

csR <- AffymetrixCelSet$byName(dataSetName, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allele-specific CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsNList <- doASCRMAv2(csR, verbose=verbose)
print(dsNList)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE34754/
#   Mapping250K_Nsp/
#    GSM854615.CEL, ..., GSM854626.CEL [12]
#
# Overall design:
#  Breast cancer cell lines HCC38 and HCC1143 and paired B
#  lymphoblastoid cell lines HCC38-BL and HCC1143-BL were
#  purchased from ATCC. [...] To mimic tumor containing normal cells,
#  DNA from HCC38 and HCC1143 cells was mixed with DNA from autologous
#  B lymphoblastoid cells HCC38-BL and HCC1143-BL, respectively,
#  in ratios (w/w) 100:0, 80:20, 60:40, 40:60, and 20:80.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE34754
##########################################################################



dataSet <- "GSE34754"
chipType <- "Mapping250K_Nsp"

verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType)
print(ds)
## AffymetrixCelSet:
## Name: GSE34754
## Tags:
## Path: rawData/GSE34754/Mapping250K_Nsp
## Platform: Affymetrix
## Chip type: Mapping250K_Nsp
## Number of arrays: 12
## Names: GSM854615, GSM854616, GSM854617, ..., GSM854626 [12]
## Time period: 2011-03-29 20:30:55 -- 2011-04-05 16:54:26
## Total file size: 751.17MB
## RAM: 0.02MB


verbose && exit(verbose)

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "GenomeWideSNP_6"
tags <- "Full"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadACS(ar, chipType, tags=".*")
verbose && cat(verbose, "ACS: ", pathname)

for (tags in list(NULL, "Full")) {
  pathname <- downloadCDF(ar, chipType, tags=tags)
  verbose && cat(verbose, "CDF: ", pathname)

  pathname <- downloadUFL(ar, chipType, tags=c(tags, ".*"))
  verbose && cat(verbose, "UFL: ", pathname)

  pathname <- downloadUGP(ar, chipType, tags=c(tags, ".*"))
  verbose && cat(verbose, "UGP: ", pathname)

  pathname <- downloadUGC(ar, chipType, tags=c(tags, ".*"))
  verbose && cat(verbose, "UGC: ", pathname)
}

verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-10, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE37861"
chipType <- "MoGene-1_0-st-v1"

cdf <- AffymetrixCdfFile$byChipType(chipType, tags="r3")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
csR <- csR[1:6]
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# RMA background correction
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Currently, you must use the standard CDF file.
bc <- RmaBackgroundCorrection(csR)
print(bc)

csB <- process(bc, verbose=verbose)
print(csB)

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the RMA
# chip-effect estimates as estimated by oligo.
# The setup is the same as in affyPLM,fitPLM.R.
#
# Author: Henrik Bengtsson
# Created: 2008-12-04 (from affyPLM,fitPLM.R)
# Last modified: 2013-07-03
###########################################################################

library("aroma.affymetrix")
library("oligo")

# Avoid being masked by affy::plotDensity()
plotDensity <- aroma.light::plotDensity

verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# ----------------------------------
# Dataset
# ----------------------------------
dataSet <- "GSE9890"
chipType <- "HG-U133_Plus_2"

cdf <- AffymetrixCdfFile$byChipType(chipType)
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)


# ----------------------------------
# RMA estimates by aroma.affymetrix
# ----------------------------------
verbose && enter(verbose, "RMA by aroma.affymetrix")

res <- doRMA(csR, flavor="oligo", drop=FALSE, verbose=verbose)
print(res)

# Extract chip effects on the log2 scale
ces <- res$ces
theta <- extractMatrix(ces)
rownames(theta) <- getUnitNames(cdf)
theta <- log2(theta)

verbose && exit(verbose)


# ----------------------
# RMA estimates by oligo
# ----------------------
verbose && enter(verbose, "RMA by oligo")
verbose && print(verbose, sessionInfo())

library("pd.hg.u133.plus.2")

raw <- read.celfiles(filenames=getPathnames(csR))
eSet <- rma(raw)
theta0 <- exprs(eSet)

verbose && exit(verbose)


# --------------------------------
# Compare the two implementations
# --------------------------------
# Reorder the aroma.affymetrix estimates
o <- match(rownames(theta0), rownames(theta))
theta <- theta[o,]

# Calculate statistics
rho <- diag(cor(theta, theta0))
print(rho)
print(range(rho))
e <- (theta - theta0)
print(summary(e))

# (a) Visual comparison
toPNG(getFullName(csR), tags=c("doRMA_vs_oligo"), width=800, {
  par(mar=c(5,5,4,2)+0.1, cex.main=2, cex.lab=2, cex.axis=1.5)

  layout(matrix(1:16, ncol=4, byrow=TRUE))

  xlab <- expression(log[2](theta[oligo]))
  ylab <- expression(log[2](theta[aroma.affymetrix]))
  for (kk in seq_len(ncol(theta))) {
    main <- colnames(theta)[kk]
    plot(theta0[,kk], theta[,kk], pch=".", xlab=xlab, ylab=ylab, main=main)
    abline(0,1, col="blue")
    stext(side=3, pos=0, line=-1.1, cex=1.2, substitute(rho==x, list(x=rho[kk])))
  }

  xlab <- expression(log[2](theta[aroma.affymetrix]/theta[oligo]))
  plotDensity(e, xlab=xlab)
})

# (b) Assert correlations
print(rho)
print(range(rho))
stopifnot(all(rho > 0.99985))

cors <- sapply(1:ncol(theta), FUN=function(cc) cor(theta[,cc], theta0[,cc]))
print(cors)
print(range(cors))
stopifnot(all(cors > 0.99985))

# (c) Assert differences
print(mean(as.vector(e^2)))
stopifnot(mean(as.vector(e^2)) < 0.0015)

print(sd(as.vector(e^2)))
stopifnot(sd(as.vector(e^2)) < 0.0025)

print(quantile(abs(e), 0.99))
## stopifnot(quantile(abs(e), 0.99) < 0.05)
stopifnot(quantile(abs(e), 0.99) < 0.11)  # Why so bad now? /HB 2014-05-28

print(max(abs(e)))
## stopifnot(max(abs(e)) < 0.085)
stopifnot(max(abs(e)) < 0.26) ## Why so bad?


verbose && print(verbose, sessionInfo())


###########################################################################
# HISTORY:
# 2013-07-03 [HB]
# o Harmonized with 11.doRMA_vs_affyPLM.R.
# 2008-12-04 [HB]
# o Created, but not tested because I miss package 'pd.hg.u133.plus.2'.
###########################################################################

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extraction test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ces <- res$cesN

# (a) Single array
ce <- ces[[1]]
Y <- extractMatrix(ce, verbose=verbose)
print(head(Y))

theta <- extractTheta(ce, verbose=verbose)
print(head(theta))

data <- extractDataFrame(ce, addNames=TRUE, verbose=verbose)
print(head(data))


# (b) Multiple arrays
Y <- extractMatrix(ces, verbose=verbose)
print(head(Y))

theta <- extractTheta(ces, verbose=verbose)
print(theta[1:6,,])

data <- extractDataFrame(ces, addNames=TRUE, verbose=verbose)
print(head(data))

# Extract unit and group name and indices together with chip effects
dataT <- extractDataFrame(ces, units=1:50, addNames=TRUE)
print(head(dataT))
# Sanity check
stopifnot(all.equal(dataT[1:50,], data[1:50,]))

# SNPs only
unf <- getUnitNamesFile(ces)
print(unf)

units <- indexOf(unf, pattern="^SNP")
str(units)

theta <- extractTheta(ces, units=units[1:10])
print(theta)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot theta:s
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
theta <- extractTheta(ces, units=units)
dimnames(theta)[[2]] <- c("A", "B")
ltheta <- log2(theta)
a <- (ltheta[,"A",]+ltheta[,"B",])/2
m <- ltheta[,"A",]-ltheta[,"B",]

toPNG(getFullName(ces), tags=c("LogDiffvsLogSum"), aspectRatio=0.7, {
  Alim <- c(5,14)
  Mlim <- diff(Alim)*c(-1,1)
  Alab <- expression(1/2%*%log[2](theta[A]*theta[B]))
  Mlab <- expression(log[2](theta[A]/theta[B]))

  I <- dim(theta)[3]
  layout(matrix(1:I, ncol=3, byrow=TRUE))
  par(mar=c(3.8,4,3,1)+0.1)

  for (ii in 1:I) {
    name <- dimnames(theta)[[3]][ii]
    plot(a[,ii], m[,ii], pch=".", xlim=Alim, ylim=Mlim, xlab=Alab, ylab=Mlab, main=name)
  }
})

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, verbose=verbose)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# (a) AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)

cesN <- res$cesN


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extraction test
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract unit and group name and indices together with chip effects
data <- extractDataFrame(cesN, units=1:50, addNames=TRUE, verbose=verbose)
print(data[1:50,1:8])


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract (thetaA, thetaB)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
theta <- extractTheta(cesN, groups=1:2, verbose=verbose)
dimnames(theta)[[2]] <- c("A", "B")
thetaA <- theta[,"A",]
thetaB <- theta[,"B",]
theta <- thetaA + thetaB
freqB <- thetaB / theta


tlim <- c(8,15)
Blim <- c(0,1)
tlab <- expression(log[2](theta))
Blab <- expression(theta[B]/theta)

nbrOfArrays <- ncol(theta)

toPNG(getFullName(cesN), tags="BAFvsTheta", width=1024, {
  layout(matrix(1:nbrOfArrays, ncol=2, byrow=TRUE))
  par(mar=c(3.8,4,3,1)+0.1)
  for (ii in seq_len(nbrOfArrays)) {
    name <- colnames(theta)[ii]
    smoothScatter(log2(theta[,ii]), freqB[,ii], 
                  xlim=tlim, ylim=Blim, xlab=tlab, ylab=Blab, main=name)
  }
})


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extract (log2(total), freqB)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
data <- extractTotalAndFreqB(cesN, verbose=verbose)
data[,1,] <- log2(data[,1,])

tlim <- c(9,15)

upperPanel <- function(x,y, pch=".", ...) {
  xy <- data[,1,c(x,y)]
  xy <- (xy - tlim[1])/diff(tlim)
  abline(a=0,b=1, col="#999999")
  points(xy, pch=pch)
}

lowerPanel <- function(x,y, pch=".", ...) {
  xy <- data[,2,c(x,y)]
  abline(a=0,b=1, col="#999999")
  abline(a=1,b=-1, col="#999999")
  points(xy, pch=pch)
}

diagPanel <- function(x, pch=".", ...) {
  xy <- data[,,x]
  xy[,1] <- (xy[,1] - tlim[1])/diff(tlim)
  smoothScatter(xy, add=TRUE)
  abline(h=1/2, col="#999999")
}

pairs <- matrix(1:nbrOfArrays, nrow=1, ncol=nbrOfArrays)
colnames(pairs) <- dimnames(data)[[length(dim)]]

toPNG(getFullName(cesN), tags="pairs", width=1024, {
  pairs(pairs, upper.panel=upperPanel, lower.panel=lowerPanel, 
               diag.panel=diagPanel, xlim=c(0,1), ylim=c(0,1))
})

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372,testset"
chipType <- "GenomeWideSNP_6,Full"

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- doASCRMAv2(csR, drop=FALSE, verbose=verbose)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Summarize theta = thetaA+thetaB
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cesN <- res$cesN
as <- AlleleSummation(cesN)
print(as)
cesT <- process(as, verbose=verbose)
print(cesT)

Y <- extractMatrix(cesT, verbose=verbose)
print(head(Y))


# Validation
dsNList <- res$dsNList
Y0 <- extractMatrix(dsNList$total, verbose=verbose)
print(head(Y0))

# Sanity check
stopifnot(all.equal(Y, Y0))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cbs <- CbsModel(cesT)
print(cbs)

ce <- ChromosomeExplorer(cbs, zooms=2^(0:5))
process(ce, arrays=1:2, chromosomes=18:23, verbose=verbose)

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")

##########################################################################
# Data set:
# GSE27691/
#  MOUSEDIVm520650/
#   GSM685813.CEL, , ..., GSM685819.CEL [7]
#
# Overall design:
#  Affymetrix SNP array analysis was performed with Mouse Diversity
#  Genotyping Arrays (Affymetrix) on genomic DNA extracted from frozen
#  biopsies of 6 recurrent mouse mammary tumor samples. Copy number
#  analysis was performed for the mouse mammary tumors using genomic DNA
#  from normal mammary tissue as the reference for copy number inference.
#
# Note: Is this one mouse with several tumors?  If so, how should the
#  different samples be ordered?  If not, then there is no matched
#  tumor/normal sample in there.  This can be checked using
#  (beta, beta) plots.
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE27691
##########################################################################
dataSet <- "GSE27691"
chipType <- "MOUSEDIVm520650"
verbose && cat(verbose, "Data set: ", dataSet)

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType)
print(ds)
## AffymetrixCelSet:
## Name: GSE27691
## Tags:
## Path: rawData/GSE27691/MOUSEDIVm520650
## Platform: Affymetrix
## Chip type: MOUSEDIVm520650
## Number of arrays: 7
## Names: GSM685813, GSM685814, GSM685815, ..., GSM685819 [7]
## Time period: 2010-01-06 20:04:57 -- 2010-01-07 02:48:38
## Total file size: 460.79MB
## RAM: 0.01MB

verbose && exit(verbose)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-20, timestamp=TRUE)

chipType <- "Mm_PromPR_v02"

cdf <- AffymetrixCdfFile$byChipType(chipType)
print(cdf)

# Get the "unique" CDF, which is generated if missing
cdfU <- getUniqueCdf(cdf, verbose=more(verbose, 60))
print(cdfU)

# Note that the "unique" CDF has the same units as the main CDF.
stopifnot(nbrOfUnits(cdfU) == nbrOfUnits(cdf))

path <- system.file("testScripts/R", package="aroma.affymetrix");
pathname <- file.path(path, "downloadUtils.R");
source(pathname);

verbose && enter(verbose, "Downloading raw data");


##########################################################################
# Data set:
# HapMap,CEU/
#   Mapping50K_Hind240/
#    GSM226867.CEL, ..., GSM226876.CEL [10 files]
#
# URL: ftp://ftp.ncbi.nlm.nih.gov/hapmap/raw_data/affy100k/
##########################################################################
dataSet <- "HapMap,CEU,testset";
chipTypes <- c("Mapping50K_Hind240", "Mapping50K_Xba240");
sampleNames <- c("CEU_NA06985", "CEU_NA06991", "CEU_NA06993",
                 "CEU_NA06994", "CEU_NA07000", "CEU_NA07019");

verbose && cat(verbose, "Data set: ", dataSet);

ds <- downloadHapMapSamples(dataSet, chipType=chipTypes[1], sampleNames=sampleNames);
print(ds);
## AffymetrixCelSet:
## Name: HapMap
## Tags: CEU
## Path: rawData/HapMap,CEU/Mapping50K_Hind240
## Platform: Affymetrix
## Chip type: Mapping50K_Hind240
## Number of arrays: 6
## Names: CEU_NA06985_HIND, CEU_NA06991_HIND, CEU_NA06993_HIND, ..., CEU_NA07019_HIND [6]
## Time period: 2004-01-14 14:02:08 -- 2004-01-17 13:53:58
## Total file size: 146.86MB
## RAM: 0.01MB

verbose && exit(verbose);

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)

csR <- AffymetrixCelSet$byName("GSE8605", chipType="Mapping10K_Xba142")
print(csR)

cesN <- doASCRMAv2(csR, arrays=1:6, drop=FALSE, verbose=verbose)$cesN
print(cesN)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export to (total,fracB) ASB files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
theta <- getAromaUnitTotalCnBinarySet(cesN, verbose=verbose)
print(theta)

fracB <- getAromaUnitFracBCnBinarySet(cesN, verbose=verbose)
print(fracB)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calculate average theta across arrays
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
thetaR <- calculateAverageColumnAcrossFiles(theta, verbose=verbose)
str(thetaR)

library("aroma.affymetrix")

ovars <- ls(all.names=TRUE)
oplan <- future::plan()

## Setup dataset
dataset <- "GSE8605"
chipType <- "Mapping10K_Xba142"

csR <- AffymetrixCelSet$byName(dataset, chipType=chipType)
csR <- csR[1:2]
print(csR)

checksum <- NULL

strategies <- future:::supportedStrategies()
strategies <- setdiff(strategies, "multiprocess")
if (require("future.batchtools")) {
  strategies <- c(strategies, "batchtools_local")
  if (any(grepl("PBS_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_torque")
  } else if (any(grepl("SGE_", names(Sys.getenv())))) {
    strategies <- c(strategies, "batchtools_sge")
  }
}

message("Future strategies: ", paste(sQuote(strategies), collapse = ", "))
mprint(future::sessionDetails())
mprint(list(
  availableCores = parallelly::availableCores(which = "all"),
  availableWorkers = parallelly::availableWorkers(which = "all")
))

for (strategy in strategies) {
  message(sprintf("*** Using %s futures ...", sQuote(strategy)))

  future::plan(strategy)
  tags <- c("*", strategy)

  ## (a) Process a single array
  acc <- AllelicCrosstalkCalibration(csR[1], model="CRMAv2", tags=c(tags, "one-array"))
  print(acc)
  csC1 <- process(acc, verbose=-10)
  print(csC1)
  csC1z <- getChecksumFileSet(csC1)
  print(csC1z[[1]])

  ## Compare file checksum to previous runs
  checksumT <- readChecksum(csC1z[[1]])
  if (is.null(checksum)) checksum <- checksumT
  stopifnot(identical(checksumT, checksum))


  ## (b) Process two arrays
  acc <- AllelicCrosstalkCalibration(csR, model="CRMAv2", tags=tags)
  print(acc)
  csC <- process(acc, verbose=-10)
  print(csC)
  csCz <- getChecksumFileSet(csC)
  print(csCz[[1]])
  res <- equals(csC1z[[1]], csCz[[1]])
  if (!res) throw(res)

  message(sprintf("*** Using %s futures ... DONE", sQuote(strategy)))
}


## CLEANUP
future::plan(oplan)
rm(list=setdiff(ls(all.names=TRUE), ovars))

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
dsNList <- doASCRMAv2(dataSet, chipType=chipType, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsT <- dsNList$total
seg <- CbsModel(dsT)
print(seg)

# Try to segment
fit(seg, arrays=c(1,2), chromosomes=19, verbose=verbose)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ChromsomeExplorer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ce <- ChromosomeExplorer(seg, zooms=2^(0:5))
print(ce)
process(ce, arrays=1:2, chromosomes=c(1:2,19,23), verbose=verbose)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS with a common reference
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Use the robust average of the first five arrays as a reference
dsR <- dsT[1:5]
dfR <- getAverageFile(dsR)
print(dfR)

seg <- CbsModel(dsT, refTuple=dfR, tags=c(getTags(dsT), "commonRef"))
print(seg)

# Try to segment
fit(seg, arrays=c(1,2), chromosomes=19, verbose=verbose)

# Write to file
pathname <- writeRegions(seg, arrays=1, oneFile=FALSE, verbose=verbose)
print(pathname)

library("aroma.affymetrix")
verbose <- Arguments$getVerbose(-4, timestamp=TRUE)

dataSet <- "GSE8605"
chipType <- "Mapping10K_Xba142"
dsNList <- doASCRMAv2(dataSet, chipType=chipType, verbose=verbose)
print(dsNList)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
seg <- GladModel(dsNList$total)
print(seg)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ChromsomeExplorer
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ce <- ChromosomeExplorer(seg, zooms=2^(0:5))
print(ce)
process(ce, arrays=1:2, chromosomes=c(1:2,19,23), verbose=verbose)

###########################################################################
# Replication test
#
# Description:
# This test verifies that aroma.affymetrix can reproduce the estimates
# of the MAT (Model-based Analysis of Tiling arrays) algorithm.
#
# Author: Mark Robinson and Henrik Bengtsson
# Created: 2008-12-09
# Last modified: 2012-09-02
###########################################################################
library("aroma.affymetrix")
library("matrixStats"); # colMedians()
verbose <- Arguments$getVerbose(-20, timestamp=TRUE)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE24546"
tags <- "testset"
chipType <- "Hs_PromPR_v02"
sampleNamesMap <- c(
  GSM605951="Prec1_MeDNA_Input1",
  GSM605952="Prec1_MeDNA_IP2",
  GSM605953="Prec1_MeDNA_IP1"
)

cdf <- AffymetrixCdfFile$byChipType(chipType)
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, tags=tags, cdf=cdf)
print(csR)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Normalize the data using the MAT model
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
mn <- MatNormalization(csR)
csM <- process(mn, verbose=more(verbose, 3))
print(csM)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Convert data set such that it maps to the "unique" CDF
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
csU <- convertToUnique(csM, verbose=verbose)
print(csU)

# Rename
setFullNamesTranslator(csU, function(names, ...) { sampleNamesMap[names] })



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare to precomputed estimates from external MAT software
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare common units with prefix "chr1F".
cdfU <- getCdf(csU)
units <- indexOf(cdfU, "^chr1F")
cells <- getCellIndices(cdfU, units=units, stratifyBy="pm",
                        unlist=TRUE, useNames=FALSE)

# Get the chromosomal positions of these cells
acp <- AromaCellPositionFile$byChipType(getChipType(cdfU))
pos <- acp[cells,2,drop=TRUE]

# Order cells by chromsomal position
o <- order(pos)
pos <- pos[o]
cells <- cells[o]


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Compare to the MAT software
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MAT normalized signals
normFile <- "Prec1_MeDNA_600_IP1-Input.tsv"
tsv <- TabularTextFile(filename=normFile, path=getPath(csR))
print(tsv)

# Sample names ran on external MAT software
sampleNames <- getColumnNames(tsv)
sampleNames <- setdiff(sampleNames, c("Chr", "Pos"))
sampleNames <- gsub("[.]CEL$", "", sampleNames)

# Sanity check
stopifnot(all(is.element(sampleNames, getNames(csU))))

# Corresponding aroma subset
csUt <- csU[sampleNames]


# Read MAT signals
colClasses <- c("Chr"="character", "Pos"="integer", rep("numeric", times=length(sampleNames)))
names(colClasses)[-(1:2)] <- sampleNames
data <- readDataFrame(tsv, colClasses=colClasses, nrow=435000)
data <- subset(data, (Chr == "chr1" & Pos %in% pos))

# Order as (pos,yN)
o <- match(data$Pos, pos)
# Sanity check
stopifnot(all(is.finite(o)))
data <- data[o,,drop=FALSE]

# Extract signals
YMAT <- as.matrix(data[,-(1:2)])
rownames(YMAT) <- NULL
colnames(YMAT) <- sampleNames

Y <- extractMatrix(csUt, cells=cells)
Y <- log2(Y)

# Sanity check
stopifnot(identical(dim(Y), dim(YMAT)))


# Graphical comparison
for (sampleName in sampleNames) {
  toPNG(getFullName(csU), tags=c(sampleName, "MatNormalization_vs_MAT"), {
    xlab <- expression(log[2](y[MAT]))
    ylab <- expression(log[2](y))
    plot(YMAT[,sampleName], Y[,sampleName], pch=".", xlab=xlab, ylab=ylab)
    abline(a=0, b=1, col="red", lwd=2, lty=3)
    stext(side=3, pos=0, sampleName)
    stext(side=3, pos=1, "Chr01")
    stext(side=4, pos=1, sprintf("n=%d", nrow(Y)))
    stext(side=4, pos=0, getFullName(csU))
  })
}

# Numerical comparison
D2 <- (Y - YMAT)^2
avgDiff <- colMedians(D2, na.rm=TRUE)
names(avgDiff) <- colnames(D2)
cat("Average differences:\n")
print(avgDiff)

# Sanity check
stopifnot(all(avgDiff < 0.001))

library("aroma.core");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);
ar <- AromaRepository(verbose=TRUE);

verbose && enter(verbose, "Downloading annotation data");

chipType <- "HG-U133_Plus_2";
verbose && cat(verbose, "Chip type: ", chipType);

pathname <- downloadCDF(ar, chipType);
verbose && cat(verbose, "CDF: ", pathname);

pathname <- downloadACS(ar, chipType, tags=".*");
verbose && cat(verbose, "ACS: ", pathname);

verbose && exit(verbose);

path <- system.file("testScripts/R", package="aroma.affymetrix")
pathname <- file.path(path, "downloadUtils.R")
source(pathname)

verbose && enter(verbose, "Downloading raw data")


##########################################################################
# Data set:
# GSE12019/
#   Mapping250K_Sty/
#   GSM303672.cel, ..., GSM303896.CEL [13]
#
# Overall design:
#  77 replicates of HCC1143 (breast ductal carcinoma), 69 replicates
#  of HCC1143BL (matched normal), 42 replicates of HCC1954 (breast 
#  ductal carcinoma), 36 replicates of HCC1954BL (matched normal), 
#  1 replicate of NCI-H2347 (lung adenocarcinoma)
#  http://www.broad.mit.edu/cancer/pub/solexa_copy_numbers
#
# URL: https://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE12019
##########################################################################
dataSet <- "GSE12019,testset"
chipType <- "Mapping250K_Sty"

sampleNamesMap <- c(
  GSM303672="HCC1143_ABORT_A02",
  GSM303673="HCC1954_ABORT_C06",
  GSM303674="HCC1143_ABORT_C12",
  GSM303675="HCC1954_ACTOR_H08",
  GSM303791="HCC1143BL_ABORT_A01",
  GSM303792="HCC1143BL_ABORT_C11",
  GSM303793="HCC1143BL_ACTOR_H09",
  GSM303794="HCC1143BL_ACTOR_H11",
  GSM303860="HCC1954BL_ABORT_C05",
  GSM303861="HCC1954BL_ACTOR_H07",
  GSM303862="HCC1954BL_AIRNS_E07",
  GSM303863="HCC1954BL_BARRE_C11",
  GSM303896="NCI-H2347"
)

sampleNames <- names(sampleNamesMap)
ds <- downloadGeoRawDataFiles(dataSet, chipType=chipType, sampleNames=sampleNames)
print(ds)
## AffymetrixCelSet:
## Name: GSE12019
## Tags: testset
## Path: rawData/GSE12019,testset/Mapping250K_Sty
## Platform: Affymetrix
## Chip type: Mapping250K_Sty
## Number of arrays: 13
## Names: GSM303672, GSM303673, GSM303674, ..., GSM303896 [13]
## Time period: 2006-05-31 18:47:05 -- 2006-10-25 00:28:43
## Total file size: 814.82MB
## RAM: 0.02MB


verbose && exit(verbose)

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")

chipType <- "Hs_PromPR_v02"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

#pathname <- downloadACS(ar, chipType, tags=".*")
pathname <- downloadACS(ar, chipType)
verbose && cat(verbose, "ACS: ", pathname)

#pathname <- downloadACM(ar, chipType, tags=".*")
pathname <- downloadACM(ar, chipType)
verbose && cat(verbose, "ACM: ", pathname)

pathname <- downloadACP(ar, chipType, tags="unique")
verbose && cat(verbose, "ACP: ", pathname)

verbose && exit(verbose)

if (interactive()) savehistory();
library("aroma.affymetrix");
log <- Verbose(threshold=-10, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Settings
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
chipType <- "HuGene-1_0-st-v1";

footer <- list(
  createdOn = format(Sys.time(), "%Y%m%d %H:%M:%S", usetz=TRUE),
  createdBy = list(
    fullname = "Henrik Bengtsson", 
    email = sprintf("%s@%s", "henrik.bengtsson", "aroma-project.org")
  ),
  srcFiles = list()
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# Get required annotation files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
cdf <- AffymetrixCdfFile$byChipType(chipType, tags=".*");
print(cdf);

ptb <- AffymetrixProbeTabFile$byChipType(chipType);
print(ptb);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Allocate aroma cell sequence file
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#acs <- AromaCellSequenceFile$allocateFromCdf(cdf, tags="*,HB20090927");
acs <- AromaCellSequenceFile$allocateFromCdf(cdf, tags="*,HB20120106b");
print(acs);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Import data from the Affymetrix probe-tab file (contains only PMs)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# There is a tiny fraction of probes with 21 and 23 base pairs;
#     21     23     25
#      1     49 862510
importFrom(acs, ptb, keepSequenceLengths=25, verbose=log);

# Infer MM from PM sequences?  Will give an error if no MMs
inferMmFromPm(acs, cdf=cdf, verbose=log); # DOES NOT WORK

library("aroma.core")
verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
ar <- AromaRepository(verbose=TRUE)

verbose && enter(verbose, "Downloading annotation data")


##########################################################################
# Annotation data:
# Hs_PromPR_v02/
#   Hs_PromPR_v02.cdf
#   Hs_PromPR_v02.acs
#   Hs_PromPR_v02.acm
#   Hs_PromPR_v02,unique.acp
##########################################################################
chipType <- "Hs_PromPR_v02"
verbose && cat(verbose, "Chip type: ", chipType)

pathname <- downloadCDF(ar, chipType)
verbose && cat(verbose, "CDF: ", pathname)

#pathname <- downloadACS(ar, chipType, tags=".*")
pathname <- downloadACS(ar, chipType)
verbose && cat(verbose, "ACS: ", pathname)

#pathname <- downloadACM(ar, chipType, tags=".*")
pathname <- downloadACM(ar, chipType)
verbose && cat(verbose, "ACM: ", pathname)

pathname <- downloadACP(ar, chipType, tags="unique")
verbose && cat(verbose, "ACP: ", pathname)

verbose && exit(verbose)
